# Incubator Registry

## Overview

This directory is an official ksonnet-compatible [registry][2]. If you are unfamiliar with ksonnet, we recommend browsing [the official site][1] to gain more context.

Out of the box, ksonnet's CLI tool (`ks`) is aware of the `incubator` registry, and can download any of its libraries via `ks pkg install`.

## Usage

Assuming that you have the `ks` tool [installed][3], you can use any library in this registry as follows, by replacing `redis` with `<library-name>`:

```
# List all available packages (e.g. apache, efk, mariadb..)
ks pkg list

# Describe a specific package
ks pkg describe incubator/redis@master

# Download a specific package
ks pkg install incubator/redis@master
```

## Library-specific Documentation

Each of the libraries in this directory has its own README.md. These are autogenerated from the metadata in their `parts.yaml` file, using the [`doc-gen` script][4].

Note that you can use the `ks` commands in your terminal to access this same documentation.

[1]: https://ksonnet.io
[2]: https://ksonnet.io/docs/concepts#registry
[3]: https://ksonnet.io/#get-started
[4]: /doc-gen/main.go
