# mariadb

> MariaDB is an open source relational database it provides a SQL interface for accessing data. The latest versions of MariaDB also include GIS and JSON features. This package deploys a maria container, a service and secret to your cluster

* [Quickstart](#quickstart)
* [Using Prototypes](#using-prototypes)
  * [io.ksonnet.pkg.stateless-maria](#io.ksonnet.pkg.stateless-maria)

## Quickstart

*The following commands use the `io.ksonnet.pkg.simple-mariadb` prototype to generate Kubernetes YAML for mariadb, and then deploys it to your Kubernetes cluster.*

First, create a cluster and install the ksonnet CLI (see root-level [README.md](rootReadme)).

If you haven't yet created a [ksonnet application](linkToSomewhere), do so using `ks init <app-name>`.

Finally, in the ksonnet application directory, run the following:

```shell
# Expand prototype as a Jsonnet file, place in a file in the
# `components/` directory. (YAML and JSON are also available.)
$ ks prototype use io.ksonnet.pkg.simple-mariadb mariadb \
  --name mariadb \
  --namespace default \
  --mariaRootPassword boot

# Apply to server.
$ ks apply -f mariadb.jsonnet
```

## Using the library

The library files for mariadb define a set of relevant *parts* (_e.g._, deployments, services, secrets, and so on) that can be combined to configure mariadb for a wide variety of scenarios. For example, a database like Redis may need a secret to hold the user password, or it may have no password if it's acting as a cache.

This library provides a set of pre-fabricated "flavors" (or "distributions") of mariadb, each of which is configured for a different use case. These are captured as ksonnet *prototypes*, which allow users to interactively customize these distributions for their specific needs.

These prototypes, as well as how to use them, are enumerated below.

### io.ksonnet.pkg.stateless-maria

Deploy stateless instance of MariaDB. This is NOT backed by a persistent volume.The MariaDB container is deployed using a deployment and exposed to the
network as a service. The password is stored as a secret.

#### Example

```shell
# Expand prototype as a Jsonnet file, place in a file in the
# `components/` directory. (YAML and JSON are also available.)
$ ks prototype use io.ksonnet.pkg.stateless-maria mariadb \
  --namespace YOUR_NAMESPACE_HERE \
  --name YOUR_NAME_HERE \
  --mariaRootPassword YOUR_MARIAROOTPASSWORD_HERE
```

Below is the Jsonnet file generated by this command.

```
// mariadb.jsonnet
<JSONNET HERE>
```

#### Parameters

The available options to pass prototype are:

* `--namespace=<namespace>`: Namespace in which to put the application [string]
* `--name=<name>`: Metadata name for each of the deployment components [string]
* `--mariaRootPassword=<mariaRootPassword>`: Password for root user [string]


[rootReadme]: https://github.com/ksonnet/mixins
