// Copyright 2018 The ksonnet authors
//
//
//    Licensed under the Apache License, Version 2.0 (the "License");
//    you may not use this file except in compliance with the License.
//    You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
//    Unless required by applicable law or agreed to in writing, software
//    distributed under the License is distributed on an "AS IS" BASIS,
//    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//    See the License for the specific language governing permissions and
//    limitations under the License.

package schema

import (
	"github.com/GeertJohan/go.rice/embedded"
	"time"
)

func init() {

	// define files
	file2 := &embedded.EmbeddedFile{
		Filename:    "k.libsonnet",
		FileModTime: time.Unix(1523278962, 0),
		Content:     string("local k8s = import \"k8s.libsonnet\";\nlocal fn = {\n  mapContainers(f):: {\n    local podContainers = super.spec.template.spec.containers,\n    spec+: {\n      template+: {\n        spec+: {\n          containers: std.map(f, podContainers),\n        },\n      },\n    },\n  },\n  mapContainersWithName(names, f)::\n    local nameSet = if std.type(names) == \"array\" then std.set(names) else std.set([names]);\n    local inNameSet(name) = std.length(std.setInter(nameSet, std.set([name]))) > 0;\n\n    self.mapContainers(function(c) if std.objectHas(c, \"name\") && inNameSet(c.name) then f(c) else c),\n};\n\nk8s + {\n  apps:: k8s.apps + {\n    v1:: k8s.apps.v1 + {\n      daemonSet:: k8s.apps.v1.daemonSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      deployment:: k8s.apps.v1.deployment + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      replicaSet:: k8s.apps.v1.replicaSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      statefulSet:: k8s.apps.v1.statefulSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n    v1beta1:: k8s.apps.v1beta1 + {\n      deployment:: k8s.apps.v1beta1.deployment + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      statefulSet:: k8s.apps.v1beta1.statefulSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n    v1beta2:: k8s.apps.v1beta2 + {\n      daemonSet:: k8s.apps.v1beta2.daemonSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      deployment:: k8s.apps.v1beta2.deployment + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      replicaSet:: k8s.apps.v1beta2.replicaSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      statefulSet:: k8s.apps.v1beta2.statefulSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n  },\n  batch:: k8s.batch + {\n    v1:: k8s.batch.v1 + {\n      job:: k8s.batch.v1.job + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n    v1beta1:: k8s.batch.v1beta1 + {\n      cronJob:: k8s.batch.v1beta1.cronJob + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n    v2alpha1:: k8s.batch.v2alpha1 + {\n      cronJob:: k8s.batch.v2alpha1.cronJob + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n  },\n  core:: k8s.core + {\n    v1:: k8s.core.v1 + {\n      list:: {\n        new(items):: {\n          apiVersion: \"v1\",\n        } + {\n          kind: \"List\",\n        } + self.items(items),\n        items(items):: if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n      },\n      pod:: k8s.core.v1.pod + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      podTemplate:: k8s.core.v1.podTemplate + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      replicationController:: k8s.core.v1.replicationController + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n  },\n  extensions:: k8s.extensions + {\n    v1beta1:: k8s.extensions.v1beta1 + {\n      daemonSet:: k8s.extensions.v1beta1.daemonSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      deployment:: k8s.extensions.v1beta1.deployment + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n      replicaSet:: k8s.extensions.v1beta1.replicaSet + {\n        mapContainers(f):: fn.mapContainers(f),\n        mapContainersWithName(names, f):: fn.mapContainersWithName(names, f),\n      },\n    },\n  },\n}"),
	}
	file3 := &embedded.EmbeddedFile{
		Filename:    "k8s.libsonnet",
		FileModTime: time.Unix(1523278962, 0),
		Content: string("{\n  \"__ksonnet\": {\n    checksum: \"734f5cb9a36efcd69dd0373d303e0f283a7d0ffd0e6ad926e1998bc48466bbec\",\n    kubernetesVersion: \"1.10.0\",\n  },\n  admissionregistration:: {\n    v1alpha1:: {\n      local apiVersion = {apiVersion: \"admissionregistration.k8s.io/v1alpha1\"},\n      // InitializerConfiguration describes the configuration of initializers.\n      initializerConfiguration:: {\n        local kind = {kind: \"InitializerConfiguration\"},\n        new():: apiVersion + kind,\n        // Initializers is a list of resources and their default initializers Order-sensitive. When merging multiple InitializerConfigurations, we sort the initializers from different InitializerConfigurations by the name of the InitializerConfigurations; the order of the initializers from the same InitializerConfiguration is preserved.\n        withInitializers(initializers):: self + if std.type(initializers) == \"array\" then {initializers: initializers} else {initializers: [initializers]},\n        // Initializers is a list of resources and their default initializers Order-sensitive. When merging multiple InitializerConfigurations, we sort the initializers from different InitializerConfigurations by the name of the InitializerConfigurations; the order of the initializers from the same InitializerConfiguration is preserved.\n        withInitializersMixin(initializers):: self + if std.type(initializers) == \"array\" then {initializers+: initializers} else {initializers+: [initializers]},\n        initializersType:: hidden.admissionregistration.v1alpha1.initializer,\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"admissionregistration.k8s.io/v1beta1\"},\n      // MutatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and may change the object.\n      mutatingWebhookConfiguration:: {\n        local kind = {kind: \"MutatingWebhookConfiguration\"},\n        new():: apiVersion + kind,\n        // Webhooks is a list of webhooks and the affected resources and operations.\n        withWebhooks(webhooks):: self + if std.type(webhooks) == \"array\" then {webhooks: webhooks} else {webhooks: [webhooks]},\n        // Webhooks is a list of webhooks and the affected resources and operations.\n        withWebhooksMixin(webhooks):: self + if std.type(webhooks) == \"array\" then {webhooks+: webhooks} else {webhooks+: [webhooks]},\n        webhooksType:: hidden.admissionregistration.v1beta1.webhook,\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // ValidatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and object without changing it.\n      validatingWebhookConfiguration:: {\n        local kind = {kind: \"ValidatingWebhookConfiguration\"},\n        new():: apiVersion + kind,\n        // Webhooks is a list of webhooks and the affected resources and operations.\n        withWebhooks(webhooks):: self + if std.type(webhooks) == \"array\" then {webhooks: webhooks} else {webhooks: [webhooks]},\n        // Webhooks is a list of webhooks and the affected resources and operations.\n        withWebhooksMixin(webhooks):: self + if std.type(webhooks) == \"array\" then {webhooks+: webhooks} else {webhooks+: [webhooks]},\n        webhooksType:: hidden.admissionregistration.v1beta1.webhook,\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n    },\n  },\n  apiextensions:: {\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"apiextensions.k8s.io/v1beta1\"},\n      // CustomResourceDefinition represents a resource that should be exposed on the API server.  Its name MUST be in the format <.spec.name>.<.spec.group>.\n      customResourceDefinition:: {\n        local kind = {kind: \"CustomResourceDefinition\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec describes how the user wants the resources to appear\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Group is the group this resource belongs in\n            withGroup(group):: self + __specMixin({group: group}),\n            // Names are the names used to describe this custom resource\n            names:: {\n              local __namesMixin(names) = __specMixin({names+: names}),\n              mixinInstance(names):: __namesMixin(names),\n              // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n              withCategories(categories):: self + if std.type(categories) == \"array\" then __namesMixin({categories: categories}) else __namesMixin({categories: [categories]}),\n              // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n              withCategoriesMixin(categories):: self + if std.type(categories) == \"array\" then __namesMixin({categories+: categories}) else __namesMixin({categories+: [categories]}),\n              // Kind is the serialized kind of the resource.  It is normally CamelCase and singular.\n              withKind(kind):: self + __namesMixin({kind: kind}),\n              // ListKind is the serialized kind of the list for this resource.  Defaults to <kind>List.\n              withListKind(listKind):: self + __namesMixin({listKind: listKind}),\n              // Plural is the plural name of the resource to serve.  It must match the name of the CustomResourceDefinition-registration too: plural.group and it must be all lowercase.\n              withPlural(plural):: self + __namesMixin({plural: plural}),\n              // ShortNames are short names for the resource.  It must be all lowercase.\n              withShortNames(shortNames):: self + if std.type(shortNames) == \"array\" then __namesMixin({shortNames: shortNames}) else __namesMixin({shortNames: [shortNames]}),\n              // ShortNames are short names for the resource.  It must be all lowercase.\n              withShortNamesMixin(shortNames):: self + if std.type(shortNames) == \"array\" then __namesMixin({shortNames+: shortNames}) else __namesMixin({shortNames+: [shortNames]}),\n              // Singular is the singular name of the resource.  It must be all lowercase  Defaults to lowercased <kind>\n              withSingular(singular):: self + __namesMixin({singular: singular}),\n            },\n            namesType:: hidden.apiextensions.v1beta1.customResourceDefinitionNames,\n            // Scope indicates whether this resource is cluster or namespace scoped.  Default is namespaced\n            withScope(scope):: self + __specMixin({scope: scope}),\n            // Subresources describes the subresources for CustomResources This field is alpha-level and should only be sent to servers that enable subresources via the CustomResourceSubresources feature gate.\n            subresources:: {\n              local __subresourcesMixin(subresources) = __specMixin({subresources+: subresources}),\n              mixinInstance(subresources):: __subresourcesMixin(subresources),\n              // Scale denotes the scale subresource for CustomResources\n              scale:: {\n                local __scaleMixin(scale) = __subresourcesMixin({scale+: scale}),\n                mixinInstance(scale):: __scaleMixin(scale),\n                // LabelSelectorPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Selector. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. Must be set to work with HPA. If there is no value under the given path in the CustomResource, the status label selector value in the /scale subresource will default to the empty string.\n                withLabelSelectorPath(labelSelectorPath):: self + __scaleMixin({labelSelectorPath: labelSelectorPath}),\n                // SpecReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Spec.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .spec. If there is no value under the given path in the CustomResource, the /scale subresource will return an error on GET.\n                withSpecReplicasPath(specReplicasPath):: self + __scaleMixin({specReplicasPath: specReplicasPath}),\n                // StatusReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. If there is no value under the given path in the CustomResource, the status replica value in the /scale subresource will default to 0.\n                withStatusReplicasPath(statusReplicasPath):: self + __scaleMixin({statusReplicasPath: statusReplicasPath}),\n              },\n              scaleType:: hidden.apiextensions.v1beta1.customResourceSubresourceScale,\n            },\n            subresourcesType:: hidden.apiextensions.v1beta1.customResourceSubresources,\n            // Validation describes the validation methods for CustomResources\n            validation:: {\n              local __validationMixin(validation) = __specMixin({validation+: validation}),\n              mixinInstance(validation):: __validationMixin(validation),\n              // OpenAPIV3Schema is the OpenAPI v3 schema to be validated against.\n              withOpenApiV3Schema(openApiV3Schema):: self + __validationMixin({openAPIV3Schema: openApiV3Schema}),\n              // OpenAPIV3Schema is the OpenAPI v3 schema to be validated against.\n              withOpenApiV3SchemaMixin(openApiV3Schema):: self + __validationMixin({openAPIV3Schema+: openApiV3Schema}),\n              openAPIV3SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n            },\n            validationType:: hidden.apiextensions.v1beta1.customResourceValidation,\n            // Version is the version this resource belongs in\n            withVersion(version):: self + __specMixin({version: version}),\n          },\n          specType:: hidden.apiextensions.v1beta1.customResourceDefinitionSpec,\n        },\n      },\n    },\n  },\n  apiregistration:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"apiregistration.k8s.io/v1\"},\n      // APIService represents a server for a particular GroupVersion. Name must be \"version.group\".\n      apiService:: {\n        local kind = {kind: \"APIService\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec contains information for locating and communicating with a server\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate.\n            withCaBundle(caBundle):: self + __specMixin({caBundle: caBundle}),\n            // Group is the API group name this server hosts\n            withGroup(group):: self + __specMixin({group: group}),\n            // GroupPriorityMininum is the priority this group should have at least. Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We'd recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s\n            withGroupPriorityMinimum(groupPriorityMinimum):: self + __specMixin({groupPriorityMinimum: groupPriorityMinimum}),\n            // InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. This is strongly discouraged.  You should use the CABundle instead.\n            withInsecureSkipTlsVerify(insecureSkipTlsVerify):: self + __specMixin({insecureSkipTLSVerify: insecureSkipTlsVerify}),\n            // Service is a reference to the service for this API server.  It must communicate on port 443 If the Service is nil, that means the handling for the API groupversion is handled locally on this server. The call will simply delegate to the normal handler chain to be fulfilled.\n            service:: {\n              local __serviceMixin(service) = __specMixin({service+: service}),\n              mixinInstance(service):: __serviceMixin(service),\n              // Name is the name of the service\n              withName(name):: self + __serviceMixin({name: name}),\n              // Namespace is the namespace of the service\n              withNamespace(namespace):: self + __serviceMixin({namespace: namespace}),\n            },\n            serviceType:: hidden.apiregistration.v1.serviceReference,\n            // Version is the API version this server hosts.  For example, \"v1\"\n            withVersion(version):: self + __specMixin({version: version}),\n            // VersionPriority controls the ordering of this API version inside of its group.  Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) Since it's inside of a group, the number can be small, probably in the 10s.\n            withVersionPriority(versionPriority):: self + __specMixin({versionPriority: versionPriority}),\n          },\n          specType:: hidden.apiregistration.v1.apiServiceSpec,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"apiregistration.k8s.io/v1beta1\"},\n      // APIService represents a server for a particular GroupVersion. Name must be \"version.group\".\n      apiService:: {\n        local kind = {kind: \"APIService\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec contains information for locating and communicating with a server\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate.\n            withCaBundle(caBundle):: self + __specMixin({caBundle: caBundle}),\n            // Group is the API group name this server hosts\n            withGroup(group):: self + __specMixin({group: group}),\n            // GroupPriorityMininum is the priority this group should have at least. Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We'd recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s\n            withGroupPriorityMinimum(groupPriorityMinimum):: self + __specMixin({groupPriorityMinimum: groupPriorityMinimum}),\n            // InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. This is strongly discouraged.  You should use the CABundle instead.\n            withInsecureSkipTlsVerify(insecureSkipTlsVerify):: self + __specMixin({insecureSkipTLSVerify: insecureSkipTlsVerify}),\n            // Service is a reference to the service for this API server.  It must communicate on port 443 If the Service is nil, that means the handling for the API groupversion is handled locally on this server. The call will simply delegate to the normal handler chain to be fulfilled.\n            service:: {\n              local __serviceMixin(service) = __specMixin({service+: service}),\n              mixinInstance(service):: __serviceMixin(service),\n              // Name is the name of the service\n              withName(name):: self + __serviceMixin({name: name}),\n              // Namespace is the namespace of the service\n              withNamespace(namespace):: self + __serviceMixin({namespace: namespace}),\n            },\n            serviceType:: hidden.apiregistration.v1beta1.serviceReference,\n            // Version is the API version this server hosts.  For example, \"v1\"\n            withVersion(version):: self + __specMixin({version: version}),\n            // VersionPriority controls the ordering of this API version inside of its group.  Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) Since it's inside of a group, the number can be small, probably in the 10s.\n            withVersionPriority(versionPriority):: self + __specMixin({versionPriority: versionPriority}),\n          },\n          specType:: hidden.apiregistration.v1beta1.apiServiceSpec,\n        },\n      },\n    },\n  },\n  apps:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"apps/v1\"},\n      // ControllerRevision implements an immutable snapshot of state data. Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.\n      controllerRevision:: {\n        local kind = {kind: \"ControllerRevision\"},\n        new():: apiVersion + kind,\n        // Revision indicates the revision of the state represented by Data.\n        withRevision(revision):: self + {revision: revision},\n        mixin:: {\n          // Data is the serialized representation of the state.\n          data:: {\n            local __dataMixin(data) = {data+: data},\n            mixinInstance(data):: __dataMixin(data),\n            // Raw is the underlying serialization of this object.\n            withRaw(raw):: self + __dataMixin({Raw: raw}),\n          },\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // DaemonSet represents the configuration of a daemon set.\n      daemonSet:: {\n        local kind = {kind: \"DaemonSet\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // The desired behavior of this daemon set. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // A label query over pods that are managed by the daemon set. Must match in order to be controlled. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // An object that describes the pod that will be created. The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // An update strategy to replace existing DaemonSet pods with new pods.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = __specMixin({updateStrategy+: updateStrategy}),\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // Rolling update config params. Present only if type = \"RollingUpdate\".\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1.rollingUpdateDaemonSet,\n              // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1.daemonSetUpdateStrategy,\n          },\n          specType:: hidden.apps.v1.daemonSetSpec,\n        },\n      },\n      // Deployment enables declarative updates for Pods and ReplicaSets.\n      deployment:: {\n        local kind = {kind: \"Deployment\"},\n        new(name=\"\", replicas=1, containers=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          // Standard object metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of the Deployment.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Indicates that the deployment is paused.\n            withPaused(paused):: self + __specMixin({paused: paused}),\n            // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.\n            withProgressDeadlineSeconds(progressDeadlineSeconds):: self + __specMixin({progressDeadlineSeconds: progressDeadlineSeconds}),\n            // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. It must match the pod template's labels.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = __specMixin({strategy+: strategy}),\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.apps.v1.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.apps.v1.deploymentSpec,\n        },\n      },\n      // ReplicaSet ensures that a specified number of pod replicas are running at any given time.\n      replicaSet:: {\n        local kind = {kind: \"ReplicaSet\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages. Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the specification of the desired behavior of the ReplicaSet. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // Selector is a label query over pods that should match the replica count. Label keys and values that must match in order to be controlled by this replica set. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.apps.v1.replicaSetSpec,\n        },\n      },\n      // StatefulSet represents a set of pods with consistent identities. Identities are defined as:\n      // - Network: A single stable DNS and hostname.\n      // - Storage: As many VolumeClaims as requested.\n      // The StatefulSet guarantees that a given network identity will always map to the same storage identity.\n      statefulSet:: {\n        local kind = {kind: \"StatefulSet\"},\n        new(name=\"\", replicas=1, containers=\"\", volumeClaims=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas).withVolumeClaimTemplates(volumeClaims) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the desired identities of pods in this set.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.\n            withPodManagementPolicy(podManagementPolicy):: self + __specMixin({podManagementPolicy: podManagementPolicy}),\n            // replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // selector is a label query over pods that should match the replica count. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where \"pod-specific-string\" is managed by the StatefulSet controller.\n            withServiceName(serviceName):: self + __specMixin({serviceName: serviceName}),\n            // template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = __specMixin({updateStrategy+: updateStrategy}),\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n                withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n              },\n              rollingUpdateType:: hidden.apps.v1.rollingUpdateStatefulSetStrategy,\n              // Type indicates the type of the StatefulSetUpdateStrategy. Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1.statefulSetUpdateStrategy,\n            // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n            withVolumeClaimTemplates(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then __specMixin({volumeClaimTemplates: volumeClaimTemplates}) else __specMixin({volumeClaimTemplates: [volumeClaimTemplates]}),\n            // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n            withVolumeClaimTemplatesMixin(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then __specMixin({volumeClaimTemplates+: volumeClaimTemplates}) else __specMixin({volumeClaimTemplates+: [volumeClaimTemplates]}),\n            volumeClaimTemplatesType:: hidden.core.v1.persistentVolumeClaim,\n          },\n          specType:: hidden.apps.v1.statefulSetSpec,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"apps/v1beta1\"},\n      // DEPRECATED - This group version of ControllerRevision is deprecated by apps/v1beta2/ControllerRevision. See the release notes for more information. ControllerRevision implements an immutable snapshot of state data. Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.\n      controllerRevision:: {\n        local kind = {kind: \"ControllerRevision\"},\n        new():: apiVersion + kind,\n        // Revision indicates the revision of the state represented by Data.\n        withRevision(revision):: self + {revision: revision},\n        mixin:: {\n          // Data is the serialized representation of the state.\n          data:: {\n            local __dataMixin(data) = {data+: data},\n            mixinInstance(data):: __dataMixin(data),\n            // Raw is the underlying serialization of this object.\n            withRaw(raw):: self + __dataMixin({Raw: raw}),\n          },\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // DEPRECATED - This group version of Deployment is deprecated by apps/v1beta2/Deployment. See the release notes for more information. Deployment enables declarative updates for Pods and ReplicaSets.\n      deployment:: {\n        local kind = {kind: \"Deployment\"},\n        new(name=\"\", replicas=1, containers=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          // Standard object metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of the Deployment.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Indicates that the deployment is paused.\n            withPaused(paused):: self + __specMixin({paused: paused}),\n            // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.\n            withProgressDeadlineSeconds(progressDeadlineSeconds):: self + __specMixin({progressDeadlineSeconds: progressDeadlineSeconds}),\n            // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 2.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // DEPRECATED. The config this deployment is rolling back to. Will be cleared after rollback is done.\n            rollbackTo:: {\n              local __rollbackToMixin(rollbackTo) = __specMixin({rollbackTo+: rollbackTo}),\n              mixinInstance(rollbackTo):: __rollbackToMixin(rollbackTo),\n              // The revision to rollback to. If set to 0, rollback to the last revision.\n              withRevision(revision):: self + __rollbackToMixin({revision: revision}),\n            },\n            rollbackToType:: hidden.apps.v1beta1.rollbackConfig,\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = __specMixin({strategy+: strategy}),\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta1.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.apps.v1beta1.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.apps.v1beta1.deploymentSpec,\n        },\n      },\n      // DEPRECATED. DeploymentRollback stores the information required to rollback a deployment.\n      deploymentRollback:: {\n        local kind = {kind: \"DeploymentRollback\"},\n        new(name=\"\"):: apiVersion + kind + self.withName(name),\n        // Required: This must match the Name of a deployment.\n        withName(name):: self + {name: name},\n        // The annotations to be updated to a deployment\n        withUpdatedAnnotations(updatedAnnotations):: self + {updatedAnnotations: updatedAnnotations},\n        // The annotations to be updated to a deployment\n        withUpdatedAnnotationsMixin(updatedAnnotations):: self + {updatedAnnotations+: updatedAnnotations},\n        mixin:: {\n          // The config of this deployment rollback.\n          rollbackTo:: {\n            local __rollbackToMixin(rollbackTo) = {rollbackTo+: rollbackTo},\n            mixinInstance(rollbackTo):: __rollbackToMixin(rollbackTo),\n            // The revision to rollback to. If set to 0, rollback to the last revision.\n            withRevision(revision):: self + __rollbackToMixin({revision: revision}),\n          },\n          rollbackToType:: hidden.apps.v1beta1.rollbackConfig,\n        },\n      },\n      // Scale represents a scaling request for a resource.\n      scale:: {\n        local kind = {kind: \"Scale\"},\n        new(replicas=1):: apiVersion + kind + self.mixin.spec.withReplicas(replicas),\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // defines the behavior of the scale. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // desired number of instances for the scaled object.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n          },\n          specType:: hidden.apps.v1beta1.scaleSpec,\n        },\n      },\n      // DEPRECATED - This group version of StatefulSet is deprecated by apps/v1beta2/StatefulSet. See the release notes for more information. StatefulSet represents a set of pods with consistent identities. Identities are defined as:\n      // - Network: A single stable DNS and hostname.\n      // - Storage: As many VolumeClaims as requested.\n      // The StatefulSet guarantees that a given network identity will always map to the same storage identity.\n      statefulSet:: {\n        local kind = {kind: \"StatefulSet\"},\n        new(name=\"\", replicas=1, containers=\"\", volumeClaims=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas).withVolumeClaimTemplates(volumeClaims) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the desired identities of pods in this set.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.\n            withPodManagementPolicy(podManagementPolicy):: self + __specMixin({podManagementPolicy: podManagementPolicy}),\n            // replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // selector is a label query over pods that should match the replica count. If empty, defaulted to labels on the pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where \"pod-specific-string\" is managed by the StatefulSet controller.\n            withServiceName(serviceName):: self + __specMixin({serviceName: serviceName}),\n            // template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = __specMixin({updateStrategy+: updateStrategy}),\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // Partition indicates the ordinal at which the StatefulSet should be partitioned.\n                withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta1.rollingUpdateStatefulSetStrategy,\n              // Type indicates the type of the StatefulSetUpdateStrategy.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1beta1.statefulSetUpdateStrategy,\n            // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n            withVolumeClaimTemplates(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then __specMixin({volumeClaimTemplates: volumeClaimTemplates}) else __specMixin({volumeClaimTemplates: [volumeClaimTemplates]}),\n            // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n            withVolumeClaimTemplatesMixin(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then __specMixin({volumeClaimTemplates+: volumeClaimTemplates}) else __specMixin({volumeClaimTemplates+: [volumeClaimTemplates]}),\n            volumeClaimTemplatesType:: hidden.core.v1.persistentVolumeClaim,\n          },\n          specType:: hidden.apps.v1beta1.statefulSetSpec,\n        },\n      },\n    },\n    v1beta2:: {\n      local apiVersion = {apiVersion: \"apps/v1beta2\"},\n      // DEPRECATED - This group version of ControllerRevision is deprecated by apps/v1/ControllerRevision. See the release notes for more information. ControllerRevision implements an immutable snapshot of state data. Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.\n      controllerRevision:: {\n        local kind = {kind: \"ControllerRevision\"},\n        new():: apiVersion + kind,\n        // Revision indicates the revision of the state represented by Data.\n        withRevision(revision):: self + {revision: revision},\n        mixin:: {\n          // Data is the serialized representation of the state.\n          data:: {\n            local __dataMixin(data) = {data+: data},\n            mixinInstance(data):: __dataMixin(data),\n            // Raw is the underlying serialization of this object.\n            withRaw(raw):: self + __dataMixin({Raw: raw}),\n          },\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // DEPRECATED - This group version of DaemonSet is deprecated by apps/v1/DaemonSet. See the release notes for more information. DaemonSet represents the configuration of a daemon set.\n      daemonSet:: {\n        local kind = {kind: \"DaemonSet\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // The desired behavior of this daemon set. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // A label query over pods that are managed by the daemon set. Must match in order to be controlled. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // An object that describes the pod that will be created. The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // An update strategy to replace existing DaemonSet pods with new pods.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = __specMixin({updateStrategy+: updateStrategy}),\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // Rolling update config params. Present only if type = \"RollingUpdate\".\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateDaemonSet,\n              // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1beta2.daemonSetUpdateStrategy,\n          },\n          specType:: hidden.apps.v1beta2.daemonSetSpec,\n        },\n      },\n      // DEPRECATED - This group version of Deployment is deprecated by apps/v1/Deployment. See the release notes for more information. Deployment enables declarative updates for Pods and ReplicaSets.\n      deployment:: {\n        local kind = {kind: \"Deployment\"},\n        new(name=\"\", replicas=1, containers=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          // Standard object metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of the Deployment.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Indicates that the deployment is paused.\n            withPaused(paused):: self + __specMixin({paused: paused}),\n            // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.\n            withProgressDeadlineSeconds(progressDeadlineSeconds):: self + __specMixin({progressDeadlineSeconds: progressDeadlineSeconds}),\n            // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. It must match the pod template's labels.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = __specMixin({strategy+: strategy}),\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.apps.v1beta2.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.apps.v1beta2.deploymentSpec,\n        },\n      },\n      // DEPRECATED - This group version of ReplicaSet is deprecated by apps/v1/ReplicaSet. See the release notes for more information. ReplicaSet ensures that a specified number of pod replicas are running at any given time.\n      replicaSet:: {\n        local kind = {kind: \"ReplicaSet\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages. Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the specification of the desired behavior of the ReplicaSet. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // Selector is a label query over pods that should match the replica count. Label keys and values that must match in order to be controlled by this replica set. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.apps.v1beta2.replicaSetSpec,\n        },\n      },\n      // Scale represents a scaling request for a resource.\n      scale:: {\n        local kind = {kind: \"Scale\"},\n        new(replicas=1):: apiVersion + kind + self.mixin.spec.withReplicas(replicas),\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // defines the behavior of the scale. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // desired number of instances for the scaled object.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n          },\n          specType:: hidden.apps.v1beta2.scaleSpec,\n        },\n      },\n      // DEPRECATED - This group version of StatefulSet is deprecated by apps/v1/StatefulSet. See the release notes for more information. StatefulSet represents a set of pods with consistent identities. Identities are defined as:\n      // - Network: A single stable DNS and hostname.\n      // - Storage: As many VolumeClaims as requested.\n      // The StatefulSet guarantees that a given network identity will always map to the same storage identity.\n      statefulSet:: {\n        local kind = {kind: \"StatefulSet\"},\n        new(name=\"\", replicas=1, containers=\"\", volumeClaims=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas).withVolumeClaimTemplates(volumeClaims) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the desired identities of pods in this set.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.\n            withPodManagementPolicy(podManagementPolicy):: self + __specMixin({podManagementPolicy: podManagementPolicy}),\n            // replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // selector is a label query over pods that should match the replica count. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where \"pod-specific-string\" is managed by the StatefulSet controller.\n            withServiceName(serviceName):: self + __specMixin({serviceName: serviceName}),\n            // template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = __specMixin({updateStrategy+: updateStrategy}),\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n                withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateStatefulSetStrategy,\n              // Type indicates the type of the StatefulSetUpdateStrategy. Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1beta2.statefulSetUpdateStrategy,\n            // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n            withVolumeClaimTemplates(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then __specMixin({volumeClaimTemplates: volumeClaimTemplates}) else __specMixin({volumeClaimTemplates: [volumeClaimTemplates]}),\n            // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n            withVolumeClaimTemplatesMixin(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then __specMixin({volumeClaimTemplates+: volumeClaimTemplates}) else __specMixin({volumeClaimTemplates+: [volumeClaimTemplates]}),\n            volumeClaimTemplatesType:: hidden.core.v1.persistentVolumeClaim,\n          },\n          specType:: hidden.apps.v1beta2.statefulSetSpec,\n        },\n      },\n    },\n  },\n  authentication:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"authentication.k8s.io/v1\"},\n      // TokenReview attempts to authenticate a token to a known user. Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.\n      tokenReview:: {\n        local kind = {kind: \"TokenReview\"},\n        new(token=\"\"):: apiVersion + kind + self.mixin.spec.withToken(token),\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Token is the opaque bearer token.\n            withToken(token):: self + __specMixin({token: token}),\n          },\n          specType:: hidden.authentication.v1.tokenReviewSpec,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"authentication.k8s.io/v1beta1\"},\n      // TokenReview attempts to authenticate a token to a known user. Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.\n      tokenReview:: {\n        local kind = {kind: \"TokenReview\"},\n        new(token=\"\"):: apiVersion + kind + self.mixin.spec.withToken(token),\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Token is the opaque bearer token.\n            withToken(token):: self + __specMixin({token: token}),\n          },\n          specType:: hidden.authentication.v1beta1.tokenReviewSpec,\n        },\n      },\n    },\n  },\n  authorization:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"authorization.k8s.io/v1\"},\n      // LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace. Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.\n      localSubjectAccessReview:: {\n        local kind = {kind: \"LocalSubjectAccessReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated.  spec.namespace must be equal to the namespace you made the request against.  If empty, it is defaulted.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtra(extra):: self + __specMixin({extra: extra}),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtraMixin(extra):: self + __specMixin({extra+: extra}),\n            // Groups is the groups you're testing for.\n            withGroups(groups):: self + if std.type(groups) == \"array\" then __specMixin({groups: groups}) else __specMixin({groups: [groups]}),\n            // Groups is the groups you're testing for.\n            withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then __specMixin({groups+: groups}) else __specMixin({groups+: [groups]}),\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = __specMixin({nonResourceAttributes+: nonResourceAttributes}),\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = __specMixin({resourceAttributes+: resourceAttributes}),\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1.resourceAttributes,\n            // UID information about the requesting user.\n            withUid(uid):: self + __specMixin({uid: uid}),\n            // User is the user you're testing for. If you specify \"User\" but not \"Groups\", then is it interpreted as \"What if User were not a member of any groups\n            withUser(user):: self + __specMixin({user: user}),\n          },\n          specType:: hidden.authorization.v1.subjectAccessReviewSpec,\n        },\n      },\n      // SelfSubjectAccessReview checks whether or the current user can perform an action.  Not filling in a spec.namespace means \"in all namespaces\".  Self is a special case, because users should always be able to check whether they can perform an action\n      selfSubjectAccessReview:: {\n        local kind = {kind: \"SelfSubjectAccessReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated.  user and groups must be empty\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = __specMixin({nonResourceAttributes+: nonResourceAttributes}),\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = __specMixin({resourceAttributes+: resourceAttributes}),\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1.resourceAttributes,\n          },\n          specType:: hidden.authorization.v1.selfSubjectAccessReviewSpec,\n        },\n      },\n      // SelfSubjectRulesReview enumerates the set of actions the current user can perform within a namespace. The returned list of actions may be incomplete depending on the server's authorization mode, and any errors experienced during the evaluation. SelfSubjectRulesReview should be used by UIs to show/hide actions, or to quickly let an end user reason about their permissions. It should NOT Be used by external systems to drive authorization decisions as this raises confused deputy, cache lifetime/revocation, and correctness concerns. SubjectAccessReview, and LocalAccessReview are the correct way to defer authorization decisions to the API server.\n      selfSubjectRulesReview:: {\n        local kind = {kind: \"SelfSubjectRulesReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Namespace to evaluate rules for. Required.\n            withNamespace(namespace):: self + __specMixin({namespace: namespace}),\n          },\n          specType:: hidden.authorization.v1.selfSubjectRulesReviewSpec,\n        },\n      },\n      // SubjectAccessReview checks whether or not a user or group can perform an action.\n      subjectAccessReview:: {\n        local kind = {kind: \"SubjectAccessReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtra(extra):: self + __specMixin({extra: extra}),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtraMixin(extra):: self + __specMixin({extra+: extra}),\n            // Groups is the groups you're testing for.\n            withGroups(groups):: self + if std.type(groups) == \"array\" then __specMixin({groups: groups}) else __specMixin({groups: [groups]}),\n            // Groups is the groups you're testing for.\n            withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then __specMixin({groups+: groups}) else __specMixin({groups+: [groups]}),\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = __specMixin({nonResourceAttributes+: nonResourceAttributes}),\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = __specMixin({resourceAttributes+: resourceAttributes}),\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1.resourceAttributes,\n            // UID information about the requesting user.\n            withUid(uid):: self + __specMixin({uid: uid}),\n            // User is the user you're testing for. If you specify \"User\" but not \"Groups\", then is it interpreted as \"What if User were not a member of any groups\n            withUser(user):: self + __specMixin({user: user}),\n          },\n          specType:: hidden.authorization.v1.subjectAccessReviewSpec,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"authorization.k8s.io/v1beta1\"},\n      // LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace. Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.\n      localSubjectAccessReview:: {\n        local kind = {kind: \"LocalSubjectAccessReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated.  spec.namespace must be equal to the namespace you made the request against.  If empty, it is defaulted.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtra(extra):: self + __specMixin({extra: extra}),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtraMixin(extra):: self + __specMixin({extra+: extra}),\n            // Groups is the groups you're testing for.\n            withGroup(group):: self + if std.type(group) == \"array\" then __specMixin({group: group}) else __specMixin({group: [group]}),\n            // Groups is the groups you're testing for.\n            withGroupMixin(group):: self + if std.type(group) == \"array\" then __specMixin({group+: group}) else __specMixin({group+: [group]}),\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = __specMixin({nonResourceAttributes+: nonResourceAttributes}),\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1beta1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = __specMixin({resourceAttributes+: resourceAttributes}),\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1beta1.resourceAttributes,\n            // UID information about the requesting user.\n            withUid(uid):: self + __specMixin({uid: uid}),\n            // User is the user you're testing for. If you specify \"User\" but not \"Group\", then is it interpreted as \"What if User were not a member of any groups\n            withUser(user):: self + __specMixin({user: user}),\n          },\n          specType:: hidden.authorization.v1beta1.subjectAccessReviewSpec,\n        },\n      },\n      // SelfSubjectAccessReview checks whether or the current user can perform an action.  Not filling in a spec.namespace means \"in all namespaces\".  Self is a special case, because users should always be able to check whether they can perform an action\n      selfSubjectAccessReview:: {\n        local kind = {kind: \"SelfSubjectAccessReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated.  user and groups must be empty\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = __specMixin({nonResourceAttributes+: nonResourceAttributes}),\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1beta1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = __specMixin({resourceAttributes+: resourceAttributes}),\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1beta1.resourceAttributes,\n          },\n          specType:: hidden.authorization.v1beta1.selfSubjectAccessReviewSpec,\n        },\n      },\n      // SelfSubjectRulesReview enumerates the set of actions the current user can perform within a namespace. The returned list of actions may be incomplete depending on the server's authorization mode, and any errors experienced during the evaluation. SelfSubjectRulesReview should be used by UIs to show/hide actions, or to quickly let an end user reason about their permissions. It should NOT Be used by external systems to drive authorization decisions as this raises confused deputy, cache lifetime/revocation, and correctness concerns. SubjectAccessReview, and LocalAccessReview are the correct way to defer authorization decisions to the API server.\n      selfSubjectRulesReview:: {\n        local kind = {kind: \"SelfSubjectRulesReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Namespace to evaluate rules for. Required.\n            withNamespace(namespace):: self + __specMixin({namespace: namespace}),\n          },\n          specType:: hidden.authorization.v1beta1.selfSubjectRulesReviewSpec,\n        },\n      },\n      // SubjectAccessReview checks whether or not a user or group can perform an action.\n      subjectAccessReview:: {\n        local kind = {kind: \"SubjectAccessReview\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec holds information about the request being evaluated\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtra(extra):: self + __specMixin({extra: extra}),\n            // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n            withExtraMixin(extra):: self + __specMixin({extra+: extra}),\n            // Groups is the groups you're testing for.\n            withGroup(group):: self + if std.type(group) == \"array\" then __specMixin({group: group}) else __specMixin({group: [group]}),\n            // Groups is the groups you're testing for.\n            withGroupMixin(group):: self + if std.type(group) == \"array\" then __specMixin({group+: group}) else __specMixin({group+: [group]}),\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = __specMixin({nonResourceAttributes+: nonResourceAttributes}),\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1beta1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = __specMixin({resourceAttributes+: resourceAttributes}),\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1beta1.resourceAttributes,\n            // UID information about the requesting user.\n            withUid(uid):: self + __specMixin({uid: uid}),\n            // User is the user you're testing for. If you specify \"User\" but not \"Group\", then is it interpreted as \"What if User were not a member of any groups\n            withUser(user):: self + __specMixin({user: user}),\n          },\n          specType:: hidden.authorization.v1beta1.subjectAccessReviewSpec,\n        },\n      },\n    },\n  },\n  autoscaling:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"autoscaling/v1\"},\n      // configuration of a horizontal pod autoscaler.\n      horizontalPodAutoscaler:: {\n        local kind = {kind: \"HorizontalPodAutoscaler\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // behaviour of autoscaler. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // upper limit for the number of pods that can be set by the autoscaler; cannot be smaller than MinReplicas.\n            withMaxReplicas(maxReplicas):: self + __specMixin({maxReplicas: maxReplicas}),\n            // lower limit for the number of pods that can be set by the autoscaler, default 1.\n            withMinReplicas(minReplicas):: self + __specMixin({minReplicas: minReplicas}),\n            // reference to scaled resource; horizontal pod autoscaler will learn the current resource consumption and will set the desired number of pods by using its Scale subresource.\n            scaleTargetRef:: {\n              local __scaleTargetRefMixin(scaleTargetRef) = __specMixin({scaleTargetRef+: scaleTargetRef}),\n              mixinInstance(scaleTargetRef):: __scaleTargetRefMixin(scaleTargetRef),\n              // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n              withKind(kind):: self + __scaleTargetRefMixin({kind: kind}),\n              // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __scaleTargetRefMixin({name: name}),\n            },\n            scaleTargetRefType:: hidden.autoscaling.v1.crossVersionObjectReference,\n            // target average CPU utilization (represented as a percentage of requested CPU) over all the pods; if not specified the default autoscaling policy will be used.\n            withTargetCpuUtilizationPercentage(targetCpuUtilizationPercentage):: self + __specMixin({targetCPUUtilizationPercentage: targetCpuUtilizationPercentage}),\n          },\n          specType:: hidden.autoscaling.v1.horizontalPodAutoscalerSpec,\n        },\n      },\n      // Scale represents a scaling request for a resource.\n      scale:: {\n        local kind = {kind: \"Scale\"},\n        new(replicas=1):: apiVersion + kind + self.mixin.spec.withReplicas(replicas),\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // defines the behavior of the scale. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // desired number of instances for the scaled object.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n          },\n          specType:: hidden.autoscaling.v1.scaleSpec,\n        },\n      },\n    },\n    v2beta1:: {\n      local apiVersion = {apiVersion: \"autoscaling/v2beta1\"},\n      // HorizontalPodAutoscaler is the configuration for a horizontal pod autoscaler, which automatically manages the replica count of any resource implementing the scale subresource based on the metrics specified.\n      horizontalPodAutoscaler:: {\n        local kind = {kind: \"HorizontalPodAutoscaler\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // metadata is the standard object metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // spec is the specification for the behaviour of the autoscaler. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up. It cannot be less that minReplicas.\n            withMaxReplicas(maxReplicas):: self + __specMixin({maxReplicas: maxReplicas}),\n            // metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).  The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond.\n            withMetrics(metrics):: self + if std.type(metrics) == \"array\" then __specMixin({metrics: metrics}) else __specMixin({metrics: [metrics]}),\n            // metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).  The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond.\n            withMetricsMixin(metrics):: self + if std.type(metrics) == \"array\" then __specMixin({metrics+: metrics}) else __specMixin({metrics+: [metrics]}),\n            metricsType:: hidden.autoscaling.v2beta1.metricSpec,\n            // minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down. It defaults to 1 pod.\n            withMinReplicas(minReplicas):: self + __specMixin({minReplicas: minReplicas}),\n            // scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count.\n            scaleTargetRef:: {\n              local __scaleTargetRefMixin(scaleTargetRef) = __specMixin({scaleTargetRef+: scaleTargetRef}),\n              mixinInstance(scaleTargetRef):: __scaleTargetRefMixin(scaleTargetRef),\n              // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n              withKind(kind):: self + __scaleTargetRefMixin({kind: kind}),\n              // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __scaleTargetRefMixin({name: name}),\n            },\n            scaleTargetRefType:: hidden.autoscaling.v2beta1.crossVersionObjectReference,\n          },\n          specType:: hidden.autoscaling.v2beta1.horizontalPodAutoscalerSpec,\n        },\n      },\n    },\n  },\n  batch:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"batch/v1\"},\n      // Job represents the configuration of a single job.\n      job:: {\n        local kind = {kind: \"Job\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of a job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n            withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n            // Specifies the number of retries before marking this job failed. Defaults to 6\n            withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n            // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n            withCompletions(completions):: self + __specMixin({completions: completions}),\n            // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n            withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n            // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n            withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n            // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.batch.v1.jobSpec,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"batch/v1beta1\"},\n      // CronJob represents the configuration of a single cron job.\n      cronJob:: {\n        local kind = {kind: \"CronJob\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of a cron job, including the schedule. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Specifies how to treat concurrent executions of a Job. Valid values are: - \"Allow\" (default): allows CronJobs to run concurrently; - \"Forbid\": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - \"Replace\": cancels currently running job and replaces it with a new one\n            withConcurrencyPolicy(concurrencyPolicy):: self + __specMixin({concurrencyPolicy: concurrencyPolicy}),\n            // The number of failed finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n            withFailedJobsHistoryLimit(failedJobsHistoryLimit):: self + __specMixin({failedJobsHistoryLimit: failedJobsHistoryLimit}),\n            // Specifies the job that will be created when executing a CronJob.\n            jobTemplate:: {\n              local __jobTemplateMixin(jobTemplate) = __specMixin({jobTemplate+: jobTemplate}),\n              mixinInstance(jobTemplate):: __jobTemplateMixin(jobTemplate),\n              // Standard object's metadata of the jobs created from this template. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __jobTemplateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __jobTemplateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // Specifies the number of retries before marking this job failed. Defaults to 6\n                withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n                // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withCompletions(completions):: self + __specMixin({completions: completions}),\n                // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n                withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n                // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n                // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n                selector:: {\n                  local __selectorMixin(selector) = __specMixin({selector+: selector}),\n                  mixinInstance(selector):: __selectorMixin(selector),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n                  matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n                },\n                selectorType:: hidden.meta.v1.labelSelector,\n                // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                template:: {\n                  local __templateMixin(template) = __specMixin({template+: template}),\n                  mixinInstance(template):: __templateMixin(template),\n                  // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n                  metadata:: {\n                    local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                    mixinInstance(metadata):: __metadataMixin(metadata),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                    // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                    withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                    // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                    //\n                    // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                    //\n                    // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                    withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                    // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                    //\n                    // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                    initializers:: {\n                      local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                      mixinInstance(initializers):: __initializersMixin(initializers),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                      pendingType:: hidden.meta.v1.initializer,\n                    },\n                    initializersType:: hidden.meta.v1.initializers,\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabels(labels):: self + __metadataMixin({labels: labels}),\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                    // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                    withName(name):: self + __metadataMixin({name: name}),\n                    // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                    //\n                    // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                    withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                    ownerReferencesType:: hidden.meta.v1.ownerReference,\n                  },\n                  metadataType:: hidden.meta.v1.objectMeta,\n                  // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n                  spec:: {\n                    local __specMixin(spec) = __templateMixin({spec+: spec}),\n                    mixinInstance(spec):: __specMixin(spec),\n                    // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                    withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                    // If specified, the pod's scheduling constraints\n                    affinity:: {\n                      local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                      mixinInstance(affinity):: __affinityMixin(affinity),\n                      // Describes node affinity scheduling rules for the pod.\n                      nodeAffinity:: {\n                        local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                        mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                        requiredDuringSchedulingIgnoredDuringExecution:: {\n                          local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                          mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                          nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                        },\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                      },\n                      nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                      // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                      podAffinity:: {\n                        local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                        mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAffinityType:: hidden.core.v1.podAffinity,\n                      // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                      podAntiAffinity:: {\n                        local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                        mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                    },\n                    affinityType:: hidden.core.v1.affinity,\n                    // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                    withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                    containersType:: hidden.core.v1.container,\n                    // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                    dnsConfig:: {\n                      local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                      mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                      optionsType:: hidden.core.v1.podDnsConfigOption,\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                    },\n                    dnsConfigType:: hidden.core.v1.podDnsConfig,\n                    // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                    withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                    hostAliasesType:: hidden.core.v1.hostAlias,\n                    // Use the host's ipc namespace. Optional: Default to false.\n                    withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                    // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                    withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                    // Use the host's pid namespace. Optional: Default to false.\n                    withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                    // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                    withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                    imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                    initContainersType:: hidden.core.v1.container,\n                    // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                    withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                    // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                    withPriority(priority):: self + __specMixin({priority: priority}),\n                    // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                    withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                    // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                    withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                    // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                    withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                    // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                    securityContext:: {\n                      local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                      mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                      // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                      //\n                      // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                      //\n                      // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                      withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                      // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                      // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                      withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                      // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                      // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      seLinuxOptions:: {\n                        local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                        mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                        // Level is SELinux level label that applies to the container.\n                        withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                        // Role is a SELinux role label that applies to the container.\n                        withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                        // Type is a SELinux type label that applies to the container.\n                        withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                        // User is a SELinux user label that applies to the container.\n                        withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                      },\n                      seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                    },\n                    securityContextType:: hidden.core.v1.podSecurityContext,\n                    // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                    withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                    // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                    withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                    // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                    withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                    // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                    withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                    // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                    withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                    // If specified, the pod's tolerations.\n                    withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                    // If specified, the pod's tolerations.\n                    withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                    tolerationsType:: hidden.core.v1.toleration,\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                    volumesType:: hidden.core.v1.volume,\n                  },\n                  specType:: hidden.core.v1.podSpec,\n                },\n                templateType:: hidden.core.v1.podTemplateSpec,\n              },\n              specType:: hidden.batch.v1.jobSpec,\n            },\n            jobTemplateType:: hidden.batch.v1beta1.jobTemplateSpec,\n            // The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.\n            withSchedule(schedule):: self + __specMixin({schedule: schedule}),\n            // Optional deadline in seconds for starting the job if it misses scheduled time for any reason.  Missed jobs executions will be counted as failed ones.\n            withStartingDeadlineSeconds(startingDeadlineSeconds):: self + __specMixin({startingDeadlineSeconds: startingDeadlineSeconds}),\n            // The number of successful finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified. Defaults to 3.\n            withSuccessfulJobsHistoryLimit(successfulJobsHistoryLimit):: self + __specMixin({successfulJobsHistoryLimit: successfulJobsHistoryLimit}),\n            // This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.  Defaults to false.\n            withSuspend(suspend):: self + __specMixin({suspend: suspend}),\n          },\n          specType:: hidden.batch.v1beta1.cronJobSpec,\n        },\n      },\n    },\n    v2alpha1:: {\n      local apiVersion = {apiVersion: \"batch/v2alpha1\"},\n      // CronJob represents the configuration of a single cron job.\n      cronJob:: {\n        local kind = {kind: \"CronJob\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of a cron job, including the schedule. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Specifies how to treat concurrent executions of a Job. Valid values are: - \"Allow\" (default): allows CronJobs to run concurrently; - \"Forbid\": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - \"Replace\": cancels currently running job and replaces it with a new one\n            withConcurrencyPolicy(concurrencyPolicy):: self + __specMixin({concurrencyPolicy: concurrencyPolicy}),\n            // The number of failed finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified.\n            withFailedJobsHistoryLimit(failedJobsHistoryLimit):: self + __specMixin({failedJobsHistoryLimit: failedJobsHistoryLimit}),\n            // Specifies the job that will be created when executing a CronJob.\n            jobTemplate:: {\n              local __jobTemplateMixin(jobTemplate) = __specMixin({jobTemplate+: jobTemplate}),\n              mixinInstance(jobTemplate):: __jobTemplateMixin(jobTemplate),\n              // Standard object's metadata of the jobs created from this template. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __jobTemplateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __jobTemplateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // Specifies the number of retries before marking this job failed. Defaults to 6\n                withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n                // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withCompletions(completions):: self + __specMixin({completions: completions}),\n                // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n                withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n                // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n                // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n                selector:: {\n                  local __selectorMixin(selector) = __specMixin({selector+: selector}),\n                  mixinInstance(selector):: __selectorMixin(selector),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n                  matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n                },\n                selectorType:: hidden.meta.v1.labelSelector,\n                // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                template:: {\n                  local __templateMixin(template) = __specMixin({template+: template}),\n                  mixinInstance(template):: __templateMixin(template),\n                  // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n                  metadata:: {\n                    local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                    mixinInstance(metadata):: __metadataMixin(metadata),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                    // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                    withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                    // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                    //\n                    // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                    //\n                    // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                    withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                    // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                    //\n                    // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                    initializers:: {\n                      local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                      mixinInstance(initializers):: __initializersMixin(initializers),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                      pendingType:: hidden.meta.v1.initializer,\n                    },\n                    initializersType:: hidden.meta.v1.initializers,\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabels(labels):: self + __metadataMixin({labels: labels}),\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                    // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                    withName(name):: self + __metadataMixin({name: name}),\n                    // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                    //\n                    // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                    withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                    ownerReferencesType:: hidden.meta.v1.ownerReference,\n                  },\n                  metadataType:: hidden.meta.v1.objectMeta,\n                  // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n                  spec:: {\n                    local __specMixin(spec) = __templateMixin({spec+: spec}),\n                    mixinInstance(spec):: __specMixin(spec),\n                    // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                    withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                    // If specified, the pod's scheduling constraints\n                    affinity:: {\n                      local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                      mixinInstance(affinity):: __affinityMixin(affinity),\n                      // Describes node affinity scheduling rules for the pod.\n                      nodeAffinity:: {\n                        local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                        mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                        requiredDuringSchedulingIgnoredDuringExecution:: {\n                          local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                          mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                          nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                        },\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                      },\n                      nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                      // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                      podAffinity:: {\n                        local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                        mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAffinityType:: hidden.core.v1.podAffinity,\n                      // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                      podAntiAffinity:: {\n                        local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                        mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                    },\n                    affinityType:: hidden.core.v1.affinity,\n                    // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                    withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                    containersType:: hidden.core.v1.container,\n                    // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                    dnsConfig:: {\n                      local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                      mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                      optionsType:: hidden.core.v1.podDnsConfigOption,\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                    },\n                    dnsConfigType:: hidden.core.v1.podDnsConfig,\n                    // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                    withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                    hostAliasesType:: hidden.core.v1.hostAlias,\n                    // Use the host's ipc namespace. Optional: Default to false.\n                    withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                    // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                    withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                    // Use the host's pid namespace. Optional: Default to false.\n                    withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                    // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                    withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                    imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                    initContainersType:: hidden.core.v1.container,\n                    // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                    withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                    // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                    withPriority(priority):: self + __specMixin({priority: priority}),\n                    // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                    withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                    // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                    withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                    // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                    withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                    // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                    securityContext:: {\n                      local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                      mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                      // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                      //\n                      // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                      //\n                      // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                      withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                      // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                      // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                      withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                      // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                      // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      seLinuxOptions:: {\n                        local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                        mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                        // Level is SELinux level label that applies to the container.\n                        withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                        // Role is a SELinux role label that applies to the container.\n                        withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                        // Type is a SELinux type label that applies to the container.\n                        withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                        // User is a SELinux user label that applies to the container.\n                        withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                      },\n                      seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                    },\n                    securityContextType:: hidden.core.v1.podSecurityContext,\n                    // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                    withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                    // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                    withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                    // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                    withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                    // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                    withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                    // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                    withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                    // If specified, the pod's tolerations.\n                    withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                    // If specified, the pod's tolerations.\n                    withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                    tolerationsType:: hidden.core.v1.toleration,\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                    volumesType:: hidden.core.v1.volume,\n                  },\n                  specType:: hidden.core.v1.podSpec,\n                },\n                templateType:: hidden.core.v1.podTemplateSpec,\n              },\n              specType:: hidden.batch.v1.jobSpec,\n            },\n            jobTemplateType:: hidden.batch.v2alpha1.jobTemplateSpec,\n            // The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.\n            withSchedule(schedule):: self + __specMixin({schedule: schedule}),\n            // Optional deadline in seconds for starting the job if it misses scheduled time for any reason.  Missed jobs executions will be counted as failed ones.\n            withStartingDeadlineSeconds(startingDeadlineSeconds):: self + __specMixin({startingDeadlineSeconds: startingDeadlineSeconds}),\n            // The number of successful finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified.\n            withSuccessfulJobsHistoryLimit(successfulJobsHistoryLimit):: self + __specMixin({successfulJobsHistoryLimit: successfulJobsHistoryLimit}),\n            // This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.  Defaults to false.\n            withSuspend(suspend):: self + __specMixin({suspend: suspend}),\n          },\n          specType:: hidden.batch.v2alpha1.cronJobSpec,\n        },\n      },\n    },\n  },\n  certificates:: {\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"certificates.k8s.io/v1beta1\"},\n      // Describes a certificate signing request\n      certificateSigningRequest:: {\n        local kind = {kind: \"CertificateSigningRequest\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // The certificate request itself and any additional information.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Extra information about the requesting user. See user.Info interface for details.\n            withExtra(extra):: self + __specMixin({extra: extra}),\n            // Extra information about the requesting user. See user.Info interface for details.\n            withExtraMixin(extra):: self + __specMixin({extra+: extra}),\n            // Group information about the requesting user. See user.Info interface for details.\n            withGroups(groups):: self + if std.type(groups) == \"array\" then __specMixin({groups: groups}) else __specMixin({groups: [groups]}),\n            // Group information about the requesting user. See user.Info interface for details.\n            withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then __specMixin({groups+: groups}) else __specMixin({groups+: [groups]}),\n            // Base64-encoded PKCS#10 CSR data\n            withRequest(request):: self + __specMixin({request: request}),\n            // UID information about the requesting user. See user.Info interface for details.\n            withUid(uid):: self + __specMixin({uid: uid}),\n            // allowedUsages specifies a set of usage contexts the key will be valid for. See: https://tools.ietf.org/html/rfc5280#section-4.2.1.3\n            // https://tools.ietf.org/html/rfc5280#section-4.2.1.12\n            withUsages(usages):: self + if std.type(usages) == \"array\" then __specMixin({usages: usages}) else __specMixin({usages: [usages]}),\n            // allowedUsages specifies a set of usage contexts the key will be valid for. See: https://tools.ietf.org/html/rfc5280#section-4.2.1.3\n            // https://tools.ietf.org/html/rfc5280#section-4.2.1.12\n            withUsagesMixin(usages):: self + if std.type(usages) == \"array\" then __specMixin({usages+: usages}) else __specMixin({usages+: [usages]}),\n            // Information about the requesting user. See user.Info interface for details.\n            withUsername(username):: self + __specMixin({username: username}),\n          },\n          specType:: hidden.certificates.v1beta1.certificateSigningRequestSpec,\n        },\n      },\n    },\n  },\n  core:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"v1\"},\n      // Binding ties one object to another; for example, a pod is bound to a node by a scheduler. Deprecated in 1.7, please use the bindings subresource of pods instead.\n      binding:: {\n        local kind = {kind: \"Binding\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // The target object that you want to bind to the standard object.\n          target:: {\n            local __targetMixin(target) = {target+: target},\n            mixinInstance(target):: __targetMixin(target),\n            // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n            withFieldPath(fieldPath):: self + __targetMixin({fieldPath: fieldPath}),\n            // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n            withName(name):: self + __targetMixin({name: name}),\n            // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n            withNamespace(namespace):: self + __targetMixin({namespace: namespace}),\n            // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n            withResourceVersion(resourceVersion):: self + __targetMixin({resourceVersion: resourceVersion}),\n            // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n            withUid(uid):: self + __targetMixin({uid: uid}),\n          },\n          targetType:: hidden.core.v1.objectReference,\n        },\n      },\n      // ConfigMap holds configuration data for pods to consume.\n      configMap:: {\n        local kind = {kind: \"ConfigMap\"},\n        new(name=\"\"):: apiVersion + kind + self.mixin.metadata.withName(name),\n        // BinaryData contains the binary data. Each key must consist of alphanumeric characters, '-', '_' or '.'. BinaryData can contain byte sequences that are not in the UTF-8 range. The keys stored in BinaryData must not overlap with the ones in the Data field, this is enforced during validation process. Using this field will require 1.10+ apiserver and kubelet.\n        withBinaryData(binaryData):: self + {binaryData: binaryData},\n        // BinaryData contains the binary data. Each key must consist of alphanumeric characters, '-', '_' or '.'. BinaryData can contain byte sequences that are not in the UTF-8 range. The keys stored in BinaryData must not overlap with the ones in the Data field, this is enforced during validation process. Using this field will require 1.10+ apiserver and kubelet.\n        withBinaryDataMixin(binaryData):: self + {binaryData+: binaryData},\n        // Data contains the configuration data. Each key must consist of alphanumeric characters, '-', '_' or '.'. Values with non-UTF-8 byte sequences must use the BinaryData field. The keys stored in Data must not overlap with the keys in the BinaryData field, this is enforced during validation process.\n        withData(data):: self + {data: data},\n        // Data contains the configuration data. Each key must consist of alphanumeric characters, '-', '_' or '.'. Values with non-UTF-8 byte sequences must use the BinaryData field. The keys stored in Data must not overlap with the keys in the BinaryData field, this is enforced during validation process.\n        withDataMixin(data):: self + {data+: data},\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // Endpoints is a collection of endpoints that implement the actual service. Example:\n      // Name: \"mysvc\",\n      // Subsets: [\n      // {\n      // Addresses: [{\"ip\": \"10.10.1.1\"}, {\"ip\": \"10.10.2.2\"}],\n      // Ports: [{\"name\": \"a\", \"port\": 8675}, {\"name\": \"b\", \"port\": 309}]\n      // },\n      // {\n      // Addresses: [{\"ip\": \"10.10.3.3\"}],\n      // Ports: [{\"name\": \"a\", \"port\": 93}, {\"name\": \"b\", \"port\": 76}]\n      // },\n      // ]\n      endpoints:: {\n        local kind = {kind: \"Endpoints\"},\n        new():: apiVersion + kind,\n        // The set of all endpoints is the union of all subsets. Addresses are placed into subsets according to the IPs they share. A single address with multiple ports, some of which are ready and some of which are not (because they come from different containers) will result in the address being displayed in different subsets for the different ports. No address will appear in both Addresses and NotReadyAddresses in the same subset. Sets of addresses and ports that comprise a service.\n        withSubsets(subsets):: self + if std.type(subsets) == \"array\" then {subsets: subsets} else {subsets: [subsets]},\n        // The set of all endpoints is the union of all subsets. Addresses are placed into subsets according to the IPs they share. A single address with multiple ports, some of which are ready and some of which are not (because they come from different containers) will result in the address being displayed in different subsets for the different ports. No address will appear in both Addresses and NotReadyAddresses in the same subset. Sets of addresses and ports that comprise a service.\n        withSubsetsMixin(subsets):: self + if std.type(subsets) == \"array\" then {subsets+: subsets} else {subsets+: [subsets]},\n        subsetsType:: hidden.core.v1.endpointSubset,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // Event is a report of an event somewhere in the cluster.\n      event:: {\n        local kind = {kind: \"Event\"},\n        new():: apiVersion + kind,\n        // What action was taken/failed regarding to the Regarding object.\n        withAction(action):: self + {action: action},\n        // The number of times this event has occurred.\n        withCount(count):: self + {count: count},\n        // Time when this Event was first observed.\n        withEventTime(eventTime):: self + {eventTime: eventTime},\n        // The time at which the event was first recorded. (Time of server receipt is in TypeMeta.)\n        withFirstTimestamp(firstTimestamp):: self + {firstTimestamp: firstTimestamp},\n        // The time at which the most recent occurrence of this event was recorded.\n        withLastTimestamp(lastTimestamp):: self + {lastTimestamp: lastTimestamp},\n        // A human-readable description of the status of this operation.\n        withMessage(message):: self + {message: message},\n        // This should be a short, machine understandable string that gives the reason for the transition into the object's current status.\n        withReason(reason):: self + {reason: reason},\n        // Name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`.\n        withReportingComponent(reportingComponent):: self + {reportingComponent: reportingComponent},\n        // ID of the controller instance, e.g. `kubelet-xyzf`.\n        withReportingInstance(reportingInstance):: self + {reportingInstance: reportingInstance},\n        // Type of this event (Normal, Warning), new types could be added in the future\n        withType(type):: self + {type: type},\n        mixin:: {\n          // The object that this event is about.\n          involvedObject:: {\n            local __involvedObjectMixin(involvedObject) = {involvedObject+: involvedObject},\n            mixinInstance(involvedObject):: __involvedObjectMixin(involvedObject),\n            // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n            withFieldPath(fieldPath):: self + __involvedObjectMixin({fieldPath: fieldPath}),\n            // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n            withName(name):: self + __involvedObjectMixin({name: name}),\n            // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n            withNamespace(namespace):: self + __involvedObjectMixin({namespace: namespace}),\n            // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n            withResourceVersion(resourceVersion):: self + __involvedObjectMixin({resourceVersion: resourceVersion}),\n            // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n            withUid(uid):: self + __involvedObjectMixin({uid: uid}),\n          },\n          involvedObjectType:: hidden.core.v1.objectReference,\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Optional secondary object for more complex actions.\n          related:: {\n            local __relatedMixin(related) = {related+: related},\n            mixinInstance(related):: __relatedMixin(related),\n            // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n            withFieldPath(fieldPath):: self + __relatedMixin({fieldPath: fieldPath}),\n            // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n            withName(name):: self + __relatedMixin({name: name}),\n            // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n            withNamespace(namespace):: self + __relatedMixin({namespace: namespace}),\n            // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n            withResourceVersion(resourceVersion):: self + __relatedMixin({resourceVersion: resourceVersion}),\n            // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n            withUid(uid):: self + __relatedMixin({uid: uid}),\n          },\n          relatedType:: hidden.core.v1.objectReference,\n          // Data about the Event series this event represents or nil if it's a singleton Event.\n          series:: {\n            local __seriesMixin(series) = {series+: series},\n            mixinInstance(series):: __seriesMixin(series),\n            // Number of occurrences in this series up to the last heartbeat time\n            withCount(count):: self + __seriesMixin({count: count}),\n            // Time of the last occurrence observed\n            withLastObservedTime(lastObservedTime):: self + __seriesMixin({lastObservedTime: lastObservedTime}),\n            // State of this Series: Ongoing or Finished\n            withState(state):: self + __seriesMixin({state: state}),\n          },\n          seriesType:: hidden.core.v1.eventSeries,\n          // The component reporting this event. Should be a short machine understandable string.\n          source:: {\n            local __sourceMixin(source) = {source+: source},\n            mixinInstance(source):: __sourceMixin(source),\n            // Component from which the event is generated.\n            withComponent(component):: self + __sourceMixin({component: component}),\n            // Node name on which the event is generated.\n            withHost(host):: self + __sourceMixin({host: host}),\n          },\n          sourceType:: hidden.core.v1.eventSource,\n        },\n      },\n      // LimitRange sets resource usage limits for each kind of resource in a Namespace.\n      limitRange:: {\n        local kind = {kind: \"LimitRange\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the limits enforced. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Limits is the list of LimitRangeItem objects that are enforced.\n            withLimits(limits):: self + if std.type(limits) == \"array\" then __specMixin({limits: limits}) else __specMixin({limits: [limits]}),\n            // Limits is the list of LimitRangeItem objects that are enforced.\n            withLimitsMixin(limits):: self + if std.type(limits) == \"array\" then __specMixin({limits+: limits}) else __specMixin({limits+: [limits]}),\n            limitsType:: hidden.core.v1.limitRangeItem,\n          },\n          specType:: hidden.core.v1.limitRangeSpec,\n        },\n      },\n      // Namespace provides a scope for Names. Use of multiple namespaces is optional.\n      namespace:: {\n        local kind = {kind: \"Namespace\"},\n        new(name=\"\"):: apiVersion + kind + self.withName(name),\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the behavior of the Namespace. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Finalizers is an opaque list of values that must be empty to permanently remove object from storage. More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __specMixin({finalizers: finalizers}) else __specMixin({finalizers: [finalizers]}),\n            // Finalizers is an opaque list of values that must be empty to permanently remove object from storage. More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __specMixin({finalizers+: finalizers}) else __specMixin({finalizers+: [finalizers]}),\n          },\n          specType:: hidden.core.v1.namespaceSpec,\n        },\n      },\n      // Node is a worker node in Kubernetes. Each node will have a unique identifier in the cache (i.e. in etcd).\n      node:: {\n        local kind = {kind: \"Node\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the behavior of a node. https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // If specified, the source to get node configuration from The DynamicKubeletConfig feature gate must be enabled for the Kubelet to use this field\n            configSource:: {\n              local __configSourceMixin(configSource) = __specMixin({configSource+: configSource}),\n              mixinInstance(configSource):: __configSourceMixin(configSource),\n              configMapRef:: {\n                local __configMapRefMixin(configMapRef) = __configSourceMixin({configMapRef+: configMapRef}),\n                mixinInstance(configMapRef):: __configMapRefMixin(configMapRef),\n                // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n                withFieldPath(fieldPath):: self + __configMapRefMixin({fieldPath: fieldPath}),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __configMapRefMixin({name: name}),\n                // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n                withNamespace(namespace):: self + __configMapRefMixin({namespace: namespace}),\n                // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n                withResourceVersion(resourceVersion):: self + __configMapRefMixin({resourceVersion: resourceVersion}),\n                // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n                withUid(uid):: self + __configMapRefMixin({uid: uid}),\n              },\n              configMapRefType:: hidden.core.v1.objectReference,\n            },\n            configSourceType:: hidden.core.v1.nodeConfigSource,\n            // External ID of the node assigned by some machine database (e.g. a cloud provider). Deprecated.\n            withExternalId(externalId):: self + __specMixin({externalID: externalId}),\n            // PodCIDR represents the pod IP range assigned to the node.\n            withPodCidr(podCidr):: self + __specMixin({podCIDR: podCidr}),\n            // ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>\n            withProviderId(providerId):: self + __specMixin({providerID: providerId}),\n            // If specified, the node's taints.\n            withTaints(taints):: self + if std.type(taints) == \"array\" then __specMixin({taints: taints}) else __specMixin({taints: [taints]}),\n            // If specified, the node's taints.\n            withTaintsMixin(taints):: self + if std.type(taints) == \"array\" then __specMixin({taints+: taints}) else __specMixin({taints+: [taints]}),\n            taintsType:: hidden.core.v1.taint,\n            // Unschedulable controls node schedulability of new pods. By default, node is schedulable. More info: https://kubernetes.io/docs/concepts/nodes/node/#manual-node-administration\n            withUnschedulable(unschedulable):: self + __specMixin({unschedulable: unschedulable}),\n          },\n          specType:: hidden.core.v1.nodeSpec,\n        },\n      },\n      // PersistentVolume (PV) is a storage resource provisioned by an administrator. It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes\n      persistentVolume:: {\n        local kind = {kind: \"PersistentVolume\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines a specification of a persistent volume owned by the cluster. Provisioned by an administrator. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // AccessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes\n            withAccessModes(accessModes):: self + if std.type(accessModes) == \"array\" then __specMixin({accessModes: accessModes}) else __specMixin({accessModes: [accessModes]}),\n            // AccessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes\n            withAccessModesMixin(accessModes):: self + if std.type(accessModes) == \"array\" then __specMixin({accessModes+: accessModes}) else __specMixin({accessModes+: [accessModes]}),\n            // AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n            awsElasticBlockStore:: {\n              local __awsElasticBlockStoreMixin(awsElasticBlockStore) = __specMixin({awsElasticBlockStore+: awsElasticBlockStore}),\n              mixinInstance(awsElasticBlockStore):: __awsElasticBlockStoreMixin(awsElasticBlockStore),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withFsType(fsType):: self + __awsElasticBlockStoreMixin({fsType: fsType}),\n              // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty).\n              withPartition(partition):: self + __awsElasticBlockStoreMixin({partition: partition}),\n              // Specify \"true\" to force and set the ReadOnly property in VolumeMounts to \"true\". If omitted, the default is \"false\". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withReadOnly(readOnly):: self + __awsElasticBlockStoreMixin({readOnly: readOnly}),\n              // Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withVolumeId(volumeId):: self + __awsElasticBlockStoreMixin({volumeID: volumeId}),\n            },\n            awsElasticBlockStoreType:: hidden.core.v1.awsElasticBlockStoreVolumeSource,\n            // AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.\n            azureDisk:: {\n              local __azureDiskMixin(azureDisk) = __specMixin({azureDisk+: azureDisk}),\n              mixinInstance(azureDisk):: __azureDiskMixin(azureDisk),\n              // Host Caching mode: None, Read Only, Read Write.\n              withCachingMode(cachingMode):: self + __azureDiskMixin({cachingMode: cachingMode}),\n              // The Name of the data disk in the blob storage\n              withDiskName(diskName):: self + __azureDiskMixin({diskName: diskName}),\n              // The URI the data disk in the blob storage\n              withDiskUri(diskUri):: self + __azureDiskMixin({diskURI: diskUri}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __azureDiskMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __azureDiskMixin({readOnly: readOnly}),\n            },\n            azureDiskType:: hidden.core.v1.azureDiskVolumeSource,\n            // AzureFile represents an Azure File Service mount on the host and bind mount to the pod.\n            azureFile:: {\n              local __azureFileMixin(azureFile) = __specMixin({azureFile+: azureFile}),\n              mixinInstance(azureFile):: __azureFileMixin(azureFile),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __azureFileMixin({readOnly: readOnly}),\n              // the name of secret that contains Azure Storage Account Name and Key\n              withSecretName(secretName):: self + __azureFileMixin({secretName: secretName}),\n              // the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod\n              withSecretNamespace(secretNamespace):: self + __azureFileMixin({secretNamespace: secretNamespace}),\n              // Share Name\n              withShareName(shareName):: self + __azureFileMixin({shareName: shareName}),\n            },\n            azureFileType:: hidden.core.v1.azureFilePersistentVolumeSource,\n            // A description of the persistent volume's resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity\n            withCapacity(capacity):: self + __specMixin({capacity: capacity}),\n            // A description of the persistent volume's resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity\n            withCapacityMixin(capacity):: self + __specMixin({capacity+: capacity}),\n            // CephFS represents a Ceph FS mount on the host that shares a pod's lifetime\n            cephfs:: {\n              local __cephfsMixin(cephfs) = __specMixin({cephfs+: cephfs}),\n              mixinInstance(cephfs):: __cephfsMixin(cephfs),\n              // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withMonitors(monitors):: self + if std.type(monitors) == \"array\" then __cephfsMixin({monitors: monitors}) else __cephfsMixin({monitors: [monitors]}),\n              // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then __cephfsMixin({monitors+: monitors}) else __cephfsMixin({monitors+: [monitors]}),\n              // Optional: Used as the mounted root, rather than the full Ceph tree, default is /\n              withPath(path):: self + __cephfsMixin({path: path}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withReadOnly(readOnly):: self + __cephfsMixin({readOnly: readOnly}),\n              // Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withSecretFile(secretFile):: self + __cephfsMixin({secretFile: secretFile}),\n              // Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __cephfsMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withUser(user):: self + __cephfsMixin({user: user}),\n            },\n            cephfsType:: hidden.core.v1.cephFsPersistentVolumeSource,\n            // Cinder represents a cinder volume attached and mounted on kubelets host machine More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n            cinder:: {\n              local __cinderMixin(cinder) = __specMixin({cinder+: cinder}),\n              mixinInstance(cinder):: __cinderMixin(cinder),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withFsType(fsType):: self + __cinderMixin({fsType: fsType}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withReadOnly(readOnly):: self + __cinderMixin({readOnly: readOnly}),\n              // volume id used to identify the volume in cinder More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withVolumeId(volumeId):: self + __cinderMixin({volumeID: volumeId}),\n            },\n            cinderType:: hidden.core.v1.cinderVolumeSource,\n            // ClaimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. Expected to be non-nil when bound. claim.VolumeName is the authoritative bind between PV and PVC. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding\n            claimRef:: {\n              local __claimRefMixin(claimRef) = __specMixin({claimRef+: claimRef}),\n              mixinInstance(claimRef):: __claimRefMixin(claimRef),\n              // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n              withFieldPath(fieldPath):: self + __claimRefMixin({fieldPath: fieldPath}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __claimRefMixin({name: name}),\n              // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n              withNamespace(namespace):: self + __claimRefMixin({namespace: namespace}),\n              // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n              withResourceVersion(resourceVersion):: self + __claimRefMixin({resourceVersion: resourceVersion}),\n              // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n              withUid(uid):: self + __claimRefMixin({uid: uid}),\n            },\n            claimRefType:: hidden.core.v1.objectReference,\n            // CSI represents storage that handled by an external CSI driver (Beta feature).\n            csi:: {\n              local __csiMixin(csi) = __specMixin({csi+: csi}),\n              mixinInstance(csi):: __csiMixin(csi),\n              // ControllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n              controllerPublishSecretRef:: {\n                local __controllerPublishSecretRefMixin(controllerPublishSecretRef) = __csiMixin({controllerPublishSecretRef+: controllerPublishSecretRef}),\n                mixinInstance(controllerPublishSecretRef):: __controllerPublishSecretRefMixin(controllerPublishSecretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __controllerPublishSecretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __controllerPublishSecretRefMixin({namespace: namespace}),\n              },\n              controllerPublishSecretRefType:: hidden.core.v1.secretReference,\n              // Driver is the name of the driver to use for this volume. Required.\n              withDriver(driver):: self + __csiMixin({driver: driver}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __csiMixin({fsType: fsType}),\n              // NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n              nodePublishSecretRef:: {\n                local __nodePublishSecretRefMixin(nodePublishSecretRef) = __csiMixin({nodePublishSecretRef+: nodePublishSecretRef}),\n                mixinInstance(nodePublishSecretRef):: __nodePublishSecretRefMixin(nodePublishSecretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __nodePublishSecretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __nodePublishSecretRefMixin({namespace: namespace}),\n              },\n              nodePublishSecretRefType:: hidden.core.v1.secretReference,\n              // NodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n              nodeStageSecretRef:: {\n                local __nodeStageSecretRefMixin(nodeStageSecretRef) = __csiMixin({nodeStageSecretRef+: nodeStageSecretRef}),\n                mixinInstance(nodeStageSecretRef):: __nodeStageSecretRefMixin(nodeStageSecretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __nodeStageSecretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __nodeStageSecretRefMixin({namespace: namespace}),\n              },\n              nodeStageSecretRefType:: hidden.core.v1.secretReference,\n              // Optional: The value to pass to ControllerPublishVolumeRequest. Defaults to false (read/write).\n              withReadOnly(readOnly):: self + __csiMixin({readOnly: readOnly}),\n              // Attributes of the volume to publish.\n              withVolumeAttributes(volumeAttributes):: self + __csiMixin({volumeAttributes: volumeAttributes}),\n              // Attributes of the volume to publish.\n              withVolumeAttributesMixin(volumeAttributes):: self + __csiMixin({volumeAttributes+: volumeAttributes}),\n              // VolumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. Required.\n              withVolumeHandle(volumeHandle):: self + __csiMixin({volumeHandle: volumeHandle}),\n            },\n            csiType:: hidden.core.v1.csiPersistentVolumeSource,\n            // FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.\n            fc:: {\n              local __fcMixin(fc) = __specMixin({fc+: fc}),\n              mixinInstance(fc):: __fcMixin(fc),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __fcMixin({fsType: fsType}),\n              // Optional: FC target lun number\n              withLun(lun):: self + __fcMixin({lun: lun}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __fcMixin({readOnly: readOnly}),\n              // Optional: FC target worldwide names (WWNs)\n              withTargetWwns(targetWwns):: self + if std.type(targetWwns) == \"array\" then __fcMixin({targetWWNs: targetWwns}) else __fcMixin({targetWWNs: [targetWwns]}),\n              // Optional: FC target worldwide names (WWNs)\n              withTargetWwnsMixin(targetWwns):: self + if std.type(targetWwns) == \"array\" then __fcMixin({targetWWNs+: targetWwns}) else __fcMixin({targetWWNs+: [targetWwns]}),\n              // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n              withWwids(wwids):: self + if std.type(wwids) == \"array\" then __fcMixin({wwids: wwids}) else __fcMixin({wwids: [wwids]}),\n              // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n              withWwidsMixin(wwids):: self + if std.type(wwids) == \"array\" then __fcMixin({wwids+: wwids}) else __fcMixin({wwids+: [wwids]}),\n            },\n            fcType:: hidden.core.v1.fcVolumeSource,\n            // FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.\n            flexVolume:: {\n              local __flexVolumeMixin(flexVolume) = __specMixin({flexVolume+: flexVolume}),\n              mixinInstance(flexVolume):: __flexVolumeMixin(flexVolume),\n              // Driver is the name of the driver to use for this volume.\n              withDriver(driver):: self + __flexVolumeMixin({driver: driver}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". The default filesystem depends on FlexVolume script.\n              withFsType(fsType):: self + __flexVolumeMixin({fsType: fsType}),\n              // Optional: Extra command options if any.\n              withOptions(options):: self + __flexVolumeMixin({options: options}),\n              // Optional: Extra command options if any.\n              withOptionsMixin(options):: self + __flexVolumeMixin({options+: options}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __flexVolumeMixin({readOnly: readOnly}),\n              // Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __flexVolumeMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n            },\n            flexVolumeType:: hidden.core.v1.flexPersistentVolumeSource,\n            // Flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage. This depends on the Flocker control service being running\n            flocker:: {\n              local __flockerMixin(flocker) = __specMixin({flocker+: flocker}),\n              mixinInstance(flocker):: __flockerMixin(flocker),\n              // Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated\n              withDatasetName(datasetName):: self + __flockerMixin({datasetName: datasetName}),\n              // UUID of the dataset. This is unique identifier of a Flocker dataset\n              withDatasetUuid(datasetUuid):: self + __flockerMixin({datasetUUID: datasetUuid}),\n            },\n            flockerType:: hidden.core.v1.flockerVolumeSource,\n            // GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n            gcePersistentDisk:: {\n              local __gcePersistentDiskMixin(gcePersistentDisk) = __specMixin({gcePersistentDisk+: gcePersistentDisk}),\n              mixinInstance(gcePersistentDisk):: __gcePersistentDiskMixin(gcePersistentDisk),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withFsType(fsType):: self + __gcePersistentDiskMixin({fsType: fsType}),\n              // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withPartition(partition):: self + __gcePersistentDiskMixin({partition: partition}),\n              // Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withPdName(pdName):: self + __gcePersistentDiskMixin({pdName: pdName}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withReadOnly(readOnly):: self + __gcePersistentDiskMixin({readOnly: readOnly}),\n            },\n            gcePersistentDiskType:: hidden.core.v1.gcePersistentDiskVolumeSource,\n            // Glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod. Provisioned by an admin. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md\n            glusterfs:: {\n              local __glusterfsMixin(glusterfs) = __specMixin({glusterfs+: glusterfs}),\n              mixinInstance(glusterfs):: __glusterfsMixin(glusterfs),\n              // EndpointsName is the endpoint name that details Glusterfs topology. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withEndpoints(endpoints):: self + __glusterfsMixin({endpoints: endpoints}),\n              // Path is the Glusterfs volume path. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withPath(path):: self + __glusterfsMixin({path: path}),\n              // ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withReadOnly(readOnly):: self + __glusterfsMixin({readOnly: readOnly}),\n            },\n            glusterfsType:: hidden.core.v1.glusterfsVolumeSource,\n            // HostPath represents a directory on the host. Provisioned by a developer or tester. This is useful for single-node development and testing only! On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n            hostPath:: {\n              local __hostPathMixin(hostPath) = __specMixin({hostPath+: hostPath}),\n              mixinInstance(hostPath):: __hostPathMixin(hostPath),\n              // Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n              withPath(path):: self + __hostPathMixin({path: path}),\n              // Type for HostPath Volume Defaults to \"\" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n              withType(type):: self + __hostPathMixin({type: type}),\n            },\n            hostPathType:: hidden.core.v1.hostPathVolumeSource,\n            // ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. Provisioned by an admin.\n            iscsi:: {\n              local __iscsiMixin(iscsi) = __specMixin({iscsi+: iscsi}),\n              mixinInstance(iscsi):: __iscsiMixin(iscsi),\n              // whether support iSCSI Discovery CHAP authentication\n              withChapAuthDiscovery(chapAuthDiscovery):: self + __iscsiMixin({chapAuthDiscovery: chapAuthDiscovery}),\n              // whether support iSCSI Session CHAP authentication\n              withChapAuthSession(chapAuthSession):: self + __iscsiMixin({chapAuthSession: chapAuthSession}),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi\n              withFsType(fsType):: self + __iscsiMixin({fsType: fsType}),\n              // Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.\n              withInitiatorName(initiatorName):: self + __iscsiMixin({initiatorName: initiatorName}),\n              // Target iSCSI Qualified Name.\n              withIqn(iqn):: self + __iscsiMixin({iqn: iqn}),\n              // iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).\n              withIscsiInterface(iscsiInterface):: self + __iscsiMixin({iscsiInterface: iscsiInterface}),\n              // iSCSI Target Lun number.\n              withLun(lun):: self + __iscsiMixin({lun: lun}),\n              // iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withPortals(portals):: self + if std.type(portals) == \"array\" then __iscsiMixin({portals: portals}) else __iscsiMixin({portals: [portals]}),\n              // iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withPortalsMixin(portals):: self + if std.type(portals) == \"array\" then __iscsiMixin({portals+: portals}) else __iscsiMixin({portals+: [portals]}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.\n              withReadOnly(readOnly):: self + __iscsiMixin({readOnly: readOnly}),\n              // CHAP Secret for iSCSI target and initiator authentication\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __iscsiMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withTargetPortal(targetPortal):: self + __iscsiMixin({targetPortal: targetPortal}),\n            },\n            iscsiType:: hidden.core.v1.iscsiPersistentVolumeSource,\n            // Local represents directly-attached storage with node affinity\n            localStorage:: {\n              local __localStorageMixin(localStorage) = __specMixin({localStorage+: localStorage}),\n              mixinInstance(localStorage):: __localStorageMixin(localStorage),\n              // The full path to the volume on the node For alpha, this path must be a directory Once block as a source is supported, then this path can point to a block device\n              withPath(path):: self + __localStorageMixin({path: path}),\n            },\n            localType:: hidden.core.v1.localVolumeSource,\n            // A list of mount options, e.g. [\"ro\", \"soft\"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options\n            withMountOptions(mountOptions):: self + if std.type(mountOptions) == \"array\" then __specMixin({mountOptions: mountOptions}) else __specMixin({mountOptions: [mountOptions]}),\n            // A list of mount options, e.g. [\"ro\", \"soft\"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options\n            withMountOptionsMixin(mountOptions):: self + if std.type(mountOptions) == \"array\" then __specMixin({mountOptions+: mountOptions}) else __specMixin({mountOptions+: [mountOptions]}),\n            // NFS represents an NFS mount on the host. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n            nfs:: {\n              local __nfsMixin(nfs) = __specMixin({nfs+: nfs}),\n              mixinInstance(nfs):: __nfsMixin(nfs),\n              // Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withPath(path):: self + __nfsMixin({path: path}),\n              // ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withReadOnly(readOnly):: self + __nfsMixin({readOnly: readOnly}),\n              // Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withServer(server):: self + __nfsMixin({server: server}),\n            },\n            nfsType:: hidden.core.v1.nfsVolumeSource,\n            // NodeAffinity defines constraints that limit what nodes this volume can be accessed from. This field influences the scheduling of pods that use this volume.\n            nodeAffinity:: {\n              local __nodeAffinityMixin(nodeAffinity) = __specMixin({nodeAffinity+: nodeAffinity}),\n              mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n              // Required specifies hard node constraints that must be met.\n              required:: {\n                local __requiredMixin(required) = __nodeAffinityMixin({required+: required}),\n                mixinInstance(required):: __requiredMixin(required),\n                // Required. A list of node selector terms. The terms are ORed.\n                withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                // Required. A list of node selector terms. The terms are ORed.\n                withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n              },\n              requiredType:: hidden.core.v1.nodeSelector,\n            },\n            nodeAffinityType:: hidden.core.v1.volumeNodeAffinity,\n            // What happens to a persistent volume when released from its claim. Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming\n            withPersistentVolumeReclaimPolicy(persistentVolumeReclaimPolicy):: self + __specMixin({persistentVolumeReclaimPolicy: persistentVolumeReclaimPolicy}),\n            // PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine\n            photonPersistentDisk:: {\n              local __photonPersistentDiskMixin(photonPersistentDisk) = __specMixin({photonPersistentDisk+: photonPersistentDisk}),\n              mixinInstance(photonPersistentDisk):: __photonPersistentDiskMixin(photonPersistentDisk),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __photonPersistentDiskMixin({fsType: fsType}),\n              // ID that identifies Photon Controller persistent disk\n              withPdId(pdId):: self + __photonPersistentDiskMixin({pdID: pdId}),\n            },\n            photonPersistentDiskType:: hidden.core.v1.photonPersistentDiskVolumeSource,\n            // PortworxVolume represents a portworx volume attached and mounted on kubelets host machine\n            portworxVolume:: {\n              local __portworxVolumeMixin(portworxVolume) = __specMixin({portworxVolume+: portworxVolume}),\n              mixinInstance(portworxVolume):: __portworxVolumeMixin(portworxVolume),\n              // FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __portworxVolumeMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __portworxVolumeMixin({readOnly: readOnly}),\n              // VolumeID uniquely identifies a Portworx volume\n              withVolumeId(volumeId):: self + __portworxVolumeMixin({volumeID: volumeId}),\n            },\n            portworxVolumeType:: hidden.core.v1.portworxVolumeSource,\n            // Quobyte represents a Quobyte mount on the host that shares a pod's lifetime\n            quobyte:: {\n              local __quobyteMixin(quobyte) = __specMixin({quobyte+: quobyte}),\n              mixinInstance(quobyte):: __quobyteMixin(quobyte),\n              // Group to map volume access to Default is no group\n              withGroup(group):: self + __quobyteMixin({group: group}),\n              // ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.\n              withReadOnly(readOnly):: self + __quobyteMixin({readOnly: readOnly}),\n              // Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes\n              withRegistry(registry):: self + __quobyteMixin({registry: registry}),\n              // User to map volume access to Defaults to serivceaccount user\n              withUser(user):: self + __quobyteMixin({user: user}),\n              // Volume is a string that references an already created Quobyte volume by name.\n              withVolume(volume):: self + __quobyteMixin({volume: volume}),\n            },\n            quobyteType:: hidden.core.v1.quobyteVolumeSource,\n            // RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md\n            rbd:: {\n              local __rbdMixin(rbd) = __specMixin({rbd+: rbd}),\n              mixinInstance(rbd):: __rbdMixin(rbd),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd\n              withFsType(fsType):: self + __rbdMixin({fsType: fsType}),\n              // The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withImage(image):: self + __rbdMixin({image: image}),\n              // Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withKeyring(keyring):: self + __rbdMixin({keyring: keyring}),\n              // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withMonitors(monitors):: self + if std.type(monitors) == \"array\" then __rbdMixin({monitors: monitors}) else __rbdMixin({monitors: [monitors]}),\n              // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then __rbdMixin({monitors+: monitors}) else __rbdMixin({monitors+: [monitors]}),\n              // The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withPool(pool):: self + __rbdMixin({pool: pool}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withReadOnly(readOnly):: self + __rbdMixin({readOnly: readOnly}),\n              // SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __rbdMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withUser(user):: self + __rbdMixin({user: user}),\n            },\n            rbdType:: hidden.core.v1.rbdPersistentVolumeSource,\n            // ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.\n            scaleIo:: {\n              local __scaleIoMixin(scaleIo) = __specMixin({scaleIo+: scaleIo}),\n              mixinInstance(scaleIo):: __scaleIoMixin(scaleIo),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __scaleIoMixin({fsType: fsType}),\n              // The host address of the ScaleIO API Gateway.\n              withGateway(gateway):: self + __scaleIoMixin({gateway: gateway}),\n              // The name of the ScaleIO Protection Domain for the configured storage.\n              withProtectionDomain(protectionDomain):: self + __scaleIoMixin({protectionDomain: protectionDomain}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __scaleIoMixin({readOnly: readOnly}),\n              // SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __scaleIoMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // Flag to enable/disable SSL communication with Gateway, default false\n              withSslEnabled(sslEnabled):: self + __scaleIoMixin({sslEnabled: sslEnabled}),\n              // Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.\n              withStorageMode(storageMode):: self + __scaleIoMixin({storageMode: storageMode}),\n              // The ScaleIO Storage Pool associated with the protection domain.\n              withStoragePool(storagePool):: self + __scaleIoMixin({storagePool: storagePool}),\n              // The name of the storage system as configured in ScaleIO.\n              withSystem(system):: self + __scaleIoMixin({system: system}),\n              // The name of a volume already created in the ScaleIO system that is associated with this volume source.\n              withVolumeName(volumeName):: self + __scaleIoMixin({volumeName: volumeName}),\n            },\n            scaleIOType:: hidden.core.v1.scaleIoPersistentVolumeSource,\n            // Name of StorageClass to which this persistent volume belongs. Empty value means that this volume does not belong to any StorageClass.\n            withStorageClassName(storageClassName):: self + __specMixin({storageClassName: storageClassName}),\n            // StorageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://releases.k8s.io/HEAD/examples/volumes/storageos/README.md\n            storageos:: {\n              local __storageosMixin(storageos) = __specMixin({storageos+: storageos}),\n              mixinInstance(storageos):: __storageosMixin(storageos),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __storageosMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __storageosMixin({readOnly: readOnly}),\n              // SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __storageosMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n                withFieldPath(fieldPath):: self + __secretRefMixin({fieldPath: fieldPath}),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n                // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n                withResourceVersion(resourceVersion):: self + __secretRefMixin({resourceVersion: resourceVersion}),\n                // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n                withUid(uid):: self + __secretRefMixin({uid: uid}),\n              },\n              secretRefType:: hidden.core.v1.objectReference,\n              // VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.\n              withVolumeName(volumeName):: self + __storageosMixin({volumeName: volumeName}),\n              // VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to \"default\" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.\n              withVolumeNamespace(volumeNamespace):: self + __storageosMixin({volumeNamespace: volumeNamespace}),\n            },\n            storageosType:: hidden.core.v1.storageOsPersistentVolumeSource,\n            // volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. Value of Filesystem is implied when not included in spec. This is an alpha feature and may change in the future.\n            withVolumeMode(volumeMode):: self + __specMixin({volumeMode: volumeMode}),\n            // VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine\n            vsphereVolume:: {\n              local __vsphereVolumeMixin(vsphereVolume) = __specMixin({vsphereVolume+: vsphereVolume}),\n              mixinInstance(vsphereVolume):: __vsphereVolumeMixin(vsphereVolume),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __vsphereVolumeMixin({fsType: fsType}),\n              // Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.\n              withStoragePolicyId(storagePolicyId):: self + __vsphereVolumeMixin({storagePolicyID: storagePolicyId}),\n              // Storage Policy Based Management (SPBM) profile name.\n              withStoragePolicyName(storagePolicyName):: self + __vsphereVolumeMixin({storagePolicyName: storagePolicyName}),\n              // Path that identifies vSphere volume vmdk\n              withVolumePath(volumePath):: self + __vsphereVolumeMixin({volumePath: volumePath}),\n            },\n            vsphereVolumeType:: hidden.core.v1.vsphereVirtualDiskVolumeSource,\n          },\n          specType:: hidden.core.v1.persistentVolumeSpec,\n        },\n      },\n      // PersistentVolumeClaim is a user's request for and claim to a persistent volume\n      persistentVolumeClaim:: {\n        local kind = {kind: \"PersistentVolumeClaim\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the desired characteristics of a volume requested by a pod author. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1\n            withAccessModes(accessModes):: self + if std.type(accessModes) == \"array\" then __specMixin({accessModes: accessModes}) else __specMixin({accessModes: [accessModes]}),\n            // AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1\n            withAccessModesMixin(accessModes):: self + if std.type(accessModes) == \"array\" then __specMixin({accessModes+: accessModes}) else __specMixin({accessModes+: [accessModes]}),\n            // Resources represents the minimum resources the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources\n            resources:: {\n              local __resourcesMixin(resources) = __specMixin({resources+: resources}),\n              mixinInstance(resources):: __resourcesMixin(resources),\n              // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withLimits(limits):: self + __resourcesMixin({limits: limits}),\n              // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withLimitsMixin(limits):: self + __resourcesMixin({limits+: limits}),\n              // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withRequests(requests):: self + __resourcesMixin({requests: requests}),\n              // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withRequestsMixin(requests):: self + __resourcesMixin({requests+: requests}),\n            },\n            resourcesType:: hidden.core.v1.resourceRequirements,\n            // A label query over volumes to consider for binding.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1\n            withStorageClassName(storageClassName):: self + __specMixin({storageClassName: storageClassName}),\n            // volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec. This is an alpha feature and may change in the future.\n            withVolumeMode(volumeMode):: self + __specMixin({volumeMode: volumeMode}),\n            // VolumeName is the binding reference to the PersistentVolume backing this claim.\n            withVolumeName(volumeName):: self + __specMixin({volumeName: volumeName}),\n          },\n          specType:: hidden.core.v1.persistentVolumeClaimSpec,\n        },\n      },\n      // Pod is a collection of containers that can run on a host. This resource is created by clients and scheduled onto hosts.\n      pod:: {\n        local kind = {kind: \"Pod\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n            withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n            // If specified, the pod's scheduling constraints\n            affinity:: {\n              local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n              mixinInstance(affinity):: __affinityMixin(affinity),\n              // Describes node affinity scheduling rules for the pod.\n              nodeAffinity:: {\n                local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                requiredDuringSchedulingIgnoredDuringExecution:: {\n                  local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                  mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                  // Required. A list of node selector terms. The terms are ORed.\n                  withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                  // Required. A list of node selector terms. The terms are ORed.\n                  withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                  nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                },\n                requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n              },\n              nodeAffinityType:: hidden.core.v1.nodeAffinity,\n              // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n              podAffinity:: {\n                local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n              },\n              podAffinityType:: hidden.core.v1.podAffinity,\n              // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n              podAntiAffinity:: {\n                local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n              },\n              podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n            },\n            affinityType:: hidden.core.v1.affinity,\n            // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n            withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n            // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n            withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n            // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n            withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n            containersType:: hidden.core.v1.container,\n            // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n            dnsConfig:: {\n              local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n              mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n              // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n              withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n              // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n              withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n              // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n              withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n              // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n              withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n              optionsType:: hidden.core.v1.podDnsConfigOption,\n              // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n              withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n              // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n              withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n            },\n            dnsConfigType:: hidden.core.v1.podDnsConfig,\n            // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n            withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n            // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n            withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n            // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n            withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n            hostAliasesType:: hidden.core.v1.hostAlias,\n            // Use the host's ipc namespace. Optional: Default to false.\n            withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n            // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n            withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n            // Use the host's pid namespace. Optional: Default to false.\n            withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n            // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n            withHostname(hostname):: self + __specMixin({hostname: hostname}),\n            // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n            withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n            // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n            withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n            imagePullSecretsType:: hidden.core.v1.localObjectReference,\n            // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n            withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n            // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n            withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n            initContainersType:: hidden.core.v1.container,\n            // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n            withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n            // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n            withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n            // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n            withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n            // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n            withPriority(priority):: self + __specMixin({priority: priority}),\n            // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n            withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n            // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n            withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n            // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n            withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n            // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n            securityContext:: {\n              local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n              mixinInstance(securityContext):: __securityContextMixin(securityContext),\n              // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n              //\n              // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n              //\n              // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n              withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n              // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n              withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n              // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n              withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n              // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n              withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n              // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n              // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n              withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n              // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n              withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n            },\n            securityContextType:: hidden.core.v1.podSecurityContext,\n            // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n            withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n            // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n            withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n            // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n            withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n            // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n            withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n            // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n            withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n            // If specified, the pod's tolerations.\n            withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n            // If specified, the pod's tolerations.\n            withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n            tolerationsType:: hidden.core.v1.toleration,\n            // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n            withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n            // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n            withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n            volumesType:: hidden.core.v1.volume,\n          },\n          specType:: hidden.core.v1.podSpec,\n        },\n      },\n      // PodTemplate describes a template for creating copies of a predefined pod.\n      podTemplate:: {\n        local kind = {kind: \"PodTemplate\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Template defines the pods that will be created from this pod template. https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          template:: {\n            local __templateMixin(template) = {template+: template},\n            mixinInstance(template):: __templateMixin(template),\n            // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n            metadata:: {\n              local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n              mixinInstance(metadata):: __metadataMixin(metadata),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n              // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n              withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n              // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n              //\n              // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n              //\n              // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n              withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n              // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n              //\n              // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n              initializers:: {\n                local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                mixinInstance(initializers):: __initializersMixin(initializers),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                pendingType:: hidden.meta.v1.initializer,\n              },\n              initializersType:: hidden.meta.v1.initializers,\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabels(labels):: self + __metadataMixin({labels: labels}),\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n              // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __metadataMixin({name: name}),\n              // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n              //\n              // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n              withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n              ownerReferencesType:: hidden.meta.v1.ownerReference,\n            },\n            metadataType:: hidden.meta.v1.objectMeta,\n            // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n            spec:: {\n              local __specMixin(spec) = __templateMixin({spec+: spec}),\n              mixinInstance(spec):: __specMixin(spec),\n              // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n              withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n              // If specified, the pod's scheduling constraints\n              affinity:: {\n                local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                mixinInstance(affinity):: __affinityMixin(affinity),\n                // Describes node affinity scheduling rules for the pod.\n                nodeAffinity:: {\n                  local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                  mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                  // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                  requiredDuringSchedulingIgnoredDuringExecution:: {\n                    local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                    mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                    // Required. A list of node selector terms. The terms are ORed.\n                    withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                    // Required. A list of node selector terms. The terms are ORed.\n                    withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                    nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                  },\n                  requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                },\n                nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                podAffinity:: {\n                  local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                  mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                  // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                },\n                podAffinityType:: hidden.core.v1.podAffinity,\n                // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                podAntiAffinity:: {\n                  local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                  mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                  // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                },\n                podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n              },\n              affinityType:: hidden.core.v1.affinity,\n              // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n              withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n              // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n              withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n              // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n              withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n              containersType:: hidden.core.v1.container,\n              // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n              dnsConfig:: {\n                local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                optionsType:: hidden.core.v1.podDnsConfigOption,\n                // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n              },\n              dnsConfigType:: hidden.core.v1.podDnsConfig,\n              // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n              withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n              // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n              withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n              // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n              withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n              hostAliasesType:: hidden.core.v1.hostAlias,\n              // Use the host's ipc namespace. Optional: Default to false.\n              withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n              // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n              withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n              // Use the host's pid namespace. Optional: Default to false.\n              withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n              // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n              withHostname(hostname):: self + __specMixin({hostname: hostname}),\n              // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n              withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n              // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n              withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n              imagePullSecretsType:: hidden.core.v1.localObjectReference,\n              // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n              withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n              // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n              withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n              initContainersType:: hidden.core.v1.container,\n              // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n              withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n              // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n              withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n              // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n              withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n              // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n              withPriority(priority):: self + __specMixin({priority: priority}),\n              // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n              withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n              // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n              withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n              // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n              withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n              // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n              securityContext:: {\n                local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                //\n                // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                //\n                // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                seLinuxOptions:: {\n                  local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                  mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                  // Level is SELinux level label that applies to the container.\n                  withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                  // Role is a SELinux role label that applies to the container.\n                  withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                  // Type is a SELinux type label that applies to the container.\n                  withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                  // User is a SELinux user label that applies to the container.\n                  withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                },\n                seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n              },\n              securityContextType:: hidden.core.v1.podSecurityContext,\n              // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n              withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n              // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n              withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n              // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n              withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n              // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n              withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n              // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n              withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n              // If specified, the pod's tolerations.\n              withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n              // If specified, the pod's tolerations.\n              withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n              tolerationsType:: hidden.core.v1.toleration,\n              // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n              withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n              // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n              withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n              volumesType:: hidden.core.v1.volume,\n            },\n            specType:: hidden.core.v1.podSpec,\n          },\n          templateType:: hidden.core.v1.podTemplateSpec,\n        },\n      },\n      // ReplicationController represents the configuration of a replication controller.\n      replicationController:: {\n        local kind = {kind: \"ReplicationController\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages. Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the specification of the desired behavior of the replication controller. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // Selector is a label query over pods that should match the Replicas count. If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            withSelector(selector):: self + __specMixin({selector: selector}),\n            // Selector is a label query over pods that should match the Replicas count. If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            withSelectorMixin(selector):: self + __specMixin({selector+: selector}),\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. This takes precedence over a TemplateRef. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.core.v1.replicationControllerSpec,\n        },\n      },\n      // ResourceQuota sets aggregate quota restrictions enforced per namespace\n      resourceQuota:: {\n        local kind = {kind: \"ResourceQuota\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the desired quota. https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Hard is the set of desired hard limits for each named resource. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n            withHard(hard):: self + __specMixin({hard: hard}),\n            // Hard is the set of desired hard limits for each named resource. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n            withHardMixin(hard):: self + __specMixin({hard+: hard}),\n            // A collection of filters that must match each object tracked by a quota. If not specified, the quota matches all objects.\n            withScopes(scopes):: self + if std.type(scopes) == \"array\" then __specMixin({scopes: scopes}) else __specMixin({scopes: [scopes]}),\n            // A collection of filters that must match each object tracked by a quota. If not specified, the quota matches all objects.\n            withScopesMixin(scopes):: self + if std.type(scopes) == \"array\" then __specMixin({scopes+: scopes}) else __specMixin({scopes+: [scopes]}),\n          },\n          specType:: hidden.core.v1.resourceQuotaSpec,\n        },\n      },\n      // Secret holds secret data of a certain type. The total bytes of the values in the Data field must be less than MaxSecretSize bytes.\n      secret:: {\n        local kind = {kind: \"Secret\"},\n        new(name=\"\", data=\"\", type=\"Opaque\"):: apiVersion + kind + self.withData(data).withType(type) + self.mixin.metadata.withName(name),\n        // Data contains the secret data. Each key must consist of alphanumeric characters, '-', '_' or '.'. The serialized form of the secret data is a base64 encoded string, representing the arbitrary (possibly non-string) data value here. Described in https://tools.ietf.org/html/rfc4648#section-4\n        withData(data):: self + {data: data},\n        // Data contains the secret data. Each key must consist of alphanumeric characters, '-', '_' or '.'. The serialized form of the secret data is a base64 encoded string, representing the arbitrary (possibly non-string) data value here. Described in https://tools.ietf.org/html/rfc4648#section-4\n        withDataMixin(data):: self + {data+: data},\n        // stringData allows specifying non-binary secret data in string form. It is provided as a write-only convenience method. All keys and values are merged into the data field on write, overwriting any existing values. It is never output when reading from the API.\n        withStringData(stringData):: self + {stringData: stringData},\n        // stringData allows specifying non-binary secret data in string form. It is provided as a write-only convenience method. All keys and values are merged into the data field on write, overwriting any existing values. It is never output when reading from the API.\n        withStringDataMixin(stringData):: self + {stringData+: stringData},\n        // Used to facilitate programmatic handling of secret data.\n        withType(type):: self + {type: type},\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // Service is a named abstraction of software service (for example, mysql) consisting of local port (for example 3306) that the proxy listens on, and the selector that determines which pods will answer requests sent through the proxy.\n      service:: {\n        local kind = {kind: \"Service\"},\n        new(name=\"\", selector=\"\", ports=\"\"):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withPorts(ports).withSelector(selector),\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the behavior of a service. https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // clusterIP is the IP address of the service and is usually assigned randomly by the master. If an address is specified manually and is not in use by others, it will be allocated to the service; otherwise, creation of the service will fail. This field can not be changed through updates. Valid values are \"None\", empty string (\"\"), or a valid IP address. \"None\" can be specified for headless services when proxying is not required. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n            withClusterIp(clusterIp):: self + __specMixin({clusterIP: clusterIp}),\n            // externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.  These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.\n            withExternalIps(externalIps):: self + if std.type(externalIps) == \"array\" then __specMixin({externalIPs: externalIps}) else __specMixin({externalIPs: [externalIps]}),\n            // externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.  These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.\n            withExternalIpsMixin(externalIps):: self + if std.type(externalIps) == \"array\" then __specMixin({externalIPs+: externalIps}) else __specMixin({externalIPs+: [externalIps]}),\n            // externalName is the external reference that kubedns or equivalent will return as a CNAME record for this service. No proxying will be involved. Must be a valid RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires Type to be ExternalName.\n            withExternalName(externalName):: self + __specMixin({externalName: externalName}),\n            // externalTrafficPolicy denotes if this Service desires to route external traffic to node-local or cluster-wide endpoints. \"Local\" preserves the client source IP and avoids a second hop for LoadBalancer and Nodeport type services, but risks potentially imbalanced traffic spreading. \"Cluster\" obscures the client source IP and may cause a second hop to another node, but should have good overall load-spreading.\n            withExternalTrafficPolicy(externalTrafficPolicy):: self + __specMixin({externalTrafficPolicy: externalTrafficPolicy}),\n            // healthCheckNodePort specifies the healthcheck nodePort for the service. If not specified, HealthCheckNodePort is created by the service api backend with the allocated nodePort. Will use user-specified nodePort value if specified by the client. Only effects when Type is set to LoadBalancer and ExternalTrafficPolicy is set to Local.\n            withHealthCheckNodePort(healthCheckNodePort):: self + __specMixin({healthCheckNodePort: healthCheckNodePort}),\n            // Only applies to Service Type: LoadBalancer LoadBalancer will get created with the IP specified in this field. This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature.\n            withLoadBalancerIp(loadBalancerIp):: self + __specMixin({loadBalancerIP: loadBalancerIp}),\n            // If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature.\" More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/\n            withLoadBalancerSourceRanges(loadBalancerSourceRanges):: self + if std.type(loadBalancerSourceRanges) == \"array\" then __specMixin({loadBalancerSourceRanges: loadBalancerSourceRanges}) else __specMixin({loadBalancerSourceRanges: [loadBalancerSourceRanges]}),\n            // If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature.\" More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/\n            withLoadBalancerSourceRangesMixin(loadBalancerSourceRanges):: self + if std.type(loadBalancerSourceRanges) == \"array\" then __specMixin({loadBalancerSourceRanges+: loadBalancerSourceRanges}) else __specMixin({loadBalancerSourceRanges+: [loadBalancerSourceRanges]}),\n            // The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n            withPorts(ports):: self + if std.type(ports) == \"array\" then __specMixin({ports: ports}) else __specMixin({ports: [ports]}),\n            // The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n            withPortsMixin(ports):: self + if std.type(ports) == \"array\" then __specMixin({ports+: ports}) else __specMixin({ports+: [ports]}),\n            portsType:: hidden.core.v1.servicePort,\n            // publishNotReadyAddresses, when set to true, indicates that DNS implementations must publish the notReadyAddresses of subsets for the Endpoints associated with the Service. The default value is false. The primary use case for setting this field is to use a StatefulSet's Headless Service to propagate SRV records for its Pods without respect to their readiness for purpose of peer discovery. This field will replace the service.alpha.kubernetes.io/tolerate-unready-endpoints when that annotation is deprecated and all clients have been converted to use this field.\n            withPublishNotReadyAddresses(publishNotReadyAddresses):: self + __specMixin({publishNotReadyAddresses: publishNotReadyAddresses}),\n            // Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/\n            withSelector(selector):: self + __specMixin({selector: selector}),\n            // Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/\n            withSelectorMixin(selector):: self + __specMixin({selector+: selector}),\n            // Supports \"ClientIP\" and \"None\". Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n            withSessionAffinity(sessionAffinity):: self + __specMixin({sessionAffinity: sessionAffinity}),\n            // sessionAffinityConfig contains the configurations of session affinity.\n            sessionAffinityConfig:: {\n              local __sessionAffinityConfigMixin(sessionAffinityConfig) = __specMixin({sessionAffinityConfig+: sessionAffinityConfig}),\n              mixinInstance(sessionAffinityConfig):: __sessionAffinityConfigMixin(sessionAffinityConfig),\n              // clientIP contains the configurations of Client IP based session affinity.\n              clientIp:: {\n                local __clientIpMixin(clientIp) = __sessionAffinityConfigMixin({clientIp+: clientIp}),\n                mixinInstance(clientIp):: __clientIpMixin(clientIp),\n                // timeoutSeconds specifies the seconds of ClientIP type session sticky time. The value must be >0 && <=86400(for 1 day) if ServiceAffinity == \"ClientIP\". Default value is 10800(for 3 hours).\n                withTimeoutSeconds(timeoutSeconds):: self + __clientIpMixin({timeoutSeconds: timeoutSeconds}),\n              },\n              clientIPType:: hidden.core.v1.clientIpConfig,\n            },\n            sessionAffinityConfigType:: hidden.core.v1.sessionAffinityConfig,\n            // type determines how the Service is exposed. Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. \"ExternalName\" maps to the specified externalName. \"ClusterIP\" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object. If clusterIP is \"None\", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a stable IP. \"NodePort\" builds on ClusterIP and allocates a port on every node which routes to the clusterIP. \"LoadBalancer\" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the clusterIP. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services---service-types\n            withType(type):: self + __specMixin({type: type}),\n          },\n          specType:: hidden.core.v1.serviceSpec,\n        },\n      },\n      // ServiceAccount binds together: * a name, understood by users, and perhaps by peripheral systems, for an identity * a principal that can be authenticated and authorized * a set of secrets\n      serviceAccount:: {\n        local kind = {kind: \"ServiceAccount\"},\n        new(name=\"\"):: apiVersion + kind + self.mixin.metadata.withName(name),\n        // AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted. Can be overridden at the pod level.\n        withAutomountServiceAccountToken(automountServiceAccountToken):: self + {automountServiceAccountToken: automountServiceAccountToken},\n        // ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod\n        withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then {imagePullSecrets: imagePullSecrets} else {imagePullSecrets: [imagePullSecrets]},\n        // ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod\n        withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then {imagePullSecrets+: imagePullSecrets} else {imagePullSecrets+: [imagePullSecrets]},\n        imagePullSecretsType:: hidden.core.v1.localObjectReference,\n        // Secrets is the list of secrets allowed to be used by pods running using this ServiceAccount. More info: https://kubernetes.io/docs/concepts/configuration/secret\n        withSecrets(secrets):: self + if std.type(secrets) == \"array\" then {secrets: secrets} else {secrets: [secrets]},\n        // Secrets is the list of secrets allowed to be used by pods running using this ServiceAccount. More info: https://kubernetes.io/docs/concepts/configuration/secret\n        withSecretsMixin(secrets):: self + if std.type(secrets) == \"array\" then {secrets+: secrets} else {secrets+: [secrets]},\n        secretsType:: hidden.core.v1.objectReference,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n    },\n  },\n  events:: {\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"events.k8s.io/v1beta1\"},\n      // Event is a report of an event somewhere in the cluster. It generally denotes some state change in the system.\n      event:: {\n        local kind = {kind: \"Event\"},\n        new():: apiVersion + kind,\n        // What action was taken/failed regarding to the regarding object.\n        withAction(action):: self + {action: action},\n        // Deprecated field assuring backward compatibility with core.v1 Event type\n        withDeprecatedCount(deprecatedCount):: self + {deprecatedCount: deprecatedCount},\n        // Deprecated field assuring backward compatibility with core.v1 Event type\n        withDeprecatedFirstTimestamp(deprecatedFirstTimestamp):: self + {deprecatedFirstTimestamp: deprecatedFirstTimestamp},\n        // Deprecated field assuring backward compatibility with core.v1 Event type\n        withDeprecatedLastTimestamp(deprecatedLastTimestamp):: self + {deprecatedLastTimestamp: deprecatedLastTimestamp},\n        // Required. Time when this Event was first observed.\n        withEventTime(eventTime):: self + {eventTime: eventTime},\n        // Optional. A human-readable description of the status of this operation. Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB.\n        withNote(note):: self + {note: note},\n        // Why the action was taken.\n        withReason(reason):: self + {reason: reason},\n        // Name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`.\n        withReportingController(reportingController):: self + {reportingController: reportingController},\n        // ID of the controller instance, e.g. `kubelet-xyzf`.\n        withReportingInstance(reportingInstance):: self + {reportingInstance: reportingInstance},\n        // Type of this event (Normal, Warning), new types could be added in the future.\n        withType(type):: self + {type: type},\n        mixin:: {\n          // Deprecated field assuring backward compatibility with core.v1 Event type\n          deprecatedSource:: {\n            local __deprecatedSourceMixin(deprecatedSource) = {deprecatedSource+: deprecatedSource},\n            mixinInstance(deprecatedSource):: __deprecatedSourceMixin(deprecatedSource),\n            // Component from which the event is generated.\n            withComponent(component):: self + __deprecatedSourceMixin({component: component}),\n            // Node name on which the event is generated.\n            withHost(host):: self + __deprecatedSourceMixin({host: host}),\n          },\n          deprecatedSourceType:: hidden.core.v1.eventSource,\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // The object this Event is about. In most cases it's an Object reporting controller implements. E.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object.\n          regarding:: {\n            local __regardingMixin(regarding) = {regarding+: regarding},\n            mixinInstance(regarding):: __regardingMixin(regarding),\n            // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n            withFieldPath(fieldPath):: self + __regardingMixin({fieldPath: fieldPath}),\n            // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n            withName(name):: self + __regardingMixin({name: name}),\n            // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n            withNamespace(namespace):: self + __regardingMixin({namespace: namespace}),\n            // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n            withResourceVersion(resourceVersion):: self + __regardingMixin({resourceVersion: resourceVersion}),\n            // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n            withUid(uid):: self + __regardingMixin({uid: uid}),\n          },\n          regardingType:: hidden.core.v1.objectReference,\n          // Optional secondary object for more complex actions. E.g. when regarding object triggers a creation or deletion of related object.\n          related:: {\n            local __relatedMixin(related) = {related+: related},\n            mixinInstance(related):: __relatedMixin(related),\n            // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n            withFieldPath(fieldPath):: self + __relatedMixin({fieldPath: fieldPath}),\n            // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n            withName(name):: self + __relatedMixin({name: name}),\n            // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n            withNamespace(namespace):: self + __relatedMixin({namespace: namespace}),\n            // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n            withResourceVersion(resourceVersion):: self + __relatedMixin({resourceVersion: resourceVersion}),\n            // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n            withUid(uid):: self + __relatedMixin({uid: uid}),\n          },\n          relatedType:: hidden.core.v1.objectReference,\n          // Data about the Event series this event represents or nil if it's a singleton Event.\n          series:: {\n            local __seriesMixin(series) = {series+: series},\n            mixinInstance(series):: __seriesMixin(series),\n            // Number of occurrences in this series up to the last heartbeat time\n            withCount(count):: self + __seriesMixin({count: count}),\n            // Time when last Event from the series was seen before last heartbeat.\n            withLastObservedTime(lastObservedTime):: self + __seriesMixin({lastObservedTime: lastObservedTime}),\n            // Information whether this series is ongoing or finished.\n            withState(state):: self + __seriesMixin({state: state}),\n          },\n          seriesType:: hidden.events.v1beta1.eventSeries,\n        },\n      },\n    },\n  },\n  extensions:: {\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"extensions/v1beta1\"},\n      // DEPRECATED - This group version of DaemonSet is deprecated by apps/v1beta2/DaemonSet. See the release notes for more information. DaemonSet represents the configuration of a daemon set.\n      daemonSet:: {\n        local kind = {kind: \"DaemonSet\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // The desired behavior of this daemon set. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // A label query over pods that are managed by the daemon set. Must match in order to be controlled. If empty, defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // An object that describes the pod that will be created. The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // DEPRECATED. A sequence number representing a specific generation of the template. Populated by the system. It can be set only during the creation.\n            withTemplateGeneration(templateGeneration):: self + __specMixin({templateGeneration: templateGeneration}),\n            // An update strategy to replace existing DaemonSet pods with new pods.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = __specMixin({updateStrategy+: updateStrategy}),\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // Rolling update config params. Present only if type = \"RollingUpdate\".\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.extensions.v1beta1.rollingUpdateDaemonSet,\n              // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is OnDelete.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.extensions.v1beta1.daemonSetUpdateStrategy,\n          },\n          specType:: hidden.extensions.v1beta1.daemonSetSpec,\n        },\n      },\n      // DEPRECATED - This group version of Deployment is deprecated by apps/v1beta2/Deployment. See the release notes for more information. Deployment enables declarative updates for Pods and ReplicaSets.\n      deployment:: {\n        local kind = {kind: \"Deployment\"},\n        new(name=\"\", replicas=1, containers=\"\", podLabels={app: \"name\"}):: apiVersion + kind + self.mixin.metadata.withName(name) + self.mixin.spec.withReplicas(replicas) + self.mixin.spec.template.metadata.withLabels(podLabels) + self.mixin.spec.template.spec.withContainers(containers),\n        mixin:: {\n          // Standard object metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of the Deployment.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Indicates that the deployment is paused and will not be processed by the deployment controller.\n            withPaused(paused):: self + __specMixin({paused: paused}),\n            // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. This is not set by default.\n            withProgressDeadlineSeconds(progressDeadlineSeconds):: self + __specMixin({progressDeadlineSeconds: progressDeadlineSeconds}),\n            // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified.\n            withRevisionHistoryLimit(revisionHistoryLimit):: self + __specMixin({revisionHistoryLimit: revisionHistoryLimit}),\n            // DEPRECATED. The config this deployment is rolling back to. Will be cleared after rollback is done.\n            rollbackTo:: {\n              local __rollbackToMixin(rollbackTo) = __specMixin({rollbackTo+: rollbackTo}),\n              mixinInstance(rollbackTo):: __rollbackToMixin(rollbackTo),\n              // The revision to rollback to. If set to 0, rollback to the last revision.\n              withRevision(revision):: self + __rollbackToMixin({revision: revision}),\n            },\n            rollbackToType:: hidden.extensions.v1beta1.rollbackConfig,\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = __specMixin({strategy+: strategy}),\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. By default, a value of 1 is used. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. By default, a fixed value of 1 is used. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.extensions.v1beta1.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.extensions.v1beta1.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.extensions.v1beta1.deploymentSpec,\n        },\n      },\n      // DEPRECATED. DeploymentRollback stores the information required to rollback a deployment.\n      deploymentRollback:: {\n        local kind = {kind: \"DeploymentRollback\"},\n        new(name=\"\"):: apiVersion + kind + self.withName(name),\n        // Required: This must match the Name of a deployment.\n        withName(name):: self + {name: name},\n        // The annotations to be updated to a deployment\n        withUpdatedAnnotations(updatedAnnotations):: self + {updatedAnnotations: updatedAnnotations},\n        // The annotations to be updated to a deployment\n        withUpdatedAnnotationsMixin(updatedAnnotations):: self + {updatedAnnotations+: updatedAnnotations},\n        mixin:: {\n          // The config of this deployment rollback.\n          rollbackTo:: {\n            local __rollbackToMixin(rollbackTo) = {rollbackTo+: rollbackTo},\n            mixinInstance(rollbackTo):: __rollbackToMixin(rollbackTo),\n            // The revision to rollback to. If set to 0, rollback to the last revision.\n            withRevision(revision):: self + __rollbackToMixin({revision: revision}),\n          },\n          rollbackToType:: hidden.extensions.v1beta1.rollbackConfig,\n        },\n      },\n      // Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend. An Ingress can be configured to give services externally-reachable urls, load balance traffic, terminate SSL, offer name based virtual hosting etc.\n      ingress:: {\n        local kind = {kind: \"Ingress\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec is the desired state of the Ingress. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // A default backend capable of servicing requests that don't match any rule. At least one of 'backend' or 'rules' must be specified. This field is optional to allow the loadbalancer controller or defaulting logic to specify a global default.\n            backend:: {\n              local __backendMixin(backend) = __specMixin({backend+: backend}),\n              mixinInstance(backend):: __backendMixin(backend),\n              // Specifies the name of the referenced service.\n              withServiceName(serviceName):: self + __backendMixin({serviceName: serviceName}),\n              // Specifies the port of the referenced service.\n              withServicePort(servicePort):: self + __backendMixin({servicePort: servicePort}),\n            },\n            backendType:: hidden.extensions.v1beta1.ingressBackend,\n            // A list of host rules used to configure the Ingress. If unspecified, or no rule matches, all traffic is sent to the default backend.\n            withRules(rules):: self + if std.type(rules) == \"array\" then __specMixin({rules: rules}) else __specMixin({rules: [rules]}),\n            // A list of host rules used to configure the Ingress. If unspecified, or no rule matches, all traffic is sent to the default backend.\n            withRulesMixin(rules):: self + if std.type(rules) == \"array\" then __specMixin({rules+: rules}) else __specMixin({rules+: [rules]}),\n            rulesType:: hidden.extensions.v1beta1.ingressRule,\n            // TLS configuration. Currently the Ingress only supports a single TLS port, 443. If multiple members of this list specify different hosts, they will be multiplexed on the same port according to the hostname specified through the SNI TLS extension, if the ingress controller fulfilling the ingress supports SNI.\n            withTls(tls):: self + if std.type(tls) == \"array\" then __specMixin({tls: tls}) else __specMixin({tls: [tls]}),\n            // TLS configuration. Currently the Ingress only supports a single TLS port, 443. If multiple members of this list specify different hosts, they will be multiplexed on the same port according to the hostname specified through the SNI TLS extension, if the ingress controller fulfilling the ingress supports SNI.\n            withTlsMixin(tls):: self + if std.type(tls) == \"array\" then __specMixin({tls+: tls}) else __specMixin({tls+: [tls]}),\n            tlsType:: hidden.extensions.v1beta1.ingressTls,\n          },\n          specType:: hidden.extensions.v1beta1.ingressSpec,\n        },\n      },\n      // DEPRECATED 1.9 - This group version of NetworkPolicy is deprecated by networking/v1/NetworkPolicy. NetworkPolicy describes what network traffic is allowed for a set of Pods\n      networkPolicy:: {\n        local kind = {kind: \"NetworkPolicy\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior for this NetworkPolicy.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n            withEgress(egress):: self + if std.type(egress) == \"array\" then __specMixin({egress: egress}) else __specMixin({egress: [egress]}),\n            // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n            withEgressMixin(egress):: self + if std.type(egress) == \"array\" then __specMixin({egress+: egress}) else __specMixin({egress+: [egress]}),\n            egressType:: hidden.extensions.v1beta1.networkPolicyEgressRule,\n            // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default).\n            withIngress(ingress):: self + if std.type(ingress) == \"array\" then __specMixin({ingress: ingress}) else __specMixin({ingress: [ingress]}),\n            // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default).\n            withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then __specMixin({ingress+: ingress}) else __specMixin({ingress+: [ingress]}),\n            ingressType:: hidden.extensions.v1beta1.networkPolicyIngressRule,\n            // Selects the pods to which this NetworkPolicy object applies.  The array of ingress rules is applied to any pods selected by this field. Multiple network policies can select the same set of pods.  In this case, the ingress rules for each are combined additively. This field is NOT optional and follows standard label selector semantics. An empty podSelector matches all pods in this namespace.\n            podSelector:: {\n              local __podSelectorMixin(podSelector) = __specMixin({podSelector+: podSelector}),\n              mixinInstance(podSelector):: __podSelectorMixin(podSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions: matchExpressions}) else __podSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions+: matchExpressions}) else __podSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __podSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __podSelectorMixin({matchLabels+: matchLabels}),\n            },\n            podSelectorType:: hidden.meta.v1.labelSelector,\n            // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n            withPolicyTypes(policyTypes):: self + if std.type(policyTypes) == \"array\" then __specMixin({policyTypes: policyTypes}) else __specMixin({policyTypes: [policyTypes]}),\n            // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n            withPolicyTypesMixin(policyTypes):: self + if std.type(policyTypes) == \"array\" then __specMixin({policyTypes+: policyTypes}) else __specMixin({policyTypes+: [policyTypes]}),\n          },\n          specType:: hidden.extensions.v1beta1.networkPolicySpec,\n        },\n      },\n      // Pod Security Policy governs the ability to make requests that affect the Security Context that will be applied to a pod and container.\n      podSecurityPolicy:: {\n        local kind = {kind: \"PodSecurityPolicy\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // spec defines the policy enforced.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // AllowPrivilegeEscalation determines if a pod can request to allow privilege escalation. If unspecified, defaults to true.\n            withAllowPrivilegeEscalation(allowPrivilegeEscalation):: self + __specMixin({allowPrivilegeEscalation: allowPrivilegeEscalation}),\n            // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n            withAllowedCapabilities(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then __specMixin({allowedCapabilities: allowedCapabilities}) else __specMixin({allowedCapabilities: [allowedCapabilities]}),\n            // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n            withAllowedCapabilitiesMixin(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then __specMixin({allowedCapabilities+: allowedCapabilities}) else __specMixin({allowedCapabilities+: [allowedCapabilities]}),\n            // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n            withAllowedFlexVolumes(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then __specMixin({allowedFlexVolumes: allowedFlexVolumes}) else __specMixin({allowedFlexVolumes: [allowedFlexVolumes]}),\n            // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n            withAllowedFlexVolumesMixin(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then __specMixin({allowedFlexVolumes+: allowedFlexVolumes}) else __specMixin({allowedFlexVolumes+: [allowedFlexVolumes]}),\n            allowedFlexVolumesType:: hidden.extensions.v1beta1.allowedFlexVolume,\n            // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n            withAllowedHostPaths(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then __specMixin({allowedHostPaths: allowedHostPaths}) else __specMixin({allowedHostPaths: [allowedHostPaths]}),\n            // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n            withAllowedHostPathsMixin(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then __specMixin({allowedHostPaths+: allowedHostPaths}) else __specMixin({allowedHostPaths+: [allowedHostPaths]}),\n            allowedHostPathsType:: hidden.extensions.v1beta1.allowedHostPath,\n            // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n            withDefaultAddCapabilities(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then __specMixin({defaultAddCapabilities: defaultAddCapabilities}) else __specMixin({defaultAddCapabilities: [defaultAddCapabilities]}),\n            // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n            withDefaultAddCapabilitiesMixin(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then __specMixin({defaultAddCapabilities+: defaultAddCapabilities}) else __specMixin({defaultAddCapabilities+: [defaultAddCapabilities]}),\n            // DefaultAllowPrivilegeEscalation controls the default setting for whether a process can gain more privileges than its parent process.\n            withDefaultAllowPrivilegeEscalation(defaultAllowPrivilegeEscalation):: self + __specMixin({defaultAllowPrivilegeEscalation: defaultAllowPrivilegeEscalation}),\n            // FSGroup is the strategy that will dictate what fs group is used by the SecurityContext.\n            fsGroup:: {\n              local __fsGroupMixin(fsGroup) = __specMixin({fsGroup+: fsGroup}),\n              mixinInstance(fsGroup):: __fsGroupMixin(fsGroup),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges: ranges}) else __fsGroupMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges+: ranges}) else __fsGroupMixin({ranges+: [ranges]}),\n              rangesType:: hidden.extensions.v1beta1.idRange,\n              // Rule is the strategy that will dictate what FSGroup is used in the SecurityContext.\n              withRule(rule):: self + __fsGroupMixin({rule: rule}),\n            },\n            fsGroupType:: hidden.extensions.v1beta1.fsGroupStrategyOptions,\n            // hostIPC determines if the policy allows the use of HostIPC in the pod spec.\n            withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n            // hostNetwork determines if the policy allows the use of HostNetwork in the pod spec.\n            withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n            // hostPID determines if the policy allows the use of HostPID in the pod spec.\n            withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n            // hostPorts determines which host port ranges are allowed to be exposed.\n            withHostPorts(hostPorts):: self + if std.type(hostPorts) == \"array\" then __specMixin({hostPorts: hostPorts}) else __specMixin({hostPorts: [hostPorts]}),\n            // hostPorts determines which host port ranges are allowed to be exposed.\n            withHostPortsMixin(hostPorts):: self + if std.type(hostPorts) == \"array\" then __specMixin({hostPorts+: hostPorts}) else __specMixin({hostPorts+: [hostPorts]}),\n            hostPortsType:: hidden.extensions.v1beta1.hostPortRange,\n            // privileged determines if a pod can request to be run as privileged.\n            withPrivileged(privileged):: self + __specMixin({privileged: privileged}),\n            // ReadOnlyRootFilesystem when set to true will force containers to run with a read only root file system.  If the container specifically requests to run with a non-read only root file system the PSP should deny the pod. If set to false the container may run with a read only root file system if it wishes but it will not be forced to.\n            withReadOnlyRootFilesystem(readOnlyRootFilesystem):: self + __specMixin({readOnlyRootFilesystem: readOnlyRootFilesystem}),\n            // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n            withRequiredDropCapabilities(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then __specMixin({requiredDropCapabilities: requiredDropCapabilities}) else __specMixin({requiredDropCapabilities: [requiredDropCapabilities]}),\n            // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n            withRequiredDropCapabilitiesMixin(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then __specMixin({requiredDropCapabilities+: requiredDropCapabilities}) else __specMixin({requiredDropCapabilities+: [requiredDropCapabilities]}),\n            // runAsUser is the strategy that will dictate the allowable RunAsUser values that may be set.\n            runAsUser:: {\n              local __runAsUserMixin(runAsUser) = __specMixin({runAsUser+: runAsUser}),\n              mixinInstance(runAsUser):: __runAsUserMixin(runAsUser),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges: ranges}) else __runAsUserMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges+: ranges}) else __runAsUserMixin({ranges+: [ranges]}),\n              rangesType:: hidden.extensions.v1beta1.idRange,\n              // Rule is the strategy that will dictate the allowable RunAsUser values that may be set.\n              withRule(rule):: self + __runAsUserMixin({rule: rule}),\n            },\n            runAsUserType:: hidden.extensions.v1beta1.runAsUserStrategyOptions,\n            // seLinux is the strategy that will dictate the allowable labels that may be set.\n            seLinux:: {\n              local __seLinuxMixin(seLinux) = __specMixin({seLinux+: seLinux}),\n              mixinInstance(seLinux):: __seLinuxMixin(seLinux),\n              // type is the strategy that will dictate the allowable labels that may be set.\n              withRule(rule):: self + __seLinuxMixin({rule: rule}),\n              // seLinuxOptions required to run as; required for MustRunAs More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __seLinuxMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n            },\n            seLinuxType:: hidden.extensions.v1beta1.seLinuxStrategyOptions,\n            // SupplementalGroups is the strategy that will dictate what supplemental groups are used by the SecurityContext.\n            supplementalGroups:: {\n              local __supplementalGroupsMixin(supplementalGroups) = __specMixin({supplementalGroups+: supplementalGroups}),\n              mixinInstance(supplementalGroups):: __supplementalGroupsMixin(supplementalGroups),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges: ranges}) else __supplementalGroupsMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges+: ranges}) else __supplementalGroupsMixin({ranges+: [ranges]}),\n              rangesType:: hidden.extensions.v1beta1.idRange,\n              // Rule is the strategy that will dictate what supplemental groups is used in the SecurityContext.\n              withRule(rule):: self + __supplementalGroupsMixin({rule: rule}),\n            },\n            supplementalGroupsType:: hidden.extensions.v1beta1.supplementalGroupsStrategyOptions,\n            // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n            withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n            // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n            withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n          },\n          specType:: hidden.extensions.v1beta1.podSecurityPolicySpec,\n        },\n      },\n      // DEPRECATED - This group version of ReplicaSet is deprecated by apps/v1beta2/ReplicaSet. See the release notes for more information. ReplicaSet ensures that a specified number of pod replicas are running at any given time.\n      replicaSet:: {\n        local kind = {kind: \"ReplicaSet\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages. Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Spec defines the specification of the desired behavior of the ReplicaSet. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n            withMinReadySeconds(minReadySeconds):: self + __specMixin({minReadySeconds: minReadySeconds}),\n            // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n            // Selector is a label query over pods that should match the replica count. If the selector is empty, it is defaulted to the labels present on the pod template. Label keys and values that must match in order to be controlled by this replica set. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = __specMixin({template+: template}),\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n          specType:: hidden.extensions.v1beta1.replicaSetSpec,\n        },\n      },\n      // represents a scaling request for a resource.\n      scale:: {\n        local kind = {kind: \"Scale\"},\n        new(replicas=1):: apiVersion + kind + self.mixin.spec.withReplicas(replicas),\n        mixin:: {\n          // Standard object metadata; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // defines the behavior of the scale. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // desired number of instances for the scaled object.\n            withReplicas(replicas):: self + __specMixin({replicas: replicas}),\n          },\n          specType:: hidden.extensions.v1beta1.scaleSpec,\n        },\n      },\n    },\n  },\n  meta:: {\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"apps/v1beta1\"},\n      // Patch is provided to give a concrete name and type to the Kubernetes PATCH request body.\n      deployment:: {\n        local kind = {kind: \"Deployment\"},\n        new():: apiVersion + kind,\n        mixin:: {\n        },\n      },\n    },\n  },\n  networking:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"networking.k8s.io/v1\"},\n      // NetworkPolicy describes what network traffic is allowed for a set of Pods\n      networkPolicy:: {\n        local kind = {kind: \"NetworkPolicy\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior for this NetworkPolicy.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n            withEgress(egress):: self + if std.type(egress) == \"array\" then __specMixin({egress: egress}) else __specMixin({egress: [egress]}),\n            // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n            withEgressMixin(egress):: self + if std.type(egress) == \"array\" then __specMixin({egress+: egress}) else __specMixin({egress+: [egress]}),\n            egressType:: hidden.networking.v1.networkPolicyEgressRule,\n            // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default)\n            withIngress(ingress):: self + if std.type(ingress) == \"array\" then __specMixin({ingress: ingress}) else __specMixin({ingress: [ingress]}),\n            // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default)\n            withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then __specMixin({ingress+: ingress}) else __specMixin({ingress+: [ingress]}),\n            ingressType:: hidden.networking.v1.networkPolicyIngressRule,\n            // Selects the pods to which this NetworkPolicy object applies. The array of ingress rules is applied to any pods selected by this field. Multiple network policies can select the same set of pods. In this case, the ingress rules for each are combined additively. This field is NOT optional and follows standard label selector semantics. An empty podSelector matches all pods in this namespace.\n            podSelector:: {\n              local __podSelectorMixin(podSelector) = __specMixin({podSelector+: podSelector}),\n              mixinInstance(podSelector):: __podSelectorMixin(podSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions: matchExpressions}) else __podSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions+: matchExpressions}) else __podSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __podSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __podSelectorMixin({matchLabels+: matchLabels}),\n            },\n            podSelectorType:: hidden.meta.v1.labelSelector,\n            // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n            withPolicyTypes(policyTypes):: self + if std.type(policyTypes) == \"array\" then __specMixin({policyTypes: policyTypes}) else __specMixin({policyTypes: [policyTypes]}),\n            // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n            withPolicyTypesMixin(policyTypes):: self + if std.type(policyTypes) == \"array\" then __specMixin({policyTypes+: policyTypes}) else __specMixin({policyTypes+: [policyTypes]}),\n          },\n          specType:: hidden.networking.v1.networkPolicySpec,\n        },\n      },\n    },\n  },\n  policy:: {\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"policy/v1beta1\"},\n      // Eviction evicts a pod from its node subject to certain policies and safety constraints. This is a subresource of Pod.  A request to cause such an eviction is created by POSTing to .../pods/<pod name>/evictions.\n      eviction:: {\n        local kind = {kind: \"Eviction\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // DeleteOptions may be provided\n          deleteOptions:: {\n            local __deleteOptionsMixin(deleteOptions) = {deleteOptions+: deleteOptions},\n            mixinInstance(deleteOptions):: __deleteOptionsMixin(deleteOptions),\n            // The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.\n            withGracePeriodSeconds(gracePeriodSeconds):: self + __deleteOptionsMixin({gracePeriodSeconds: gracePeriodSeconds}),\n            // Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \"orphan\" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both.\n            withOrphanDependents(orphanDependents):: self + __deleteOptionsMixin({orphanDependents: orphanDependents}),\n            // Must be fulfilled before a deletion is carried out. If not possible, a 409 Conflict status will be returned.\n            preconditions:: {\n              local __preconditionsMixin(preconditions) = __deleteOptionsMixin({preconditions+: preconditions}),\n              mixinInstance(preconditions):: __preconditionsMixin(preconditions),\n              // Specifies the target UID.\n              withUid(uid):: self + __preconditionsMixin({uid: uid}),\n            },\n            preconditionsType:: hidden.meta.v1.preconditions,\n            // Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: 'Orphan' - orphan the dependents; 'Background' - allow the garbage collector to delete the dependents in the background; 'Foreground' - a cascading policy that deletes all dependents in the foreground.\n            withPropagationPolicy(propagationPolicy):: self + __deleteOptionsMixin({propagationPolicy: propagationPolicy}),\n          },\n          deleteOptionsType:: hidden.meta.v1.deleteOptions,\n          // ObjectMeta describes the pod that is being evicted.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // PodDisruptionBudget is an object to define the max disruption that can be caused to a collection of pods\n      podDisruptionBudget:: {\n        local kind = {kind: \"PodDisruptionBudget\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired behavior of the PodDisruptionBudget.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // An eviction is allowed if at most \"maxUnavailable\" pods selected by \"selector\" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with \"minAvailable\".\n            withMaxUnavailable(maxUnavailable):: self + __specMixin({maxUnavailable: maxUnavailable}),\n            // An eviction is allowed if at least \"minAvailable\" pods selected by \"selector\" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying \"100%\".\n            withMinAvailable(minAvailable):: self + __specMixin({minAvailable: minAvailable}),\n            // Label query over pods whose evictions are managed by the disruption budget.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n          },\n          specType:: hidden.policy.v1beta1.podDisruptionBudgetSpec,\n        },\n      },\n      // Pod Security Policy governs the ability to make requests that affect the Security Context that will be applied to a pod and container.\n      podSecurityPolicy:: {\n        local kind = {kind: \"PodSecurityPolicy\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // spec defines the policy enforced.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // AllowPrivilegeEscalation determines if a pod can request to allow privilege escalation. If unspecified, defaults to true.\n            withAllowPrivilegeEscalation(allowPrivilegeEscalation):: self + __specMixin({allowPrivilegeEscalation: allowPrivilegeEscalation}),\n            // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n            withAllowedCapabilities(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then __specMixin({allowedCapabilities: allowedCapabilities}) else __specMixin({allowedCapabilities: [allowedCapabilities]}),\n            // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n            withAllowedCapabilitiesMixin(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then __specMixin({allowedCapabilities+: allowedCapabilities}) else __specMixin({allowedCapabilities+: [allowedCapabilities]}),\n            // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n            withAllowedFlexVolumes(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then __specMixin({allowedFlexVolumes: allowedFlexVolumes}) else __specMixin({allowedFlexVolumes: [allowedFlexVolumes]}),\n            // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n            withAllowedFlexVolumesMixin(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then __specMixin({allowedFlexVolumes+: allowedFlexVolumes}) else __specMixin({allowedFlexVolumes+: [allowedFlexVolumes]}),\n            allowedFlexVolumesType:: hidden.policy.v1beta1.allowedFlexVolume,\n            // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n            withAllowedHostPaths(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then __specMixin({allowedHostPaths: allowedHostPaths}) else __specMixin({allowedHostPaths: [allowedHostPaths]}),\n            // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n            withAllowedHostPathsMixin(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then __specMixin({allowedHostPaths+: allowedHostPaths}) else __specMixin({allowedHostPaths+: [allowedHostPaths]}),\n            allowedHostPathsType:: hidden.policy.v1beta1.allowedHostPath,\n            // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n            withDefaultAddCapabilities(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then __specMixin({defaultAddCapabilities: defaultAddCapabilities}) else __specMixin({defaultAddCapabilities: [defaultAddCapabilities]}),\n            // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n            withDefaultAddCapabilitiesMixin(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then __specMixin({defaultAddCapabilities+: defaultAddCapabilities}) else __specMixin({defaultAddCapabilities+: [defaultAddCapabilities]}),\n            // DefaultAllowPrivilegeEscalation controls the default setting for whether a process can gain more privileges than its parent process.\n            withDefaultAllowPrivilegeEscalation(defaultAllowPrivilegeEscalation):: self + __specMixin({defaultAllowPrivilegeEscalation: defaultAllowPrivilegeEscalation}),\n            // FSGroup is the strategy that will dictate what fs group is used by the SecurityContext.\n            fsGroup:: {\n              local __fsGroupMixin(fsGroup) = __specMixin({fsGroup+: fsGroup}),\n              mixinInstance(fsGroup):: __fsGroupMixin(fsGroup),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges: ranges}) else __fsGroupMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges+: ranges}) else __fsGroupMixin({ranges+: [ranges]}),\n              rangesType:: hidden.policy.v1beta1.idRange,\n              // Rule is the strategy that will dictate what FSGroup is used in the SecurityContext.\n              withRule(rule):: self + __fsGroupMixin({rule: rule}),\n            },\n            fsGroupType:: hidden.policy.v1beta1.fsGroupStrategyOptions,\n            // hostIPC determines if the policy allows the use of HostIPC in the pod spec.\n            withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n            // hostNetwork determines if the policy allows the use of HostNetwork in the pod spec.\n            withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n            // hostPID determines if the policy allows the use of HostPID in the pod spec.\n            withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n            // hostPorts determines which host port ranges are allowed to be exposed.\n            withHostPorts(hostPorts):: self + if std.type(hostPorts) == \"array\" then __specMixin({hostPorts: hostPorts}) else __specMixin({hostPorts: [hostPorts]}),\n            // hostPorts determines which host port ranges are allowed to be exposed.\n            withHostPortsMixin(hostPorts):: self + if std.type(hostPorts) == \"array\" then __specMixin({hostPorts+: hostPorts}) else __specMixin({hostPorts+: [hostPorts]}),\n            hostPortsType:: hidden.policy.v1beta1.hostPortRange,\n            // privileged determines if a pod can request to be run as privileged.\n            withPrivileged(privileged):: self + __specMixin({privileged: privileged}),\n            // ReadOnlyRootFilesystem when set to true will force containers to run with a read only root file system.  If the container specifically requests to run with a non-read only root file system the PSP should deny the pod. If set to false the container may run with a read only root file system if it wishes but it will not be forced to.\n            withReadOnlyRootFilesystem(readOnlyRootFilesystem):: self + __specMixin({readOnlyRootFilesystem: readOnlyRootFilesystem}),\n            // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n            withRequiredDropCapabilities(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then __specMixin({requiredDropCapabilities: requiredDropCapabilities}) else __specMixin({requiredDropCapabilities: [requiredDropCapabilities]}),\n            // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n            withRequiredDropCapabilitiesMixin(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then __specMixin({requiredDropCapabilities+: requiredDropCapabilities}) else __specMixin({requiredDropCapabilities+: [requiredDropCapabilities]}),\n            // runAsUser is the strategy that will dictate the allowable RunAsUser values that may be set.\n            runAsUser:: {\n              local __runAsUserMixin(runAsUser) = __specMixin({runAsUser+: runAsUser}),\n              mixinInstance(runAsUser):: __runAsUserMixin(runAsUser),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges: ranges}) else __runAsUserMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges+: ranges}) else __runAsUserMixin({ranges+: [ranges]}),\n              rangesType:: hidden.policy.v1beta1.idRange,\n              // Rule is the strategy that will dictate the allowable RunAsUser values that may be set.\n              withRule(rule):: self + __runAsUserMixin({rule: rule}),\n            },\n            runAsUserType:: hidden.policy.v1beta1.runAsUserStrategyOptions,\n            // seLinux is the strategy that will dictate the allowable labels that may be set.\n            seLinux:: {\n              local __seLinuxMixin(seLinux) = __specMixin({seLinux+: seLinux}),\n              mixinInstance(seLinux):: __seLinuxMixin(seLinux),\n              // type is the strategy that will dictate the allowable labels that may be set.\n              withRule(rule):: self + __seLinuxMixin({rule: rule}),\n              // seLinuxOptions required to run as; required for MustRunAs More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __seLinuxMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n            },\n            seLinuxType:: hidden.policy.v1beta1.seLinuxStrategyOptions,\n            // SupplementalGroups is the strategy that will dictate what supplemental groups are used by the SecurityContext.\n            supplementalGroups:: {\n              local __supplementalGroupsMixin(supplementalGroups) = __specMixin({supplementalGroups+: supplementalGroups}),\n              mixinInstance(supplementalGroups):: __supplementalGroupsMixin(supplementalGroups),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges: ranges}) else __supplementalGroupsMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges+: ranges}) else __supplementalGroupsMixin({ranges+: [ranges]}),\n              rangesType:: hidden.policy.v1beta1.idRange,\n              // Rule is the strategy that will dictate what supplemental groups is used in the SecurityContext.\n              withRule(rule):: self + __supplementalGroupsMixin({rule: rule}),\n            },\n            supplementalGroupsType:: hidden.policy.v1beta1.supplementalGroupsStrategyOptions,\n            // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n            withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n            // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n            withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n          },\n          specType:: hidden.policy.v1beta1.podSecurityPolicySpec,\n        },\n      },\n    },\n  },\n  rbac:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"rbac.authorization.k8s.io/v1\"},\n      // ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.\n      clusterRole:: {\n        local kind = {kind: \"ClusterRole\"},\n        new():: apiVersion + kind,\n        // Rules holds all the PolicyRules for this ClusterRole\n        withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n        // Rules holds all the PolicyRules for this ClusterRole\n        withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n        rulesType:: hidden.rbac.v1.policyRule,\n        mixin:: {\n          // AggregationRule is an optional field that describes how to build the Rules for this ClusterRole. If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.\n          aggregationRule:: {\n            local __aggregationRuleMixin(aggregationRule) = {aggregationRule+: aggregationRule},\n            mixinInstance(aggregationRule):: __aggregationRuleMixin(aggregationRule),\n            // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n            withClusterRoleSelectors(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then __aggregationRuleMixin({clusterRoleSelectors: clusterRoleSelectors}) else __aggregationRuleMixin({clusterRoleSelectors: [clusterRoleSelectors]}),\n            // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n            withClusterRoleSelectorsMixin(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then __aggregationRuleMixin({clusterRoleSelectors+: clusterRoleSelectors}) else __aggregationRuleMixin({clusterRoleSelectors+: [clusterRoleSelectors]}),\n            clusterRoleSelectorsType:: hidden.meta.v1.labelSelector,\n          },\n          aggregationRuleType:: hidden.rbac.v1.aggregationRule,\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // ClusterRoleBinding references a ClusterRole, but not contain it.  It can reference a ClusterRole in the global namespace, and adds who information via Subject.\n      clusterRoleBinding:: {\n        local kind = {kind: \"ClusterRoleBinding\"},\n        new():: apiVersion + kind,\n        // Subjects holds references to the objects the role applies to.\n        withSubjects(subjects):: self + if std.type(subjects) == \"array\" then {subjects: subjects} else {subjects: [subjects]},\n        // Subjects holds references to the objects the role applies to.\n        withSubjectsMixin(subjects):: self + if std.type(subjects) == \"array\" then {subjects+: subjects} else {subjects+: [subjects]},\n        subjectsType:: hidden.rbac.v1.subject,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // RoleRef can only reference a ClusterRole in the global namespace. If the RoleRef cannot be resolved, the Authorizer must return an error.\n          roleRef:: {\n            local __roleRefMixin(roleRef) = {roleRef+: roleRef},\n            mixinInstance(roleRef):: __roleRefMixin(roleRef),\n            // APIGroup is the group for the resource being referenced\n            withApiGroup(apiGroup):: self + __roleRefMixin({apiGroup: apiGroup}),\n            // Kind is the type of resource being referenced\n            withKind(kind):: self + __roleRefMixin({kind: kind}),\n            // Name is the name of resource being referenced\n            withName(name):: self + __roleRefMixin({name: name}),\n          },\n          roleRefType:: hidden.rbac.v1.roleRef,\n        },\n      },\n      // Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.\n      role:: {\n        local kind = {kind: \"Role\"},\n        new():: apiVersion + kind,\n        // Rules holds all the PolicyRules for this Role\n        withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n        // Rules holds all the PolicyRules for this Role\n        withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n        rulesType:: hidden.rbac.v1.policyRule,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // RoleBinding references a role, but does not contain it.  It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.\n      roleBinding:: {\n        local kind = {kind: \"RoleBinding\"},\n        new():: apiVersion + kind,\n        // Subjects holds references to the objects the role applies to.\n        withSubjects(subjects):: self + if std.type(subjects) == \"array\" then {subjects: subjects} else {subjects: [subjects]},\n        // Subjects holds references to the objects the role applies to.\n        withSubjectsMixin(subjects):: self + if std.type(subjects) == \"array\" then {subjects+: subjects} else {subjects+: [subjects]},\n        subjectsType:: hidden.rbac.v1.subject,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace. If the RoleRef cannot be resolved, the Authorizer must return an error.\n          roleRef:: {\n            local __roleRefMixin(roleRef) = {roleRef+: roleRef},\n            mixinInstance(roleRef):: __roleRefMixin(roleRef),\n            // APIGroup is the group for the resource being referenced\n            withApiGroup(apiGroup):: self + __roleRefMixin({apiGroup: apiGroup}),\n            // Kind is the type of resource being referenced\n            withKind(kind):: self + __roleRefMixin({kind: kind}),\n            // Name is the name of resource being referenced\n            withName(name):: self + __roleRefMixin({name: name}),\n          },\n          roleRefType:: hidden.rbac.v1.roleRef,\n        },\n      },\n    },\n    v1alpha1:: {\n      local apiVersion = {apiVersion: \"rbac.authorization.k8s.io/v1alpha1\"},\n      // ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.\n      clusterRole:: {\n        local kind = {kind: \"ClusterRole\"},\n        new():: apiVersion + kind,\n        // Rules holds all the PolicyRules for this ClusterRole\n        withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n        // Rules holds all the PolicyRules for this ClusterRole\n        withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n        rulesType:: hidden.rbac.v1alpha1.policyRule,\n        mixin:: {\n          // AggregationRule is an optional field that describes how to build the Rules for this ClusterRole. If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.\n          aggregationRule:: {\n            local __aggregationRuleMixin(aggregationRule) = {aggregationRule+: aggregationRule},\n            mixinInstance(aggregationRule):: __aggregationRuleMixin(aggregationRule),\n            // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n            withClusterRoleSelectors(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then __aggregationRuleMixin({clusterRoleSelectors: clusterRoleSelectors}) else __aggregationRuleMixin({clusterRoleSelectors: [clusterRoleSelectors]}),\n            // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n            withClusterRoleSelectorsMixin(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then __aggregationRuleMixin({clusterRoleSelectors+: clusterRoleSelectors}) else __aggregationRuleMixin({clusterRoleSelectors+: [clusterRoleSelectors]}),\n            clusterRoleSelectorsType:: hidden.meta.v1.labelSelector,\n          },\n          aggregationRuleType:: hidden.rbac.v1alpha1.aggregationRule,\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // ClusterRoleBinding references a ClusterRole, but not contain it.  It can reference a ClusterRole in the global namespace, and adds who information via Subject.\n      clusterRoleBinding:: {\n        local kind = {kind: \"ClusterRoleBinding\"},\n        new():: apiVersion + kind,\n        // Subjects holds references to the objects the role applies to.\n        withSubjects(subjects):: self + if std.type(subjects) == \"array\" then {subjects: subjects} else {subjects: [subjects]},\n        // Subjects holds references to the objects the role applies to.\n        withSubjectsMixin(subjects):: self + if std.type(subjects) == \"array\" then {subjects+: subjects} else {subjects+: [subjects]},\n        subjectsType:: hidden.rbac.v1alpha1.subject,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // RoleRef can only reference a ClusterRole in the global namespace. If the RoleRef cannot be resolved, the Authorizer must return an error.\n          roleRef:: {\n            local __roleRefMixin(roleRef) = {roleRef+: roleRef},\n            mixinInstance(roleRef):: __roleRefMixin(roleRef),\n            // APIGroup is the group for the resource being referenced\n            withApiGroup(apiGroup):: self + __roleRefMixin({apiGroup: apiGroup}),\n            // Kind is the type of resource being referenced\n            withKind(kind):: self + __roleRefMixin({kind: kind}),\n            // Name is the name of resource being referenced\n            withName(name):: self + __roleRefMixin({name: name}),\n          },\n          roleRefType:: hidden.rbac.v1alpha1.roleRef,\n        },\n      },\n      // Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.\n      role:: {\n        local kind = {kind: \"Role\"},\n        new():: apiVersion + kind,\n        // Rules holds all the PolicyRules for this Role\n        withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n        // Rules holds all the PolicyRules for this Role\n        withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n        rulesType:: hidden.rbac.v1alpha1.policyRule,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // RoleBinding references a role, but does not contain it.  It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.\n      roleBinding:: {\n        local kind = {kind: \"RoleBinding\"},\n        new():: apiVersion + kind,\n        // Subjects holds references to the objects the role applies to.\n        withSubjects(subjects):: self + if std.type(subjects) == \"array\" then {subjects: subjects} else {subjects: [subjects]},\n        // Subjects holds references to the objects the role applies to.\n        withSubjectsMixin(subjects):: self + if std.type(subjects) == \"array\" then {subjects+: subjects} else {subjects+: [subjects]},\n        subjectsType:: hidden.rbac.v1alpha1.subject,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace. If the RoleRef cannot be resolved, the Authorizer must return an error.\n          roleRef:: {\n            local __roleRefMixin(roleRef) = {roleRef+: roleRef},\n            mixinInstance(roleRef):: __roleRefMixin(roleRef),\n            // APIGroup is the group for the resource being referenced\n            withApiGroup(apiGroup):: self + __roleRefMixin({apiGroup: apiGroup}),\n            // Kind is the type of resource being referenced\n            withKind(kind):: self + __roleRefMixin({kind: kind}),\n            // Name is the name of resource being referenced\n            withName(name):: self + __roleRefMixin({name: name}),\n          },\n          roleRefType:: hidden.rbac.v1alpha1.roleRef,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"rbac.authorization.k8s.io/v1beta1\"},\n      // ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.\n      clusterRole:: {\n        local kind = {kind: \"ClusterRole\"},\n        new():: apiVersion + kind,\n        // Rules holds all the PolicyRules for this ClusterRole\n        withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n        // Rules holds all the PolicyRules for this ClusterRole\n        withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n        rulesType:: hidden.rbac.v1beta1.policyRule,\n        mixin:: {\n          // AggregationRule is an optional field that describes how to build the Rules for this ClusterRole. If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.\n          aggregationRule:: {\n            local __aggregationRuleMixin(aggregationRule) = {aggregationRule+: aggregationRule},\n            mixinInstance(aggregationRule):: __aggregationRuleMixin(aggregationRule),\n            // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n            withClusterRoleSelectors(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then __aggregationRuleMixin({clusterRoleSelectors: clusterRoleSelectors}) else __aggregationRuleMixin({clusterRoleSelectors: [clusterRoleSelectors]}),\n            // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n            withClusterRoleSelectorsMixin(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then __aggregationRuleMixin({clusterRoleSelectors+: clusterRoleSelectors}) else __aggregationRuleMixin({clusterRoleSelectors+: [clusterRoleSelectors]}),\n            clusterRoleSelectorsType:: hidden.meta.v1.labelSelector,\n          },\n          aggregationRuleType:: hidden.rbac.v1beta1.aggregationRule,\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // ClusterRoleBinding references a ClusterRole, but not contain it.  It can reference a ClusterRole in the global namespace, and adds who information via Subject.\n      clusterRoleBinding:: {\n        local kind = {kind: \"ClusterRoleBinding\"},\n        new():: apiVersion + kind,\n        // Subjects holds references to the objects the role applies to.\n        withSubjects(subjects):: self + if std.type(subjects) == \"array\" then {subjects: subjects} else {subjects: [subjects]},\n        // Subjects holds references to the objects the role applies to.\n        withSubjectsMixin(subjects):: self + if std.type(subjects) == \"array\" then {subjects+: subjects} else {subjects+: [subjects]},\n        subjectsType:: hidden.rbac.v1beta1.subject,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // RoleRef can only reference a ClusterRole in the global namespace. If the RoleRef cannot be resolved, the Authorizer must return an error.\n          roleRef:: {\n            local __roleRefMixin(roleRef) = {roleRef+: roleRef},\n            mixinInstance(roleRef):: __roleRefMixin(roleRef),\n            // APIGroup is the group for the resource being referenced\n            withApiGroup(apiGroup):: self + __roleRefMixin({apiGroup: apiGroup}),\n            // Kind is the type of resource being referenced\n            withKind(kind):: self + __roleRefMixin({kind: kind}),\n            // Name is the name of resource being referenced\n            withName(name):: self + __roleRefMixin({name: name}),\n          },\n          roleRefType:: hidden.rbac.v1beta1.roleRef,\n        },\n      },\n      // Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.\n      role:: {\n        local kind = {kind: \"Role\"},\n        new():: apiVersion + kind,\n        // Rules holds all the PolicyRules for this Role\n        withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n        // Rules holds all the PolicyRules for this Role\n        withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n        rulesType:: hidden.rbac.v1beta1.policyRule,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // RoleBinding references a role, but does not contain it.  It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.\n      roleBinding:: {\n        local kind = {kind: \"RoleBinding\"},\n        new():: apiVersion + kind,\n        // Subjects holds references to the objects the role applies to.\n        withSubjects(subjects):: self + if std.type(subjects) == \"array\" then {subjects: subjects} else {subjects: [subjects]},\n        // Subjects holds references to the objects the role applies to.\n        withSubjectsMixin(subjects):: self + if std.type(subjects) == \"array\" then {subjects+: subjects} else {subjects+: [subjects]},\n        subjectsType:: hidden.rbac.v1beta1.subject,\n        mixin:: {\n          // Standard object's metadata.\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace. If the RoleRef cannot be resolved, the Authorizer must return an error.\n          roleRef:: {\n            local __roleRefMixin(roleRef) = {roleRef+: roleRef},\n            mixinInstance(roleRef):: __roleRefMixin(roleRef),\n            // APIGroup is the group for the resource being referenced\n            withApiGroup(apiGroup):: self + __roleRefMixin({apiGroup: apiGroup}),\n            // Kind is the type of resource being referenced\n            withKind(kind):: self + __roleRefMixin({kind: kind}),\n            // Name is the name of resource being referenced\n            withName(name):: self + __roleRefMixin({name: name}),\n          },\n          roleRefType:: hidden.rbac.v1beta1.roleRef,\n        },\n      },\n    },\n  },\n  scheduling:: {\n    v1alpha1:: {\n      local apiVersion = {apiVersion: \"scheduling.k8s.io/v1alpha1\"},\n      // PriorityClass defines mapping from a priority class name to the priority integer value. The value can be any valid integer.\n      priorityClass:: {\n        local kind = {kind: \"PriorityClass\"},\n        new():: apiVersion + kind,\n        // description is an arbitrary string that usually provides guidelines on when this priority class should be used.\n        withDescription(description):: self + {description: description},\n        // globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class. Only one PriorityClass can be marked as `globalDefault`. However, if more than one PriorityClasses exists with their `globalDefault` field set to true, the smallest value of such global default PriorityClasses will be used as the default priority.\n        withGlobalDefault(globalDefault):: self + {globalDefault: globalDefault},\n        // The value of this priority class. This is the actual priority that pods receive when they have the name of this class in their pod spec.\n        withValue(value):: self + {value: value},\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n    },\n  },\n  settings:: {\n    v1alpha1:: {\n      local apiVersion = {apiVersion: \"settings.k8s.io/v1alpha1\"},\n      // PodPreset is a policy resource that defines additional runtime requirements for a Pod.\n      podPreset:: {\n        local kind = {kind: \"PodPreset\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Env defines the collection of EnvVar to inject into containers.\n            withEnv(env):: self + if std.type(env) == \"array\" then __specMixin({env: env}) else __specMixin({env: [env]}),\n            // Env defines the collection of EnvVar to inject into containers.\n            withEnvMixin(env):: self + if std.type(env) == \"array\" then __specMixin({env+: env}) else __specMixin({env+: [env]}),\n            envType:: hidden.core.v1.envVar,\n            // EnvFrom defines the collection of EnvFromSource to inject into containers.\n            withEnvFrom(envFrom):: self + if std.type(envFrom) == \"array\" then __specMixin({envFrom: envFrom}) else __specMixin({envFrom: [envFrom]}),\n            // EnvFrom defines the collection of EnvFromSource to inject into containers.\n            withEnvFromMixin(envFrom):: self + if std.type(envFrom) == \"array\" then __specMixin({envFrom+: envFrom}) else __specMixin({envFrom+: [envFrom]}),\n            envFromType:: hidden.core.v1.envFromSource,\n            // Selector is a label query over a set of resources, in this case pods. Required.\n            selector:: {\n              local __selectorMixin(selector) = __specMixin({selector+: selector}),\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // VolumeMounts defines the collection of VolumeMount to inject into containers.\n            withVolumeMounts(volumeMounts):: self + if std.type(volumeMounts) == \"array\" then __specMixin({volumeMounts: volumeMounts}) else __specMixin({volumeMounts: [volumeMounts]}),\n            // VolumeMounts defines the collection of VolumeMount to inject into containers.\n            withVolumeMountsMixin(volumeMounts):: self + if std.type(volumeMounts) == \"array\" then __specMixin({volumeMounts+: volumeMounts}) else __specMixin({volumeMounts+: [volumeMounts]}),\n            volumeMountsType:: hidden.core.v1.volumeMount,\n            // Volumes defines the collection of Volume to inject into the pod.\n            withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n            // Volumes defines the collection of Volume to inject into the pod.\n            withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n            volumesType:: hidden.core.v1.volume,\n          },\n          specType:: hidden.settings.v1alpha1.podPresetSpec,\n        },\n      },\n    },\n  },\n  storage:: {\n    v1:: {\n      local apiVersion = {apiVersion: \"storage.k8s.io/v1\"},\n      // StorageClass describes the parameters for a class of storage for which PersistentVolumes can be dynamically provisioned.\n      //\n      // StorageClasses are non-namespaced; the name of the storage class according to etcd is in ObjectMeta.Name.\n      storageClass:: {\n        local kind = {kind: \"StorageClass\"},\n        new():: apiVersion + kind,\n        // AllowVolumeExpansion shows whether the storage class allow volume expand\n        withAllowVolumeExpansion(allowVolumeExpansion):: self + {allowVolumeExpansion: allowVolumeExpansion},\n        // Dynamically provisioned PersistentVolumes of this storage class are created with these mountOptions, e.g. [\"ro\", \"soft\"]. Not validated - mount of the PVs will simply fail if one is invalid.\n        withMountOptions(mountOptions):: self + if std.type(mountOptions) == \"array\" then {mountOptions: mountOptions} else {mountOptions: [mountOptions]},\n        // Dynamically provisioned PersistentVolumes of this storage class are created with these mountOptions, e.g. [\"ro\", \"soft\"]. Not validated - mount of the PVs will simply fail if one is invalid.\n        withMountOptionsMixin(mountOptions):: self + if std.type(mountOptions) == \"array\" then {mountOptions+: mountOptions} else {mountOptions+: [mountOptions]},\n        // Parameters holds the parameters for the provisioner that should create volumes of this storage class.\n        withParameters(parameters):: self + {parameters: parameters},\n        // Parameters holds the parameters for the provisioner that should create volumes of this storage class.\n        withParametersMixin(parameters):: self + {parameters+: parameters},\n        // Provisioner indicates the type of the provisioner.\n        withProvisioner(provisioner):: self + {provisioner: provisioner},\n        // Dynamically provisioned PersistentVolumes of this storage class are created with this reclaimPolicy. Defaults to Delete.\n        withReclaimPolicy(reclaimPolicy):: self + {reclaimPolicy: reclaimPolicy},\n        // VolumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound.  When unset, VolumeBindingImmediate is used. This field is alpha-level and is only honored by servers that enable the VolumeScheduling feature.\n        withVolumeBindingMode(volumeBindingMode):: self + {volumeBindingMode: volumeBindingMode},\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n    },\n    v1alpha1:: {\n      local apiVersion = {apiVersion: \"storage.k8s.io/v1alpha1\"},\n      // VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.\n      //\n      // VolumeAttachment objects are non-namespaced.\n      volumeAttachment:: {\n        local kind = {kind: \"VolumeAttachment\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired attach/detach volume behavior. Populated by the Kubernetes system.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Attacher indicates the name of the volume driver that MUST handle this request. This is the name returned by GetPluginName().\n            withAttacher(attacher):: self + __specMixin({attacher: attacher}),\n            // The node that the volume should be attached to.\n            withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n            // Source represents the volume that should be attached.\n            source:: {\n              local __sourceMixin(source) = __specMixin({source+: source}),\n              mixinInstance(source):: __sourceMixin(source),\n              // Name of the persistent volume to attach.\n              withPersistentVolumeName(persistentVolumeName):: self + __sourceMixin({persistentVolumeName: persistentVolumeName}),\n            },\n            sourceType:: hidden.storage.v1alpha1.volumeAttachmentSource,\n          },\n          specType:: hidden.storage.v1alpha1.volumeAttachmentSpec,\n        },\n      },\n    },\n    v1beta1:: {\n      local apiVersion = {apiVersion: \"storage.k8s.io/v1beta1\"},\n      // StorageClass describes the parameters for a class of storage for which PersistentVolumes can be dynamically provisioned.\n      //\n      // StorageClasses are non-namespaced; the name of the storage class according to etcd is in ObjectMeta.Name.\n      storageClass:: {\n        local kind = {kind: \"StorageClass\"},\n        new():: apiVersion + kind,\n        // AllowVolumeExpansion shows whether the storage class allow volume expand\n        withAllowVolumeExpansion(allowVolumeExpansion):: self + {allowVolumeExpansion: allowVolumeExpansion},\n        // Dynamically provisioned PersistentVolumes of this storage class are created with these mountOptions, e.g. [\"ro\", \"soft\"]. Not validated - mount of the PVs will simply fail if one is invalid.\n        withMountOptions(mountOptions):: self + if std.type(mountOptions) == \"array\" then {mountOptions: mountOptions} else {mountOptions: [mountOptions]},\n        // Dynamically provisioned PersistentVolumes of this storage class are created with these mountOptions, e.g. [\"ro\", \"soft\"]. Not validated - mount of the PVs will simply fail if one is invalid.\n        withMountOptionsMixin(mountOptions):: self + if std.type(mountOptions) == \"array\" then {mountOptions+: mountOptions} else {mountOptions+: [mountOptions]},\n        // Parameters holds the parameters for the provisioner that should create volumes of this storage class.\n        withParameters(parameters):: self + {parameters: parameters},\n        // Parameters holds the parameters for the provisioner that should create volumes of this storage class.\n        withParametersMixin(parameters):: self + {parameters+: parameters},\n        // Provisioner indicates the type of the provisioner.\n        withProvisioner(provisioner):: self + {provisioner: provisioner},\n        // Dynamically provisioned PersistentVolumes of this storage class are created with this reclaimPolicy. Defaults to Delete.\n        withReclaimPolicy(reclaimPolicy):: self + {reclaimPolicy: reclaimPolicy},\n        // VolumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound.  When unset, VolumeBindingImmediate is used. This field is alpha-level and is only honored by servers that enable the VolumeScheduling feature.\n        withVolumeBindingMode(volumeBindingMode):: self + {volumeBindingMode: volumeBindingMode},\n        mixin:: {\n          // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n        },\n      },\n      // VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.\n      //\n      // VolumeAttachment objects are non-namespaced.\n      volumeAttachment:: {\n        local kind = {kind: \"VolumeAttachment\"},\n        new():: apiVersion + kind,\n        mixin:: {\n          // Standard object metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n          metadata:: {\n            local __metadataMixin(metadata) = {metadata+: metadata},\n            mixinInstance(metadata):: __metadataMixin(metadata),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n            // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n            withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n            // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n            withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n            // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n            withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n            // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n            //\n            // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n            //\n            // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n            withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabels(labels):: self + __metadataMixin({labels: labels}),\n            // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n            withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n            // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n            withName(name):: self + __metadataMixin({name: name}),\n            // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n            //\n            // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n            withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n            // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n            withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n            ownerReferencesType:: hidden.meta.v1.ownerReference,\n          },\n          metadataType:: hidden.meta.v1.objectMeta,\n          // Specification of the desired attach/detach volume behavior. Populated by the Kubernetes system.\n          spec:: {\n            local __specMixin(spec) = {spec+: spec},\n            mixinInstance(spec):: __specMixin(spec),\n            // Attacher indicates the name of the volume driver that MUST handle this request. This is the name returned by GetPluginName().\n            withAttacher(attacher):: self + __specMixin({attacher: attacher}),\n            // The node that the volume should be attached to.\n            withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n            // Source represents the volume that should be attached.\n            source:: {\n              local __sourceMixin(source) = __specMixin({source+: source}),\n              mixinInstance(source):: __sourceMixin(source),\n              // Name of the persistent volume to attach.\n              withPersistentVolumeName(persistentVolumeName):: self + __sourceMixin({persistentVolumeName: persistentVolumeName}),\n            },\n            sourceType:: hidden.storage.v1beta1.volumeAttachmentSource,\n          },\n          specType:: hidden.storage.v1beta1.volumeAttachmentSpec,\n        },\n      },\n    },\n  },\n  local hidden = {\n    admissionregistration:: {\n      v1alpha1:: {\n        local apiVersion = {apiVersion: \"admissionregistration/v1alpha1\"},\n        // Initializer describes the name and the failure policy of an initializer, and what resources it applies to.\n        initializer:: {\n          new():: {},\n          // Name is the identifier of the initializer. It will be added to the object that needs to be initialized. Name should be fully qualified, e.g., alwayspullimages.kubernetes.io, where \"alwayspullimages\" is the name of the webhook, and kubernetes.io is the name of the organization. Required\n          withName(name):: self + {name: name},\n          // Rules describes what resources/subresources the initializer cares about. The initializer cares about an operation if it matches _any_ Rule. Rule.Resources must not include subresources.\n          withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n          // Rules describes what resources/subresources the initializer cares about. The initializer cares about an operation if it matches _any_ Rule. Rule.Resources must not include subresources.\n          withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n          rulesType:: hidden.admissionregistration.v1alpha1.rule,\n          mixin:: {\n          },\n        },\n        // InitializerConfigurationList is a list of InitializerConfiguration.\n        initializerConfigurationList:: {\n          new():: {},\n          // List of InitializerConfiguration.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of InitializerConfiguration.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.admissionregistration.v1alpha1.initializerConfiguration,\n          mixin:: {\n          },\n        },\n        // Rule is a tuple of APIGroups, APIVersion, and Resources.It is recommended to make sure that all the tuple expansions are valid.\n        rule:: {\n          new():: {},\n          // APIGroups is the API groups the resources belong to. '*' is all groups. If '*' is present, the length of the slice must be one. Required.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the API groups the resources belong to. '*' is all groups. If '*' is present, the length of the slice must be one. Required.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // APIVersions is the API versions the resources belong to. '*' is all versions. If '*' is present, the length of the slice must be one. Required.\n          withApiVersions(apiVersions):: self + if std.type(apiVersions) == \"array\" then {apiVersions: apiVersions} else {apiVersions: [apiVersions]},\n          // APIVersions is the API versions the resources belong to. '*' is all versions. If '*' is present, the length of the slice must be one. Required.\n          withApiVersionsMixin(apiVersions):: self + if std.type(apiVersions) == \"array\" then {apiVersions+: apiVersions} else {apiVersions+: [apiVersions]},\n          // Resources is a list of resources this rule applies to.\n          //\n          // For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.\n          //\n          // If wildcard is present, the validation rule will ensure resources do not overlap with each other.\n          //\n          // Depending on the enclosing object, subresources might not be allowed. Required.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.\n          //\n          // For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.\n          //\n          // If wildcard is present, the validation rule will ensure resources do not overlap with each other.\n          //\n          // Depending on the enclosing object, subresources might not be allowed. Required.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"admissionregistration/v1beta1\"},\n        // MutatingWebhookConfigurationList is a list of MutatingWebhookConfiguration.\n        mutatingWebhookConfigurationList:: {\n          new():: {},\n          // List of MutatingWebhookConfiguration.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of MutatingWebhookConfiguration.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.admissionregistration.v1beta1.mutatingWebhookConfiguration,\n          mixin:: {\n          },\n        },\n        // RuleWithOperations is a tuple of Operations and Resources. It is recommended to make sure that all the tuple expansions are valid.\n        ruleWithOperations:: {\n          new():: {},\n          // APIGroups is the API groups the resources belong to. '*' is all groups. If '*' is present, the length of the slice must be one. Required.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the API groups the resources belong to. '*' is all groups. If '*' is present, the length of the slice must be one. Required.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // APIVersions is the API versions the resources belong to. '*' is all versions. If '*' is present, the length of the slice must be one. Required.\n          withApiVersions(apiVersions):: self + if std.type(apiVersions) == \"array\" then {apiVersions: apiVersions} else {apiVersions: [apiVersions]},\n          // APIVersions is the API versions the resources belong to. '*' is all versions. If '*' is present, the length of the slice must be one. Required.\n          withApiVersionsMixin(apiVersions):: self + if std.type(apiVersions) == \"array\" then {apiVersions+: apiVersions} else {apiVersions+: [apiVersions]},\n          // Operations is the operations the admission hook cares about - CREATE, UPDATE, or * for all operations. If '*' is present, the length of the slice must be one. Required.\n          withOperations(operations):: self + if std.type(operations) == \"array\" then {operations: operations} else {operations: [operations]},\n          // Operations is the operations the admission hook cares about - CREATE, UPDATE, or * for all operations. If '*' is present, the length of the slice must be one. Required.\n          withOperationsMixin(operations):: self + if std.type(operations) == \"array\" then {operations+: operations} else {operations+: [operations]},\n          // Resources is a list of resources this rule applies to.\n          //\n          // For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.\n          //\n          // If wildcard is present, the validation rule will ensure resources do not overlap with each other.\n          //\n          // Depending on the enclosing object, subresources might not be allowed. Required.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.\n          //\n          // For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.\n          //\n          // If wildcard is present, the validation rule will ensure resources do not overlap with each other.\n          //\n          // Depending on the enclosing object, subresources might not be allowed. Required.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          mixin:: {\n          },\n        },\n        // ServiceReference holds a reference to Service.legacy.k8s.io\n        serviceReference:: {\n          new():: {},\n          // `name` is the name of the service. Required\n          withName(name):: self + {name: name},\n          // `namespace` is the namespace of the service. Required\n          withNamespace(namespace):: self + {namespace: namespace},\n          // `path` is an optional URL path which will be sent in any request to this service.\n          withPath(path):: self + {path: path},\n          mixin:: {\n          },\n        },\n        // ValidatingWebhookConfigurationList is a list of ValidatingWebhookConfiguration.\n        validatingWebhookConfigurationList:: {\n          new():: {},\n          // List of ValidatingWebhookConfiguration.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of ValidatingWebhookConfiguration.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.admissionregistration.v1beta1.validatingWebhookConfiguration,\n          mixin:: {\n          },\n        },\n        // Webhook describes an admission webhook and the resources and operations it applies to.\n        webhook:: {\n          new():: {},\n          // FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail. Defaults to Ignore.\n          withFailurePolicy(failurePolicy):: self + {failurePolicy: failurePolicy},\n          // The name of the admission webhook. Name should be fully qualified, e.g., imagepolicy.kubernetes.io, where \"imagepolicy\" is the name of the webhook, and kubernetes.io is the name of the organization. Required.\n          withName(name):: self + {name: name},\n          // Rules describes what operations on what resources/subresources the webhook cares about. The webhook cares about an operation if it matches _any_ Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.\n          withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n          // Rules describes what operations on what resources/subresources the webhook cares about. The webhook cares about an operation if it matches _any_ Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.\n          withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n          rulesType:: hidden.admissionregistration.v1beta1.ruleWithOperations,\n          mixin:: {\n            // ClientConfig defines how to communicate with the hook. Required\n            clientConfig:: {\n              local __clientConfigMixin(clientConfig) = {clientConfig+: clientConfig},\n              mixinInstance(clientConfig):: __clientConfigMixin(clientConfig),\n              // `caBundle` is a PEM encoded CA bundle which will be used to validate the webhook's server certificate. Required.\n              withCaBundle(caBundle):: self + __clientConfigMixin({caBundle: caBundle}),\n              // `service` is a reference to the service for this webhook. Either `service` or `url` must be specified.\n              //\n              // If the webhook is running within the cluster, then you should use `service`.\n              //\n              // If there is only one port open for the service, that port will be used. If there are multiple ports open, port 443 will be used if it is open, otherwise it is an error.\n              service:: {\n                local __serviceMixin(service) = __clientConfigMixin({service+: service}),\n                mixinInstance(service):: __serviceMixin(service),\n                // `name` is the name of the service. Required\n                withName(name):: self + __serviceMixin({name: name}),\n                // `namespace` is the namespace of the service. Required\n                withNamespace(namespace):: self + __serviceMixin({namespace: namespace}),\n                // `path` is an optional URL path which will be sent in any request to this service.\n                withPath(path):: self + __serviceMixin({path: path}),\n              },\n              serviceType:: hidden.admissionregistration.v1beta1.serviceReference,\n              // `url` gives the location of the webhook, in standard URL form (`[scheme://]host:port/path`). Exactly one of `url` or `service` must be specified.\n              //\n              // The `host` should not refer to a service running in the cluster; use the `service` field instead. The host might be resolved via external DNS in some apiservers (e.g., `kube-apiserver` cannot resolve in-cluster DNS as that would be a layering violation). `host` may also be an IP address.\n              //\n              // Please note that using `localhost` or `127.0.0.1` as a `host` is risky unless you take great care to run this webhook on all hosts which run an apiserver which might need to make calls to this webhook. Such installs are likely to be non-portable, i.e., not easy to turn up in a new cluster.\n              //\n              // The scheme must be \"https\"; the URL must begin with \"https://\".\n              //\n              // A path is optional, and if present may be any string permissible in a URL. You may use the path to pass an arbitrary string to the webhook, for example, a cluster identifier.\n              //\n              // Attempting to use a user or basic auth e.g. \"user:password@\" is not allowed. Fragments (\"#...\") and query parameters (\"?...\") are not allowed, either.\n              withUrl(url):: self + __clientConfigMixin({url: url}),\n            },\n            clientConfigType:: hidden.admissionregistration.v1beta1.webhookClientConfig,\n            // NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector. If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the webhook.\n            //\n            // For example, to run the webhook on any objects whose namespace is not associated with \"runlevel\" of \"0\" or \"1\";  you will set the selector as follows: \"namespaceSelector\": {\n            // \"matchExpressions\": [\n            // {\n            // \"key\": \"runlevel\",\n            // \"operator\": \"NotIn\",\n            // \"values\": [\n            // \"0\",\n            // \"1\"\n            // ]\n            // }\n            // ]\n            // }\n            //\n            // If instead you want to only run the webhook on any objects whose namespace is associated with the \"environment\" of \"prod\" or \"staging\"; you will set the selector as follows: \"namespaceSelector\": {\n            // \"matchExpressions\": [\n            // {\n            // \"key\": \"environment\",\n            // \"operator\": \"In\",\n            // \"values\": [\n            // \"prod\",\n            // \"staging\"\n            // ]\n            // }\n            // ]\n            // }\n            //\n            // See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.\n            //\n            // Default to the empty LabelSelector, which matches everything.\n            namespaceSelector:: {\n              local __namespaceSelectorMixin(namespaceSelector) = {namespaceSelector+: namespaceSelector},\n              mixinInstance(namespaceSelector):: __namespaceSelectorMixin(namespaceSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __namespaceSelectorMixin({matchExpressions: matchExpressions}) else __namespaceSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __namespaceSelectorMixin({matchExpressions+: matchExpressions}) else __namespaceSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __namespaceSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __namespaceSelectorMixin({matchLabels+: matchLabels}),\n            },\n            namespaceSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // WebhookClientConfig contains the information to make a TLS connection with the webhook\n        webhookClientConfig:: {\n          new():: {},\n          // `caBundle` is a PEM encoded CA bundle which will be used to validate the webhook's server certificate. Required.\n          withCaBundle(caBundle):: self + {caBundle: caBundle},\n          // `url` gives the location of the webhook, in standard URL form (`[scheme://]host:port/path`). Exactly one of `url` or `service` must be specified.\n          //\n          // The `host` should not refer to a service running in the cluster; use the `service` field instead. The host might be resolved via external DNS in some apiservers (e.g., `kube-apiserver` cannot resolve in-cluster DNS as that would be a layering violation). `host` may also be an IP address.\n          //\n          // Please note that using `localhost` or `127.0.0.1` as a `host` is risky unless you take great care to run this webhook on all hosts which run an apiserver which might need to make calls to this webhook. Such installs are likely to be non-portable, i.e., not easy to turn up in a new cluster.\n          //\n          // The scheme must be \"https\"; the URL must begin with \"https://\".\n          //\n          // A path is optional, and if present may be any string permissible in a URL. You may use the path to pass an arbitrary string to the webhook, for example, a cluster identifier.\n          //\n          // Attempting to use a user or basic auth e.g. \"user:password@\" is not allowed. Fragments (\"#...\") and query parameters (\"?...\") are not allowed, either.\n          withUrl(url):: self + {url: url},\n          mixin:: {\n            // `service` is a reference to the service for this webhook. Either `service` or `url` must be specified.\n            //\n            // If the webhook is running within the cluster, then you should use `service`.\n            //\n            // If there is only one port open for the service, that port will be used. If there are multiple ports open, port 443 will be used if it is open, otherwise it is an error.\n            service:: {\n              local __serviceMixin(service) = {service+: service},\n              mixinInstance(service):: __serviceMixin(service),\n              // `name` is the name of the service. Required\n              withName(name):: self + __serviceMixin({name: name}),\n              // `namespace` is the namespace of the service. Required\n              withNamespace(namespace):: self + __serviceMixin({namespace: namespace}),\n              // `path` is an optional URL path which will be sent in any request to this service.\n              withPath(path):: self + __serviceMixin({path: path}),\n            },\n            serviceType:: hidden.admissionregistration.v1beta1.serviceReference,\n          },\n        },\n      },\n    },\n    apiextensions:: {\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"apiextensions/v1beta1\"},\n        // CustomResourceDefinitionCondition contains details for the current condition of this pod.\n        customResourceDefinitionCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human-readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // Unique, one-word, CamelCase reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status is the status of the condition. Can be True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type is the type of the condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // CustomResourceDefinitionList is a list of CustomResourceDefinition objects.\n        customResourceDefinitionList:: {\n          new():: {},\n          // Items individual CustomResourceDefinitions\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items individual CustomResourceDefinitions\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apiextensions.v1beta1.customResourceDefinition,\n          mixin:: {\n          },\n        },\n        // CustomResourceDefinitionNames indicates the names to serve this CustomResourceDefinition\n        customResourceDefinitionNames:: {\n          new():: {},\n          // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n          withCategories(categories):: self + if std.type(categories) == \"array\" then {categories: categories} else {categories: [categories]},\n          // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n          withCategoriesMixin(categories):: self + if std.type(categories) == \"array\" then {categories+: categories} else {categories+: [categories]},\n          // Kind is the serialized kind of the resource.  It is normally CamelCase and singular.\n          withKind(kind):: self + {kind: kind},\n          // ListKind is the serialized kind of the list for this resource.  Defaults to <kind>List.\n          withListKind(listKind):: self + {listKind: listKind},\n          // Plural is the plural name of the resource to serve.  It must match the name of the CustomResourceDefinition-registration too: plural.group and it must be all lowercase.\n          withPlural(plural):: self + {plural: plural},\n          // ShortNames are short names for the resource.  It must be all lowercase.\n          withShortNames(shortNames):: self + if std.type(shortNames) == \"array\" then {shortNames: shortNames} else {shortNames: [shortNames]},\n          // ShortNames are short names for the resource.  It must be all lowercase.\n          withShortNamesMixin(shortNames):: self + if std.type(shortNames) == \"array\" then {shortNames+: shortNames} else {shortNames+: [shortNames]},\n          // Singular is the singular name of the resource.  It must be all lowercase  Defaults to lowercased <kind>\n          withSingular(singular):: self + {singular: singular},\n          mixin:: {\n          },\n        },\n        // CustomResourceDefinitionSpec describes how a user wants their resource to appear\n        customResourceDefinitionSpec:: {\n          new():: {},\n          // Group is the group this resource belongs in\n          withGroup(group):: self + {group: group},\n          // Scope indicates whether this resource is cluster or namespace scoped.  Default is namespaced\n          withScope(scope):: self + {scope: scope},\n          // Version is the version this resource belongs in\n          withVersion(version):: self + {version: version},\n          mixin:: {\n            // Names are the names used to describe this custom resource\n            names:: {\n              local __namesMixin(names) = {names+: names},\n              mixinInstance(names):: __namesMixin(names),\n              // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n              withCategories(categories):: self + if std.type(categories) == \"array\" then __namesMixin({categories: categories}) else __namesMixin({categories: [categories]}),\n              // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n              withCategoriesMixin(categories):: self + if std.type(categories) == \"array\" then __namesMixin({categories+: categories}) else __namesMixin({categories+: [categories]}),\n              // Kind is the serialized kind of the resource.  It is normally CamelCase and singular.\n              withKind(kind):: self + __namesMixin({kind: kind}),\n              // ListKind is the serialized kind of the list for this resource.  Defaults to <kind>List.\n              withListKind(listKind):: self + __namesMixin({listKind: listKind}),\n              // Plural is the plural name of the resource to serve.  It must match the name of the CustomResourceDefinition-registration too: plural.group and it must be all lowercase.\n              withPlural(plural):: self + __namesMixin({plural: plural}),\n              // ShortNames are short names for the resource.  It must be all lowercase.\n              withShortNames(shortNames):: self + if std.type(shortNames) == \"array\" then __namesMixin({shortNames: shortNames}) else __namesMixin({shortNames: [shortNames]}),\n              // ShortNames are short names for the resource.  It must be all lowercase.\n              withShortNamesMixin(shortNames):: self + if std.type(shortNames) == \"array\" then __namesMixin({shortNames+: shortNames}) else __namesMixin({shortNames+: [shortNames]}),\n              // Singular is the singular name of the resource.  It must be all lowercase  Defaults to lowercased <kind>\n              withSingular(singular):: self + __namesMixin({singular: singular}),\n            },\n            namesType:: hidden.apiextensions.v1beta1.customResourceDefinitionNames,\n            // Subresources describes the subresources for CustomResources This field is alpha-level and should only be sent to servers that enable subresources via the CustomResourceSubresources feature gate.\n            subresources:: {\n              local __subresourcesMixin(subresources) = {subresources+: subresources},\n              mixinInstance(subresources):: __subresourcesMixin(subresources),\n              // Scale denotes the scale subresource for CustomResources\n              scale:: {\n                local __scaleMixin(scale) = __subresourcesMixin({scale+: scale}),\n                mixinInstance(scale):: __scaleMixin(scale),\n                // LabelSelectorPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Selector. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. Must be set to work with HPA. If there is no value under the given path in the CustomResource, the status label selector value in the /scale subresource will default to the empty string.\n                withLabelSelectorPath(labelSelectorPath):: self + __scaleMixin({labelSelectorPath: labelSelectorPath}),\n                // SpecReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Spec.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .spec. If there is no value under the given path in the CustomResource, the /scale subresource will return an error on GET.\n                withSpecReplicasPath(specReplicasPath):: self + __scaleMixin({specReplicasPath: specReplicasPath}),\n                // StatusReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. If there is no value under the given path in the CustomResource, the status replica value in the /scale subresource will default to 0.\n                withStatusReplicasPath(statusReplicasPath):: self + __scaleMixin({statusReplicasPath: statusReplicasPath}),\n              },\n              scaleType:: hidden.apiextensions.v1beta1.customResourceSubresourceScale,\n            },\n            subresourcesType:: hidden.apiextensions.v1beta1.customResourceSubresources,\n            // Validation describes the validation methods for CustomResources\n            validation:: {\n              local __validationMixin(validation) = {validation+: validation},\n              mixinInstance(validation):: __validationMixin(validation),\n              // OpenAPIV3Schema is the OpenAPI v3 schema to be validated against.\n              withOpenApiV3Schema(openApiV3Schema):: self + __validationMixin({openAPIV3Schema: openApiV3Schema}),\n              // OpenAPIV3Schema is the OpenAPI v3 schema to be validated against.\n              withOpenApiV3SchemaMixin(openApiV3Schema):: self + __validationMixin({openAPIV3Schema+: openApiV3Schema}),\n              openAPIV3SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n            },\n            validationType:: hidden.apiextensions.v1beta1.customResourceValidation,\n          },\n        },\n        // CustomResourceDefinitionStatus indicates the state of the CustomResourceDefinition\n        customResourceDefinitionStatus:: {\n          new():: {},\n          // Conditions indicate state for particular aspects of a CustomResourceDefinition\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Conditions indicate state for particular aspects of a CustomResourceDefinition\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apiextensions.v1beta1.customResourceDefinitionCondition,\n          mixin:: {\n            // AcceptedNames are the names that are actually being used to serve discovery They may be different than the names in spec.\n            acceptedNames:: {\n              local __acceptedNamesMixin(acceptedNames) = {acceptedNames+: acceptedNames},\n              mixinInstance(acceptedNames):: __acceptedNamesMixin(acceptedNames),\n              // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n              withCategories(categories):: self + if std.type(categories) == \"array\" then __acceptedNamesMixin({categories: categories}) else __acceptedNamesMixin({categories: [categories]}),\n              // Categories is a list of grouped resources custom resources belong to (e.g. 'all')\n              withCategoriesMixin(categories):: self + if std.type(categories) == \"array\" then __acceptedNamesMixin({categories+: categories}) else __acceptedNamesMixin({categories+: [categories]}),\n              // Kind is the serialized kind of the resource.  It is normally CamelCase and singular.\n              withKind(kind):: self + __acceptedNamesMixin({kind: kind}),\n              // ListKind is the serialized kind of the list for this resource.  Defaults to <kind>List.\n              withListKind(listKind):: self + __acceptedNamesMixin({listKind: listKind}),\n              // Plural is the plural name of the resource to serve.  It must match the name of the CustomResourceDefinition-registration too: plural.group and it must be all lowercase.\n              withPlural(plural):: self + __acceptedNamesMixin({plural: plural}),\n              // ShortNames are short names for the resource.  It must be all lowercase.\n              withShortNames(shortNames):: self + if std.type(shortNames) == \"array\" then __acceptedNamesMixin({shortNames: shortNames}) else __acceptedNamesMixin({shortNames: [shortNames]}),\n              // ShortNames are short names for the resource.  It must be all lowercase.\n              withShortNamesMixin(shortNames):: self + if std.type(shortNames) == \"array\" then __acceptedNamesMixin({shortNames+: shortNames}) else __acceptedNamesMixin({shortNames+: [shortNames]}),\n              // Singular is the singular name of the resource.  It must be all lowercase  Defaults to lowercased <kind>\n              withSingular(singular):: self + __acceptedNamesMixin({singular: singular}),\n            },\n            acceptedNamesType:: hidden.apiextensions.v1beta1.customResourceDefinitionNames,\n          },\n        },\n        // CustomResourceSubresourceScale defines how to serve the scale subresource for CustomResources.\n        customResourceSubresourceScale:: {\n          new():: {},\n          // LabelSelectorPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Selector. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. Must be set to work with HPA. If there is no value under the given path in the CustomResource, the status label selector value in the /scale subresource will default to the empty string.\n          withLabelSelectorPath(labelSelectorPath):: self + {labelSelectorPath: labelSelectorPath},\n          // SpecReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Spec.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .spec. If there is no value under the given path in the CustomResource, the /scale subresource will return an error on GET.\n          withSpecReplicasPath(specReplicasPath):: self + {specReplicasPath: specReplicasPath},\n          // StatusReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. If there is no value under the given path in the CustomResource, the status replica value in the /scale subresource will default to 0.\n          withStatusReplicasPath(statusReplicasPath):: self + {statusReplicasPath: statusReplicasPath},\n          mixin:: {\n          },\n        },\n        // CustomResourceSubresourceStatus defines how to serve the status subresource for CustomResources. Status is represented by the `.status` JSON path inside of a CustomResource. When set, * exposes a /status subresource for the custom resource * PUT requests to the /status subresource take a custom resource object, and ignore changes to anything except the status stanza * PUT/POST/PATCH requests to the custom resource ignore changes to the status stanza\n        customResourceSubresourceStatus:: {\n          new():: {},\n          mixin:: {\n          },\n        },\n        // CustomResourceSubresources defines the status and scale subresources for CustomResources.\n        customResourceSubresources:: {\n          new():: {},\n          mixin:: {\n            // Scale denotes the scale subresource for CustomResources\n            scale:: {\n              local __scaleMixin(scale) = {scale+: scale},\n              mixinInstance(scale):: __scaleMixin(scale),\n              // LabelSelectorPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Selector. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. Must be set to work with HPA. If there is no value under the given path in the CustomResource, the status label selector value in the /scale subresource will default to the empty string.\n              withLabelSelectorPath(labelSelectorPath):: self + __scaleMixin({labelSelectorPath: labelSelectorPath}),\n              // SpecReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Spec.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .spec. If there is no value under the given path in the CustomResource, the /scale subresource will return an error on GET.\n              withSpecReplicasPath(specReplicasPath):: self + __scaleMixin({specReplicasPath: specReplicasPath}),\n              // StatusReplicasPath defines the JSON path inside of a CustomResource that corresponds to Scale.Status.Replicas. Only JSON paths without the array notation are allowed. Must be a JSON Path under .status. If there is no value under the given path in the CustomResource, the status replica value in the /scale subresource will default to 0.\n              withStatusReplicasPath(statusReplicasPath):: self + __scaleMixin({statusReplicasPath: statusReplicasPath}),\n            },\n            scaleType:: hidden.apiextensions.v1beta1.customResourceSubresourceScale,\n          },\n        },\n        // CustomResourceValidation is a list of validation methods for CustomResources.\n        customResourceValidation:: {\n          new():: {},\n          // OpenAPIV3Schema is the OpenAPI v3 schema to be validated against.\n          withOpenApiV3Schema(openApiV3Schema):: self + {openAPIV3Schema: openApiV3Schema},\n          // OpenAPIV3Schema is the OpenAPI v3 schema to be validated against.\n          withOpenApiV3SchemaMixin(openApiV3Schema):: self + {openAPIV3Schema+: openApiV3Schema},\n          openAPIV3SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          mixin:: {\n          },\n        },\n        // ExternalDocumentation allows referencing an external resource for extended documentation.\n        externalDocumentation:: {\n          new():: {},\n          withDescription(description):: self + {description: description},\n          withUrl(url):: self + {url: url},\n          mixin:: {\n          },\n        },\n        // JSON represents any valid JSON value. These types are supported: bool, int64, float64, string, []interface{}, map[string]interface{} and nil.\n        json:: {\n          new():: {},\n          withRaw(raw):: self + {Raw: raw},\n          mixin:: {\n          },\n        },\n        // JSONSchemaProps is a JSON-Schema following Specification Draft 4 (http://json-schema.org/).\n        jsonSchemaProps:: {\n          new():: {},\n          withDollarRef(dollarRef):: self + {\"$ref\": dollarRef},\n          withDollarSchema(dollarSchema):: self + {\"$schema\": dollarSchema},\n          withAllOf(allOf):: self + if std.type(allOf) == \"array\" then {allOf: allOf} else {allOf: [allOf]},\n          withAllOfMixin(allOf):: self + if std.type(allOf) == \"array\" then {allOf+: allOf} else {allOf+: [allOf]},\n          allOfType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          withAnyOf(anyOf):: self + if std.type(anyOf) == \"array\" then {anyOf: anyOf} else {anyOf: [anyOf]},\n          withAnyOfMixin(anyOf):: self + if std.type(anyOf) == \"array\" then {anyOf+: anyOf} else {anyOf+: [anyOf]},\n          anyOfType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          withDefinitions(definitions):: self + {definitions: definitions},\n          withDefinitionsMixin(definitions):: self + {definitions+: definitions},\n          withDependencies(dependencies):: self + {dependencies: dependencies},\n          withDependenciesMixin(dependencies):: self + {dependencies+: dependencies},\n          withDescription(description):: self + {description: description},\n          withEnum(enum):: self + if std.type(enum) == \"array\" then {enum: enum} else {enum: [enum]},\n          withEnumMixin(enum):: self + if std.type(enum) == \"array\" then {enum+: enum} else {enum+: [enum]},\n          enumType:: hidden.apiextensions.v1beta1.json,\n          withExclusiveMaximum(exclusiveMaximum):: self + {exclusiveMaximum: exclusiveMaximum},\n          withExclusiveMinimum(exclusiveMinimum):: self + {exclusiveMinimum: exclusiveMinimum},\n          withFormat(format):: self + {format: format},\n          withId(id):: self + {id: id},\n          withMaxItems(maxItems):: self + {maxItems: maxItems},\n          withMaxLength(maxLength):: self + {maxLength: maxLength},\n          withMaxProperties(maxProperties):: self + {maxProperties: maxProperties},\n          withMaximum(maximum):: self + {maximum: maximum},\n          withMinItems(minItems):: self + {minItems: minItems},\n          withMinLength(minLength):: self + {minLength: minLength},\n          withMinProperties(minProperties):: self + {minProperties: minProperties},\n          withMinimum(minimum):: self + {minimum: minimum},\n          withMultipleOf(multipleOf):: self + {multipleOf: multipleOf},\n          withNot(not):: self + {not: not},\n          withNotMixin(not):: self + {not+: not},\n          notType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          withOneOf(oneOf):: self + if std.type(oneOf) == \"array\" then {oneOf: oneOf} else {oneOf: [oneOf]},\n          withOneOfMixin(oneOf):: self + if std.type(oneOf) == \"array\" then {oneOf+: oneOf} else {oneOf+: [oneOf]},\n          oneOfType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          withPattern(pattern):: self + {pattern: pattern},\n          withPatternProperties(patternProperties):: self + {patternProperties: patternProperties},\n          withPatternPropertiesMixin(patternProperties):: self + {patternProperties+: patternProperties},\n          withProperties(properties):: self + {properties: properties},\n          withPropertiesMixin(properties):: self + {properties+: properties},\n          withRequired(required):: self + if std.type(required) == \"array\" then {required: required} else {required: [required]},\n          withRequiredMixin(required):: self + if std.type(required) == \"array\" then {required+: required} else {required+: [required]},\n          withTitle(title):: self + {title: title},\n          withType(type):: self + {type: type},\n          withUniqueItems(uniqueItems):: self + {uniqueItems: uniqueItems},\n          mixin:: {\n            additionalItems:: {\n              local __additionalItemsMixin(additionalItems) = {additionalItems+: additionalItems},\n              mixinInstance(additionalItems):: __additionalItemsMixin(additionalItems),\n              withAllows(allows):: self + __additionalItemsMixin({Allows: allows}),\n              withSchema(schema):: self + __additionalItemsMixin({Schema: schema}),\n              withSchemaMixin(schema):: self + __additionalItemsMixin({Schema+: schema}),\n              SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n            },\n            additionalItemsType:: hidden.apiextensions.v1beta1.jsonSchemaPropsOrBool,\n            additionalProperties:: {\n              local __additionalPropertiesMixin(additionalProperties) = {additionalProperties+: additionalProperties},\n              mixinInstance(additionalProperties):: __additionalPropertiesMixin(additionalProperties),\n              withAllows(allows):: self + __additionalPropertiesMixin({Allows: allows}),\n              withSchema(schema):: self + __additionalPropertiesMixin({Schema: schema}),\n              withSchemaMixin(schema):: self + __additionalPropertiesMixin({Schema+: schema}),\n              SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n            },\n            additionalPropertiesType:: hidden.apiextensions.v1beta1.jsonSchemaPropsOrBool,\n            default:: {\n              local __defaultMixin(default) = {default+: default},\n              mixinInstance(default):: __defaultMixin(default),\n              withRaw(raw):: self + __defaultMixin({Raw: raw}),\n            },\n            defaultType:: hidden.apiextensions.v1beta1.json,\n            example:: {\n              local __exampleMixin(example) = {example+: example},\n              mixinInstance(example):: __exampleMixin(example),\n              withRaw(raw):: self + __exampleMixin({Raw: raw}),\n            },\n            exampleType:: hidden.apiextensions.v1beta1.json,\n            externalDocs:: {\n              local __externalDocsMixin(externalDocs) = {externalDocs+: externalDocs},\n              mixinInstance(externalDocs):: __externalDocsMixin(externalDocs),\n              withDescription(description):: self + __externalDocsMixin({description: description}),\n              withUrl(url):: self + __externalDocsMixin({url: url}),\n            },\n            externalDocsType:: hidden.apiextensions.v1beta1.externalDocumentation,\n            items:: {\n              local __itemsMixin(items) = {items+: items},\n              mixinInstance(items):: __itemsMixin(items),\n              withJsonSchemas(jsonSchemas):: self + if std.type(jsonSchemas) == \"array\" then __itemsMixin({JSONSchemas: jsonSchemas}) else __itemsMixin({JSONSchemas: [jsonSchemas]}),\n              withJsonSchemasMixin(jsonSchemas):: self + if std.type(jsonSchemas) == \"array\" then __itemsMixin({JSONSchemas+: jsonSchemas}) else __itemsMixin({JSONSchemas+: [jsonSchemas]}),\n              JSONSchemasType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n              withSchema(schema):: self + __itemsMixin({Schema: schema}),\n              withSchemaMixin(schema):: self + __itemsMixin({Schema+: schema}),\n              SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n            },\n            itemsType:: hidden.apiextensions.v1beta1.jsonSchemaPropsOrArray,\n          },\n        },\n        // JSONSchemaPropsOrArray represents a value that can either be a JSONSchemaProps or an array of JSONSchemaProps. Mainly here for serialization purposes.\n        jsonSchemaPropsOrArray:: {\n          new():: {},\n          withJsonSchemas(jsonSchemas):: self + if std.type(jsonSchemas) == \"array\" then {JSONSchemas: jsonSchemas} else {JSONSchemas: [jsonSchemas]},\n          withJsonSchemasMixin(jsonSchemas):: self + if std.type(jsonSchemas) == \"array\" then {JSONSchemas+: jsonSchemas} else {JSONSchemas+: [jsonSchemas]},\n          JSONSchemasType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          withSchema(schema):: self + {Schema: schema},\n          withSchemaMixin(schema):: self + {Schema+: schema},\n          SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          mixin:: {\n          },\n        },\n        // JSONSchemaPropsOrBool represents JSONSchemaProps or a boolean value. Defaults to true for the boolean property.\n        jsonSchemaPropsOrBool:: {\n          new():: {},\n          withAllows(allows):: self + {Allows: allows},\n          withSchema(schema):: self + {Schema: schema},\n          withSchemaMixin(schema):: self + {Schema+: schema},\n          SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          mixin:: {\n          },\n        },\n        // JSONSchemaPropsOrStringArray represents a JSONSchemaProps or a string array.\n        jsonSchemaPropsOrStringArray:: {\n          new():: {},\n          withProperty(property):: self + if std.type(property) == \"array\" then {Property: property} else {Property: [property]},\n          withPropertyMixin(property):: self + if std.type(property) == \"array\" then {Property+: property} else {Property+: [property]},\n          withSchema(schema):: self + {Schema: schema},\n          withSchemaMixin(schema):: self + {Schema+: schema},\n          SchemaType:: hidden.apiextensions.v1beta1.jsonSchemaProps,\n          mixin:: {\n          },\n        },\n      },\n    },\n    apiregistration:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"apiregistration/v1\"},\n        apiServiceCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human-readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // Unique, one-word, CamelCase reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status is the status of the condition. Can be True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type is the type of the condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // APIServiceList is a list of APIService objects.\n        apiServiceList:: {\n          new():: {},\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apiregistration.v1.apiService,\n          mixin:: {\n          },\n        },\n        // APIServiceSpec contains information for locating and communicating with a server. Only https is supported, though you are able to disable certificate verification.\n        apiServiceSpec:: {\n          new():: {},\n          // CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate.\n          withCaBundle(caBundle):: self + {caBundle: caBundle},\n          // Group is the API group name this server hosts\n          withGroup(group):: self + {group: group},\n          // GroupPriorityMininum is the priority this group should have at least. Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We'd recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s\n          withGroupPriorityMinimum(groupPriorityMinimum):: self + {groupPriorityMinimum: groupPriorityMinimum},\n          // InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. This is strongly discouraged.  You should use the CABundle instead.\n          withInsecureSkipTlsVerify(insecureSkipTlsVerify):: self + {insecureSkipTLSVerify: insecureSkipTlsVerify},\n          // Version is the API version this server hosts.  For example, \"v1\"\n          withVersion(version):: self + {version: version},\n          // VersionPriority controls the ordering of this API version inside of its group.  Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) Since it's inside of a group, the number can be small, probably in the 10s.\n          withVersionPriority(versionPriority):: self + {versionPriority: versionPriority},\n          mixin:: {\n            // Service is a reference to the service for this API server.  It must communicate on port 443 If the Service is nil, that means the handling for the API groupversion is handled locally on this server. The call will simply delegate to the normal handler chain to be fulfilled.\n            service:: {\n              local __serviceMixin(service) = {service+: service},\n              mixinInstance(service):: __serviceMixin(service),\n              // Name is the name of the service\n              withName(name):: self + __serviceMixin({name: name}),\n              // Namespace is the namespace of the service\n              withNamespace(namespace):: self + __serviceMixin({namespace: namespace}),\n            },\n            serviceType:: hidden.apiregistration.v1.serviceReference,\n          },\n        },\n        // APIServiceStatus contains derived information about an API server\n        apiServiceStatus:: {\n          new():: {},\n          // Current service state of apiService.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Current service state of apiService.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apiregistration.v1.apiServiceCondition,\n          mixin:: {\n          },\n        },\n        // ServiceReference holds a reference to Service.legacy.k8s.io\n        serviceReference:: {\n          new():: {},\n          // Name is the name of the service\n          withName(name):: self + {name: name},\n          // Namespace is the namespace of the service\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"apiregistration/v1beta1\"},\n        apiServiceCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human-readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // Unique, one-word, CamelCase reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status is the status of the condition. Can be True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type is the type of the condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // APIServiceList is a list of APIService objects.\n        apiServiceList:: {\n          new():: {},\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apiregistration.v1beta1.apiService,\n          mixin:: {\n          },\n        },\n        // APIServiceSpec contains information for locating and communicating with a server. Only https is supported, though you are able to disable certificate verification.\n        apiServiceSpec:: {\n          new():: {},\n          // CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate.\n          withCaBundle(caBundle):: self + {caBundle: caBundle},\n          // Group is the API group name this server hosts\n          withGroup(group):: self + {group: group},\n          // GroupPriorityMininum is the priority this group should have at least. Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We'd recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s\n          withGroupPriorityMinimum(groupPriorityMinimum):: self + {groupPriorityMinimum: groupPriorityMinimum},\n          // InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. This is strongly discouraged.  You should use the CABundle instead.\n          withInsecureSkipTlsVerify(insecureSkipTlsVerify):: self + {insecureSkipTLSVerify: insecureSkipTlsVerify},\n          // Version is the API version this server hosts.  For example, \"v1\"\n          withVersion(version):: self + {version: version},\n          // VersionPriority controls the ordering of this API version inside of its group.  Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) Since it's inside of a group, the number can be small, probably in the 10s.\n          withVersionPriority(versionPriority):: self + {versionPriority: versionPriority},\n          mixin:: {\n            // Service is a reference to the service for this API server.  It must communicate on port 443 If the Service is nil, that means the handling for the API groupversion is handled locally on this server. The call will simply delegate to the normal handler chain to be fulfilled.\n            service:: {\n              local __serviceMixin(service) = {service+: service},\n              mixinInstance(service):: __serviceMixin(service),\n              // Name is the name of the service\n              withName(name):: self + __serviceMixin({name: name}),\n              // Namespace is the namespace of the service\n              withNamespace(namespace):: self + __serviceMixin({namespace: namespace}),\n            },\n            serviceType:: hidden.apiregistration.v1beta1.serviceReference,\n          },\n        },\n        // APIServiceStatus contains derived information about an API server\n        apiServiceStatus:: {\n          new():: {},\n          // Current service state of apiService.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Current service state of apiService.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apiregistration.v1beta1.apiServiceCondition,\n          mixin:: {\n          },\n        },\n        // ServiceReference holds a reference to Service.legacy.k8s.io\n        serviceReference:: {\n          new():: {},\n          // Name is the name of the service\n          withName(name):: self + {name: name},\n          // Namespace is the namespace of the service\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n      },\n    },\n    apps:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"apps/v1\"},\n        // ControllerRevisionList is a resource containing a list of ControllerRevision objects.\n        controllerRevisionList:: {\n          new():: {},\n          // Items is the list of ControllerRevisions\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of ControllerRevisions\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1.controllerRevision,\n          mixin:: {\n          },\n        },\n        // DaemonSetCondition describes the state of a DaemonSet at a certain point.\n        daemonSetCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of DaemonSet condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DaemonSetList is a collection of daemon sets.\n        daemonSetList:: {\n          new():: {},\n          // A list of daemon sets.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // A list of daemon sets.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1.daemonSet,\n          mixin:: {\n          },\n        },\n        // DaemonSetSpec is the specification of a daemon set.\n        daemonSetSpec:: {\n          new():: {},\n          // The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          mixin:: {\n            // A label query over pods that are managed by the daemon set. Must match in order to be controlled. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // An object that describes the pod that will be created. The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // An update strategy to replace existing DaemonSet pods with new pods.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = {updateStrategy+: updateStrategy},\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // Rolling update config params. Present only if type = \"RollingUpdate\".\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1.rollingUpdateDaemonSet,\n              // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1.daemonSetUpdateStrategy,\n          },\n        },\n        // DaemonSetStatus represents the current status of a daemon set.\n        daemonSetStatus:: {\n          new():: {},\n          // Count of hash collisions for the DaemonSet. The DaemonSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a DaemonSet's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a DaemonSet's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1.daemonSetCondition,\n          // The number of nodes that are running at least 1 daemon pod and are supposed to run the daemon pod. More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withCurrentNumberScheduled(currentNumberScheduled):: self + {currentNumberScheduled: currentNumberScheduled},\n          // The total number of nodes that should be running the daemon pod (including nodes correctly running the daemon pod). More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withDesiredNumberScheduled(desiredNumberScheduled):: self + {desiredNumberScheduled: desiredNumberScheduled},\n          // The number of nodes that should be running the daemon pod and have one or more of the daemon pod running and available (ready for at least spec.minReadySeconds)\n          withNumberAvailable(numberAvailable):: self + {numberAvailable: numberAvailable},\n          // The number of nodes that are running the daemon pod, but are not supposed to run the daemon pod. More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withNumberMisscheduled(numberMisscheduled):: self + {numberMisscheduled: numberMisscheduled},\n          // The number of nodes that should be running the daemon pod and have one or more of the daemon pod running and ready.\n          withNumberReady(numberReady):: self + {numberReady: numberReady},\n          // The number of nodes that should be running the daemon pod and have none of the daemon pod running and available (ready for at least spec.minReadySeconds)\n          withNumberUnavailable(numberUnavailable):: self + {numberUnavailable: numberUnavailable},\n          // The most recent generation observed by the daemon set controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The total number of nodes that are running updated daemon pod\n          withUpdatedNumberScheduled(updatedNumberScheduled):: self + {updatedNumberScheduled: updatedNumberScheduled},\n          mixin:: {\n          },\n        },\n        // DaemonSetUpdateStrategy is a struct used to control the update strategy for a DaemonSet.\n        daemonSetUpdateStrategy:: {\n          new():: {},\n          // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if type = \"RollingUpdate\".\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.apps.v1.rollingUpdateDaemonSet,\n          },\n        },\n        // DeploymentCondition describes the state of a deployment at a certain point.\n        deploymentCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // The last time this condition was updated.\n          withLastUpdateTime(lastUpdateTime):: self + {lastUpdateTime: lastUpdateTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of deployment condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DeploymentList is a list of Deployments.\n        deploymentList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is the list of Deployments.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of Deployments.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1.deployment,\n          mixin:: {\n          },\n        },\n        // DeploymentSpec is the specification of the desired behavior of the Deployment.\n        deploymentSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Indicates that the deployment is paused.\n          withPaused(paused):: self + {paused: paused},\n          // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.\n          withProgressDeadlineSeconds(progressDeadlineSeconds):: self + {progressDeadlineSeconds: progressDeadlineSeconds},\n          // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          mixin:: {\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. It must match the pod template's labels.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = {strategy+: strategy},\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.apps.v1.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // DeploymentStatus is the most recently observed status of the Deployment.\n        deploymentStatus:: {\n          new():: {},\n          // Total number of available pods (ready for at least minReadySeconds) targeted by this deployment.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Count of hash collisions for the Deployment. The Deployment controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ReplicaSet.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a deployment's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a deployment's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1.deploymentCondition,\n          // The generation observed by the deployment controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // Total number of ready pods targeted by this deployment.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Total number of non-terminated pods targeted by this deployment (their labels match the selector).\n          withReplicas(replicas):: self + {replicas: replicas},\n          // Total number of unavailable pods targeted by this deployment. This is the total number of pods that are still required for the deployment to have 100% available capacity. They may either be pods that are running but not yet available or pods that still have not been created.\n          withUnavailableReplicas(unavailableReplicas):: self + {unavailableReplicas: unavailableReplicas},\n          // Total number of non-terminated pods targeted by this deployment that have the desired template spec.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // DeploymentStrategy describes how to replace existing pods with new ones.\n        deploymentStrategy:: {\n          new():: {},\n          // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.\n              withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n              // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.apps.v1.rollingUpdateDeployment,\n          },\n        },\n        // ReplicaSetCondition describes the state of a replica set at a certain point.\n        replicaSetCondition:: {\n          new():: {},\n          // The last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of replica set condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // ReplicaSetList is a collection of ReplicaSets.\n        replicaSetList:: {\n          new():: {},\n          // List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1.replicaSet,\n          mixin:: {\n          },\n        },\n        // ReplicaSetSpec is the specification of a ReplicaSet.\n        replicaSetSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n            // Selector is a label query over pods that should match the replica count. Label keys and values that must match in order to be controlled by this replica set. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // ReplicaSetStatus represents the current status of a ReplicaSet.\n        replicaSetStatus:: {\n          new():: {},\n          // The number of available replicas (ready for at least minReadySeconds) for this replica set.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Represents the latest available observations of a replica set's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a replica set's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1.replicaSetCondition,\n          // The number of pods that have labels matching the labels of the pod template of the replicaset.\n          withFullyLabeledReplicas(fullyLabeledReplicas):: self + {fullyLabeledReplicas: fullyLabeledReplicas},\n          // ObservedGeneration reflects the generation of the most recently observed ReplicaSet.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The number of ready replicas for this replica set.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of daemon set rolling update.\n        rollingUpdateDaemonSet:: {\n          new():: {},\n          // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of rolling update.\n        rollingUpdateDeployment:: {\n          new():: {},\n          // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.\n          withMaxSurge(maxSurge):: self + {maxSurge: maxSurge},\n          // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // RollingUpdateStatefulSetStrategy is used to communicate parameter for RollingUpdateStatefulSetStrategyType.\n        rollingUpdateStatefulSetStrategy:: {\n          new():: {},\n          // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n          withPartition(partition):: self + {partition: partition},\n          mixin:: {\n          },\n        },\n        // StatefulSetCondition describes the state of a statefulset at a certain point.\n        statefulSetCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of statefulset condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // StatefulSetList is a collection of StatefulSets.\n        statefulSetList:: {\n          new(items=\"\"):: self.withItems(items),\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1.statefulSet,\n          mixin:: {\n          },\n        },\n        // A StatefulSetSpec is the specification of a StatefulSet.\n        statefulSetSpec:: {\n          new():: {},\n          // podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.\n          withPodManagementPolicy(podManagementPolicy):: self + {podManagementPolicy: podManagementPolicy},\n          // replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          // serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where \"pod-specific-string\" is managed by the StatefulSet controller.\n          withServiceName(serviceName):: self + {serviceName: serviceName},\n          // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n          withVolumeClaimTemplates(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then {volumeClaimTemplates: volumeClaimTemplates} else {volumeClaimTemplates: [volumeClaimTemplates]},\n          // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n          withVolumeClaimTemplatesMixin(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then {volumeClaimTemplates+: volumeClaimTemplates} else {volumeClaimTemplates+: [volumeClaimTemplates]},\n          volumeClaimTemplatesType:: hidden.core.v1.persistentVolumeClaim,\n          mixin:: {\n            // selector is a label query over pods that should match the replica count. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = {updateStrategy+: updateStrategy},\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n                withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n              },\n              rollingUpdateType:: hidden.apps.v1.rollingUpdateStatefulSetStrategy,\n              // Type indicates the type of the StatefulSetUpdateStrategy. Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1.statefulSetUpdateStrategy,\n          },\n        },\n        // StatefulSetStatus represents the current state of a StatefulSet.\n        statefulSetStatus:: {\n          new():: {},\n          // collisionCount is the count of hash collisions for the StatefulSet. The StatefulSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a statefulset's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a statefulset's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1.statefulSetCondition,\n          // currentReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by currentRevision.\n          withCurrentReplicas(currentReplicas):: self + {currentReplicas: currentReplicas},\n          // currentRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [0,currentReplicas).\n          withCurrentRevision(currentRevision):: self + {currentRevision: currentRevision},\n          // observedGeneration is the most recent generation observed for this StatefulSet. It corresponds to the StatefulSet's generation, which is updated on mutation by the API Server.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // readyReplicas is the number of Pods created by the StatefulSet controller that have a Ready Condition.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // replicas is the number of Pods created by the StatefulSet controller.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // updateRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [replicas-updatedReplicas,replicas)\n          withUpdateRevision(updateRevision):: self + {updateRevision: updateRevision},\n          // updatedReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by updateRevision.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // StatefulSetUpdateStrategy indicates the strategy that the StatefulSet controller will use to perform updates. It includes any additional parameters necessary to perform the update for the indicated strategy.\n        statefulSetUpdateStrategy:: {\n          new():: {},\n          // Type indicates the type of the StatefulSetUpdateStrategy. Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n              withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n            },\n            rollingUpdateType:: hidden.apps.v1.rollingUpdateStatefulSetStrategy,\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"apps/v1beta1\"},\n        // ControllerRevisionList is a resource containing a list of ControllerRevision objects.\n        controllerRevisionList:: {\n          new():: {},\n          // Items is the list of ControllerRevisions\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of ControllerRevisions\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta1.controllerRevision,\n          mixin:: {\n          },\n        },\n        // DeploymentCondition describes the state of a deployment at a certain point.\n        deploymentCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // The last time this condition was updated.\n          withLastUpdateTime(lastUpdateTime):: self + {lastUpdateTime: lastUpdateTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of deployment condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DeploymentList is a list of Deployments.\n        deploymentList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is the list of Deployments.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of Deployments.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta1.deployment,\n          mixin:: {\n          },\n        },\n        // DeploymentSpec is the specification of the desired behavior of the Deployment.\n        deploymentSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Indicates that the deployment is paused.\n          withPaused(paused):: self + {paused: paused},\n          // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.\n          withProgressDeadlineSeconds(progressDeadlineSeconds):: self + {progressDeadlineSeconds: progressDeadlineSeconds},\n          // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 2.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          mixin:: {\n            // DEPRECATED. The config this deployment is rolling back to. Will be cleared after rollback is done.\n            rollbackTo:: {\n              local __rollbackToMixin(rollbackTo) = {rollbackTo+: rollbackTo},\n              mixinInstance(rollbackTo):: __rollbackToMixin(rollbackTo),\n              // The revision to rollback to. If set to 0, rollback to the last revision.\n              withRevision(revision):: self + __rollbackToMixin({revision: revision}),\n            },\n            rollbackToType:: hidden.apps.v1beta1.rollbackConfig,\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = {strategy+: strategy},\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta1.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.apps.v1beta1.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // DeploymentStatus is the most recently observed status of the Deployment.\n        deploymentStatus:: {\n          new():: {},\n          // Total number of available pods (ready for at least minReadySeconds) targeted by this deployment.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Count of hash collisions for the Deployment. The Deployment controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ReplicaSet.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a deployment's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a deployment's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1beta1.deploymentCondition,\n          // The generation observed by the deployment controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // Total number of ready pods targeted by this deployment.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Total number of non-terminated pods targeted by this deployment (their labels match the selector).\n          withReplicas(replicas):: self + {replicas: replicas},\n          // Total number of unavailable pods targeted by this deployment. This is the total number of pods that are still required for the deployment to have 100% available capacity. They may either be pods that are running but not yet available or pods that still have not been created.\n          withUnavailableReplicas(unavailableReplicas):: self + {unavailableReplicas: unavailableReplicas},\n          // Total number of non-terminated pods targeted by this deployment that have the desired template spec.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // DeploymentStrategy describes how to replace existing pods with new ones.\n        deploymentStrategy:: {\n          new():: {},\n          // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n              withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n              // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.apps.v1beta1.rollingUpdateDeployment,\n          },\n        },\n        // DEPRECATED.\n        rollbackConfig:: {\n          new():: {},\n          // The revision to rollback to. If set to 0, rollback to the last revision.\n          withRevision(revision):: self + {revision: revision},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of rolling update.\n        rollingUpdateDeployment:: {\n          new():: {},\n          // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n          withMaxSurge(maxSurge):: self + {maxSurge: maxSurge},\n          // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // RollingUpdateStatefulSetStrategy is used to communicate parameter for RollingUpdateStatefulSetStrategyType.\n        rollingUpdateStatefulSetStrategy:: {\n          new():: {},\n          // Partition indicates the ordinal at which the StatefulSet should be partitioned.\n          withPartition(partition):: self + {partition: partition},\n          mixin:: {\n          },\n        },\n        // ScaleSpec describes the attributes of a scale subresource\n        scaleSpec:: {\n          new():: {},\n          // desired number of instances for the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // ScaleStatus represents the current status of a scale subresource.\n        scaleStatus:: {\n          new():: {},\n          // actual number of observed instances of the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelector(selector):: self + {selector: selector},\n          // label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelectorMixin(selector):: self + {selector+: selector},\n          // label selector for pods that should match the replicas count. This is a serializated version of both map-based and more expressive set-based selectors. This is done to avoid introspection in the clients. The string will be in the same format as the query-param syntax. If the target type only supports map-based selectors, both this field and map-based selector field are populated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n          withTargetSelector(targetSelector):: self + {targetSelector: targetSelector},\n          mixin:: {\n          },\n        },\n        // StatefulSetCondition describes the state of a statefulset at a certain point.\n        statefulSetCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of statefulset condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // StatefulSetList is a collection of StatefulSets.\n        statefulSetList:: {\n          new(items=\"\"):: self.withItems(items),\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta1.statefulSet,\n          mixin:: {\n          },\n        },\n        // A StatefulSetSpec is the specification of a StatefulSet.\n        statefulSetSpec:: {\n          new():: {},\n          // podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.\n          withPodManagementPolicy(podManagementPolicy):: self + {podManagementPolicy: podManagementPolicy},\n          // replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          // serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where \"pod-specific-string\" is managed by the StatefulSet controller.\n          withServiceName(serviceName):: self + {serviceName: serviceName},\n          // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n          withVolumeClaimTemplates(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then {volumeClaimTemplates: volumeClaimTemplates} else {volumeClaimTemplates: [volumeClaimTemplates]},\n          // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n          withVolumeClaimTemplatesMixin(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then {volumeClaimTemplates+: volumeClaimTemplates} else {volumeClaimTemplates+: [volumeClaimTemplates]},\n          volumeClaimTemplatesType:: hidden.core.v1.persistentVolumeClaim,\n          mixin:: {\n            // selector is a label query over pods that should match the replica count. If empty, defaulted to labels on the pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = {updateStrategy+: updateStrategy},\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // Partition indicates the ordinal at which the StatefulSet should be partitioned.\n                withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta1.rollingUpdateStatefulSetStrategy,\n              // Type indicates the type of the StatefulSetUpdateStrategy.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1beta1.statefulSetUpdateStrategy,\n          },\n        },\n        // StatefulSetStatus represents the current state of a StatefulSet.\n        statefulSetStatus:: {\n          new():: {},\n          // collisionCount is the count of hash collisions for the StatefulSet. The StatefulSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a statefulset's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a statefulset's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1beta1.statefulSetCondition,\n          // currentReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by currentRevision.\n          withCurrentReplicas(currentReplicas):: self + {currentReplicas: currentReplicas},\n          // currentRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [0,currentReplicas).\n          withCurrentRevision(currentRevision):: self + {currentRevision: currentRevision},\n          // observedGeneration is the most recent generation observed for this StatefulSet. It corresponds to the StatefulSet's generation, which is updated on mutation by the API Server.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // readyReplicas is the number of Pods created by the StatefulSet controller that have a Ready Condition.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // replicas is the number of Pods created by the StatefulSet controller.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // updateRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [replicas-updatedReplicas,replicas)\n          withUpdateRevision(updateRevision):: self + {updateRevision: updateRevision},\n          // updatedReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by updateRevision.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // StatefulSetUpdateStrategy indicates the strategy that the StatefulSet controller will use to perform updates. It includes any additional parameters necessary to perform the update for the indicated strategy.\n        statefulSetUpdateStrategy:: {\n          new():: {},\n          // Type indicates the type of the StatefulSetUpdateStrategy.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // Partition indicates the ordinal at which the StatefulSet should be partitioned.\n              withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n            },\n            rollingUpdateType:: hidden.apps.v1beta1.rollingUpdateStatefulSetStrategy,\n          },\n        },\n      },\n      v1beta2:: {\n        local apiVersion = {apiVersion: \"apps/v1beta2\"},\n        // ControllerRevisionList is a resource containing a list of ControllerRevision objects.\n        controllerRevisionList:: {\n          new():: {},\n          // Items is the list of ControllerRevisions\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of ControllerRevisions\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta2.controllerRevision,\n          mixin:: {\n          },\n        },\n        // DaemonSetCondition describes the state of a DaemonSet at a certain point.\n        daemonSetCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of DaemonSet condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DaemonSetList is a collection of daemon sets.\n        daemonSetList:: {\n          new():: {},\n          // A list of daemon sets.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // A list of daemon sets.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta2.daemonSet,\n          mixin:: {\n          },\n        },\n        // DaemonSetSpec is the specification of a daemon set.\n        daemonSetSpec:: {\n          new():: {},\n          // The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          mixin:: {\n            // A label query over pods that are managed by the daemon set. Must match in order to be controlled. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // An object that describes the pod that will be created. The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // An update strategy to replace existing DaemonSet pods with new pods.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = {updateStrategy+: updateStrategy},\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // Rolling update config params. Present only if type = \"RollingUpdate\".\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateDaemonSet,\n              // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1beta2.daemonSetUpdateStrategy,\n          },\n        },\n        // DaemonSetStatus represents the current status of a daemon set.\n        daemonSetStatus:: {\n          new():: {},\n          // Count of hash collisions for the DaemonSet. The DaemonSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a DaemonSet's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a DaemonSet's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1beta2.daemonSetCondition,\n          // The number of nodes that are running at least 1 daemon pod and are supposed to run the daemon pod. More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withCurrentNumberScheduled(currentNumberScheduled):: self + {currentNumberScheduled: currentNumberScheduled},\n          // The total number of nodes that should be running the daemon pod (including nodes correctly running the daemon pod). More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withDesiredNumberScheduled(desiredNumberScheduled):: self + {desiredNumberScheduled: desiredNumberScheduled},\n          // The number of nodes that should be running the daemon pod and have one or more of the daemon pod running and available (ready for at least spec.minReadySeconds)\n          withNumberAvailable(numberAvailable):: self + {numberAvailable: numberAvailable},\n          // The number of nodes that are running the daemon pod, but are not supposed to run the daemon pod. More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withNumberMisscheduled(numberMisscheduled):: self + {numberMisscheduled: numberMisscheduled},\n          // The number of nodes that should be running the daemon pod and have one or more of the daemon pod running and ready.\n          withNumberReady(numberReady):: self + {numberReady: numberReady},\n          // The number of nodes that should be running the daemon pod and have none of the daemon pod running and available (ready for at least spec.minReadySeconds)\n          withNumberUnavailable(numberUnavailable):: self + {numberUnavailable: numberUnavailable},\n          // The most recent generation observed by the daemon set controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The total number of nodes that are running updated daemon pod\n          withUpdatedNumberScheduled(updatedNumberScheduled):: self + {updatedNumberScheduled: updatedNumberScheduled},\n          mixin:: {\n          },\n        },\n        // DaemonSetUpdateStrategy is a struct used to control the update strategy for a DaemonSet.\n        daemonSetUpdateStrategy:: {\n          new():: {},\n          // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if type = \"RollingUpdate\".\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateDaemonSet,\n          },\n        },\n        // DeploymentCondition describes the state of a deployment at a certain point.\n        deploymentCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // The last time this condition was updated.\n          withLastUpdateTime(lastUpdateTime):: self + {lastUpdateTime: lastUpdateTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of deployment condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DeploymentList is a list of Deployments.\n        deploymentList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is the list of Deployments.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of Deployments.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta2.deployment,\n          mixin:: {\n          },\n        },\n        // DeploymentSpec is the specification of the desired behavior of the Deployment.\n        deploymentSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Indicates that the deployment is paused.\n          withPaused(paused):: self + {paused: paused},\n          // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.\n          withProgressDeadlineSeconds(progressDeadlineSeconds):: self + {progressDeadlineSeconds: progressDeadlineSeconds},\n          // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          mixin:: {\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. It must match the pod template's labels.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = {strategy+: strategy},\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.apps.v1beta2.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // DeploymentStatus is the most recently observed status of the Deployment.\n        deploymentStatus:: {\n          new():: {},\n          // Total number of available pods (ready for at least minReadySeconds) targeted by this deployment.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Count of hash collisions for the Deployment. The Deployment controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ReplicaSet.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a deployment's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a deployment's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1beta2.deploymentCondition,\n          // The generation observed by the deployment controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // Total number of ready pods targeted by this deployment.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Total number of non-terminated pods targeted by this deployment (their labels match the selector).\n          withReplicas(replicas):: self + {replicas: replicas},\n          // Total number of unavailable pods targeted by this deployment. This is the total number of pods that are still required for the deployment to have 100% available capacity. They may either be pods that are running but not yet available or pods that still have not been created.\n          withUnavailableReplicas(unavailableReplicas):: self + {unavailableReplicas: unavailableReplicas},\n          // Total number of non-terminated pods targeted by this deployment that have the desired template spec.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // DeploymentStrategy describes how to replace existing pods with new ones.\n        deploymentStrategy:: {\n          new():: {},\n          // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n              withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n              // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateDeployment,\n          },\n        },\n        // ReplicaSetCondition describes the state of a replica set at a certain point.\n        replicaSetCondition:: {\n          new():: {},\n          // The last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of replica set condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // ReplicaSetList is a collection of ReplicaSets.\n        replicaSetList:: {\n          new():: {},\n          // List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta2.replicaSet,\n          mixin:: {\n          },\n        },\n        // ReplicaSetSpec is the specification of a ReplicaSet.\n        replicaSetSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n            // Selector is a label query over pods that should match the replica count. Label keys and values that must match in order to be controlled by this replica set. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // ReplicaSetStatus represents the current status of a ReplicaSet.\n        replicaSetStatus:: {\n          new():: {},\n          // The number of available replicas (ready for at least minReadySeconds) for this replica set.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Represents the latest available observations of a replica set's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a replica set's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1beta2.replicaSetCondition,\n          // The number of pods that have labels matching the labels of the pod template of the replicaset.\n          withFullyLabeledReplicas(fullyLabeledReplicas):: self + {fullyLabeledReplicas: fullyLabeledReplicas},\n          // ObservedGeneration reflects the generation of the most recently observed ReplicaSet.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The number of ready replicas for this replica set.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of daemon set rolling update.\n        rollingUpdateDaemonSet:: {\n          new():: {},\n          // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of rolling update.\n        rollingUpdateDeployment:: {\n          new():: {},\n          // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n          withMaxSurge(maxSurge):: self + {maxSurge: maxSurge},\n          // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // RollingUpdateStatefulSetStrategy is used to communicate parameter for RollingUpdateStatefulSetStrategyType.\n        rollingUpdateStatefulSetStrategy:: {\n          new():: {},\n          // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n          withPartition(partition):: self + {partition: partition},\n          mixin:: {\n          },\n        },\n        // ScaleSpec describes the attributes of a scale subresource\n        scaleSpec:: {\n          new():: {},\n          // desired number of instances for the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // ScaleStatus represents the current status of a scale subresource.\n        scaleStatus:: {\n          new():: {},\n          // actual number of observed instances of the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelector(selector):: self + {selector: selector},\n          // label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelectorMixin(selector):: self + {selector+: selector},\n          // label selector for pods that should match the replicas count. This is a serializated version of both map-based and more expressive set-based selectors. This is done to avoid introspection in the clients. The string will be in the same format as the query-param syntax. If the target type only supports map-based selectors, both this field and map-based selector field are populated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n          withTargetSelector(targetSelector):: self + {targetSelector: targetSelector},\n          mixin:: {\n          },\n        },\n        // StatefulSetCondition describes the state of a statefulset at a certain point.\n        statefulSetCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of statefulset condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // StatefulSetList is a collection of StatefulSets.\n        statefulSetList:: {\n          new(items=\"\"):: self.withItems(items),\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.apps.v1beta2.statefulSet,\n          mixin:: {\n          },\n        },\n        // A StatefulSetSpec is the specification of a StatefulSet.\n        statefulSetSpec:: {\n          new():: {},\n          // podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.\n          withPodManagementPolicy(podManagementPolicy):: self + {podManagementPolicy: podManagementPolicy},\n          // replicas is the desired number of replicas of the given Template. These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          // serviceName is the name of the service that governs this StatefulSet. This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where \"pod-specific-string\" is managed by the StatefulSet controller.\n          withServiceName(serviceName):: self + {serviceName: serviceName},\n          // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n          withVolumeClaimTemplates(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then {volumeClaimTemplates: volumeClaimTemplates} else {volumeClaimTemplates: [volumeClaimTemplates]},\n          // volumeClaimTemplates is a list of claims that pods are allowed to reference. The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.\n          withVolumeClaimTemplatesMixin(volumeClaimTemplates):: self + if std.type(volumeClaimTemplates) == \"array\" then {volumeClaimTemplates+: volumeClaimTemplates} else {volumeClaimTemplates+: [volumeClaimTemplates]},\n          volumeClaimTemplatesType:: hidden.core.v1.persistentVolumeClaim,\n          mixin:: {\n            // selector is a label query over pods that should match the replica count. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // template is the object that describes the pod that will be created if insufficient replicas are detected. Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = {updateStrategy+: updateStrategy},\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n                withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n              },\n              rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateStatefulSetStrategy,\n              // Type indicates the type of the StatefulSetUpdateStrategy. Default is RollingUpdate.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.apps.v1beta2.statefulSetUpdateStrategy,\n          },\n        },\n        // StatefulSetStatus represents the current state of a StatefulSet.\n        statefulSetStatus:: {\n          new():: {},\n          // collisionCount is the count of hash collisions for the StatefulSet. The StatefulSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a statefulset's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a statefulset's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.apps.v1beta2.statefulSetCondition,\n          // currentReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by currentRevision.\n          withCurrentReplicas(currentReplicas):: self + {currentReplicas: currentReplicas},\n          // currentRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [0,currentReplicas).\n          withCurrentRevision(currentRevision):: self + {currentRevision: currentRevision},\n          // observedGeneration is the most recent generation observed for this StatefulSet. It corresponds to the StatefulSet's generation, which is updated on mutation by the API Server.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // readyReplicas is the number of Pods created by the StatefulSet controller that have a Ready Condition.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // replicas is the number of Pods created by the StatefulSet controller.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // updateRevision, if not empty, indicates the version of the StatefulSet used to generate Pods in the sequence [replicas-updatedReplicas,replicas)\n          withUpdateRevision(updateRevision):: self + {updateRevision: updateRevision},\n          // updatedReplicas is the number of Pods created by the StatefulSet controller from the StatefulSet version indicated by updateRevision.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // StatefulSetUpdateStrategy indicates the strategy that the StatefulSet controller will use to perform updates. It includes any additional parameters necessary to perform the update for the indicated strategy.\n        statefulSetUpdateStrategy:: {\n          new():: {},\n          // Type indicates the type of the StatefulSetUpdateStrategy. Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // Partition indicates the ordinal at which the StatefulSet should be partitioned. Default value is 0.\n              withPartition(partition):: self + __rollingUpdateMixin({partition: partition}),\n            },\n            rollingUpdateType:: hidden.apps.v1beta2.rollingUpdateStatefulSetStrategy,\n          },\n        },\n      },\n    },\n    authentication:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"authentication/v1\"},\n        // TokenReviewSpec is a description of the token authentication request.\n        tokenReviewSpec:: {\n          new():: {},\n          // Token is the opaque bearer token.\n          withToken(token):: self + {token: token},\n          mixin:: {\n          },\n        },\n        // TokenReviewStatus is the result of the token authentication request.\n        tokenReviewStatus:: {\n          new():: {},\n          // Authenticated indicates that the token was associated with a known user.\n          withAuthenticated(authenticated):: self + {authenticated: authenticated},\n          // Error indicates that the token couldn't be checked\n          withErrorParam(errorParam):: self + {\"error\": errorParam},\n          mixin:: {\n            // User is the UserInfo associated with the provided token.\n            user:: {\n              local __userMixin(user) = {user+: user},\n              mixinInstance(user):: __userMixin(user),\n              // Any additional information provided by the authenticator.\n              withExtra(extra):: self + __userMixin({extra: extra}),\n              // Any additional information provided by the authenticator.\n              withExtraMixin(extra):: self + __userMixin({extra+: extra}),\n              // The names of groups this user is a part of.\n              withGroups(groups):: self + if std.type(groups) == \"array\" then __userMixin({groups: groups}) else __userMixin({groups: [groups]}),\n              // The names of groups this user is a part of.\n              withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then __userMixin({groups+: groups}) else __userMixin({groups+: [groups]}),\n              // A unique value that identifies this user across time. If this user is deleted and another user by the same name is added, they will have different UIDs.\n              withUid(uid):: self + __userMixin({uid: uid}),\n              // The name that uniquely identifies this user among all active users.\n              withUsername(username):: self + __userMixin({username: username}),\n            },\n            userType:: hidden.authentication.v1.userInfo,\n          },\n        },\n        // UserInfo holds the information about the user needed to implement the user.Info interface.\n        userInfo:: {\n          new():: {},\n          // Any additional information provided by the authenticator.\n          withExtra(extra):: self + {extra: extra},\n          // Any additional information provided by the authenticator.\n          withExtraMixin(extra):: self + {extra+: extra},\n          // The names of groups this user is a part of.\n          withGroups(groups):: self + if std.type(groups) == \"array\" then {groups: groups} else {groups: [groups]},\n          // The names of groups this user is a part of.\n          withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then {groups+: groups} else {groups+: [groups]},\n          // A unique value that identifies this user across time. If this user is deleted and another user by the same name is added, they will have different UIDs.\n          withUid(uid):: self + {uid: uid},\n          // The name that uniquely identifies this user among all active users.\n          withUsername(username):: self + {username: username},\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"authentication/v1beta1\"},\n        // TokenReviewSpec is a description of the token authentication request.\n        tokenReviewSpec:: {\n          new():: {},\n          // Token is the opaque bearer token.\n          withToken(token):: self + {token: token},\n          mixin:: {\n          },\n        },\n        // TokenReviewStatus is the result of the token authentication request.\n        tokenReviewStatus:: {\n          new():: {},\n          // Authenticated indicates that the token was associated with a known user.\n          withAuthenticated(authenticated):: self + {authenticated: authenticated},\n          // Error indicates that the token couldn't be checked\n          withErrorParam(errorParam):: self + {\"error\": errorParam},\n          mixin:: {\n            // User is the UserInfo associated with the provided token.\n            user:: {\n              local __userMixin(user) = {user+: user},\n              mixinInstance(user):: __userMixin(user),\n              // Any additional information provided by the authenticator.\n              withExtra(extra):: self + __userMixin({extra: extra}),\n              // Any additional information provided by the authenticator.\n              withExtraMixin(extra):: self + __userMixin({extra+: extra}),\n              // The names of groups this user is a part of.\n              withGroups(groups):: self + if std.type(groups) == \"array\" then __userMixin({groups: groups}) else __userMixin({groups: [groups]}),\n              // The names of groups this user is a part of.\n              withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then __userMixin({groups+: groups}) else __userMixin({groups+: [groups]}),\n              // A unique value that identifies this user across time. If this user is deleted and another user by the same name is added, they will have different UIDs.\n              withUid(uid):: self + __userMixin({uid: uid}),\n              // The name that uniquely identifies this user among all active users.\n              withUsername(username):: self + __userMixin({username: username}),\n            },\n            userType:: hidden.authentication.v1beta1.userInfo,\n          },\n        },\n        // UserInfo holds the information about the user needed to implement the user.Info interface.\n        userInfo:: {\n          new():: {},\n          // Any additional information provided by the authenticator.\n          withExtra(extra):: self + {extra: extra},\n          // Any additional information provided by the authenticator.\n          withExtraMixin(extra):: self + {extra+: extra},\n          // The names of groups this user is a part of.\n          withGroups(groups):: self + if std.type(groups) == \"array\" then {groups: groups} else {groups: [groups]},\n          // The names of groups this user is a part of.\n          withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then {groups+: groups} else {groups+: [groups]},\n          // A unique value that identifies this user across time. If this user is deleted and another user by the same name is added, they will have different UIDs.\n          withUid(uid):: self + {uid: uid},\n          // The name that uniquely identifies this user among all active users.\n          withUsername(username):: self + {username: username},\n          mixin:: {\n          },\n        },\n      },\n    },\n    authorization:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"authorization/v1\"},\n        // NonResourceAttributes includes the authorization attributes available for non-resource requests to the Authorizer interface\n        nonResourceAttributes:: {\n          new():: {},\n          // Path is the URL path of the request\n          withPath(path):: self + {path: path},\n          // Verb is the standard HTTP verb\n          withVerb(verb):: self + {verb: verb},\n          mixin:: {\n          },\n        },\n        // NonResourceRule holds information that describes a rule for the non-resource\n        nonResourceRule:: {\n          new():: {},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path.  \"*\" means all.\n          withNonResourceUrls(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs: nonResourceUrls} else {nonResourceURLs: [nonResourceUrls]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path.  \"*\" means all.\n          withNonResourceUrlsMixin(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs+: nonResourceUrls} else {nonResourceURLs+: [nonResourceUrls]},\n          // Verb is a list of kubernetes non-resource API verbs, like: get, post, put, delete, patch, head, options.  \"*\" means all.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verb is a list of kubernetes non-resource API verbs, like: get, post, put, delete, patch, head, options.  \"*\" means all.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // ResourceAttributes includes the authorization attributes available for resource requests to the Authorizer interface\n        resourceAttributes:: {\n          new():: {},\n          // Group is the API Group of the Resource.  \"*\" means all.\n          withGroup(group):: self + {group: group},\n          // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n          withName(name):: self + {name: name},\n          // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n          withNamespace(namespace):: self + {namespace: namespace},\n          // Resource is one of the existing resource types.  \"*\" means all.\n          withResource(resource):: self + {resource: resource},\n          // Subresource is one of the existing resource types.  \"\" means none.\n          withSubresource(subresource):: self + {subresource: subresource},\n          // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n          withVerb(verb):: self + {verb: verb},\n          // Version is the API Version of the Resource.  \"*\" means all.\n          withVersion(version):: self + {version: version},\n          mixin:: {\n          },\n        },\n        // ResourceRule is the list of actions the subject is allowed to perform on resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n        resourceRule:: {\n          new():: {},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.  \"*\" means all.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.  \"*\" means all.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.  \"*\" means all.\n          withResourceNames(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames: resourceNames} else {resourceNames: [resourceNames]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.  \"*\" means all.\n          withResourceNamesMixin(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames+: resourceNames} else {resourceNames+: [resourceNames]},\n          // Resources is a list of resources this rule applies to.  \"*\" means all in the specified apiGroups.\n          // \"*/foo\" represents the subresource 'foo' for all resources in the specified apiGroups.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.  \"*\" means all in the specified apiGroups.\n          // \"*/foo\" represents the subresource 'foo' for all resources in the specified apiGroups.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          // Verb is a list of kubernetes resource API verbs, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verb is a list of kubernetes resource API verbs, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // SelfSubjectAccessReviewSpec is a description of the access request.  Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set\n        selfSubjectAccessReviewSpec:: {\n          new():: {},\n          mixin:: {\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = {nonResourceAttributes+: nonResourceAttributes},\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = {resourceAttributes+: resourceAttributes},\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1.resourceAttributes,\n          },\n        },\n        selfSubjectRulesReviewSpec:: {\n          new():: {},\n          // Namespace to evaluate rules for. Required.\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n        // SubjectAccessReviewSpec is a description of the access request.  Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set\n        subjectAccessReviewSpec:: {\n          new():: {},\n          // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n          withExtra(extra):: self + {extra: extra},\n          // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n          withExtraMixin(extra):: self + {extra+: extra},\n          // Groups is the groups you're testing for.\n          withGroups(groups):: self + if std.type(groups) == \"array\" then {groups: groups} else {groups: [groups]},\n          // Groups is the groups you're testing for.\n          withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then {groups+: groups} else {groups+: [groups]},\n          // UID information about the requesting user.\n          withUid(uid):: self + {uid: uid},\n          // User is the user you're testing for. If you specify \"User\" but not \"Groups\", then is it interpreted as \"What if User were not a member of any groups\n          withUser(user):: self + {user: user},\n          mixin:: {\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = {nonResourceAttributes+: nonResourceAttributes},\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = {resourceAttributes+: resourceAttributes},\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1.resourceAttributes,\n          },\n        },\n        // SubjectAccessReviewStatus\n        subjectAccessReviewStatus:: {\n          new():: {},\n          // Allowed is required. True if the action would be allowed, false otherwise.\n          withAllowed(allowed):: self + {allowed: allowed},\n          // Denied is optional. True if the action would be denied, otherwise false. If both allowed is false and denied is false, then the authorizer has no opinion on whether to authorize the action. Denied may not be true if Allowed is true.\n          withDenied(denied):: self + {denied: denied},\n          // EvaluationError is an indication that some error occurred during the authorization check. It is entirely possible to get an error and be able to continue determine authorization status in spite of it. For instance, RBAC can be missing a role, but enough roles are still present and bound to reason about the request.\n          withEvaluationError(evaluationError):: self + {evaluationError: evaluationError},\n          // Reason is optional.  It indicates why a request was allowed or denied.\n          withReason(reason):: self + {reason: reason},\n          mixin:: {\n          },\n        },\n        // SubjectRulesReviewStatus contains the result of a rules check. This check can be incomplete depending on the set of authorizers the server is configured with and any errors experienced during evaluation. Because authorization rules are additive, if a rule appears in a list it's safe to assume the subject has that permission, even if that list is incomplete.\n        subjectRulesReviewStatus:: {\n          new():: {},\n          // EvaluationError can appear in combination with Rules. It indicates an error occurred during rule evaluation, such as an authorizer that doesn't support rule evaluation, and that ResourceRules and/or NonResourceRules may be incomplete.\n          withEvaluationError(evaluationError):: self + {evaluationError: evaluationError},\n          // Incomplete is true when the rules returned by this call are incomplete. This is most commonly encountered when an authorizer, such as an external authorizer, doesn't support rules evaluation.\n          withIncomplete(incomplete):: self + {incomplete: incomplete},\n          // NonResourceRules is the list of actions the subject is allowed to perform on non-resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withNonResourceRules(nonResourceRules):: self + if std.type(nonResourceRules) == \"array\" then {nonResourceRules: nonResourceRules} else {nonResourceRules: [nonResourceRules]},\n          // NonResourceRules is the list of actions the subject is allowed to perform on non-resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withNonResourceRulesMixin(nonResourceRules):: self + if std.type(nonResourceRules) == \"array\" then {nonResourceRules+: nonResourceRules} else {nonResourceRules+: [nonResourceRules]},\n          nonResourceRulesType:: hidden.authorization.v1.nonResourceRule,\n          // ResourceRules is the list of actions the subject is allowed to perform on resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withResourceRules(resourceRules):: self + if std.type(resourceRules) == \"array\" then {resourceRules: resourceRules} else {resourceRules: [resourceRules]},\n          // ResourceRules is the list of actions the subject is allowed to perform on resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withResourceRulesMixin(resourceRules):: self + if std.type(resourceRules) == \"array\" then {resourceRules+: resourceRules} else {resourceRules+: [resourceRules]},\n          resourceRulesType:: hidden.authorization.v1.resourceRule,\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"authorization/v1beta1\"},\n        // NonResourceAttributes includes the authorization attributes available for non-resource requests to the Authorizer interface\n        nonResourceAttributes:: {\n          new():: {},\n          // Path is the URL path of the request\n          withPath(path):: self + {path: path},\n          // Verb is the standard HTTP verb\n          withVerb(verb):: self + {verb: verb},\n          mixin:: {\n          },\n        },\n        // NonResourceRule holds information that describes a rule for the non-resource\n        nonResourceRule:: {\n          new():: {},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path.  \"*\" means all.\n          withNonResourceUrls(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs: nonResourceUrls} else {nonResourceURLs: [nonResourceUrls]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path.  \"*\" means all.\n          withNonResourceUrlsMixin(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs+: nonResourceUrls} else {nonResourceURLs+: [nonResourceUrls]},\n          // Verb is a list of kubernetes non-resource API verbs, like: get, post, put, delete, patch, head, options.  \"*\" means all.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verb is a list of kubernetes non-resource API verbs, like: get, post, put, delete, patch, head, options.  \"*\" means all.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // ResourceAttributes includes the authorization attributes available for resource requests to the Authorizer interface\n        resourceAttributes:: {\n          new():: {},\n          // Group is the API Group of the Resource.  \"*\" means all.\n          withGroup(group):: self + {group: group},\n          // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n          withName(name):: self + {name: name},\n          // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n          withNamespace(namespace):: self + {namespace: namespace},\n          // Resource is one of the existing resource types.  \"*\" means all.\n          withResource(resource):: self + {resource: resource},\n          // Subresource is one of the existing resource types.  \"\" means none.\n          withSubresource(subresource):: self + {subresource: subresource},\n          // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n          withVerb(verb):: self + {verb: verb},\n          // Version is the API Version of the Resource.  \"*\" means all.\n          withVersion(version):: self + {version: version},\n          mixin:: {\n          },\n        },\n        // ResourceRule is the list of actions the subject is allowed to perform on resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n        resourceRule:: {\n          new():: {},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.  \"*\" means all.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.  \"*\" means all.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.  \"*\" means all.\n          withResourceNames(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames: resourceNames} else {resourceNames: [resourceNames]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.  \"*\" means all.\n          withResourceNamesMixin(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames+: resourceNames} else {resourceNames+: [resourceNames]},\n          // Resources is a list of resources this rule applies to.  \"*\" means all in the specified apiGroups.\n          // \"*/foo\" represents the subresource 'foo' for all resources in the specified apiGroups.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.  \"*\" means all in the specified apiGroups.\n          // \"*/foo\" represents the subresource 'foo' for all resources in the specified apiGroups.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          // Verb is a list of kubernetes resource API verbs, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verb is a list of kubernetes resource API verbs, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // SelfSubjectAccessReviewSpec is a description of the access request.  Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set\n        selfSubjectAccessReviewSpec:: {\n          new():: {},\n          mixin:: {\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = {nonResourceAttributes+: nonResourceAttributes},\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1beta1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = {resourceAttributes+: resourceAttributes},\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1beta1.resourceAttributes,\n          },\n        },\n        selfSubjectRulesReviewSpec:: {\n          new():: {},\n          // Namespace to evaluate rules for. Required.\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n        // SubjectAccessReviewSpec is a description of the access request.  Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set\n        subjectAccessReviewSpec:: {\n          new():: {},\n          // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n          withExtra(extra):: self + {extra: extra},\n          // Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.\n          withExtraMixin(extra):: self + {extra+: extra},\n          // Groups is the groups you're testing for.\n          withGroup(group):: self + if std.type(group) == \"array\" then {group: group} else {group: [group]},\n          // Groups is the groups you're testing for.\n          withGroupMixin(group):: self + if std.type(group) == \"array\" then {group+: group} else {group+: [group]},\n          // UID information about the requesting user.\n          withUid(uid):: self + {uid: uid},\n          // User is the user you're testing for. If you specify \"User\" but not \"Group\", then is it interpreted as \"What if User were not a member of any groups\n          withUser(user):: self + {user: user},\n          mixin:: {\n            // NonResourceAttributes describes information for a non-resource access request\n            nonResourceAttributes:: {\n              local __nonResourceAttributesMixin(nonResourceAttributes) = {nonResourceAttributes+: nonResourceAttributes},\n              mixinInstance(nonResourceAttributes):: __nonResourceAttributesMixin(nonResourceAttributes),\n              // Path is the URL path of the request\n              withPath(path):: self + __nonResourceAttributesMixin({path: path}),\n              // Verb is the standard HTTP verb\n              withVerb(verb):: self + __nonResourceAttributesMixin({verb: verb}),\n            },\n            nonResourceAttributesType:: hidden.authorization.v1beta1.nonResourceAttributes,\n            // ResourceAuthorizationAttributes describes information for a resource access request\n            resourceAttributes:: {\n              local __resourceAttributesMixin(resourceAttributes) = {resourceAttributes+: resourceAttributes},\n              mixinInstance(resourceAttributes):: __resourceAttributesMixin(resourceAttributes),\n              // Group is the API Group of the Resource.  \"*\" means all.\n              withGroup(group):: self + __resourceAttributesMixin({group: group}),\n              // Name is the name of the resource being requested for a \"get\" or deleted for a \"delete\". \"\" (empty) means all.\n              withName(name):: self + __resourceAttributesMixin({name: name}),\n              // Namespace is the namespace of the action being requested.  Currently, there is no distinction between no namespace and all namespaces \"\" (empty) is defaulted for LocalSubjectAccessReviews \"\" (empty) is empty for cluster-scoped resources \"\" (empty) means \"all\" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview\n              withNamespace(namespace):: self + __resourceAttributesMixin({namespace: namespace}),\n              // Resource is one of the existing resource types.  \"*\" means all.\n              withResource(resource):: self + __resourceAttributesMixin({resource: resource}),\n              // Subresource is one of the existing resource types.  \"\" means none.\n              withSubresource(subresource):: self + __resourceAttributesMixin({subresource: subresource}),\n              // Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.  \"*\" means all.\n              withVerb(verb):: self + __resourceAttributesMixin({verb: verb}),\n              // Version is the API Version of the Resource.  \"*\" means all.\n              withVersion(version):: self + __resourceAttributesMixin({version: version}),\n            },\n            resourceAttributesType:: hidden.authorization.v1beta1.resourceAttributes,\n          },\n        },\n        // SubjectAccessReviewStatus\n        subjectAccessReviewStatus:: {\n          new():: {},\n          // Allowed is required. True if the action would be allowed, false otherwise.\n          withAllowed(allowed):: self + {allowed: allowed},\n          // Denied is optional. True if the action would be denied, otherwise false. If both allowed is false and denied is false, then the authorizer has no opinion on whether to authorize the action. Denied may not be true if Allowed is true.\n          withDenied(denied):: self + {denied: denied},\n          // EvaluationError is an indication that some error occurred during the authorization check. It is entirely possible to get an error and be able to continue determine authorization status in spite of it. For instance, RBAC can be missing a role, but enough roles are still present and bound to reason about the request.\n          withEvaluationError(evaluationError):: self + {evaluationError: evaluationError},\n          // Reason is optional.  It indicates why a request was allowed or denied.\n          withReason(reason):: self + {reason: reason},\n          mixin:: {\n          },\n        },\n        // SubjectRulesReviewStatus contains the result of a rules check. This check can be incomplete depending on the set of authorizers the server is configured with and any errors experienced during evaluation. Because authorization rules are additive, if a rule appears in a list it's safe to assume the subject has that permission, even if that list is incomplete.\n        subjectRulesReviewStatus:: {\n          new():: {},\n          // EvaluationError can appear in combination with Rules. It indicates an error occurred during rule evaluation, such as an authorizer that doesn't support rule evaluation, and that ResourceRules and/or NonResourceRules may be incomplete.\n          withEvaluationError(evaluationError):: self + {evaluationError: evaluationError},\n          // Incomplete is true when the rules returned by this call are incomplete. This is most commonly encountered when an authorizer, such as an external authorizer, doesn't support rules evaluation.\n          withIncomplete(incomplete):: self + {incomplete: incomplete},\n          // NonResourceRules is the list of actions the subject is allowed to perform on non-resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withNonResourceRules(nonResourceRules):: self + if std.type(nonResourceRules) == \"array\" then {nonResourceRules: nonResourceRules} else {nonResourceRules: [nonResourceRules]},\n          // NonResourceRules is the list of actions the subject is allowed to perform on non-resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withNonResourceRulesMixin(nonResourceRules):: self + if std.type(nonResourceRules) == \"array\" then {nonResourceRules+: nonResourceRules} else {nonResourceRules+: [nonResourceRules]},\n          nonResourceRulesType:: hidden.authorization.v1beta1.nonResourceRule,\n          // ResourceRules is the list of actions the subject is allowed to perform on resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withResourceRules(resourceRules):: self + if std.type(resourceRules) == \"array\" then {resourceRules: resourceRules} else {resourceRules: [resourceRules]},\n          // ResourceRules is the list of actions the subject is allowed to perform on resources. The list ordering isn't significant, may contain duplicates, and possibly be incomplete.\n          withResourceRulesMixin(resourceRules):: self + if std.type(resourceRules) == \"array\" then {resourceRules+: resourceRules} else {resourceRules+: [resourceRules]},\n          resourceRulesType:: hidden.authorization.v1beta1.resourceRule,\n          mixin:: {\n          },\n        },\n      },\n    },\n    autoscaling:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"autoscaling/v1\"},\n        // CrossVersionObjectReference contains enough information to let you identify the referred resource.\n        crossVersionObjectReference:: {\n          new():: {},\n          // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n          withKind(kind):: self + {kind: kind},\n          // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // list of horizontal pod autoscaler objects.\n        horizontalPodAutoscalerList:: {\n          new(items=\"\"):: self.withItems(items),\n          // list of horizontal pod autoscaler objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // list of horizontal pod autoscaler objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.autoscaling.v1.horizontalPodAutoscaler,\n          mixin:: {\n          },\n        },\n        // specification of a horizontal pod autoscaler.\n        horizontalPodAutoscalerSpec:: {\n          new():: {},\n          // upper limit for the number of pods that can be set by the autoscaler; cannot be smaller than MinReplicas.\n          withMaxReplicas(maxReplicas):: self + {maxReplicas: maxReplicas},\n          // lower limit for the number of pods that can be set by the autoscaler, default 1.\n          withMinReplicas(minReplicas):: self + {minReplicas: minReplicas},\n          // target average CPU utilization (represented as a percentage of requested CPU) over all the pods; if not specified the default autoscaling policy will be used.\n          withTargetCpuUtilizationPercentage(targetCpuUtilizationPercentage):: self + {targetCPUUtilizationPercentage: targetCpuUtilizationPercentage},\n          mixin:: {\n            // reference to scaled resource; horizontal pod autoscaler will learn the current resource consumption and will set the desired number of pods by using its Scale subresource.\n            scaleTargetRef:: {\n              local __scaleTargetRefMixin(scaleTargetRef) = {scaleTargetRef+: scaleTargetRef},\n              mixinInstance(scaleTargetRef):: __scaleTargetRefMixin(scaleTargetRef),\n              // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n              withKind(kind):: self + __scaleTargetRefMixin({kind: kind}),\n              // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __scaleTargetRefMixin({name: name}),\n            },\n            scaleTargetRefType:: hidden.autoscaling.v1.crossVersionObjectReference,\n          },\n        },\n        // current status of a horizontal pod autoscaler\n        horizontalPodAutoscalerStatus:: {\n          new():: {},\n          // current average CPU utilization over all pods, represented as a percentage of requested CPU, e.g. 70 means that an average pod is using now 70% of its requested CPU.\n          withCurrentCpuUtilizationPercentage(currentCpuUtilizationPercentage):: self + {currentCPUUtilizationPercentage: currentCpuUtilizationPercentage},\n          // current number of replicas of pods managed by this autoscaler.\n          withCurrentReplicas(currentReplicas):: self + {currentReplicas: currentReplicas},\n          // desired number of replicas of pods managed by this autoscaler.\n          withDesiredReplicas(desiredReplicas):: self + {desiredReplicas: desiredReplicas},\n          // last time the HorizontalPodAutoscaler scaled the number of pods; used by the autoscaler to control how often the number of pods is changed.\n          withLastScaleTime(lastScaleTime):: self + {lastScaleTime: lastScaleTime},\n          // most recent generation observed by this autoscaler.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          mixin:: {\n          },\n        },\n        // ScaleSpec describes the attributes of a scale subresource.\n        scaleSpec:: {\n          new():: {},\n          // desired number of instances for the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // ScaleStatus represents the current status of a scale subresource.\n        scaleStatus:: {\n          new():: {},\n          // actual number of observed instances of the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // label query over pods that should match the replicas count. This is same as the label selector but in the string format to avoid introspection by clients. The string will be in the same format as the query-param syntax. More info about label selectors: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelector(selector):: self + {selector: selector},\n          mixin:: {\n          },\n        },\n      },\n      v2beta1:: {\n        local apiVersion = {apiVersion: \"autoscaling/v2beta1\"},\n        // CrossVersionObjectReference contains enough information to let you identify the referred resource.\n        crossVersionObjectReference:: {\n          new():: {},\n          // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n          withKind(kind):: self + {kind: kind},\n          // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // ExternalMetricSource indicates how to scale on a metric not associated with any Kubernetes object (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster). Exactly one \"target\" type should be set.\n        externalMetricSource:: {\n          new():: {},\n          // metricName is the name of the metric in question.\n          withMetricName(metricName):: self + {metricName: metricName},\n          mixin:: {\n            // metricSelector is used to identify a specific time series within a given metric.\n            metricSelector:: {\n              local __metricSelectorMixin(metricSelector) = {metricSelector+: metricSelector},\n              mixinInstance(metricSelector):: __metricSelectorMixin(metricSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions: matchExpressions}) else __metricSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions+: matchExpressions}) else __metricSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __metricSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __metricSelectorMixin({matchLabels+: matchLabels}),\n            },\n            metricSelectorType:: hidden.meta.v1.labelSelector,\n            // targetAverageValue is the target per-pod value of global metric (as a quantity). Mutually exclusive with TargetValue.\n            targetAverageValue:: {\n              local __targetAverageValueMixin(targetAverageValue) = {targetAverageValue+: targetAverageValue},\n              mixinInstance(targetAverageValue):: __targetAverageValueMixin(targetAverageValue),\n            },\n            targetAverageValueType:: hidden.core.resource.quantity,\n            // targetValue is the target value of the metric (as a quantity). Mutually exclusive with TargetAverageValue.\n            targetValue:: {\n              local __targetValueMixin(targetValue) = {targetValue+: targetValue},\n              mixinInstance(targetValue):: __targetValueMixin(targetValue),\n            },\n            targetValueType:: hidden.core.resource.quantity,\n          },\n        },\n        // ExternalMetricStatus indicates the current value of a global metric not associated with any Kubernetes object.\n        externalMetricStatus:: {\n          new():: {},\n          // metricName is the name of a metric used for autoscaling in metric system.\n          withMetricName(metricName):: self + {metricName: metricName},\n          mixin:: {\n            // currentAverageValue is the current value of metric averaged over autoscaled pods.\n            currentAverageValue:: {\n              local __currentAverageValueMixin(currentAverageValue) = {currentAverageValue+: currentAverageValue},\n              mixinInstance(currentAverageValue):: __currentAverageValueMixin(currentAverageValue),\n            },\n            currentAverageValueType:: hidden.core.resource.quantity,\n            // currentValue is the current value of the metric (as a quantity)\n            currentValue:: {\n              local __currentValueMixin(currentValue) = {currentValue+: currentValue},\n              mixinInstance(currentValue):: __currentValueMixin(currentValue),\n            },\n            currentValueType:: hidden.core.resource.quantity,\n            // metricSelector is used to identify a specific time series within a given metric.\n            metricSelector:: {\n              local __metricSelectorMixin(metricSelector) = {metricSelector+: metricSelector},\n              mixinInstance(metricSelector):: __metricSelectorMixin(metricSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions: matchExpressions}) else __metricSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions+: matchExpressions}) else __metricSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __metricSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __metricSelectorMixin({matchLabels+: matchLabels}),\n            },\n            metricSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // HorizontalPodAutoscalerCondition describes the state of a HorizontalPodAutoscaler at a certain point.\n        horizontalPodAutoscalerCondition:: {\n          new():: {},\n          // lastTransitionTime is the last time the condition transitioned from one status to another\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // message is a human-readable explanation containing details about the transition\n          withMessage(message):: self + {message: message},\n          // reason is the reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // status is the status of the condition (True, False, Unknown)\n          withStatus(status):: self + {status: status},\n          // type describes the current condition\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // HorizontalPodAutoscaler is a list of horizontal pod autoscaler objects.\n        horizontalPodAutoscalerList:: {\n          new(items=\"\"):: self.withItems(items),\n          // items is the list of horizontal pod autoscaler objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // items is the list of horizontal pod autoscaler objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.autoscaling.v2beta1.horizontalPodAutoscaler,\n          mixin:: {\n          },\n        },\n        // HorizontalPodAutoscalerSpec describes the desired functionality of the HorizontalPodAutoscaler.\n        horizontalPodAutoscalerSpec:: {\n          new():: {},\n          // maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up. It cannot be less that minReplicas.\n          withMaxReplicas(maxReplicas):: self + {maxReplicas: maxReplicas},\n          // metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).  The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond.\n          withMetrics(metrics):: self + if std.type(metrics) == \"array\" then {metrics: metrics} else {metrics: [metrics]},\n          // metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).  The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond.\n          withMetricsMixin(metrics):: self + if std.type(metrics) == \"array\" then {metrics+: metrics} else {metrics+: [metrics]},\n          metricsType:: hidden.autoscaling.v2beta1.metricSpec,\n          // minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down. It defaults to 1 pod.\n          withMinReplicas(minReplicas):: self + {minReplicas: minReplicas},\n          mixin:: {\n            // scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count.\n            scaleTargetRef:: {\n              local __scaleTargetRefMixin(scaleTargetRef) = {scaleTargetRef+: scaleTargetRef},\n              mixinInstance(scaleTargetRef):: __scaleTargetRefMixin(scaleTargetRef),\n              // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n              withKind(kind):: self + __scaleTargetRefMixin({kind: kind}),\n              // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __scaleTargetRefMixin({name: name}),\n            },\n            scaleTargetRefType:: hidden.autoscaling.v2beta1.crossVersionObjectReference,\n          },\n        },\n        // HorizontalPodAutoscalerStatus describes the current status of a horizontal pod autoscaler.\n        horizontalPodAutoscalerStatus:: {\n          new():: {},\n          // conditions is the set of conditions required for this autoscaler to scale its target, and indicates whether or not those conditions are met.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // conditions is the set of conditions required for this autoscaler to scale its target, and indicates whether or not those conditions are met.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.autoscaling.v2beta1.horizontalPodAutoscalerCondition,\n          // currentMetrics is the last read state of the metrics used by this autoscaler.\n          withCurrentMetrics(currentMetrics):: self + if std.type(currentMetrics) == \"array\" then {currentMetrics: currentMetrics} else {currentMetrics: [currentMetrics]},\n          // currentMetrics is the last read state of the metrics used by this autoscaler.\n          withCurrentMetricsMixin(currentMetrics):: self + if std.type(currentMetrics) == \"array\" then {currentMetrics+: currentMetrics} else {currentMetrics+: [currentMetrics]},\n          currentMetricsType:: hidden.autoscaling.v2beta1.metricStatus,\n          // currentReplicas is current number of replicas of pods managed by this autoscaler, as last seen by the autoscaler.\n          withCurrentReplicas(currentReplicas):: self + {currentReplicas: currentReplicas},\n          // desiredReplicas is the desired number of replicas of pods managed by this autoscaler, as last calculated by the autoscaler.\n          withDesiredReplicas(desiredReplicas):: self + {desiredReplicas: desiredReplicas},\n          // lastScaleTime is the last time the HorizontalPodAutoscaler scaled the number of pods, used by the autoscaler to control how often the number of pods is changed.\n          withLastScaleTime(lastScaleTime):: self + {lastScaleTime: lastScaleTime},\n          // observedGeneration is the most recent generation observed by this autoscaler.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          mixin:: {\n          },\n        },\n        // MetricSpec specifies how to scale based on a single metric (only `type` and one other matching field should be set at once).\n        metricSpec:: {\n          new():: {},\n          // type is the type of metric source.  It should be one of \"Object\", \"Pods\" or \"Resource\", each mapping to a matching field in the object.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // external refers to a global metric that is not associated with any Kubernetes object. It allows autoscaling based on information coming from components running outside of cluster (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster).\n            external:: {\n              local __externalMixin(external) = {external+: external},\n              mixinInstance(external):: __externalMixin(external),\n              // metricName is the name of the metric in question.\n              withMetricName(metricName):: self + __externalMixin({metricName: metricName}),\n              // metricSelector is used to identify a specific time series within a given metric.\n              metricSelector:: {\n                local __metricSelectorMixin(metricSelector) = __externalMixin({metricSelector+: metricSelector}),\n                mixinInstance(metricSelector):: __metricSelectorMixin(metricSelector),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions: matchExpressions}) else __metricSelectorMixin({matchExpressions: [matchExpressions]}),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions+: matchExpressions}) else __metricSelectorMixin({matchExpressions+: [matchExpressions]}),\n                matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabels(matchLabels):: self + __metricSelectorMixin({matchLabels: matchLabels}),\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabelsMixin(matchLabels):: self + __metricSelectorMixin({matchLabels+: matchLabels}),\n              },\n              metricSelectorType:: hidden.meta.v1.labelSelector,\n              // targetAverageValue is the target per-pod value of global metric (as a quantity). Mutually exclusive with TargetValue.\n              targetAverageValue:: {\n                local __targetAverageValueMixin(targetAverageValue) = __externalMixin({targetAverageValue+: targetAverageValue}),\n                mixinInstance(targetAverageValue):: __targetAverageValueMixin(targetAverageValue),\n              },\n              targetAverageValueType:: hidden.core.resource.quantity,\n              // targetValue is the target value of the metric (as a quantity). Mutually exclusive with TargetAverageValue.\n              targetValue:: {\n                local __targetValueMixin(targetValue) = __externalMixin({targetValue+: targetValue}),\n                mixinInstance(targetValue):: __targetValueMixin(targetValue),\n              },\n              targetValueType:: hidden.core.resource.quantity,\n            },\n            externalType:: hidden.autoscaling.v2beta1.externalMetricSource,\n            // object refers to a metric describing a single kubernetes object (for example, hits-per-second on an Ingress object).\n            object:: {\n              local __objectMixin(object) = {object+: object},\n              mixinInstance(object):: __objectMixin(object),\n              // metricName is the name of the metric in question.\n              withMetricName(metricName):: self + __objectMixin({metricName: metricName}),\n              // target is the described Kubernetes object.\n              target:: {\n                local __targetMixin(target) = __objectMixin({target+: target}),\n                mixinInstance(target):: __targetMixin(target),\n                // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n                withKind(kind):: self + __targetMixin({kind: kind}),\n                // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __targetMixin({name: name}),\n              },\n              targetType:: hidden.autoscaling.v2beta1.crossVersionObjectReference,\n              // targetValue is the target value of the metric (as a quantity).\n              targetValue:: {\n                local __targetValueMixin(targetValue) = __objectMixin({targetValue+: targetValue}),\n                mixinInstance(targetValue):: __targetValueMixin(targetValue),\n              },\n              targetValueType:: hidden.core.resource.quantity,\n            },\n            objectType:: hidden.autoscaling.v2beta1.objectMetricSource,\n            // pods refers to a metric describing each pod in the current scale target (for example, transactions-processed-per-second).  The values will be averaged together before being compared to the target value.\n            pods:: {\n              local __podsMixin(pods) = {pods+: pods},\n              mixinInstance(pods):: __podsMixin(pods),\n              // metricName is the name of the metric in question\n              withMetricName(metricName):: self + __podsMixin({metricName: metricName}),\n              // targetAverageValue is the target value of the average of the metric across all relevant pods (as a quantity)\n              targetAverageValue:: {\n                local __targetAverageValueMixin(targetAverageValue) = __podsMixin({targetAverageValue+: targetAverageValue}),\n                mixinInstance(targetAverageValue):: __targetAverageValueMixin(targetAverageValue),\n              },\n              targetAverageValueType:: hidden.core.resource.quantity,\n            },\n            podsType:: hidden.autoscaling.v2beta1.podsMetricSource,\n            // resource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing each pod in the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the \"pods\" source.\n            resource:: {\n              local __resourceMixin(resource) = {resource+: resource},\n              mixinInstance(resource):: __resourceMixin(resource),\n              // name is the name of the resource in question.\n              withName(name):: self + __resourceMixin({name: name}),\n              // targetAverageUtilization is the target value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods.\n              withTargetAverageUtilization(targetAverageUtilization):: self + __resourceMixin({targetAverageUtilization: targetAverageUtilization}),\n              // targetAverageValue is the target value of the average of the resource metric across all relevant pods, as a raw value (instead of as a percentage of the request), similar to the \"pods\" metric source type.\n              targetAverageValue:: {\n                local __targetAverageValueMixin(targetAverageValue) = __resourceMixin({targetAverageValue+: targetAverageValue}),\n                mixinInstance(targetAverageValue):: __targetAverageValueMixin(targetAverageValue),\n              },\n              targetAverageValueType:: hidden.core.resource.quantity,\n            },\n            resourceType:: hidden.autoscaling.v2beta1.resourceMetricSource,\n          },\n        },\n        // MetricStatus describes the last-read state of a single metric.\n        metricStatus:: {\n          new():: {},\n          // type is the type of metric source.  It will be one of \"Object\", \"Pods\" or \"Resource\", each corresponds to a matching field in the object.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // external refers to a global metric that is not associated with any Kubernetes object. It allows autoscaling based on information coming from components running outside of cluster (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster).\n            external:: {\n              local __externalMixin(external) = {external+: external},\n              mixinInstance(external):: __externalMixin(external),\n              // currentAverageValue is the current value of metric averaged over autoscaled pods.\n              currentAverageValue:: {\n                local __currentAverageValueMixin(currentAverageValue) = __externalMixin({currentAverageValue+: currentAverageValue}),\n                mixinInstance(currentAverageValue):: __currentAverageValueMixin(currentAverageValue),\n              },\n              currentAverageValueType:: hidden.core.resource.quantity,\n              // currentValue is the current value of the metric (as a quantity)\n              currentValue:: {\n                local __currentValueMixin(currentValue) = __externalMixin({currentValue+: currentValue}),\n                mixinInstance(currentValue):: __currentValueMixin(currentValue),\n              },\n              currentValueType:: hidden.core.resource.quantity,\n              // metricName is the name of a metric used for autoscaling in metric system.\n              withMetricName(metricName):: self + __externalMixin({metricName: metricName}),\n              // metricSelector is used to identify a specific time series within a given metric.\n              metricSelector:: {\n                local __metricSelectorMixin(metricSelector) = __externalMixin({metricSelector+: metricSelector}),\n                mixinInstance(metricSelector):: __metricSelectorMixin(metricSelector),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions: matchExpressions}) else __metricSelectorMixin({matchExpressions: [matchExpressions]}),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __metricSelectorMixin({matchExpressions+: matchExpressions}) else __metricSelectorMixin({matchExpressions+: [matchExpressions]}),\n                matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabels(matchLabels):: self + __metricSelectorMixin({matchLabels: matchLabels}),\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabelsMixin(matchLabels):: self + __metricSelectorMixin({matchLabels+: matchLabels}),\n              },\n              metricSelectorType:: hidden.meta.v1.labelSelector,\n            },\n            externalType:: hidden.autoscaling.v2beta1.externalMetricStatus,\n            // object refers to a metric describing a single kubernetes object (for example, hits-per-second on an Ingress object).\n            object:: {\n              local __objectMixin(object) = {object+: object},\n              mixinInstance(object):: __objectMixin(object),\n              // currentValue is the current value of the metric (as a quantity).\n              currentValue:: {\n                local __currentValueMixin(currentValue) = __objectMixin({currentValue+: currentValue}),\n                mixinInstance(currentValue):: __currentValueMixin(currentValue),\n              },\n              currentValueType:: hidden.core.resource.quantity,\n              // metricName is the name of the metric in question.\n              withMetricName(metricName):: self + __objectMixin({metricName: metricName}),\n              // target is the described Kubernetes object.\n              target:: {\n                local __targetMixin(target) = __objectMixin({target+: target}),\n                mixinInstance(target):: __targetMixin(target),\n                // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n                withKind(kind):: self + __targetMixin({kind: kind}),\n                // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __targetMixin({name: name}),\n              },\n              targetType:: hidden.autoscaling.v2beta1.crossVersionObjectReference,\n            },\n            objectType:: hidden.autoscaling.v2beta1.objectMetricStatus,\n            // pods refers to a metric describing each pod in the current scale target (for example, transactions-processed-per-second).  The values will be averaged together before being compared to the target value.\n            pods:: {\n              local __podsMixin(pods) = {pods+: pods},\n              mixinInstance(pods):: __podsMixin(pods),\n              // currentAverageValue is the current value of the average of the metric across all relevant pods (as a quantity)\n              currentAverageValue:: {\n                local __currentAverageValueMixin(currentAverageValue) = __podsMixin({currentAverageValue+: currentAverageValue}),\n                mixinInstance(currentAverageValue):: __currentAverageValueMixin(currentAverageValue),\n              },\n              currentAverageValueType:: hidden.core.resource.quantity,\n              // metricName is the name of the metric in question\n              withMetricName(metricName):: self + __podsMixin({metricName: metricName}),\n            },\n            podsType:: hidden.autoscaling.v2beta1.podsMetricStatus,\n            // resource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing each pod in the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the \"pods\" source.\n            resource:: {\n              local __resourceMixin(resource) = {resource+: resource},\n              mixinInstance(resource):: __resourceMixin(resource),\n              // currentAverageUtilization is the current value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods.  It will only be present if `targetAverageValue` was set in the corresponding metric specification.\n              withCurrentAverageUtilization(currentAverageUtilization):: self + __resourceMixin({currentAverageUtilization: currentAverageUtilization}),\n              // currentAverageValue is the current value of the average of the resource metric across all relevant pods, as a raw value (instead of as a percentage of the request), similar to the \"pods\" metric source type. It will always be set, regardless of the corresponding metric specification.\n              currentAverageValue:: {\n                local __currentAverageValueMixin(currentAverageValue) = __resourceMixin({currentAverageValue+: currentAverageValue}),\n                mixinInstance(currentAverageValue):: __currentAverageValueMixin(currentAverageValue),\n              },\n              currentAverageValueType:: hidden.core.resource.quantity,\n              // name is the name of the resource in question.\n              withName(name):: self + __resourceMixin({name: name}),\n            },\n            resourceType:: hidden.autoscaling.v2beta1.resourceMetricStatus,\n          },\n        },\n        // ObjectMetricSource indicates how to scale on a metric describing a kubernetes object (for example, hits-per-second on an Ingress object).\n        objectMetricSource:: {\n          new():: {},\n          // metricName is the name of the metric in question.\n          withMetricName(metricName):: self + {metricName: metricName},\n          mixin:: {\n            // target is the described Kubernetes object.\n            target:: {\n              local __targetMixin(target) = {target+: target},\n              mixinInstance(target):: __targetMixin(target),\n              // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n              withKind(kind):: self + __targetMixin({kind: kind}),\n              // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __targetMixin({name: name}),\n            },\n            targetType:: hidden.autoscaling.v2beta1.crossVersionObjectReference,\n            // targetValue is the target value of the metric (as a quantity).\n            targetValue:: {\n              local __targetValueMixin(targetValue) = {targetValue+: targetValue},\n              mixinInstance(targetValue):: __targetValueMixin(targetValue),\n            },\n            targetValueType:: hidden.core.resource.quantity,\n          },\n        },\n        // ObjectMetricStatus indicates the current value of a metric describing a kubernetes object (for example, hits-per-second on an Ingress object).\n        objectMetricStatus:: {\n          new():: {},\n          // metricName is the name of the metric in question.\n          withMetricName(metricName):: self + {metricName: metricName},\n          mixin:: {\n            // currentValue is the current value of the metric (as a quantity).\n            currentValue:: {\n              local __currentValueMixin(currentValue) = {currentValue+: currentValue},\n              mixinInstance(currentValue):: __currentValueMixin(currentValue),\n            },\n            currentValueType:: hidden.core.resource.quantity,\n            // target is the described Kubernetes object.\n            target:: {\n              local __targetMixin(target) = {target+: target},\n              mixinInstance(target):: __targetMixin(target),\n              // Kind of the referent; More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\"\n              withKind(kind):: self + __targetMixin({kind: kind}),\n              // Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __targetMixin({name: name}),\n            },\n            targetType:: hidden.autoscaling.v2beta1.crossVersionObjectReference,\n          },\n        },\n        // PodsMetricSource indicates how to scale on a metric describing each pod in the current scale target (for example, transactions-processed-per-second). The values will be averaged together before being compared to the target value.\n        podsMetricSource:: {\n          new():: {},\n          // metricName is the name of the metric in question\n          withMetricName(metricName):: self + {metricName: metricName},\n          mixin:: {\n            // targetAverageValue is the target value of the average of the metric across all relevant pods (as a quantity)\n            targetAverageValue:: {\n              local __targetAverageValueMixin(targetAverageValue) = {targetAverageValue+: targetAverageValue},\n              mixinInstance(targetAverageValue):: __targetAverageValueMixin(targetAverageValue),\n            },\n            targetAverageValueType:: hidden.core.resource.quantity,\n          },\n        },\n        // PodsMetricStatus indicates the current value of a metric describing each pod in the current scale target (for example, transactions-processed-per-second).\n        podsMetricStatus:: {\n          new():: {},\n          // metricName is the name of the metric in question\n          withMetricName(metricName):: self + {metricName: metricName},\n          mixin:: {\n            // currentAverageValue is the current value of the average of the metric across all relevant pods (as a quantity)\n            currentAverageValue:: {\n              local __currentAverageValueMixin(currentAverageValue) = {currentAverageValue+: currentAverageValue},\n              mixinInstance(currentAverageValue):: __currentAverageValueMixin(currentAverageValue),\n            },\n            currentAverageValueType:: hidden.core.resource.quantity,\n          },\n        },\n        // ResourceMetricSource indicates how to scale on a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  The values will be averaged together before being compared to the target.  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the \"pods\" source.  Only one \"target\" type should be set.\n        resourceMetricSource:: {\n          new():: {},\n          // name is the name of the resource in question.\n          withName(name):: self + {name: name},\n          // targetAverageUtilization is the target value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods.\n          withTargetAverageUtilization(targetAverageUtilization):: self + {targetAverageUtilization: targetAverageUtilization},\n          mixin:: {\n            // targetAverageValue is the target value of the average of the resource metric across all relevant pods, as a raw value (instead of as a percentage of the request), similar to the \"pods\" metric source type.\n            targetAverageValue:: {\n              local __targetAverageValueMixin(targetAverageValue) = {targetAverageValue+: targetAverageValue},\n              mixinInstance(targetAverageValue):: __targetAverageValueMixin(targetAverageValue),\n            },\n            targetAverageValueType:: hidden.core.resource.quantity,\n          },\n        },\n        // ResourceMetricStatus indicates the current value of a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the \"pods\" source.\n        resourceMetricStatus:: {\n          new():: {},\n          // currentAverageUtilization is the current value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods.  It will only be present if `targetAverageValue` was set in the corresponding metric specification.\n          withCurrentAverageUtilization(currentAverageUtilization):: self + {currentAverageUtilization: currentAverageUtilization},\n          // name is the name of the resource in question.\n          withName(name):: self + {name: name},\n          mixin:: {\n            // currentAverageValue is the current value of the average of the resource metric across all relevant pods, as a raw value (instead of as a percentage of the request), similar to the \"pods\" metric source type. It will always be set, regardless of the corresponding metric specification.\n            currentAverageValue:: {\n              local __currentAverageValueMixin(currentAverageValue) = {currentAverageValue+: currentAverageValue},\n              mixinInstance(currentAverageValue):: __currentAverageValueMixin(currentAverageValue),\n            },\n            currentAverageValueType:: hidden.core.resource.quantity,\n          },\n        },\n      },\n    },\n    batch:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"batch/v1\"},\n        // JobCondition describes current state of a job.\n        jobCondition:: {\n          new():: {},\n          // Last time the condition was checked.\n          withLastProbeTime(lastProbeTime):: self + {lastProbeTime: lastProbeTime},\n          // Last time the condition transit from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // (brief) reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of job condition, Complete or Failed.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // JobList is a collection of jobs.\n        jobList:: {\n          new(items=\"\"):: self.withItems(items),\n          // items is the list of Jobs.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // items is the list of Jobs.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.batch.v1.job,\n          mixin:: {\n          },\n        },\n        // JobSpec describes how the job execution will look like.\n        jobSpec:: {\n          new():: {},\n          // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n          withActiveDeadlineSeconds(activeDeadlineSeconds):: self + {activeDeadlineSeconds: activeDeadlineSeconds},\n          // Specifies the number of retries before marking this job failed. Defaults to 6\n          withBackoffLimit(backoffLimit):: self + {backoffLimit: backoffLimit},\n          // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n          withCompletions(completions):: self + {completions: completions},\n          // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n          withManualSelector(manualSelector):: self + {manualSelector: manualSelector},\n          // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n          withParallelism(parallelism):: self + {parallelism: parallelism},\n          mixin:: {\n            // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // JobStatus represents the current state of a Job.\n        jobStatus:: {\n          new():: {},\n          // The number of actively running pods.\n          withActive(active):: self + {active: active},\n          // Represents time when the job was completed. It is not guaranteed to be set in happens-before order across separate operations. It is represented in RFC3339 form and is in UTC.\n          withCompletionTime(completionTime):: self + {completionTime: completionTime},\n          // The latest available observations of an object's current state. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // The latest available observations of an object's current state. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.batch.v1.jobCondition,\n          // The number of pods which reached phase Failed.\n          withFailed(failed):: self + {failed: failed},\n          // Represents time when the job was acknowledged by the job controller. It is not guaranteed to be set in happens-before order across separate operations. It is represented in RFC3339 form and is in UTC.\n          withStartTime(startTime):: self + {startTime: startTime},\n          // The number of pods which reached phase Succeeded.\n          withSucceeded(succeeded):: self + {succeeded: succeeded},\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"batch/v1beta1\"},\n        // CronJobList is a collection of cron jobs.\n        cronJobList:: {\n          new(items=\"\"):: self.withItems(items),\n          // items is the list of CronJobs.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // items is the list of CronJobs.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.batch.v1beta1.cronJob,\n          mixin:: {\n          },\n        },\n        // CronJobSpec describes how the job execution will look like and when it will actually run.\n        cronJobSpec:: {\n          new():: {},\n          // Specifies how to treat concurrent executions of a Job. Valid values are: - \"Allow\" (default): allows CronJobs to run concurrently; - \"Forbid\": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - \"Replace\": cancels currently running job and replaces it with a new one\n          withConcurrencyPolicy(concurrencyPolicy):: self + {concurrencyPolicy: concurrencyPolicy},\n          // The number of failed finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n          withFailedJobsHistoryLimit(failedJobsHistoryLimit):: self + {failedJobsHistoryLimit: failedJobsHistoryLimit},\n          // The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.\n          withSchedule(schedule):: self + {schedule: schedule},\n          // Optional deadline in seconds for starting the job if it misses scheduled time for any reason.  Missed jobs executions will be counted as failed ones.\n          withStartingDeadlineSeconds(startingDeadlineSeconds):: self + {startingDeadlineSeconds: startingDeadlineSeconds},\n          // The number of successful finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified. Defaults to 3.\n          withSuccessfulJobsHistoryLimit(successfulJobsHistoryLimit):: self + {successfulJobsHistoryLimit: successfulJobsHistoryLimit},\n          // This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.  Defaults to false.\n          withSuspend(suspend):: self + {suspend: suspend},\n          mixin:: {\n            // Specifies the job that will be created when executing a CronJob.\n            jobTemplate:: {\n              local __jobTemplateMixin(jobTemplate) = {jobTemplate+: jobTemplate},\n              mixinInstance(jobTemplate):: __jobTemplateMixin(jobTemplate),\n              // Standard object's metadata of the jobs created from this template. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __jobTemplateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __jobTemplateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // Specifies the number of retries before marking this job failed. Defaults to 6\n                withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n                // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withCompletions(completions):: self + __specMixin({completions: completions}),\n                // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n                withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n                // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n                // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n                selector:: {\n                  local __selectorMixin(selector) = __specMixin({selector+: selector}),\n                  mixinInstance(selector):: __selectorMixin(selector),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n                  matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n                },\n                selectorType:: hidden.meta.v1.labelSelector,\n                // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                template:: {\n                  local __templateMixin(template) = __specMixin({template+: template}),\n                  mixinInstance(template):: __templateMixin(template),\n                  // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n                  metadata:: {\n                    local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                    mixinInstance(metadata):: __metadataMixin(metadata),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                    // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                    withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                    // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                    //\n                    // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                    //\n                    // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                    withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                    // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                    //\n                    // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                    initializers:: {\n                      local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                      mixinInstance(initializers):: __initializersMixin(initializers),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                      pendingType:: hidden.meta.v1.initializer,\n                    },\n                    initializersType:: hidden.meta.v1.initializers,\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabels(labels):: self + __metadataMixin({labels: labels}),\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                    // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                    withName(name):: self + __metadataMixin({name: name}),\n                    // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                    //\n                    // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                    withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                    ownerReferencesType:: hidden.meta.v1.ownerReference,\n                  },\n                  metadataType:: hidden.meta.v1.objectMeta,\n                  // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n                  spec:: {\n                    local __specMixin(spec) = __templateMixin({spec+: spec}),\n                    mixinInstance(spec):: __specMixin(spec),\n                    // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                    withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                    // If specified, the pod's scheduling constraints\n                    affinity:: {\n                      local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                      mixinInstance(affinity):: __affinityMixin(affinity),\n                      // Describes node affinity scheduling rules for the pod.\n                      nodeAffinity:: {\n                        local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                        mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                        requiredDuringSchedulingIgnoredDuringExecution:: {\n                          local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                          mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                          nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                        },\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                      },\n                      nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                      // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                      podAffinity:: {\n                        local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                        mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAffinityType:: hidden.core.v1.podAffinity,\n                      // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                      podAntiAffinity:: {\n                        local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                        mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                    },\n                    affinityType:: hidden.core.v1.affinity,\n                    // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                    withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                    containersType:: hidden.core.v1.container,\n                    // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                    dnsConfig:: {\n                      local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                      mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                      optionsType:: hidden.core.v1.podDnsConfigOption,\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                    },\n                    dnsConfigType:: hidden.core.v1.podDnsConfig,\n                    // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                    withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                    hostAliasesType:: hidden.core.v1.hostAlias,\n                    // Use the host's ipc namespace. Optional: Default to false.\n                    withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                    // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                    withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                    // Use the host's pid namespace. Optional: Default to false.\n                    withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                    // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                    withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                    imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                    initContainersType:: hidden.core.v1.container,\n                    // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                    withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                    // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                    withPriority(priority):: self + __specMixin({priority: priority}),\n                    // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                    withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                    // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                    withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                    // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                    withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                    // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                    securityContext:: {\n                      local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                      mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                      // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                      //\n                      // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                      //\n                      // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                      withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                      // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                      // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                      withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                      // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                      // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      seLinuxOptions:: {\n                        local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                        mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                        // Level is SELinux level label that applies to the container.\n                        withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                        // Role is a SELinux role label that applies to the container.\n                        withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                        // Type is a SELinux type label that applies to the container.\n                        withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                        // User is a SELinux user label that applies to the container.\n                        withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                      },\n                      seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                    },\n                    securityContextType:: hidden.core.v1.podSecurityContext,\n                    // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                    withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                    // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                    withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                    // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                    withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                    // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                    withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                    // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                    withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                    // If specified, the pod's tolerations.\n                    withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                    // If specified, the pod's tolerations.\n                    withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                    tolerationsType:: hidden.core.v1.toleration,\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                    volumesType:: hidden.core.v1.volume,\n                  },\n                  specType:: hidden.core.v1.podSpec,\n                },\n                templateType:: hidden.core.v1.podTemplateSpec,\n              },\n              specType:: hidden.batch.v1.jobSpec,\n            },\n            jobTemplateType:: hidden.batch.v1beta1.jobTemplateSpec,\n          },\n        },\n        // CronJobStatus represents the current state of a cron job.\n        cronJobStatus:: {\n          new():: {},\n          // A list of pointers to currently running jobs.\n          withActive(active):: self + if std.type(active) == \"array\" then {active: active} else {active: [active]},\n          // A list of pointers to currently running jobs.\n          withActiveMixin(active):: self + if std.type(active) == \"array\" then {active+: active} else {active+: [active]},\n          activeType:: hidden.core.v1.objectReference,\n          // Information when was the last time the job was successfully scheduled.\n          withLastScheduleTime(lastScheduleTime):: self + {lastScheduleTime: lastScheduleTime},\n          mixin:: {\n          },\n        },\n        // JobTemplateSpec describes the data a Job should have when created from a template\n        jobTemplateSpec:: {\n          new():: {},\n          mixin:: {\n            // Standard object's metadata of the jobs created from this template. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n            metadata:: {\n              local __metadataMixin(metadata) = {metadata+: metadata},\n              mixinInstance(metadata):: __metadataMixin(metadata),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n              // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n              withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n              // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n              //\n              // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n              //\n              // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n              withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n              // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n              //\n              // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n              initializers:: {\n                local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                mixinInstance(initializers):: __initializersMixin(initializers),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                pendingType:: hidden.meta.v1.initializer,\n              },\n              initializersType:: hidden.meta.v1.initializers,\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabels(labels):: self + __metadataMixin({labels: labels}),\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n              // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __metadataMixin({name: name}),\n              // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n              //\n              // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n              withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n              ownerReferencesType:: hidden.meta.v1.ownerReference,\n            },\n            metadataType:: hidden.meta.v1.objectMeta,\n            // Specification of the desired behavior of the job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n            spec:: {\n              local __specMixin(spec) = {spec+: spec},\n              mixinInstance(spec):: __specMixin(spec),\n              // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n              withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n              // Specifies the number of retries before marking this job failed. Defaults to 6\n              withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n              // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n              withCompletions(completions):: self + __specMixin({completions: completions}),\n              // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n              withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n              // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n              withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n              // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n              selector:: {\n                local __selectorMixin(selector) = __specMixin({selector+: selector}),\n                mixinInstance(selector):: __selectorMixin(selector),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n                matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n              },\n              selectorType:: hidden.meta.v1.labelSelector,\n              // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n              template:: {\n                local __templateMixin(template) = __specMixin({template+: template}),\n                mixinInstance(template):: __templateMixin(template),\n                // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n                metadata:: {\n                  local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                  mixinInstance(metadata):: __metadataMixin(metadata),\n                  // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                  withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                  // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                  withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                  // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                  withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                  // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                  withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                  // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                  withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                  // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                  //\n                  // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                  //\n                  // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                  withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                  // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                  //\n                  // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                  initializers:: {\n                    local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                    mixinInstance(initializers):: __initializersMixin(initializers),\n                    // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                    withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                    // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                    withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                    pendingType:: hidden.meta.v1.initializer,\n                  },\n                  initializersType:: hidden.meta.v1.initializers,\n                  // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                  withLabels(labels):: self + __metadataMixin({labels: labels}),\n                  // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                  withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                  // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                  withName(name):: self + __metadataMixin({name: name}),\n                  // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                  //\n                  // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                  withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                  // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                  withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                  // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                  withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                  ownerReferencesType:: hidden.meta.v1.ownerReference,\n                },\n                metadataType:: hidden.meta.v1.objectMeta,\n                // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n                spec:: {\n                  local __specMixin(spec) = __templateMixin({spec+: spec}),\n                  mixinInstance(spec):: __specMixin(spec),\n                  // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                  withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                  // If specified, the pod's scheduling constraints\n                  affinity:: {\n                    local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                    mixinInstance(affinity):: __affinityMixin(affinity),\n                    // Describes node affinity scheduling rules for the pod.\n                    nodeAffinity:: {\n                      local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                      mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                      // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                      requiredDuringSchedulingIgnoredDuringExecution:: {\n                        local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                        mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                        // Required. A list of node selector terms. The terms are ORed.\n                        withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                        // Required. A list of node selector terms. The terms are ORed.\n                        withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                        nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                      },\n                      requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                    },\n                    nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                    // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                    podAffinity:: {\n                      local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                      mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                      // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                    },\n                    podAffinityType:: hidden.core.v1.podAffinity,\n                    // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                    podAntiAffinity:: {\n                      local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                      mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                      // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                    },\n                    podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                  },\n                  affinityType:: hidden.core.v1.affinity,\n                  // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                  withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                  // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                  withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                  // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                  withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                  containersType:: hidden.core.v1.container,\n                  // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                  dnsConfig:: {\n                    local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                    mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                    // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                    withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                    // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                    withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                    // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                    withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                    // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                    withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                    optionsType:: hidden.core.v1.podDnsConfigOption,\n                    // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                    withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                    // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                    withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                  },\n                  dnsConfigType:: hidden.core.v1.podDnsConfig,\n                  // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                  withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                  // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                  withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                  // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                  withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                  hostAliasesType:: hidden.core.v1.hostAlias,\n                  // Use the host's ipc namespace. Optional: Default to false.\n                  withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                  // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                  withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                  // Use the host's pid namespace. Optional: Default to false.\n                  withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                  // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                  withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                  // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                  withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                  // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                  withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                  imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                  // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                  withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                  // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                  withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                  initContainersType:: hidden.core.v1.container,\n                  // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                  withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                  // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                  withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                  // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                  withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                  // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                  withPriority(priority):: self + __specMixin({priority: priority}),\n                  // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                  withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                  // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                  withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                  // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                  withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                  // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                  securityContext:: {\n                    local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                    mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                    // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                    //\n                    // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                    //\n                    // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                    withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                    // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                    withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                    // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                    withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                    // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                    withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                    // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                    seLinuxOptions:: {\n                      local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                      mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                      // Level is SELinux level label that applies to the container.\n                      withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                      // Role is a SELinux role label that applies to the container.\n                      withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                      // Type is a SELinux type label that applies to the container.\n                      withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                      // User is a SELinux user label that applies to the container.\n                      withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                    },\n                    seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                    // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                    withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                    // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                    withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                  },\n                  securityContextType:: hidden.core.v1.podSecurityContext,\n                  // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                  withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                  // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                  withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                  // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                  withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                  // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                  withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                  // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                  withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                  // If specified, the pod's tolerations.\n                  withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                  // If specified, the pod's tolerations.\n                  withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                  tolerationsType:: hidden.core.v1.toleration,\n                  // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                  withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                  // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                  withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                  volumesType:: hidden.core.v1.volume,\n                },\n                specType:: hidden.core.v1.podSpec,\n              },\n              templateType:: hidden.core.v1.podTemplateSpec,\n            },\n            specType:: hidden.batch.v1.jobSpec,\n          },\n        },\n      },\n      v2alpha1:: {\n        local apiVersion = {apiVersion: \"batch/v2alpha1\"},\n        // CronJobList is a collection of cron jobs.\n        cronJobList:: {\n          new(items=\"\"):: self.withItems(items),\n          // items is the list of CronJobs.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // items is the list of CronJobs.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.batch.v2alpha1.cronJob,\n          mixin:: {\n          },\n        },\n        // CronJobSpec describes how the job execution will look like and when it will actually run.\n        cronJobSpec:: {\n          new():: {},\n          // Specifies how to treat concurrent executions of a Job. Valid values are: - \"Allow\" (default): allows CronJobs to run concurrently; - \"Forbid\": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - \"Replace\": cancels currently running job and replaces it with a new one\n          withConcurrencyPolicy(concurrencyPolicy):: self + {concurrencyPolicy: concurrencyPolicy},\n          // The number of failed finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified.\n          withFailedJobsHistoryLimit(failedJobsHistoryLimit):: self + {failedJobsHistoryLimit: failedJobsHistoryLimit},\n          // The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.\n          withSchedule(schedule):: self + {schedule: schedule},\n          // Optional deadline in seconds for starting the job if it misses scheduled time for any reason.  Missed jobs executions will be counted as failed ones.\n          withStartingDeadlineSeconds(startingDeadlineSeconds):: self + {startingDeadlineSeconds: startingDeadlineSeconds},\n          // The number of successful finished jobs to retain. This is a pointer to distinguish between explicit zero and not specified.\n          withSuccessfulJobsHistoryLimit(successfulJobsHistoryLimit):: self + {successfulJobsHistoryLimit: successfulJobsHistoryLimit},\n          // This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.  Defaults to false.\n          withSuspend(suspend):: self + {suspend: suspend},\n          mixin:: {\n            // Specifies the job that will be created when executing a CronJob.\n            jobTemplate:: {\n              local __jobTemplateMixin(jobTemplate) = {jobTemplate+: jobTemplate},\n              mixinInstance(jobTemplate):: __jobTemplateMixin(jobTemplate),\n              // Standard object's metadata of the jobs created from this template. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __jobTemplateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __jobTemplateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // Specifies the number of retries before marking this job failed. Defaults to 6\n                withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n                // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withCompletions(completions):: self + __specMixin({completions: completions}),\n                // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n                withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n                // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n                // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n                selector:: {\n                  local __selectorMixin(selector) = __specMixin({selector+: selector}),\n                  mixinInstance(selector):: __selectorMixin(selector),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n                  // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                  withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n                  matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n                  // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                  withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n                },\n                selectorType:: hidden.meta.v1.labelSelector,\n                // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n                template:: {\n                  local __templateMixin(template) = __specMixin({template+: template}),\n                  mixinInstance(template):: __templateMixin(template),\n                  // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n                  metadata:: {\n                    local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                    mixinInstance(metadata):: __metadataMixin(metadata),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                    // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                    withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                    // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                    withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                    // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                    withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                    // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                    //\n                    // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                    //\n                    // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                    withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                    // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                    //\n                    // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                    initializers:: {\n                      local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                      mixinInstance(initializers):: __initializersMixin(initializers),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                      // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                      withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                      pendingType:: hidden.meta.v1.initializer,\n                    },\n                    initializersType:: hidden.meta.v1.initializers,\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabels(labels):: self + __metadataMixin({labels: labels}),\n                    // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                    withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                    // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                    withName(name):: self + __metadataMixin({name: name}),\n                    // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                    //\n                    // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                    withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                    // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                    withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                    ownerReferencesType:: hidden.meta.v1.ownerReference,\n                  },\n                  metadataType:: hidden.meta.v1.objectMeta,\n                  // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n                  spec:: {\n                    local __specMixin(spec) = __templateMixin({spec+: spec}),\n                    mixinInstance(spec):: __specMixin(spec),\n                    // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                    withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                    // If specified, the pod's scheduling constraints\n                    affinity:: {\n                      local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                      mixinInstance(affinity):: __affinityMixin(affinity),\n                      // Describes node affinity scheduling rules for the pod.\n                      nodeAffinity:: {\n                        local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                        mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                        requiredDuringSchedulingIgnoredDuringExecution:: {\n                          local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                          mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                          // Required. A list of node selector terms. The terms are ORed.\n                          withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                          nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                        },\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                      },\n                      nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                      // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                      podAffinity:: {\n                        local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                        mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAffinityType:: hidden.core.v1.podAffinity,\n                      // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                      podAntiAffinity:: {\n                        local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                        mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                        withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                        preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                        withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                        requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                      },\n                      podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                    },\n                    affinityType:: hidden.core.v1.affinity,\n                    // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                    withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                    // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                    withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                    containersType:: hidden.core.v1.container,\n                    // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                    dnsConfig:: {\n                      local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                      mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                      // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                      withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                      // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                      withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                      optionsType:: hidden.core.v1.podDnsConfigOption,\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                      // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                      withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                    },\n                    dnsConfigType:: hidden.core.v1.podDnsConfig,\n                    // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                    withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                    // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                    withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                    hostAliasesType:: hidden.core.v1.hostAlias,\n                    // Use the host's ipc namespace. Optional: Default to false.\n                    withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                    // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                    withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                    // Use the host's pid namespace. Optional: Default to false.\n                    withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                    // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                    withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                    // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                    withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                    imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                    // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                    withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                    initContainersType:: hidden.core.v1.container,\n                    // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                    withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                    // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                    withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                    // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                    withPriority(priority):: self + __specMixin({priority: priority}),\n                    // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                    withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                    // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                    withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                    // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                    withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                    // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                    securityContext:: {\n                      local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                      mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                      // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                      //\n                      // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                      //\n                      // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                      withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                      // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                      // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                      withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                      // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                      // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                      seLinuxOptions:: {\n                        local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                        mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                        // Level is SELinux level label that applies to the container.\n                        withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                        // Role is a SELinux role label that applies to the container.\n                        withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                        // Type is a SELinux type label that applies to the container.\n                        withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                        // User is a SELinux user label that applies to the container.\n                        withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                      },\n                      seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                      // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                      withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                    },\n                    securityContextType:: hidden.core.v1.podSecurityContext,\n                    // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                    withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                    // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                    withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                    // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                    withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                    // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                    withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                    // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                    withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                    // If specified, the pod's tolerations.\n                    withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                    // If specified, the pod's tolerations.\n                    withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                    tolerationsType:: hidden.core.v1.toleration,\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                    // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                    withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                    volumesType:: hidden.core.v1.volume,\n                  },\n                  specType:: hidden.core.v1.podSpec,\n                },\n                templateType:: hidden.core.v1.podTemplateSpec,\n              },\n              specType:: hidden.batch.v1.jobSpec,\n            },\n            jobTemplateType:: hidden.batch.v2alpha1.jobTemplateSpec,\n          },\n        },\n        // CronJobStatus represents the current state of a cron job.\n        cronJobStatus:: {\n          new():: {},\n          // A list of pointers to currently running jobs.\n          withActive(active):: self + if std.type(active) == \"array\" then {active: active} else {active: [active]},\n          // A list of pointers to currently running jobs.\n          withActiveMixin(active):: self + if std.type(active) == \"array\" then {active+: active} else {active+: [active]},\n          activeType:: hidden.core.v1.objectReference,\n          // Information when was the last time the job was successfully scheduled.\n          withLastScheduleTime(lastScheduleTime):: self + {lastScheduleTime: lastScheduleTime},\n          mixin:: {\n          },\n        },\n        // JobTemplateSpec describes the data a Job should have when created from a template\n        jobTemplateSpec:: {\n          new():: {},\n          mixin:: {\n            // Standard object's metadata of the jobs created from this template. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n            metadata:: {\n              local __metadataMixin(metadata) = {metadata+: metadata},\n              mixinInstance(metadata):: __metadataMixin(metadata),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n              // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n              withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n              // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n              //\n              // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n              //\n              // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n              withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n              // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n              //\n              // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n              initializers:: {\n                local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                mixinInstance(initializers):: __initializersMixin(initializers),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                pendingType:: hidden.meta.v1.initializer,\n              },\n              initializersType:: hidden.meta.v1.initializers,\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabels(labels):: self + __metadataMixin({labels: labels}),\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n              // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __metadataMixin({name: name}),\n              // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n              //\n              // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n              withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n              ownerReferencesType:: hidden.meta.v1.ownerReference,\n            },\n            metadataType:: hidden.meta.v1.objectMeta,\n            // Specification of the desired behavior of the job. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n            spec:: {\n              local __specMixin(spec) = {spec+: spec},\n              mixinInstance(spec):: __specMixin(spec),\n              // Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer\n              withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n              // Specifies the number of retries before marking this job failed. Defaults to 6\n              withBackoffLimit(backoffLimit):: self + __specMixin({backoffLimit: backoffLimit}),\n              // Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n              withCompletions(completions):: self + __specMixin({completions: completions}),\n              // manualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n              withManualSelector(manualSelector):: self + __specMixin({manualSelector: manualSelector}),\n              // Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n              withParallelism(parallelism):: self + __specMixin({parallelism: parallelism}),\n              // A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n              selector:: {\n                local __selectorMixin(selector) = __specMixin({selector+: selector}),\n                mixinInstance(selector):: __selectorMixin(selector),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n                matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n              },\n              selectorType:: hidden.meta.v1.labelSelector,\n              // Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n              template:: {\n                local __templateMixin(template) = __specMixin({template+: template}),\n                mixinInstance(template):: __templateMixin(template),\n                // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n                metadata:: {\n                  local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                  mixinInstance(metadata):: __metadataMixin(metadata),\n                  // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                  withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                  // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                  withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                  // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                  withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                  // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                  withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                  // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                  withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                  // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                  //\n                  // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                  //\n                  // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                  withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                  // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                  //\n                  // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                  initializers:: {\n                    local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                    mixinInstance(initializers):: __initializersMixin(initializers),\n                    // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                    withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                    // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                    withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                    pendingType:: hidden.meta.v1.initializer,\n                  },\n                  initializersType:: hidden.meta.v1.initializers,\n                  // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                  withLabels(labels):: self + __metadataMixin({labels: labels}),\n                  // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                  withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                  // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                  withName(name):: self + __metadataMixin({name: name}),\n                  // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                  //\n                  // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                  withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                  // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                  withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                  // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                  withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                  ownerReferencesType:: hidden.meta.v1.ownerReference,\n                },\n                metadataType:: hidden.meta.v1.objectMeta,\n                // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n                spec:: {\n                  local __specMixin(spec) = __templateMixin({spec+: spec}),\n                  mixinInstance(spec):: __specMixin(spec),\n                  // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                  withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                  // If specified, the pod's scheduling constraints\n                  affinity:: {\n                    local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                    mixinInstance(affinity):: __affinityMixin(affinity),\n                    // Describes node affinity scheduling rules for the pod.\n                    nodeAffinity:: {\n                      local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                      mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                      // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                      requiredDuringSchedulingIgnoredDuringExecution:: {\n                        local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                        mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                        // Required. A list of node selector terms. The terms are ORed.\n                        withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                        // Required. A list of node selector terms. The terms are ORed.\n                        withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                        nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                      },\n                      requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                    },\n                    nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                    // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                    podAffinity:: {\n                      local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                      mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                      // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                    },\n                    podAffinityType:: hidden.core.v1.podAffinity,\n                    // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                    podAntiAffinity:: {\n                      local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                      mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                      withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                      preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                      // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                      withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                      requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                    },\n                    podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                  },\n                  affinityType:: hidden.core.v1.affinity,\n                  // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                  withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                  // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                  withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                  // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                  withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                  containersType:: hidden.core.v1.container,\n                  // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                  dnsConfig:: {\n                    local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                    mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                    // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                    withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                    // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                    withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                    // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                    withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                    // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                    withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                    optionsType:: hidden.core.v1.podDnsConfigOption,\n                    // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                    withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                    // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                    withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                  },\n                  dnsConfigType:: hidden.core.v1.podDnsConfig,\n                  // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                  withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                  // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                  withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                  // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                  withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                  hostAliasesType:: hidden.core.v1.hostAlias,\n                  // Use the host's ipc namespace. Optional: Default to false.\n                  withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                  // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                  withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                  // Use the host's pid namespace. Optional: Default to false.\n                  withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                  // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                  withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                  // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                  withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                  // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                  withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                  imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                  // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                  withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                  // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                  withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                  initContainersType:: hidden.core.v1.container,\n                  // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                  withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                  // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                  withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                  // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                  withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                  // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                  withPriority(priority):: self + __specMixin({priority: priority}),\n                  // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                  withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                  // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                  withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                  // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                  withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                  // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                  securityContext:: {\n                    local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                    mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                    // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                    //\n                    // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                    //\n                    // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                    withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                    // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                    withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                    // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                    withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                    // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                    withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                    // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                    seLinuxOptions:: {\n                      local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                      mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                      // Level is SELinux level label that applies to the container.\n                      withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                      // Role is a SELinux role label that applies to the container.\n                      withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                      // Type is a SELinux type label that applies to the container.\n                      withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                      // User is a SELinux user label that applies to the container.\n                      withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                    },\n                    seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                    // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                    withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                    // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                    withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                  },\n                  securityContextType:: hidden.core.v1.podSecurityContext,\n                  // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                  withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                  // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                  withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                  // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                  withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                  // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                  withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                  // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                  withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                  // If specified, the pod's tolerations.\n                  withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                  // If specified, the pod's tolerations.\n                  withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                  tolerationsType:: hidden.core.v1.toleration,\n                  // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                  withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                  // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                  withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                  volumesType:: hidden.core.v1.volume,\n                },\n                specType:: hidden.core.v1.podSpec,\n              },\n              templateType:: hidden.core.v1.podTemplateSpec,\n            },\n            specType:: hidden.batch.v1.jobSpec,\n          },\n        },\n      },\n    },\n    certificates:: {\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"certificates/v1beta1\"},\n        certificateSigningRequestCondition:: {\n          new():: {},\n          // timestamp for the last update to this condition\n          withLastUpdateTime(lastUpdateTime):: self + {lastUpdateTime: lastUpdateTime},\n          // human readable message with details about the request state\n          withMessage(message):: self + {message: message},\n          // brief reason for the request state\n          withReason(reason):: self + {reason: reason},\n          // request approval state, currently Approved or Denied.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        certificateSigningRequestList:: {\n          new(items=\"\"):: self.withItems(items),\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.certificates.v1beta1.certificateSigningRequest,\n          mixin:: {\n          },\n        },\n        // This information is immutable after the request is created. Only the Request and Usages fields can be set on creation, other fields are derived by Kubernetes and cannot be modified by users.\n        certificateSigningRequestSpec:: {\n          new():: {},\n          // Extra information about the requesting user. See user.Info interface for details.\n          withExtra(extra):: self + {extra: extra},\n          // Extra information about the requesting user. See user.Info interface for details.\n          withExtraMixin(extra):: self + {extra+: extra},\n          // Group information about the requesting user. See user.Info interface for details.\n          withGroups(groups):: self + if std.type(groups) == \"array\" then {groups: groups} else {groups: [groups]},\n          // Group information about the requesting user. See user.Info interface for details.\n          withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then {groups+: groups} else {groups+: [groups]},\n          // Base64-encoded PKCS#10 CSR data\n          withRequest(request):: self + {request: request},\n          // UID information about the requesting user. See user.Info interface for details.\n          withUid(uid):: self + {uid: uid},\n          // allowedUsages specifies a set of usage contexts the key will be valid for. See: https://tools.ietf.org/html/rfc5280#section-4.2.1.3\n          // https://tools.ietf.org/html/rfc5280#section-4.2.1.12\n          withUsages(usages):: self + if std.type(usages) == \"array\" then {usages: usages} else {usages: [usages]},\n          // allowedUsages specifies a set of usage contexts the key will be valid for. See: https://tools.ietf.org/html/rfc5280#section-4.2.1.3\n          // https://tools.ietf.org/html/rfc5280#section-4.2.1.12\n          withUsagesMixin(usages):: self + if std.type(usages) == \"array\" then {usages+: usages} else {usages+: [usages]},\n          // Information about the requesting user. See user.Info interface for details.\n          withUsername(username):: self + {username: username},\n          mixin:: {\n          },\n        },\n        certificateSigningRequestStatus:: {\n          new():: {},\n          // If request was approved, the controller will place the issued certificate here.\n          withCertificate(certificate):: self + {certificate: certificate},\n          // Conditions applied to the request, such as approval or denial.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Conditions applied to the request, such as approval or denial.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.certificates.v1beta1.certificateSigningRequestCondition,\n          mixin:: {\n          },\n        },\n      },\n    },\n    core:: {\n      intstr:: {\n        local apiVersion = {apiVersion: \"intstr\"},\n        intOrString:: {\n          new():: {},\n          mixin:: {\n          },\n        },\n      },\n      resource:: {\n        local apiVersion = {apiVersion: \"resource\"},\n        quantity:: {\n          new():: {},\n          mixin:: {\n          },\n        },\n      },\n      v1:: {\n        local apiVersion = {apiVersion: \"v1\"},\n        // Affinity is a group of affinity scheduling rules.\n        affinity:: {\n          new():: {},\n          mixin:: {\n            // Describes node affinity scheduling rules for the pod.\n            nodeAffinity:: {\n              local __nodeAffinityMixin(nodeAffinity) = {nodeAffinity+: nodeAffinity},\n              mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n              // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n              withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n              // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n              withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n              preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n              // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n              requiredDuringSchedulingIgnoredDuringExecution:: {\n                local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                // Required. A list of node selector terms. The terms are ORed.\n                withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                // Required. A list of node selector terms. The terms are ORed.\n                withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n              },\n              requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n            },\n            nodeAffinityType:: hidden.core.v1.nodeAffinity,\n            // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n            podAffinity:: {\n              local __podAffinityMixin(podAffinity) = {podAffinity+: podAffinity},\n              mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n              // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n              withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n              // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n              withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n              preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n              // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n              withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n              // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n              withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n              requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n            },\n            podAffinityType:: hidden.core.v1.podAffinity,\n            // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n            podAntiAffinity:: {\n              local __podAntiAffinityMixin(podAntiAffinity) = {podAntiAffinity+: podAntiAffinity},\n              mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n              // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n              withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n              // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n              withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n              preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n              // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n              withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n              // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n              withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n              requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n            },\n            podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n          },\n        },\n        // AttachedVolume describes a volume attached to a node\n        attachedVolume:: {\n          new():: {},\n          // DevicePath represents the device path where the volume should be available\n          withDevicePath(devicePath):: self + {devicePath: devicePath},\n          // Name of the attached volume\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // Represents a Persistent Disk resource in AWS.\n        //\n        // An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.\n        awsElasticBlockStoreVolumeSource:: {\n          new():: {},\n          // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n          withFsType(fsType):: self + {fsType: fsType},\n          // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty).\n          withPartition(partition):: self + {partition: partition},\n          // Specify \"true\" to force and set the ReadOnly property in VolumeMounts to \"true\". If omitted, the default is \"false\". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n          withVolumeId(volumeId):: self + {volumeID: volumeId},\n          mixin:: {\n          },\n        },\n        // AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.\n        azureDiskVolumeSource:: {\n          new():: {},\n          // Host Caching mode: None, Read Only, Read Write.\n          withCachingMode(cachingMode):: self + {cachingMode: cachingMode},\n          // The Name of the data disk in the blob storage\n          withDiskName(diskName):: self + {diskName: diskName},\n          // The URI the data disk in the blob storage\n          withDiskUri(diskUri):: self + {diskURI: diskUri},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          mixin:: {\n          },\n        },\n        // AzureFile represents an Azure File Service mount on the host and bind mount to the pod.\n        azureFilePersistentVolumeSource:: {\n          new():: {},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // the name of secret that contains Azure Storage Account Name and Key\n          withSecretName(secretName):: self + {secretName: secretName},\n          // the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod\n          withSecretNamespace(secretNamespace):: self + {secretNamespace: secretNamespace},\n          // Share Name\n          withShareName(shareName):: self + {shareName: shareName},\n          mixin:: {\n          },\n        },\n        // AzureFile represents an Azure File Service mount on the host and bind mount to the pod.\n        azureFileVolumeSource:: {\n          new():: {},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // the name of secret that contains Azure Storage Account Name and Key\n          withSecretName(secretName):: self + {secretName: secretName},\n          // Share Name\n          withShareName(shareName):: self + {shareName: shareName},\n          mixin:: {\n          },\n        },\n        // Adds and removes POSIX capabilities from running containers.\n        capabilities:: {\n          new():: {},\n          // Added capabilities\n          withAdd(add):: self + if std.type(add) == \"array\" then {add: add} else {add: [add]},\n          // Added capabilities\n          withAddMixin(add):: self + if std.type(add) == \"array\" then {add+: add} else {add+: [add]},\n          // Removed capabilities\n          withDrop(drop):: self + if std.type(drop) == \"array\" then {drop: drop} else {drop: [drop]},\n          // Removed capabilities\n          withDropMixin(drop):: self + if std.type(drop) == \"array\" then {drop+: drop} else {drop+: [drop]},\n          mixin:: {\n          },\n        },\n        // Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.\n        cephFsPersistentVolumeSource:: {\n          new():: {},\n          // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withMonitors(monitors):: self + if std.type(monitors) == \"array\" then {monitors: monitors} else {monitors: [monitors]},\n          // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then {monitors+: monitors} else {monitors+: [monitors]},\n          // Optional: Used as the mounted root, rather than the full Ceph tree, default is /\n          withPath(path):: self + {path: path},\n          // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withSecretFile(secretFile):: self + {secretFile: secretFile},\n          // Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withUser(user):: self + {user: user},\n          mixin:: {\n            // Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n            },\n            secretRefType:: hidden.core.v1.secretReference,\n          },\n        },\n        // Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.\n        cephFsVolumeSource:: {\n          new():: {},\n          // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withMonitors(monitors):: self + if std.type(monitors) == \"array\" then {monitors: monitors} else {monitors: [monitors]},\n          // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then {monitors+: monitors} else {monitors+: [monitors]},\n          // Optional: Used as the mounted root, rather than the full Ceph tree, default is /\n          withPath(path):: self + {path: path},\n          // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withSecretFile(secretFile):: self + {secretFile: secretFile},\n          // Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n          withUser(user):: self + {user: user},\n          mixin:: {\n            // Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n            },\n            secretRefType:: hidden.core.v1.localObjectReference,\n          },\n        },\n        // Represents a cinder volume resource in Openstack. A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.\n        cinderVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n          withFsType(fsType):: self + {fsType: fsType},\n          // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // volume id used to identify the volume in cinder More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n          withVolumeId(volumeId):: self + {volumeID: volumeId},\n          mixin:: {\n          },\n        },\n        // ClientIPConfig represents the configurations of Client IP based session affinity.\n        clientIpConfig:: {\n          new():: {},\n          // timeoutSeconds specifies the seconds of ClientIP type session sticky time. The value must be >0 && <=86400(for 1 day) if ServiceAffinity == \"ClientIP\". Default value is 10800(for 3 hours).\n          withTimeoutSeconds(timeoutSeconds):: self + {timeoutSeconds: timeoutSeconds},\n          mixin:: {\n          },\n        },\n        // Information about the condition of a component.\n        componentCondition:: {\n          new():: {},\n          // Condition error code for a component. For example, a health check error code.\n          withErrorParam(errorParam):: self + {\"error\": errorParam},\n          // Message about the condition for a component. For example, information about a health check.\n          withMessage(message):: self + {message: message},\n          // Status of the condition for a component. Valid values for \"Healthy\": \"True\", \"False\", or \"Unknown\".\n          withStatus(status):: self + {status: status},\n          // Type of condition for a component. Valid value: \"Healthy\"\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // ComponentStatus (and ComponentStatusList) holds the cluster validation info.\n        componentStatus:: {\n          new():: {},\n          // List of component conditions observed\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // List of component conditions observed\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.core.v1.componentCondition,\n          mixin:: {\n            // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n            metadata:: {\n              local __metadataMixin(metadata) = {metadata+: metadata},\n              mixinInstance(metadata):: __metadataMixin(metadata),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n              // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n              withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n              // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n              //\n              // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n              //\n              // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n              withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n              // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n              //\n              // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n              initializers:: {\n                local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                mixinInstance(initializers):: __initializersMixin(initializers),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                pendingType:: hidden.meta.v1.initializer,\n              },\n              initializersType:: hidden.meta.v1.initializers,\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabels(labels):: self + __metadataMixin({labels: labels}),\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n              // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __metadataMixin({name: name}),\n              // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n              //\n              // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n              withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n              ownerReferencesType:: hidden.meta.v1.ownerReference,\n            },\n            metadataType:: hidden.meta.v1.objectMeta,\n          },\n        },\n        // Status of all the conditions for the component as a list of ComponentStatus objects.\n        componentStatusList:: {\n          new():: {},\n          // List of ComponentStatus objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of ComponentStatus objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.componentStatus,\n          mixin:: {\n          },\n        },\n        // ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.\n        //\n        // The contents of the target ConfigMap's Data field will represent the key-value pairs as environment variables.\n        configMapEnvSource:: {\n          new():: {},\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the ConfigMap must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // Selects a key from a ConfigMap.\n        configMapKeySelector:: {\n          new():: {},\n          // The key to select.\n          withKey(key):: self + {key: key},\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the ConfigMap or it's key must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // ConfigMapList is a resource containing a list of ConfigMap objects.\n        configMapList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is the list of ConfigMaps.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of ConfigMaps.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.configMap,\n          mixin:: {\n          },\n        },\n        // Adapts a ConfigMap into a projected volume.\n        //\n        // The contents of the target ConfigMap's Data field will be presented in a projected volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. Note that this is identical to a configmap volume source without the default mode.\n        configMapProjection:: {\n          new():: {},\n          // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.keyToPath,\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the ConfigMap or it's keys must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // Adapts a ConfigMap into a volume.\n        //\n        // The contents of the target ConfigMap's Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.\n        configMapVolumeSource:: {\n          new():: {},\n          // Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n          withDefaultMode(defaultMode):: self + {defaultMode: defaultMode},\n          // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.keyToPath,\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the ConfigMap or it's keys must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // A single application container that you want to run within a pod.\n        container:: {\n          new(name=\"\", image=\"\"):: self.withImage(image).withName(name),\n          // Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell\n          withArgs(args):: self + if std.type(args) == \"array\" then {args: args} else {args: [args]},\n          // Arguments to the entrypoint. The docker image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell\n          withArgsMixin(args):: self + if std.type(args) == \"array\" then {args+: args} else {args+: [args]},\n          // Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell\n          withCommand(command):: self + if std.type(command) == \"array\" then {command: command} else {command: [command]},\n          // Entrypoint array. Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell\n          withCommandMixin(command):: self + if std.type(command) == \"array\" then {command+: command} else {command+: [command]},\n          // List of environment variables to set in the container. Cannot be updated.\n          withEnv(env):: self + if std.type(env) == \"array\" then {env: env} else {env: [env]},\n          // List of environment variables to set in the container. Cannot be updated.\n          withEnvMixin(env):: self + if std.type(env) == \"array\" then {env+: env} else {env+: [env]},\n          envType:: hidden.core.v1.envVar,\n          // List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.\n          withEnvFrom(envFrom):: self + if std.type(envFrom) == \"array\" then {envFrom: envFrom} else {envFrom: [envFrom]},\n          // List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.\n          withEnvFromMixin(envFrom):: self + if std.type(envFrom) == \"array\" then {envFrom+: envFrom} else {envFrom+: [envFrom]},\n          envFromType:: hidden.core.v1.envFromSource,\n          // Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.\n          withImage(image):: self + {image: image},\n          // Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images\n          withImagePullPolicy(imagePullPolicy):: self + {imagePullPolicy: imagePullPolicy},\n          // Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.\n          withName(name):: self + {name: name},\n          // List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.core.v1.containerPort,\n          // Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.\n          withStdin(stdin):: self + {stdin: stdin},\n          // Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false\n          withStdinOnce(stdinOnce):: self + {stdinOnce: stdinOnce},\n          // Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.\n          withTerminationMessagePath(terminationMessagePath):: self + {terminationMessagePath: terminationMessagePath},\n          // Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.\n          withTerminationMessagePolicy(terminationMessagePolicy):: self + {terminationMessagePolicy: terminationMessagePolicy},\n          // Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.\n          withTty(tty):: self + {tty: tty},\n          // volumeDevices is the list of block devices to be used by the container. This is an alpha feature and may change in the future.\n          withVolumeDevices(volumeDevices):: self + if std.type(volumeDevices) == \"array\" then {volumeDevices: volumeDevices} else {volumeDevices: [volumeDevices]},\n          // volumeDevices is the list of block devices to be used by the container. This is an alpha feature and may change in the future.\n          withVolumeDevicesMixin(volumeDevices):: self + if std.type(volumeDevices) == \"array\" then {volumeDevices+: volumeDevices} else {volumeDevices+: [volumeDevices]},\n          volumeDevicesType:: hidden.core.v1.volumeDevice,\n          // Pod volumes to mount into the container's filesystem. Cannot be updated.\n          withVolumeMounts(volumeMounts):: self + if std.type(volumeMounts) == \"array\" then {volumeMounts: volumeMounts} else {volumeMounts: [volumeMounts]},\n          // Pod volumes to mount into the container's filesystem. Cannot be updated.\n          withVolumeMountsMixin(volumeMounts):: self + if std.type(volumeMounts) == \"array\" then {volumeMounts+: volumeMounts} else {volumeMounts+: [volumeMounts]},\n          volumeMountsType:: hidden.core.v1.volumeMount,\n          // Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.\n          withWorkingDir(workingDir):: self + {workingDir: workingDir},\n          mixin:: {\n            // Actions that the management system should take in response to container lifecycle events. Cannot be updated.\n            lifecycle:: {\n              local __lifecycleMixin(lifecycle) = {lifecycle+: lifecycle},\n              mixinInstance(lifecycle):: __lifecycleMixin(lifecycle),\n              // PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks\n              postStart:: {\n                local __postStartMixin(postStart) = __lifecycleMixin({postStart+: postStart}),\n                mixinInstance(postStart):: __postStartMixin(postStart),\n                // One and only one of the following should be specified. Exec specifies the action to take.\n                exec:: {\n                  local __execMixin(exec) = __postStartMixin({exec+: exec}),\n                  mixinInstance(exec):: __execMixin(exec),\n                  // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                  withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n                  // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                  withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n                },\n                execType:: hidden.core.v1.execAction,\n                // HTTPGet specifies the http request to perform.\n                httpGet:: {\n                  local __httpGetMixin(httpGet) = __postStartMixin({httpGet+: httpGet}),\n                  mixinInstance(httpGet):: __httpGetMixin(httpGet),\n                  // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n                  withHost(host):: self + __httpGetMixin({host: host}),\n                  // Custom headers to set in the request. HTTP allows repeated headers.\n                  withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n                  // Custom headers to set in the request. HTTP allows repeated headers.\n                  withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n                  httpHeadersType:: hidden.core.v1.httpHeader,\n                  // Path to access on the HTTP server.\n                  withPath(path):: self + __httpGetMixin({path: path}),\n                  // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                  withPort(port):: self + __httpGetMixin({port: port}),\n                  // Scheme to use for connecting to the host. Defaults to HTTP.\n                  withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n                },\n                httpGetType:: hidden.core.v1.httpGetAction,\n                // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n                tcpSocket:: {\n                  local __tcpSocketMixin(tcpSocket) = __postStartMixin({tcpSocket+: tcpSocket}),\n                  mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n                  // Optional: Host name to connect to, defaults to the pod IP.\n                  withHost(host):: self + __tcpSocketMixin({host: host}),\n                  // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                  withPort(port):: self + __tcpSocketMixin({port: port}),\n                },\n                tcpSocketType:: hidden.core.v1.tcpSocketAction,\n              },\n              postStartType:: hidden.core.v1.handler,\n              // PreStop is called immediately before a container is terminated. The container is terminated after the handler completes. The reason for termination is passed to the handler. Regardless of the outcome of the handler, the container is eventually terminated. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks\n              preStop:: {\n                local __preStopMixin(preStop) = __lifecycleMixin({preStop+: preStop}),\n                mixinInstance(preStop):: __preStopMixin(preStop),\n                // One and only one of the following should be specified. Exec specifies the action to take.\n                exec:: {\n                  local __execMixin(exec) = __preStopMixin({exec+: exec}),\n                  mixinInstance(exec):: __execMixin(exec),\n                  // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                  withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n                  // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                  withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n                },\n                execType:: hidden.core.v1.execAction,\n                // HTTPGet specifies the http request to perform.\n                httpGet:: {\n                  local __httpGetMixin(httpGet) = __preStopMixin({httpGet+: httpGet}),\n                  mixinInstance(httpGet):: __httpGetMixin(httpGet),\n                  // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n                  withHost(host):: self + __httpGetMixin({host: host}),\n                  // Custom headers to set in the request. HTTP allows repeated headers.\n                  withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n                  // Custom headers to set in the request. HTTP allows repeated headers.\n                  withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n                  httpHeadersType:: hidden.core.v1.httpHeader,\n                  // Path to access on the HTTP server.\n                  withPath(path):: self + __httpGetMixin({path: path}),\n                  // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                  withPort(port):: self + __httpGetMixin({port: port}),\n                  // Scheme to use for connecting to the host. Defaults to HTTP.\n                  withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n                },\n                httpGetType:: hidden.core.v1.httpGetAction,\n                // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n                tcpSocket:: {\n                  local __tcpSocketMixin(tcpSocket) = __preStopMixin({tcpSocket+: tcpSocket}),\n                  mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n                  // Optional: Host name to connect to, defaults to the pod IP.\n                  withHost(host):: self + __tcpSocketMixin({host: host}),\n                  // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                  withPort(port):: self + __tcpSocketMixin({port: port}),\n                },\n                tcpSocketType:: hidden.core.v1.tcpSocketAction,\n              },\n              preStopType:: hidden.core.v1.handler,\n            },\n            lifecycleType:: hidden.core.v1.lifecycle,\n            // Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n            livenessProbe:: {\n              local __livenessProbeMixin(livenessProbe) = {livenessProbe+: livenessProbe},\n              mixinInstance(livenessProbe):: __livenessProbeMixin(livenessProbe),\n              // One and only one of the following should be specified. Exec specifies the action to take.\n              exec:: {\n                local __execMixin(exec) = __livenessProbeMixin({exec+: exec}),\n                mixinInstance(exec):: __execMixin(exec),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n              },\n              execType:: hidden.core.v1.execAction,\n              // Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.\n              withFailureThreshold(failureThreshold):: self + __livenessProbeMixin({failureThreshold: failureThreshold}),\n              // HTTPGet specifies the http request to perform.\n              httpGet:: {\n                local __httpGetMixin(httpGet) = __livenessProbeMixin({httpGet+: httpGet}),\n                mixinInstance(httpGet):: __httpGetMixin(httpGet),\n                // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n                withHost(host):: self + __httpGetMixin({host: host}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n                httpHeadersType:: hidden.core.v1.httpHeader,\n                // Path to access on the HTTP server.\n                withPath(path):: self + __httpGetMixin({path: path}),\n                // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __httpGetMixin({port: port}),\n                // Scheme to use for connecting to the host. Defaults to HTTP.\n                withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n              },\n              httpGetType:: hidden.core.v1.httpGetAction,\n              // Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n              withInitialDelaySeconds(initialDelaySeconds):: self + __livenessProbeMixin({initialDelaySeconds: initialDelaySeconds}),\n              // How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.\n              withPeriodSeconds(periodSeconds):: self + __livenessProbeMixin({periodSeconds: periodSeconds}),\n              // Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness. Minimum value is 1.\n              withSuccessThreshold(successThreshold):: self + __livenessProbeMixin({successThreshold: successThreshold}),\n              // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n              tcpSocket:: {\n                local __tcpSocketMixin(tcpSocket) = __livenessProbeMixin({tcpSocket+: tcpSocket}),\n                mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n                // Optional: Host name to connect to, defaults to the pod IP.\n                withHost(host):: self + __tcpSocketMixin({host: host}),\n                // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __tcpSocketMixin({port: port}),\n              },\n              tcpSocketType:: hidden.core.v1.tcpSocketAction,\n              // Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n              withTimeoutSeconds(timeoutSeconds):: self + __livenessProbeMixin({timeoutSeconds: timeoutSeconds}),\n            },\n            livenessProbeType:: hidden.core.v1.probe,\n            // Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n            readinessProbe:: {\n              local __readinessProbeMixin(readinessProbe) = {readinessProbe+: readinessProbe},\n              mixinInstance(readinessProbe):: __readinessProbeMixin(readinessProbe),\n              // One and only one of the following should be specified. Exec specifies the action to take.\n              exec:: {\n                local __execMixin(exec) = __readinessProbeMixin({exec+: exec}),\n                mixinInstance(exec):: __execMixin(exec),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n              },\n              execType:: hidden.core.v1.execAction,\n              // Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.\n              withFailureThreshold(failureThreshold):: self + __readinessProbeMixin({failureThreshold: failureThreshold}),\n              // HTTPGet specifies the http request to perform.\n              httpGet:: {\n                local __httpGetMixin(httpGet) = __readinessProbeMixin({httpGet+: httpGet}),\n                mixinInstance(httpGet):: __httpGetMixin(httpGet),\n                // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n                withHost(host):: self + __httpGetMixin({host: host}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n                httpHeadersType:: hidden.core.v1.httpHeader,\n                // Path to access on the HTTP server.\n                withPath(path):: self + __httpGetMixin({path: path}),\n                // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __httpGetMixin({port: port}),\n                // Scheme to use for connecting to the host. Defaults to HTTP.\n                withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n              },\n              httpGetType:: hidden.core.v1.httpGetAction,\n              // Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n              withInitialDelaySeconds(initialDelaySeconds):: self + __readinessProbeMixin({initialDelaySeconds: initialDelaySeconds}),\n              // How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.\n              withPeriodSeconds(periodSeconds):: self + __readinessProbeMixin({periodSeconds: periodSeconds}),\n              // Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness. Minimum value is 1.\n              withSuccessThreshold(successThreshold):: self + __readinessProbeMixin({successThreshold: successThreshold}),\n              // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n              tcpSocket:: {\n                local __tcpSocketMixin(tcpSocket) = __readinessProbeMixin({tcpSocket+: tcpSocket}),\n                mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n                // Optional: Host name to connect to, defaults to the pod IP.\n                withHost(host):: self + __tcpSocketMixin({host: host}),\n                // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __tcpSocketMixin({port: port}),\n              },\n              tcpSocketType:: hidden.core.v1.tcpSocketAction,\n              // Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n              withTimeoutSeconds(timeoutSeconds):: self + __readinessProbeMixin({timeoutSeconds: timeoutSeconds}),\n            },\n            readinessProbeType:: hidden.core.v1.probe,\n            // Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources\n            resources:: {\n              local __resourcesMixin(resources) = {resources+: resources},\n              mixinInstance(resources):: __resourcesMixin(resources),\n              // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withLimits(limits):: self + __resourcesMixin({limits: limits}),\n              // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withLimitsMixin(limits):: self + __resourcesMixin({limits+: limits}),\n              // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withRequests(requests):: self + __resourcesMixin({requests: requests}),\n              // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withRequestsMixin(requests):: self + __resourcesMixin({requests+: requests}),\n            },\n            resourcesType:: hidden.core.v1.resourceRequirements,\n            // Security options the pod should run with. More info: https://kubernetes.io/docs/concepts/policy/security-context/ More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n            securityContext:: {\n              local __securityContextMixin(securityContext) = {securityContext+: securityContext},\n              mixinInstance(securityContext):: __securityContextMixin(securityContext),\n              // AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN\n              withAllowPrivilegeEscalation(allowPrivilegeEscalation):: self + __securityContextMixin({allowPrivilegeEscalation: allowPrivilegeEscalation}),\n              // The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime.\n              capabilities:: {\n                local __capabilitiesMixin(capabilities) = __securityContextMixin({capabilities+: capabilities}),\n                mixinInstance(capabilities):: __capabilitiesMixin(capabilities),\n                // Added capabilities\n                withAdd(add):: self + if std.type(add) == \"array\" then __capabilitiesMixin({add: add}) else __capabilitiesMixin({add: [add]}),\n                // Added capabilities\n                withAddMixin(add):: self + if std.type(add) == \"array\" then __capabilitiesMixin({add+: add}) else __capabilitiesMixin({add+: [add]}),\n                // Removed capabilities\n                withDrop(drop):: self + if std.type(drop) == \"array\" then __capabilitiesMixin({drop: drop}) else __capabilitiesMixin({drop: [drop]}),\n                // Removed capabilities\n                withDropMixin(drop):: self + if std.type(drop) == \"array\" then __capabilitiesMixin({drop+: drop}) else __capabilitiesMixin({drop+: [drop]}),\n              },\n              capabilitiesType:: hidden.core.v1.capabilities,\n              // Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false.\n              withPrivileged(privileged):: self + __securityContextMixin({privileged: privileged}),\n              // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n              withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n              // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n              withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n              // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n              withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n              // The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n            },\n            securityContextType:: hidden.core.v1.securityContext,\n          },\n        },\n        // Describe a container image\n        containerImage:: {\n          new():: {},\n          // Names by which this image is known. e.g. [\"k8s.gcr.io/hyperkube:v1.0.7\", \"dockerhub.io/google_containers/hyperkube:v1.0.7\"]\n          withNames(names):: self + if std.type(names) == \"array\" then {names: names} else {names: [names]},\n          // Names by which this image is known. e.g. [\"k8s.gcr.io/hyperkube:v1.0.7\", \"dockerhub.io/google_containers/hyperkube:v1.0.7\"]\n          withNamesMixin(names):: self + if std.type(names) == \"array\" then {names+: names} else {names+: [names]},\n          // The size of the image in bytes.\n          withSizeBytes(sizeBytes):: self + {sizeBytes: sizeBytes},\n          mixin:: {\n          },\n        },\n        // ContainerPort represents a network port in a single container.\n        containerPort:: {\n          new(containerPort=\"\"):: self.withContainerPort(containerPort),\n          newNamed(containerPort=\"\", name=\"\"):: self.withContainerPort(containerPort).withName(name),\n          // Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.\n          withContainerPort(containerPort):: self + {containerPort: containerPort},\n          // What host IP to bind the external port to.\n          withHostIp(hostIp):: self + {hostIP: hostIp},\n          // Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.\n          withHostPort(hostPort):: self + {hostPort: hostPort},\n          // If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.\n          withName(name):: self + {name: name},\n          // Protocol for port. Must be UDP or TCP. Defaults to \"TCP\".\n          withProtocol(protocol):: self + {protocol: protocol},\n          mixin:: {\n          },\n        },\n        // ContainerState holds a possible state of container. Only one of its members may be specified. If none of them is specified, the default one is ContainerStateWaiting.\n        containerState:: {\n          new():: {},\n          mixin:: {\n            // Details about a running container\n            running:: {\n              local __runningMixin(running) = {running+: running},\n              mixinInstance(running):: __runningMixin(running),\n              // Time at which the container was last (re-)started\n              withStartedAt(startedAt):: self + __runningMixin({startedAt: startedAt}),\n            },\n            runningType:: hidden.core.v1.containerStateRunning,\n            // Details about a terminated container\n            terminated:: {\n              local __terminatedMixin(terminated) = {terminated+: terminated},\n              mixinInstance(terminated):: __terminatedMixin(terminated),\n              // Container's ID in the format 'docker://<container_id>'\n              withContainerId(containerId):: self + __terminatedMixin({containerID: containerId}),\n              // Exit status from the last termination of the container\n              withExitCode(exitCode):: self + __terminatedMixin({exitCode: exitCode}),\n              // Time at which the container last terminated\n              withFinishedAt(finishedAt):: self + __terminatedMixin({finishedAt: finishedAt}),\n              // Message regarding the last termination of the container\n              withMessage(message):: self + __terminatedMixin({message: message}),\n              // (brief) reason from the last termination of the container\n              withReason(reason):: self + __terminatedMixin({reason: reason}),\n              // Signal from the last termination of the container\n              withSignal(signal):: self + __terminatedMixin({signal: signal}),\n              // Time at which previous execution of the container started\n              withStartedAt(startedAt):: self + __terminatedMixin({startedAt: startedAt}),\n            },\n            terminatedType:: hidden.core.v1.containerStateTerminated,\n            // Details about a waiting container\n            waiting:: {\n              local __waitingMixin(waiting) = {waiting+: waiting},\n              mixinInstance(waiting):: __waitingMixin(waiting),\n              // Message regarding why the container is not yet running.\n              withMessage(message):: self + __waitingMixin({message: message}),\n              // (brief) reason the container is not yet running.\n              withReason(reason):: self + __waitingMixin({reason: reason}),\n            },\n            waitingType:: hidden.core.v1.containerStateWaiting,\n          },\n        },\n        // ContainerStateRunning is a running state of a container.\n        containerStateRunning:: {\n          new():: {},\n          // Time at which the container was last (re-)started\n          withStartedAt(startedAt):: self + {startedAt: startedAt},\n          mixin:: {\n          },\n        },\n        // ContainerStateTerminated is a terminated state of a container.\n        containerStateTerminated:: {\n          new():: {},\n          // Container's ID in the format 'docker://<container_id>'\n          withContainerId(containerId):: self + {containerID: containerId},\n          // Exit status from the last termination of the container\n          withExitCode(exitCode):: self + {exitCode: exitCode},\n          // Time at which the container last terminated\n          withFinishedAt(finishedAt):: self + {finishedAt: finishedAt},\n          // Message regarding the last termination of the container\n          withMessage(message):: self + {message: message},\n          // (brief) reason from the last termination of the container\n          withReason(reason):: self + {reason: reason},\n          // Signal from the last termination of the container\n          withSignal(signal):: self + {signal: signal},\n          // Time at which previous execution of the container started\n          withStartedAt(startedAt):: self + {startedAt: startedAt},\n          mixin:: {\n          },\n        },\n        // ContainerStateWaiting is a waiting state of a container.\n        containerStateWaiting:: {\n          new():: {},\n          // Message regarding why the container is not yet running.\n          withMessage(message):: self + {message: message},\n          // (brief) reason the container is not yet running.\n          withReason(reason):: self + {reason: reason},\n          mixin:: {\n          },\n        },\n        // ContainerStatus contains details for the current status of this container.\n        containerStatus:: {\n          new():: {},\n          // Container's ID in the format 'docker://<container_id>'.\n          withContainerId(containerId):: self + {containerID: containerId},\n          // The image the container is running. More info: https://kubernetes.io/docs/concepts/containers/images\n          withImage(image):: self + {image: image},\n          // ImageID of the container's image.\n          withImageId(imageId):: self + {imageID: imageId},\n          // This must be a DNS_LABEL. Each container in a pod must have a unique name. Cannot be updated.\n          withName(name):: self + {name: name},\n          // Specifies whether the container has passed its readiness probe.\n          withReady(ready):: self + {ready: ready},\n          // The number of times the container has been restarted, currently based on the number of dead containers that have not yet been removed. Note that this is calculated from dead containers. But those containers are subject to garbage collection. This value will get capped at 5 by GC.\n          withRestartCount(restartCount):: self + {restartCount: restartCount},\n          mixin:: {\n            // Details about the container's last termination condition.\n            lastState:: {\n              local __lastStateMixin(lastState) = {lastState+: lastState},\n              mixinInstance(lastState):: __lastStateMixin(lastState),\n              // Details about a running container\n              running:: {\n                local __runningMixin(running) = __lastStateMixin({running+: running}),\n                mixinInstance(running):: __runningMixin(running),\n                // Time at which the container was last (re-)started\n                withStartedAt(startedAt):: self + __runningMixin({startedAt: startedAt}),\n              },\n              runningType:: hidden.core.v1.containerStateRunning,\n              // Details about a terminated container\n              terminated:: {\n                local __terminatedMixin(terminated) = __lastStateMixin({terminated+: terminated}),\n                mixinInstance(terminated):: __terminatedMixin(terminated),\n                // Container's ID in the format 'docker://<container_id>'\n                withContainerId(containerId):: self + __terminatedMixin({containerID: containerId}),\n                // Exit status from the last termination of the container\n                withExitCode(exitCode):: self + __terminatedMixin({exitCode: exitCode}),\n                // Time at which the container last terminated\n                withFinishedAt(finishedAt):: self + __terminatedMixin({finishedAt: finishedAt}),\n                // Message regarding the last termination of the container\n                withMessage(message):: self + __terminatedMixin({message: message}),\n                // (brief) reason from the last termination of the container\n                withReason(reason):: self + __terminatedMixin({reason: reason}),\n                // Signal from the last termination of the container\n                withSignal(signal):: self + __terminatedMixin({signal: signal}),\n                // Time at which previous execution of the container started\n                withStartedAt(startedAt):: self + __terminatedMixin({startedAt: startedAt}),\n              },\n              terminatedType:: hidden.core.v1.containerStateTerminated,\n              // Details about a waiting container\n              waiting:: {\n                local __waitingMixin(waiting) = __lastStateMixin({waiting+: waiting}),\n                mixinInstance(waiting):: __waitingMixin(waiting),\n                // Message regarding why the container is not yet running.\n                withMessage(message):: self + __waitingMixin({message: message}),\n                // (brief) reason the container is not yet running.\n                withReason(reason):: self + __waitingMixin({reason: reason}),\n              },\n              waitingType:: hidden.core.v1.containerStateWaiting,\n            },\n            lastStateType:: hidden.core.v1.containerState,\n            // Details about the container's current condition.\n            state:: {\n              local __stateMixin(state) = {state+: state},\n              mixinInstance(state):: __stateMixin(state),\n              // Details about a running container\n              running:: {\n                local __runningMixin(running) = __stateMixin({running+: running}),\n                mixinInstance(running):: __runningMixin(running),\n                // Time at which the container was last (re-)started\n                withStartedAt(startedAt):: self + __runningMixin({startedAt: startedAt}),\n              },\n              runningType:: hidden.core.v1.containerStateRunning,\n              // Details about a terminated container\n              terminated:: {\n                local __terminatedMixin(terminated) = __stateMixin({terminated+: terminated}),\n                mixinInstance(terminated):: __terminatedMixin(terminated),\n                // Container's ID in the format 'docker://<container_id>'\n                withContainerId(containerId):: self + __terminatedMixin({containerID: containerId}),\n                // Exit status from the last termination of the container\n                withExitCode(exitCode):: self + __terminatedMixin({exitCode: exitCode}),\n                // Time at which the container last terminated\n                withFinishedAt(finishedAt):: self + __terminatedMixin({finishedAt: finishedAt}),\n                // Message regarding the last termination of the container\n                withMessage(message):: self + __terminatedMixin({message: message}),\n                // (brief) reason from the last termination of the container\n                withReason(reason):: self + __terminatedMixin({reason: reason}),\n                // Signal from the last termination of the container\n                withSignal(signal):: self + __terminatedMixin({signal: signal}),\n                // Time at which previous execution of the container started\n                withStartedAt(startedAt):: self + __terminatedMixin({startedAt: startedAt}),\n              },\n              terminatedType:: hidden.core.v1.containerStateTerminated,\n              // Details about a waiting container\n              waiting:: {\n                local __waitingMixin(waiting) = __stateMixin({waiting+: waiting}),\n                mixinInstance(waiting):: __waitingMixin(waiting),\n                // Message regarding why the container is not yet running.\n                withMessage(message):: self + __waitingMixin({message: message}),\n                // (brief) reason the container is not yet running.\n                withReason(reason):: self + __waitingMixin({reason: reason}),\n              },\n              waitingType:: hidden.core.v1.containerStateWaiting,\n            },\n            stateType:: hidden.core.v1.containerState,\n          },\n        },\n        // Represents storage that is managed by an external CSI volume driver (Beta feature)\n        csiPersistentVolumeSource:: {\n          new():: {},\n          // Driver is the name of the driver to use for this volume. Required.\n          withDriver(driver):: self + {driver: driver},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Optional: The value to pass to ControllerPublishVolumeRequest. Defaults to false (read/write).\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Attributes of the volume to publish.\n          withVolumeAttributes(volumeAttributes):: self + {volumeAttributes: volumeAttributes},\n          // Attributes of the volume to publish.\n          withVolumeAttributesMixin(volumeAttributes):: self + {volumeAttributes+: volumeAttributes},\n          // VolumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. Required.\n          withVolumeHandle(volumeHandle):: self + {volumeHandle: volumeHandle},\n          mixin:: {\n            // ControllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n            controllerPublishSecretRef:: {\n              local __controllerPublishSecretRefMixin(controllerPublishSecretRef) = {controllerPublishSecretRef+: controllerPublishSecretRef},\n              mixinInstance(controllerPublishSecretRef):: __controllerPublishSecretRefMixin(controllerPublishSecretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __controllerPublishSecretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __controllerPublishSecretRefMixin({namespace: namespace}),\n            },\n            controllerPublishSecretRefType:: hidden.core.v1.secretReference,\n            // NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n            nodePublishSecretRef:: {\n              local __nodePublishSecretRefMixin(nodePublishSecretRef) = {nodePublishSecretRef+: nodePublishSecretRef},\n              mixinInstance(nodePublishSecretRef):: __nodePublishSecretRefMixin(nodePublishSecretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __nodePublishSecretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __nodePublishSecretRefMixin({namespace: namespace}),\n            },\n            nodePublishSecretRefType:: hidden.core.v1.secretReference,\n            // NodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n            nodeStageSecretRef:: {\n              local __nodeStageSecretRefMixin(nodeStageSecretRef) = {nodeStageSecretRef+: nodeStageSecretRef},\n              mixinInstance(nodeStageSecretRef):: __nodeStageSecretRefMixin(nodeStageSecretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __nodeStageSecretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __nodeStageSecretRefMixin({namespace: namespace}),\n            },\n            nodeStageSecretRefType:: hidden.core.v1.secretReference,\n          },\n        },\n        // DaemonEndpoint contains information about a single Daemon endpoint.\n        daemonEndpoint:: {\n          new():: {},\n          // Port number of the given endpoint.\n          withPort(port):: self + {Port: port},\n          mixin:: {\n          },\n        },\n        // Represents downward API info for projecting into a projected volume. Note that this is identical to a downwardAPI volume source without the default mode.\n        downwardApiProjection:: {\n          new():: {},\n          // Items is a list of DownwardAPIVolume file\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of DownwardAPIVolume file\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.downwardApiVolumeFile,\n          mixin:: {\n          },\n        },\n        // DownwardAPIVolumeFile represents information to create the file containing the pod field\n        downwardApiVolumeFile:: {\n          new():: {},\n          // Optional: mode bits to use on this file, must be a value between 0 and 0777. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n          withMode(mode):: self + {mode: mode},\n          // Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'\n          withPath(path):: self + {path: path},\n          mixin:: {\n            // Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.\n            fieldRef:: {\n              local __fieldRefMixin(fieldRef) = {fieldRef+: fieldRef},\n              mixinInstance(fieldRef):: __fieldRefMixin(fieldRef),\n              // Path of the field to select in the specified API version.\n              withFieldPath(fieldPath):: self + __fieldRefMixin({fieldPath: fieldPath}),\n            },\n            fieldRefType:: hidden.core.v1.objectFieldSelector,\n            // Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.\n            resourceFieldRef:: {\n              local __resourceFieldRefMixin(resourceFieldRef) = {resourceFieldRef+: resourceFieldRef},\n              mixinInstance(resourceFieldRef):: __resourceFieldRefMixin(resourceFieldRef),\n              // Container name: required for volumes, optional for env vars\n              withContainerName(containerName):: self + __resourceFieldRefMixin({containerName: containerName}),\n              // Specifies the output format of the exposed resources, defaults to \"1\"\n              divisor:: {\n                local __divisorMixin(divisor) = __resourceFieldRefMixin({divisor+: divisor}),\n                mixinInstance(divisor):: __divisorMixin(divisor),\n              },\n              divisorType:: hidden.core.resource.quantity,\n              // Required: resource to select\n              withResource(resource):: self + __resourceFieldRefMixin({resource: resource}),\n            },\n            resourceFieldRefType:: hidden.core.v1.resourceFieldSelector,\n          },\n        },\n        // DownwardAPIVolumeSource represents a volume containing downward API info. Downward API volumes support ownership management and SELinux relabeling.\n        downwardApiVolumeSource:: {\n          new():: {},\n          // Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n          withDefaultMode(defaultMode):: self + {defaultMode: defaultMode},\n          // Items is a list of downward API volume file\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of downward API volume file\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.downwardApiVolumeFile,\n          mixin:: {\n          },\n        },\n        // Represents an empty directory for a pod. Empty directory volumes support ownership management and SELinux relabeling.\n        emptyDirVolumeSource:: {\n          new():: {},\n          // What type of storage medium should back this directory. The default is \"\" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir\n          withMedium(medium):: self + {medium: medium},\n          mixin:: {\n            // Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir\n            sizeLimit:: {\n              local __sizeLimitMixin(sizeLimit) = {sizeLimit+: sizeLimit},\n              mixinInstance(sizeLimit):: __sizeLimitMixin(sizeLimit),\n            },\n            sizeLimitType:: hidden.core.resource.quantity,\n          },\n        },\n        // EndpointAddress is a tuple that describes single IP address.\n        endpointAddress:: {\n          new():: {},\n          // The Hostname of this endpoint\n          withHostname(hostname):: self + {hostname: hostname},\n          // The IP of this endpoint. May not be loopback (127.0.0.0/8), link-local (169.254.0.0/16), or link-local multicast ((224.0.0.0/24). IPv6 is also accepted but not fully supported on all platforms. Also, certain kubernetes components, like kube-proxy, are not IPv6 ready.\n          withIp(ip):: self + {ip: ip},\n          // Optional: Node hosting this endpoint. This can be used to determine endpoints local to a node.\n          withNodeName(nodeName):: self + {nodeName: nodeName},\n          mixin:: {\n            // Reference to object providing the endpoint.\n            targetRef:: {\n              local __targetRefMixin(targetRef) = {targetRef+: targetRef},\n              mixinInstance(targetRef):: __targetRefMixin(targetRef),\n              // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n              withFieldPath(fieldPath):: self + __targetRefMixin({fieldPath: fieldPath}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __targetRefMixin({name: name}),\n              // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n              withNamespace(namespace):: self + __targetRefMixin({namespace: namespace}),\n              // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n              withResourceVersion(resourceVersion):: self + __targetRefMixin({resourceVersion: resourceVersion}),\n              // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n              withUid(uid):: self + __targetRefMixin({uid: uid}),\n            },\n            targetRefType:: hidden.core.v1.objectReference,\n          },\n        },\n        // EndpointPort is a tuple that describes a single port.\n        endpointPort:: {\n          new():: {},\n          // The name of this port (corresponds to ServicePort.Name). Must be a DNS_LABEL. Optional only if one port is defined.\n          withName(name):: self + {name: name},\n          // The port number of the endpoint.\n          withPort(port):: self + {port: port},\n          // The IP protocol for this port. Must be UDP or TCP. Default is TCP.\n          withProtocol(protocol):: self + {protocol: protocol},\n          mixin:: {\n          },\n        },\n        // EndpointSubset is a group of addresses with a common set of ports. The expanded set of endpoints is the Cartesian product of Addresses x Ports. For example, given:\n        // {\n        // Addresses: [{\"ip\": \"10.10.1.1\"}, {\"ip\": \"10.10.2.2\"}],\n        // Ports:     [{\"name\": \"a\", \"port\": 8675}, {\"name\": \"b\", \"port\": 309}]\n        // }\n        // The resulting set of endpoints can be viewed as:\n        // a: [ 10.10.1.1:8675, 10.10.2.2:8675 ],\n        // b: [ 10.10.1.1:309, 10.10.2.2:309 ]\n        endpointSubset:: {\n          new():: {},\n          // IP addresses which offer the related ports that are marked as ready. These endpoints should be considered safe for load balancers and clients to utilize.\n          withAddresses(addresses):: self + if std.type(addresses) == \"array\" then {addresses: addresses} else {addresses: [addresses]},\n          // IP addresses which offer the related ports that are marked as ready. These endpoints should be considered safe for load balancers and clients to utilize.\n          withAddressesMixin(addresses):: self + if std.type(addresses) == \"array\" then {addresses+: addresses} else {addresses+: [addresses]},\n          addressesType:: hidden.core.v1.endpointAddress,\n          // IP addresses which offer the related ports but are not currently marked as ready because they have not yet finished starting, have recently failed a readiness check, or have recently failed a liveness check.\n          withNotReadyAddresses(notReadyAddresses):: self + if std.type(notReadyAddresses) == \"array\" then {notReadyAddresses: notReadyAddresses} else {notReadyAddresses: [notReadyAddresses]},\n          // IP addresses which offer the related ports but are not currently marked as ready because they have not yet finished starting, have recently failed a readiness check, or have recently failed a liveness check.\n          withNotReadyAddressesMixin(notReadyAddresses):: self + if std.type(notReadyAddresses) == \"array\" then {notReadyAddresses+: notReadyAddresses} else {notReadyAddresses+: [notReadyAddresses]},\n          notReadyAddressesType:: hidden.core.v1.endpointAddress,\n          // Port numbers available on the related IP addresses.\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // Port numbers available on the related IP addresses.\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.core.v1.endpointPort,\n          mixin:: {\n          },\n        },\n        // EndpointsList is a list of endpoints.\n        endpointsList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of endpoints.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of endpoints.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.endpoints,\n          mixin:: {\n          },\n        },\n        // EnvFromSource represents the source of a set of ConfigMaps\n        envFromSource:: {\n          new():: {},\n          // An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.\n          withPrefix(prefix):: self + {prefix: prefix},\n          mixin:: {\n            // The ConfigMap to select from\n            configMapRef:: {\n              local __configMapRefMixin(configMapRef) = {configMapRef+: configMapRef},\n              mixinInstance(configMapRef):: __configMapRefMixin(configMapRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __configMapRefMixin({name: name}),\n              // Specify whether the ConfigMap must be defined\n              withOptional(optional):: self + __configMapRefMixin({optional: optional}),\n            },\n            configMapRefType:: hidden.core.v1.configMapEnvSource,\n            // The Secret to select from\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Specify whether the Secret must be defined\n              withOptional(optional):: self + __secretRefMixin({optional: optional}),\n            },\n            secretRefType:: hidden.core.v1.secretEnvSource,\n          },\n        },\n        // EnvVar represents an environment variable present in a Container.\n        envVar:: {\n          new(name=\"\", value=\"\"):: self.withName(name).withValue(value),\n          fromSecretRef(name=\"\", secretRefName=\"\", secretRefKey=\"\"):: self.withName(name) + self.mixin.valueFrom.secretKeyRef.withKey(secretRefKey).withName(secretRefName),\n          fromFieldPath(name=\"\", fieldPath=\"\"):: self.withName(name) + self.mixin.valueFrom.fieldRef.withFieldPath(fieldPath),\n          // Name of the environment variable. Must be a C_IDENTIFIER.\n          withName(name):: self + {name: name},\n          // Variable references $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to \"\".\n          withValue(value):: self + {value: value},\n          mixin:: {\n            // Source for the environment variable's value. Cannot be used if value is not empty.\n            valueFrom:: {\n              local __valueFromMixin(valueFrom) = {valueFrom+: valueFrom},\n              mixinInstance(valueFrom):: __valueFromMixin(valueFrom),\n              // Selects a key of a ConfigMap.\n              configMapKeyRef:: {\n                local __configMapKeyRefMixin(configMapKeyRef) = __valueFromMixin({configMapKeyRef+: configMapKeyRef}),\n                mixinInstance(configMapKeyRef):: __configMapKeyRefMixin(configMapKeyRef),\n                // The key to select.\n                withKey(key):: self + __configMapKeyRefMixin({key: key}),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __configMapKeyRefMixin({name: name}),\n                // Specify whether the ConfigMap or it's key must be defined\n                withOptional(optional):: self + __configMapKeyRefMixin({optional: optional}),\n              },\n              configMapKeyRefType:: hidden.core.v1.configMapKeySelector,\n              // Selects a field of the pod: supports metadata.name, metadata.namespace, metadata.labels, metadata.annotations, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP.\n              fieldRef:: {\n                local __fieldRefMixin(fieldRef) = __valueFromMixin({fieldRef+: fieldRef}),\n                mixinInstance(fieldRef):: __fieldRefMixin(fieldRef),\n                // Path of the field to select in the specified API version.\n                withFieldPath(fieldPath):: self + __fieldRefMixin({fieldPath: fieldPath}),\n              },\n              fieldRefType:: hidden.core.v1.objectFieldSelector,\n              // Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.\n              resourceFieldRef:: {\n                local __resourceFieldRefMixin(resourceFieldRef) = __valueFromMixin({resourceFieldRef+: resourceFieldRef}),\n                mixinInstance(resourceFieldRef):: __resourceFieldRefMixin(resourceFieldRef),\n                // Container name: required for volumes, optional for env vars\n                withContainerName(containerName):: self + __resourceFieldRefMixin({containerName: containerName}),\n                // Specifies the output format of the exposed resources, defaults to \"1\"\n                divisor:: {\n                  local __divisorMixin(divisor) = __resourceFieldRefMixin({divisor+: divisor}),\n                  mixinInstance(divisor):: __divisorMixin(divisor),\n                },\n                divisorType:: hidden.core.resource.quantity,\n                // Required: resource to select\n                withResource(resource):: self + __resourceFieldRefMixin({resource: resource}),\n              },\n              resourceFieldRefType:: hidden.core.v1.resourceFieldSelector,\n              // Selects a key of a secret in the pod's namespace\n              secretKeyRef:: {\n                local __secretKeyRefMixin(secretKeyRef) = __valueFromMixin({secretKeyRef+: secretKeyRef}),\n                mixinInstance(secretKeyRef):: __secretKeyRefMixin(secretKeyRef),\n                // The key of the secret to select from.  Must be a valid secret key.\n                withKey(key):: self + __secretKeyRefMixin({key: key}),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretKeyRefMixin({name: name}),\n                // Specify whether the Secret or it's key must be defined\n                withOptional(optional):: self + __secretKeyRefMixin({optional: optional}),\n              },\n              secretKeyRefType:: hidden.core.v1.secretKeySelector,\n            },\n            valueFromType:: hidden.core.v1.envVarSource,\n          },\n        },\n        // EnvVarSource represents a source for the value of an EnvVar.\n        envVarSource:: {\n          new():: {},\n          mixin:: {\n            // Selects a key of a ConfigMap.\n            configMapKeyRef:: {\n              local __configMapKeyRefMixin(configMapKeyRef) = {configMapKeyRef+: configMapKeyRef},\n              mixinInstance(configMapKeyRef):: __configMapKeyRefMixin(configMapKeyRef),\n              // The key to select.\n              withKey(key):: self + __configMapKeyRefMixin({key: key}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __configMapKeyRefMixin({name: name}),\n              // Specify whether the ConfigMap or it's key must be defined\n              withOptional(optional):: self + __configMapKeyRefMixin({optional: optional}),\n            },\n            configMapKeyRefType:: hidden.core.v1.configMapKeySelector,\n            // Selects a field of the pod: supports metadata.name, metadata.namespace, metadata.labels, metadata.annotations, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP.\n            fieldRef:: {\n              local __fieldRefMixin(fieldRef) = {fieldRef+: fieldRef},\n              mixinInstance(fieldRef):: __fieldRefMixin(fieldRef),\n              // Path of the field to select in the specified API version.\n              withFieldPath(fieldPath):: self + __fieldRefMixin({fieldPath: fieldPath}),\n            },\n            fieldRefType:: hidden.core.v1.objectFieldSelector,\n            // Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.\n            resourceFieldRef:: {\n              local __resourceFieldRefMixin(resourceFieldRef) = {resourceFieldRef+: resourceFieldRef},\n              mixinInstance(resourceFieldRef):: __resourceFieldRefMixin(resourceFieldRef),\n              // Container name: required for volumes, optional for env vars\n              withContainerName(containerName):: self + __resourceFieldRefMixin({containerName: containerName}),\n              // Specifies the output format of the exposed resources, defaults to \"1\"\n              divisor:: {\n                local __divisorMixin(divisor) = __resourceFieldRefMixin({divisor+: divisor}),\n                mixinInstance(divisor):: __divisorMixin(divisor),\n              },\n              divisorType:: hidden.core.resource.quantity,\n              // Required: resource to select\n              withResource(resource):: self + __resourceFieldRefMixin({resource: resource}),\n            },\n            resourceFieldRefType:: hidden.core.v1.resourceFieldSelector,\n            // Selects a key of a secret in the pod's namespace\n            secretKeyRef:: {\n              local __secretKeyRefMixin(secretKeyRef) = {secretKeyRef+: secretKeyRef},\n              mixinInstance(secretKeyRef):: __secretKeyRefMixin(secretKeyRef),\n              // The key of the secret to select from.  Must be a valid secret key.\n              withKey(key):: self + __secretKeyRefMixin({key: key}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretKeyRefMixin({name: name}),\n              // Specify whether the Secret or it's key must be defined\n              withOptional(optional):: self + __secretKeyRefMixin({optional: optional}),\n            },\n            secretKeyRefType:: hidden.core.v1.secretKeySelector,\n          },\n        },\n        // EventList is a list of events.\n        eventList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of events\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of events\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.event,\n          mixin:: {\n          },\n        },\n        // EventSeries contain information on series of events, i.e. thing that was/is happening continuously for some time.\n        eventSeries:: {\n          new():: {},\n          // Number of occurrences in this series up to the last heartbeat time\n          withCount(count):: self + {count: count},\n          // Time of the last occurrence observed\n          withLastObservedTime(lastObservedTime):: self + {lastObservedTime: lastObservedTime},\n          // State of this Series: Ongoing or Finished\n          withState(state):: self + {state: state},\n          mixin:: {\n          },\n        },\n        // EventSource contains information for an event.\n        eventSource:: {\n          new():: {},\n          // Component from which the event is generated.\n          withComponent(component):: self + {component: component},\n          // Node name on which the event is generated.\n          withHost(host):: self + {host: host},\n          mixin:: {\n          },\n        },\n        // ExecAction describes a \"run in container\" action.\n        execAction:: {\n          new():: {},\n          // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n          withCommand(command):: self + if std.type(command) == \"array\" then {command: command} else {command: [command]},\n          // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n          withCommandMixin(command):: self + if std.type(command) == \"array\" then {command+: command} else {command+: [command]},\n          mixin:: {\n          },\n        },\n        // Represents a Fibre Channel volume. Fibre Channel volumes can only be mounted as read/write once. Fibre Channel volumes support ownership management and SELinux relabeling.\n        fcVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Optional: FC target lun number\n          withLun(lun):: self + {lun: lun},\n          // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Optional: FC target worldwide names (WWNs)\n          withTargetWwns(targetWwns):: self + if std.type(targetWwns) == \"array\" then {targetWWNs: targetWwns} else {targetWWNs: [targetWwns]},\n          // Optional: FC target worldwide names (WWNs)\n          withTargetWwnsMixin(targetWwns):: self + if std.type(targetWwns) == \"array\" then {targetWWNs+: targetWwns} else {targetWWNs+: [targetWwns]},\n          // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n          withWwids(wwids):: self + if std.type(wwids) == \"array\" then {wwids: wwids} else {wwids: [wwids]},\n          // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n          withWwidsMixin(wwids):: self + if std.type(wwids) == \"array\" then {wwids+: wwids} else {wwids+: [wwids]},\n          mixin:: {\n          },\n        },\n        // FlexPersistentVolumeSource represents a generic persistent volume resource that is provisioned/attached using an exec based plugin.\n        flexPersistentVolumeSource:: {\n          new():: {},\n          // Driver is the name of the driver to use for this volume.\n          withDriver(driver):: self + {driver: driver},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". The default filesystem depends on FlexVolume script.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Optional: Extra command options if any.\n          withOptions(options):: self + {options: options},\n          // Optional: Extra command options if any.\n          withOptionsMixin(options):: self + {options+: options},\n          // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          mixin:: {\n            // Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n            },\n            secretRefType:: hidden.core.v1.secretReference,\n          },\n        },\n        // FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.\n        flexVolumeSource:: {\n          new():: {},\n          // Driver is the name of the driver to use for this volume.\n          withDriver(driver):: self + {driver: driver},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". The default filesystem depends on FlexVolume script.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Optional: Extra command options if any.\n          withOptions(options):: self + {options: options},\n          // Optional: Extra command options if any.\n          withOptionsMixin(options):: self + {options+: options},\n          // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          mixin:: {\n            // Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n            },\n            secretRefType:: hidden.core.v1.localObjectReference,\n          },\n        },\n        // Represents a Flocker volume mounted by the Flocker agent. One and only one of datasetName and datasetUUID should be set. Flocker volumes do not support ownership management or SELinux relabeling.\n        flockerVolumeSource:: {\n          new():: {},\n          // Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated\n          withDatasetName(datasetName):: self + {datasetName: datasetName},\n          // UUID of the dataset. This is unique identifier of a Flocker dataset\n          withDatasetUuid(datasetUuid):: self + {datasetUUID: datasetUuid},\n          mixin:: {\n          },\n        },\n        // Represents a Persistent Disk resource in Google Compute Engine.\n        //\n        // A GCE PD must exist before mounting to a container. The disk must also be in the same GCE project and zone as the kubelet. A GCE PD can only be mounted as read/write once or read-only many times. GCE PDs support ownership management and SELinux relabeling.\n        gcePersistentDiskVolumeSource:: {\n          new():: {},\n          // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n          withFsType(fsType):: self + {fsType: fsType},\n          // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n          withPartition(partition):: self + {partition: partition},\n          // Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n          withPdName(pdName):: self + {pdName: pdName},\n          // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          mixin:: {\n          },\n        },\n        // Represents a volume that is populated with the contents of a git repository. Git repo volumes do not support ownership management. Git repo volumes support SELinux relabeling.\n        gitRepoVolumeSource:: {\n          new():: {},\n          // Target directory name. Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.\n          withDirectory(directory):: self + {directory: directory},\n          // Repository URL\n          withRepository(repository):: self + {repository: repository},\n          // Commit hash for the specified revision.\n          withRevision(revision):: self + {revision: revision},\n          mixin:: {\n          },\n        },\n        // Represents a Glusterfs mount that lasts the lifetime of a pod. Glusterfs volumes do not support ownership management or SELinux relabeling.\n        glusterfsVolumeSource:: {\n          new():: {},\n          // EndpointsName is the endpoint name that details Glusterfs topology. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n          withEndpoints(endpoints):: self + {endpoints: endpoints},\n          // Path is the Glusterfs volume path. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n          withPath(path):: self + {path: path},\n          // ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          mixin:: {\n          },\n        },\n        // Handler defines a specific action that should be taken\n        handler:: {\n          new():: {},\n          mixin:: {\n            // One and only one of the following should be specified. Exec specifies the action to take.\n            exec:: {\n              local __execMixin(exec) = {exec+: exec},\n              mixinInstance(exec):: __execMixin(exec),\n              // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n              withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n              // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n              withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n            },\n            execType:: hidden.core.v1.execAction,\n            // HTTPGet specifies the http request to perform.\n            httpGet:: {\n              local __httpGetMixin(httpGet) = {httpGet+: httpGet},\n              mixinInstance(httpGet):: __httpGetMixin(httpGet),\n              // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n              withHost(host):: self + __httpGetMixin({host: host}),\n              // Custom headers to set in the request. HTTP allows repeated headers.\n              withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n              // Custom headers to set in the request. HTTP allows repeated headers.\n              withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n              httpHeadersType:: hidden.core.v1.httpHeader,\n              // Path to access on the HTTP server.\n              withPath(path):: self + __httpGetMixin({path: path}),\n              // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n              withPort(port):: self + __httpGetMixin({port: port}),\n              // Scheme to use for connecting to the host. Defaults to HTTP.\n              withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n            },\n            httpGetType:: hidden.core.v1.httpGetAction,\n            // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n            tcpSocket:: {\n              local __tcpSocketMixin(tcpSocket) = {tcpSocket+: tcpSocket},\n              mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n              // Optional: Host name to connect to, defaults to the pod IP.\n              withHost(host):: self + __tcpSocketMixin({host: host}),\n              // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n              withPort(port):: self + __tcpSocketMixin({port: port}),\n            },\n            tcpSocketType:: hidden.core.v1.tcpSocketAction,\n          },\n        },\n        // HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.\n        hostAlias:: {\n          new():: {},\n          // Hostnames for the above IP address.\n          withHostnames(hostnames):: self + if std.type(hostnames) == \"array\" then {hostnames: hostnames} else {hostnames: [hostnames]},\n          // Hostnames for the above IP address.\n          withHostnamesMixin(hostnames):: self + if std.type(hostnames) == \"array\" then {hostnames+: hostnames} else {hostnames+: [hostnames]},\n          // IP address of the host file entry.\n          withIp(ip):: self + {ip: ip},\n          mixin:: {\n          },\n        },\n        // Represents a host path mapped into a pod. Host path volumes do not support ownership management or SELinux relabeling.\n        hostPathVolumeSource:: {\n          new():: {},\n          // Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n          withPath(path):: self + {path: path},\n          // Type for HostPath Volume Defaults to \"\" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // HTTPGetAction describes an action based on HTTP Get requests.\n        httpGetAction:: {\n          new():: {},\n          // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n          withHost(host):: self + {host: host},\n          // Custom headers to set in the request. HTTP allows repeated headers.\n          withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then {httpHeaders: httpHeaders} else {httpHeaders: [httpHeaders]},\n          // Custom headers to set in the request. HTTP allows repeated headers.\n          withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then {httpHeaders+: httpHeaders} else {httpHeaders+: [httpHeaders]},\n          httpHeadersType:: hidden.core.v1.httpHeader,\n          // Path to access on the HTTP server.\n          withPath(path):: self + {path: path},\n          // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n          withPort(port):: self + {port: port},\n          // Scheme to use for connecting to the host. Defaults to HTTP.\n          withScheme(scheme):: self + {scheme: scheme},\n          mixin:: {\n          },\n        },\n        // HTTPHeader describes a custom header to be used in HTTP probes\n        httpHeader:: {\n          new():: {},\n          // The header field name\n          withName(name):: self + {name: name},\n          // The header field value\n          withValue(value):: self + {value: value},\n          mixin:: {\n          },\n        },\n        // ISCSIPersistentVolumeSource represents an ISCSI disk. ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.\n        iscsiPersistentVolumeSource:: {\n          new():: {},\n          // whether support iSCSI Discovery CHAP authentication\n          withChapAuthDiscovery(chapAuthDiscovery):: self + {chapAuthDiscovery: chapAuthDiscovery},\n          // whether support iSCSI Session CHAP authentication\n          withChapAuthSession(chapAuthSession):: self + {chapAuthSession: chapAuthSession},\n          // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi\n          withFsType(fsType):: self + {fsType: fsType},\n          // Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.\n          withInitiatorName(initiatorName):: self + {initiatorName: initiatorName},\n          // Target iSCSI Qualified Name.\n          withIqn(iqn):: self + {iqn: iqn},\n          // iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).\n          withIscsiInterface(iscsiInterface):: self + {iscsiInterface: iscsiInterface},\n          // iSCSI Target Lun number.\n          withLun(lun):: self + {lun: lun},\n          // iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n          withPortals(portals):: self + if std.type(portals) == \"array\" then {portals: portals} else {portals: [portals]},\n          // iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n          withPortalsMixin(portals):: self + if std.type(portals) == \"array\" then {portals+: portals} else {portals+: [portals]},\n          // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n          withTargetPortal(targetPortal):: self + {targetPortal: targetPortal},\n          mixin:: {\n            // CHAP Secret for iSCSI target and initiator authentication\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n            },\n            secretRefType:: hidden.core.v1.secretReference,\n          },\n        },\n        // Represents an ISCSI disk. ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.\n        iscsiVolumeSource:: {\n          new():: {},\n          // whether support iSCSI Discovery CHAP authentication\n          withChapAuthDiscovery(chapAuthDiscovery):: self + {chapAuthDiscovery: chapAuthDiscovery},\n          // whether support iSCSI Session CHAP authentication\n          withChapAuthSession(chapAuthSession):: self + {chapAuthSession: chapAuthSession},\n          // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi\n          withFsType(fsType):: self + {fsType: fsType},\n          // Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.\n          withInitiatorName(initiatorName):: self + {initiatorName: initiatorName},\n          // Target iSCSI Qualified Name.\n          withIqn(iqn):: self + {iqn: iqn},\n          // iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).\n          withIscsiInterface(iscsiInterface):: self + {iscsiInterface: iscsiInterface},\n          // iSCSI Target Lun number.\n          withLun(lun):: self + {lun: lun},\n          // iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n          withPortals(portals):: self + if std.type(portals) == \"array\" then {portals: portals} else {portals: [portals]},\n          // iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n          withPortalsMixin(portals):: self + if std.type(portals) == \"array\" then {portals+: portals} else {portals+: [portals]},\n          // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n          withTargetPortal(targetPortal):: self + {targetPortal: targetPortal},\n          mixin:: {\n            // CHAP Secret for iSCSI target and initiator authentication\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n            },\n            secretRefType:: hidden.core.v1.localObjectReference,\n          },\n        },\n        // Maps a string key to a path within a volume.\n        keyToPath:: {\n          new(key=\"\", path=\"\"):: self.withKey(key).withPath(path),\n          // The key to project.\n          withKey(key):: self + {key: key},\n          // Optional: mode bits to use on this file, must be a value between 0 and 0777. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n          withMode(mode):: self + {mode: mode},\n          // The relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.\n          withPath(path):: self + {path: path},\n          mixin:: {\n          },\n        },\n        // Lifecycle describes actions that the management system should take in response to container lifecycle events. For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.\n        lifecycle:: {\n          new():: {},\n          mixin:: {\n            // PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks\n            postStart:: {\n              local __postStartMixin(postStart) = {postStart+: postStart},\n              mixinInstance(postStart):: __postStartMixin(postStart),\n              // One and only one of the following should be specified. Exec specifies the action to take.\n              exec:: {\n                local __execMixin(exec) = __postStartMixin({exec+: exec}),\n                mixinInstance(exec):: __execMixin(exec),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n              },\n              execType:: hidden.core.v1.execAction,\n              // HTTPGet specifies the http request to perform.\n              httpGet:: {\n                local __httpGetMixin(httpGet) = __postStartMixin({httpGet+: httpGet}),\n                mixinInstance(httpGet):: __httpGetMixin(httpGet),\n                // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n                withHost(host):: self + __httpGetMixin({host: host}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n                httpHeadersType:: hidden.core.v1.httpHeader,\n                // Path to access on the HTTP server.\n                withPath(path):: self + __httpGetMixin({path: path}),\n                // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __httpGetMixin({port: port}),\n                // Scheme to use for connecting to the host. Defaults to HTTP.\n                withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n              },\n              httpGetType:: hidden.core.v1.httpGetAction,\n              // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n              tcpSocket:: {\n                local __tcpSocketMixin(tcpSocket) = __postStartMixin({tcpSocket+: tcpSocket}),\n                mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n                // Optional: Host name to connect to, defaults to the pod IP.\n                withHost(host):: self + __tcpSocketMixin({host: host}),\n                // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __tcpSocketMixin({port: port}),\n              },\n              tcpSocketType:: hidden.core.v1.tcpSocketAction,\n            },\n            postStartType:: hidden.core.v1.handler,\n            // PreStop is called immediately before a container is terminated. The container is terminated after the handler completes. The reason for termination is passed to the handler. Regardless of the outcome of the handler, the container is eventually terminated. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks\n            preStop:: {\n              local __preStopMixin(preStop) = {preStop+: preStop},\n              mixinInstance(preStop):: __preStopMixin(preStop),\n              // One and only one of the following should be specified. Exec specifies the action to take.\n              exec:: {\n                local __execMixin(exec) = __preStopMixin({exec+: exec}),\n                mixinInstance(exec):: __execMixin(exec),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n                // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n                withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n              },\n              execType:: hidden.core.v1.execAction,\n              // HTTPGet specifies the http request to perform.\n              httpGet:: {\n                local __httpGetMixin(httpGet) = __preStopMixin({httpGet+: httpGet}),\n                mixinInstance(httpGet):: __httpGetMixin(httpGet),\n                // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n                withHost(host):: self + __httpGetMixin({host: host}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n                // Custom headers to set in the request. HTTP allows repeated headers.\n                withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n                httpHeadersType:: hidden.core.v1.httpHeader,\n                // Path to access on the HTTP server.\n                withPath(path):: self + __httpGetMixin({path: path}),\n                // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __httpGetMixin({port: port}),\n                // Scheme to use for connecting to the host. Defaults to HTTP.\n                withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n              },\n              httpGetType:: hidden.core.v1.httpGetAction,\n              // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n              tcpSocket:: {\n                local __tcpSocketMixin(tcpSocket) = __preStopMixin({tcpSocket+: tcpSocket}),\n                mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n                // Optional: Host name to connect to, defaults to the pod IP.\n                withHost(host):: self + __tcpSocketMixin({host: host}),\n                // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n                withPort(port):: self + __tcpSocketMixin({port: port}),\n              },\n              tcpSocketType:: hidden.core.v1.tcpSocketAction,\n            },\n            preStopType:: hidden.core.v1.handler,\n          },\n        },\n        // LimitRangeItem defines a min/max usage limit for any resource that matches on kind.\n        limitRangeItem:: {\n          new():: {},\n          // Default resource requirement limit value by resource name if resource limit is omitted.\n          withDefault(default):: self + {default: default},\n          // Default resource requirement limit value by resource name if resource limit is omitted.\n          withDefaultMixin(default):: self + {default+: default},\n          // DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.\n          withDefaultRequest(defaultRequest):: self + {defaultRequest: defaultRequest},\n          // DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.\n          withDefaultRequestMixin(defaultRequest):: self + {defaultRequest+: defaultRequest},\n          // Max usage constraints on this kind by resource name.\n          withMax(max):: self + {max: max},\n          // Max usage constraints on this kind by resource name.\n          withMaxMixin(max):: self + {max+: max},\n          // MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; this represents the max burst for the named resource.\n          withMaxLimitRequestRatio(maxLimitRequestRatio):: self + {maxLimitRequestRatio: maxLimitRequestRatio},\n          // MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; this represents the max burst for the named resource.\n          withMaxLimitRequestRatioMixin(maxLimitRequestRatio):: self + {maxLimitRequestRatio+: maxLimitRequestRatio},\n          // Min usage constraints on this kind by resource name.\n          withMin(min):: self + {min: min},\n          // Min usage constraints on this kind by resource name.\n          withMinMixin(min):: self + {min+: min},\n          // Type of resource that this limit applies to.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // LimitRangeList is a list of LimitRange items.\n        limitRangeList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is a list of LimitRange objects. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of LimitRange objects. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.limitRange,\n          mixin:: {\n          },\n        },\n        // LimitRangeSpec defines a min/max usage limit for resources that match on kind.\n        limitRangeSpec:: {\n          new():: {},\n          // Limits is the list of LimitRangeItem objects that are enforced.\n          withLimits(limits):: self + if std.type(limits) == \"array\" then {limits: limits} else {limits: [limits]},\n          // Limits is the list of LimitRangeItem objects that are enforced.\n          withLimitsMixin(limits):: self + if std.type(limits) == \"array\" then {limits+: limits} else {limits+: [limits]},\n          limitsType:: hidden.core.v1.limitRangeItem,\n          mixin:: {\n          },\n        },\n        // LoadBalancerIngress represents the status of a load-balancer ingress point: traffic intended for the service should be sent to an ingress point.\n        loadBalancerIngress:: {\n          new():: {},\n          // Hostname is set for load-balancer ingress points that are DNS based (typically AWS load-balancers)\n          withHostname(hostname):: self + {hostname: hostname},\n          // IP is set for load-balancer ingress points that are IP based (typically GCE or OpenStack load-balancers)\n          withIp(ip):: self + {ip: ip},\n          mixin:: {\n          },\n        },\n        // LoadBalancerStatus represents the status of a load-balancer.\n        loadBalancerStatus:: {\n          new():: {},\n          // Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points.\n          withIngress(ingress):: self + if std.type(ingress) == \"array\" then {ingress: ingress} else {ingress: [ingress]},\n          // Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points.\n          withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then {ingress+: ingress} else {ingress+: [ingress]},\n          ingressType:: hidden.core.v1.loadBalancerIngress,\n          mixin:: {\n          },\n        },\n        // LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.\n        localObjectReference:: {\n          new():: {},\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // Local represents directly-attached storage with node affinity\n        localVolumeSource:: {\n          new():: {},\n          // The full path to the volume on the node For alpha, this path must be a directory Once block as a source is supported, then this path can point to a block device\n          withPath(path):: self + {path: path},\n          mixin:: {\n          },\n        },\n        // NamespaceList is a list of Namespaces.\n        namespaceList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is the list of Namespace objects in the list. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of Namespace objects in the list. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.namespace,\n          mixin:: {\n          },\n        },\n        // NamespaceSpec describes the attributes on a Namespace.\n        namespaceSpec:: {\n          new():: {},\n          // Finalizers is an opaque list of values that must be empty to permanently remove object from storage. More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/\n          withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then {finalizers: finalizers} else {finalizers: [finalizers]},\n          // Finalizers is an opaque list of values that must be empty to permanently remove object from storage. More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/\n          withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then {finalizers+: finalizers} else {finalizers+: [finalizers]},\n          mixin:: {\n          },\n        },\n        // NamespaceStatus is information about the current status of a Namespace.\n        namespaceStatus:: {\n          new():: {},\n          // Phase is the current lifecycle phase of the namespace. More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/\n          withPhase(phase):: self + {phase: phase},\n          mixin:: {\n          },\n        },\n        // Represents an NFS mount that lasts the lifetime of a pod. NFS volumes do not support ownership management or SELinux relabeling.\n        nfsVolumeSource:: {\n          new():: {},\n          // Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n          withPath(path):: self + {path: path},\n          // ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n          withServer(server):: self + {server: server},\n          mixin:: {\n          },\n        },\n        // NodeAddress contains information for the node's address.\n        nodeAddress:: {\n          new():: {},\n          // The node address.\n          withAddress(address):: self + {address: address},\n          // Node address type, one of Hostname, ExternalIP or InternalIP.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // Node affinity is a group of node affinity scheduling rules.\n        nodeAffinity:: {\n          new():: {},\n          // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n          withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then {preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution} else {preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]},\n          // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n          withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then {preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution} else {preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]},\n          preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n          mixin:: {\n            // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n            requiredDuringSchedulingIgnoredDuringExecution:: {\n              local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = {requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution},\n              mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n              // Required. A list of node selector terms. The terms are ORed.\n              withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n              // Required. A list of node selector terms. The terms are ORed.\n              withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n              nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n            },\n            requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n          },\n        },\n        // NodeCondition contains condition information for a node.\n        nodeCondition:: {\n          new():: {},\n          // Last time we got an update on a given condition.\n          withLastHeartbeatTime(lastHeartbeatTime):: self + {lastHeartbeatTime: lastHeartbeatTime},\n          // Last time the condition transit from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // (brief) reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of node condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // NodeConfigSource specifies a source of node configuration. Exactly one subfield (excluding metadata) must be non-nil.\n        nodeConfigSource:: {\n          new():: {},\n          mixin:: {\n            configMapRef:: {\n              local __configMapRefMixin(configMapRef) = {configMapRef+: configMapRef},\n              mixinInstance(configMapRef):: __configMapRefMixin(configMapRef),\n              // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n              withFieldPath(fieldPath):: self + __configMapRefMixin({fieldPath: fieldPath}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __configMapRefMixin({name: name}),\n              // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n              withNamespace(namespace):: self + __configMapRefMixin({namespace: namespace}),\n              // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n              withResourceVersion(resourceVersion):: self + __configMapRefMixin({resourceVersion: resourceVersion}),\n              // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n              withUid(uid):: self + __configMapRefMixin({uid: uid}),\n            },\n            configMapRefType:: hidden.core.v1.objectReference,\n          },\n        },\n        // NodeDaemonEndpoints lists ports opened by daemons running on the Node.\n        nodeDaemonEndpoints:: {\n          new():: {},\n          mixin:: {\n            // Endpoint on which Kubelet is listening.\n            kubeletEndpoint:: {\n              local __kubeletEndpointMixin(kubeletEndpoint) = {kubeletEndpoint+: kubeletEndpoint},\n              mixinInstance(kubeletEndpoint):: __kubeletEndpointMixin(kubeletEndpoint),\n              // Port number of the given endpoint.\n              withPort(port):: self + __kubeletEndpointMixin({Port: port}),\n            },\n            kubeletEndpointType:: hidden.core.v1.daemonEndpoint,\n          },\n        },\n        // NodeList is the whole list of all Nodes which have been registered with master.\n        nodeList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of nodes\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of nodes\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.node,\n          mixin:: {\n          },\n        },\n        // A node selector represents the union of the results of one or more label queries over a set of nodes; that is, it represents the OR of the selectors represented by the node selector terms.\n        nodeSelector:: {\n          new():: {},\n          // Required. A list of node selector terms. The terms are ORed.\n          withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then {nodeSelectorTerms: nodeSelectorTerms} else {nodeSelectorTerms: [nodeSelectorTerms]},\n          // Required. A list of node selector terms. The terms are ORed.\n          withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then {nodeSelectorTerms+: nodeSelectorTerms} else {nodeSelectorTerms+: [nodeSelectorTerms]},\n          nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n          mixin:: {\n          },\n        },\n        // A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.\n        nodeSelectorRequirement:: {\n          new():: {},\n          // The label key that the selector applies to.\n          withKey(key):: self + {key: key},\n          // Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.\n          withOperator(operator):: self + {operator: operator},\n          // An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.\n          withValues(values):: self + if std.type(values) == \"array\" then {values: values} else {values: [values]},\n          // An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.\n          withValuesMixin(values):: self + if std.type(values) == \"array\" then {values+: values} else {values+: [values]},\n          mixin:: {\n          },\n        },\n        // A null or empty node selector term matches no objects.\n        nodeSelectorTerm:: {\n          new():: {},\n          // Required. A list of node selector requirements. The requirements are ANDed.\n          withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then {matchExpressions: matchExpressions} else {matchExpressions: [matchExpressions]},\n          // Required. A list of node selector requirements. The requirements are ANDed.\n          withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then {matchExpressions+: matchExpressions} else {matchExpressions+: [matchExpressions]},\n          matchExpressionsType:: hidden.core.v1.nodeSelectorRequirement,\n          mixin:: {\n          },\n        },\n        // NodeSpec describes the attributes that a node is created with.\n        nodeSpec:: {\n          new():: {},\n          // External ID of the node assigned by some machine database (e.g. a cloud provider). Deprecated.\n          withExternalId(externalId):: self + {externalID: externalId},\n          // PodCIDR represents the pod IP range assigned to the node.\n          withPodCidr(podCidr):: self + {podCIDR: podCidr},\n          // ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>\n          withProviderId(providerId):: self + {providerID: providerId},\n          // If specified, the node's taints.\n          withTaints(taints):: self + if std.type(taints) == \"array\" then {taints: taints} else {taints: [taints]},\n          // If specified, the node's taints.\n          withTaintsMixin(taints):: self + if std.type(taints) == \"array\" then {taints+: taints} else {taints+: [taints]},\n          taintsType:: hidden.core.v1.taint,\n          // Unschedulable controls node schedulability of new pods. By default, node is schedulable. More info: https://kubernetes.io/docs/concepts/nodes/node/#manual-node-administration\n          withUnschedulable(unschedulable):: self + {unschedulable: unschedulable},\n          mixin:: {\n            // If specified, the source to get node configuration from The DynamicKubeletConfig feature gate must be enabled for the Kubelet to use this field\n            configSource:: {\n              local __configSourceMixin(configSource) = {configSource+: configSource},\n              mixinInstance(configSource):: __configSourceMixin(configSource),\n              configMapRef:: {\n                local __configMapRefMixin(configMapRef) = __configSourceMixin({configMapRef+: configMapRef}),\n                mixinInstance(configMapRef):: __configMapRefMixin(configMapRef),\n                // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n                withFieldPath(fieldPath):: self + __configMapRefMixin({fieldPath: fieldPath}),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __configMapRefMixin({name: name}),\n                // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n                withNamespace(namespace):: self + __configMapRefMixin({namespace: namespace}),\n                // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n                withResourceVersion(resourceVersion):: self + __configMapRefMixin({resourceVersion: resourceVersion}),\n                // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n                withUid(uid):: self + __configMapRefMixin({uid: uid}),\n              },\n              configMapRefType:: hidden.core.v1.objectReference,\n            },\n            configSourceType:: hidden.core.v1.nodeConfigSource,\n          },\n        },\n        // NodeStatus is information about the current status of a node.\n        nodeStatus:: {\n          new():: {},\n          // List of addresses reachable to the node. Queried from cloud provider, if available. More info: https://kubernetes.io/docs/concepts/nodes/node/#addresses\n          withAddresses(addresses):: self + if std.type(addresses) == \"array\" then {addresses: addresses} else {addresses: [addresses]},\n          // List of addresses reachable to the node. Queried from cloud provider, if available. More info: https://kubernetes.io/docs/concepts/nodes/node/#addresses\n          withAddressesMixin(addresses):: self + if std.type(addresses) == \"array\" then {addresses+: addresses} else {addresses+: [addresses]},\n          addressesType:: hidden.core.v1.nodeAddress,\n          // Allocatable represents the resources of a node that are available for scheduling. Defaults to Capacity.\n          withAllocatable(allocatable):: self + {allocatable: allocatable},\n          // Allocatable represents the resources of a node that are available for scheduling. Defaults to Capacity.\n          withAllocatableMixin(allocatable):: self + {allocatable+: allocatable},\n          // Capacity represents the total resources of a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity\n          withCapacity(capacity):: self + {capacity: capacity},\n          // Capacity represents the total resources of a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity\n          withCapacityMixin(capacity):: self + {capacity+: capacity},\n          // Conditions is an array of current observed node conditions. More info: https://kubernetes.io/docs/concepts/nodes/node/#condition\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Conditions is an array of current observed node conditions. More info: https://kubernetes.io/docs/concepts/nodes/node/#condition\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.core.v1.nodeCondition,\n          // List of container images on this node\n          withImages(images):: self + if std.type(images) == \"array\" then {images: images} else {images: [images]},\n          // List of container images on this node\n          withImagesMixin(images):: self + if std.type(images) == \"array\" then {images+: images} else {images+: [images]},\n          imagesType:: hidden.core.v1.containerImage,\n          // NodePhase is the recently observed lifecycle phase of the node. More info: https://kubernetes.io/docs/concepts/nodes/node/#phase The field is never populated, and now is deprecated.\n          withPhase(phase):: self + {phase: phase},\n          // List of volumes that are attached to the node.\n          withVolumesAttached(volumesAttached):: self + if std.type(volumesAttached) == \"array\" then {volumesAttached: volumesAttached} else {volumesAttached: [volumesAttached]},\n          // List of volumes that are attached to the node.\n          withVolumesAttachedMixin(volumesAttached):: self + if std.type(volumesAttached) == \"array\" then {volumesAttached+: volumesAttached} else {volumesAttached+: [volumesAttached]},\n          volumesAttachedType:: hidden.core.v1.attachedVolume,\n          // List of attachable volumes in use (mounted) by the node.\n          withVolumesInUse(volumesInUse):: self + if std.type(volumesInUse) == \"array\" then {volumesInUse: volumesInUse} else {volumesInUse: [volumesInUse]},\n          // List of attachable volumes in use (mounted) by the node.\n          withVolumesInUseMixin(volumesInUse):: self + if std.type(volumesInUse) == \"array\" then {volumesInUse+: volumesInUse} else {volumesInUse+: [volumesInUse]},\n          mixin:: {\n            // Endpoints of daemons running on the Node.\n            daemonEndpoints:: {\n              local __daemonEndpointsMixin(daemonEndpoints) = {daemonEndpoints+: daemonEndpoints},\n              mixinInstance(daemonEndpoints):: __daemonEndpointsMixin(daemonEndpoints),\n              // Endpoint on which Kubelet is listening.\n              kubeletEndpoint:: {\n                local __kubeletEndpointMixin(kubeletEndpoint) = __daemonEndpointsMixin({kubeletEndpoint+: kubeletEndpoint}),\n                mixinInstance(kubeletEndpoint):: __kubeletEndpointMixin(kubeletEndpoint),\n                // Port number of the given endpoint.\n                withPort(port):: self + __kubeletEndpointMixin({Port: port}),\n              },\n              kubeletEndpointType:: hidden.core.v1.daemonEndpoint,\n            },\n            daemonEndpointsType:: hidden.core.v1.nodeDaemonEndpoints,\n            // Set of ids/uuids to uniquely identify the node. More info: https://kubernetes.io/docs/concepts/nodes/node/#info\n            nodeInfo:: {\n              local __nodeInfoMixin(nodeInfo) = {nodeInfo+: nodeInfo},\n              mixinInstance(nodeInfo):: __nodeInfoMixin(nodeInfo),\n              // The Architecture reported by the node\n              withArchitecture(architecture):: self + __nodeInfoMixin({architecture: architecture}),\n              // Boot ID reported by the node.\n              withBootId(bootId):: self + __nodeInfoMixin({bootID: bootId}),\n              // ContainerRuntime Version reported by the node through runtime remote API (e.g. docker://1.5.0).\n              withContainerRuntimeVersion(containerRuntimeVersion):: self + __nodeInfoMixin({containerRuntimeVersion: containerRuntimeVersion}),\n              // Kernel Version reported by the node from 'uname -r' (e.g. 3.16.0-0.bpo.4-amd64).\n              withKernelVersion(kernelVersion):: self + __nodeInfoMixin({kernelVersion: kernelVersion}),\n              // KubeProxy Version reported by the node.\n              withKubeProxyVersion(kubeProxyVersion):: self + __nodeInfoMixin({kubeProxyVersion: kubeProxyVersion}),\n              // Kubelet Version reported by the node.\n              withKubeletVersion(kubeletVersion):: self + __nodeInfoMixin({kubeletVersion: kubeletVersion}),\n              // MachineID reported by the node. For unique machine identification in the cluster this field is preferred. Learn more from man(5) machine-id: http://man7.org/linux/man-pages/man5/machine-id.5.html\n              withMachineId(machineId):: self + __nodeInfoMixin({machineID: machineId}),\n              // The Operating System reported by the node\n              withOperatingSystem(operatingSystem):: self + __nodeInfoMixin({operatingSystem: operatingSystem}),\n              // OS Image reported by the node from /etc/os-release (e.g. Debian GNU/Linux 7 (wheezy)).\n              withOsImage(osImage):: self + __nodeInfoMixin({osImage: osImage}),\n              // SystemUUID reported by the node. For unique machine identification MachineID is preferred. This field is specific to Red Hat hosts https://access.redhat.com/documentation/en-US/Red_Hat_Subscription_Management/1/html/RHSM/getting-system-uuid.html\n              withSystemUuid(systemUuid):: self + __nodeInfoMixin({systemUUID: systemUuid}),\n            },\n            nodeInfoType:: hidden.core.v1.nodeSystemInfo,\n          },\n        },\n        // NodeSystemInfo is a set of ids/uuids to uniquely identify the node.\n        nodeSystemInfo:: {\n          new():: {},\n          // The Architecture reported by the node\n          withArchitecture(architecture):: self + {architecture: architecture},\n          // Boot ID reported by the node.\n          withBootId(bootId):: self + {bootID: bootId},\n          // ContainerRuntime Version reported by the node through runtime remote API (e.g. docker://1.5.0).\n          withContainerRuntimeVersion(containerRuntimeVersion):: self + {containerRuntimeVersion: containerRuntimeVersion},\n          // Kernel Version reported by the node from 'uname -r' (e.g. 3.16.0-0.bpo.4-amd64).\n          withKernelVersion(kernelVersion):: self + {kernelVersion: kernelVersion},\n          // KubeProxy Version reported by the node.\n          withKubeProxyVersion(kubeProxyVersion):: self + {kubeProxyVersion: kubeProxyVersion},\n          // Kubelet Version reported by the node.\n          withKubeletVersion(kubeletVersion):: self + {kubeletVersion: kubeletVersion},\n          // MachineID reported by the node. For unique machine identification in the cluster this field is preferred. Learn more from man(5) machine-id: http://man7.org/linux/man-pages/man5/machine-id.5.html\n          withMachineId(machineId):: self + {machineID: machineId},\n          // The Operating System reported by the node\n          withOperatingSystem(operatingSystem):: self + {operatingSystem: operatingSystem},\n          // OS Image reported by the node from /etc/os-release (e.g. Debian GNU/Linux 7 (wheezy)).\n          withOsImage(osImage):: self + {osImage: osImage},\n          // SystemUUID reported by the node. For unique machine identification MachineID is preferred. This field is specific to Red Hat hosts https://access.redhat.com/documentation/en-US/Red_Hat_Subscription_Management/1/html/RHSM/getting-system-uuid.html\n          withSystemUuid(systemUuid):: self + {systemUUID: systemUuid},\n          mixin:: {\n          },\n        },\n        // ObjectFieldSelector selects an APIVersioned field of an object.\n        objectFieldSelector:: {\n          new():: {},\n          // Path of the field to select in the specified API version.\n          withFieldPath(fieldPath):: self + {fieldPath: fieldPath},\n          mixin:: {\n          },\n        },\n        // ObjectReference contains enough information to let you inspect or modify the referred object.\n        objectReference:: {\n          new():: {},\n          // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n          withFieldPath(fieldPath):: self + {fieldPath: fieldPath},\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n          withNamespace(namespace):: self + {namespace: namespace},\n          // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n          withResourceVersion(resourceVersion):: self + {resourceVersion: resourceVersion},\n          // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n          withUid(uid):: self + {uid: uid},\n          mixin:: {\n          },\n        },\n        // PersistentVolumeClaimCondition contails details about state of pvc\n        persistentVolumeClaimCondition:: {\n          new():: {},\n          // Last time we probed the condition.\n          withLastProbeTime(lastProbeTime):: self + {lastProbeTime: lastProbeTime},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human-readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // Unique, this should be a short, machine understandable string that gives the reason for condition's last transition. If it reports \"ResizeStarted\" that means the underlying persistent volume is being resized.\n          withReason(reason):: self + {reason: reason},\n          withStatus(status):: self + {status: status},\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // PersistentVolumeClaimList is a list of PersistentVolumeClaim items.\n        persistentVolumeClaimList:: {\n          new(items=\"\"):: self.withItems(items),\n          // A list of persistent volume claims. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // A list of persistent volume claims. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.persistentVolumeClaim,\n          mixin:: {\n          },\n        },\n        // PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes\n        persistentVolumeClaimSpec:: {\n          new():: {},\n          // AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1\n          withAccessModes(accessModes):: self + if std.type(accessModes) == \"array\" then {accessModes: accessModes} else {accessModes: [accessModes]},\n          // AccessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1\n          withAccessModesMixin(accessModes):: self + if std.type(accessModes) == \"array\" then {accessModes+: accessModes} else {accessModes+: [accessModes]},\n          // Name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1\n          withStorageClassName(storageClassName):: self + {storageClassName: storageClassName},\n          // volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec. This is an alpha feature and may change in the future.\n          withVolumeMode(volumeMode):: self + {volumeMode: volumeMode},\n          // VolumeName is the binding reference to the PersistentVolume backing this claim.\n          withVolumeName(volumeName):: self + {volumeName: volumeName},\n          mixin:: {\n            // Resources represents the minimum resources the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources\n            resources:: {\n              local __resourcesMixin(resources) = {resources+: resources},\n              mixinInstance(resources):: __resourcesMixin(resources),\n              // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withLimits(limits):: self + __resourcesMixin({limits: limits}),\n              // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withLimitsMixin(limits):: self + __resourcesMixin({limits+: limits}),\n              // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withRequests(requests):: self + __resourcesMixin({requests: requests}),\n              // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n              withRequestsMixin(requests):: self + __resourcesMixin({requests+: requests}),\n            },\n            resourcesType:: hidden.core.v1.resourceRequirements,\n            // A label query over volumes to consider for binding.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // PersistentVolumeClaimStatus is the current status of a persistent volume claim.\n        persistentVolumeClaimStatus:: {\n          new():: {},\n          // AccessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1\n          withAccessModes(accessModes):: self + if std.type(accessModes) == \"array\" then {accessModes: accessModes} else {accessModes: [accessModes]},\n          // AccessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1\n          withAccessModesMixin(accessModes):: self + if std.type(accessModes) == \"array\" then {accessModes+: accessModes} else {accessModes+: [accessModes]},\n          // Represents the actual resources of the underlying volume.\n          withCapacity(capacity):: self + {capacity: capacity},\n          // Represents the actual resources of the underlying volume.\n          withCapacityMixin(capacity):: self + {capacity+: capacity},\n          // Current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.core.v1.persistentVolumeClaimCondition,\n          // Phase represents the current phase of PersistentVolumeClaim.\n          withPhase(phase):: self + {phase: phase},\n          mixin:: {\n          },\n        },\n        // PersistentVolumeClaimVolumeSource references the user's PVC in the same namespace. This volume finds the bound PV and mounts that volume for the pod. A PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another type of volume that is owned by someone else (the system).\n        persistentVolumeClaimVolumeSource:: {\n          new():: {},\n          // ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims\n          withClaimName(claimName):: self + {claimName: claimName},\n          // Will force the ReadOnly setting in VolumeMounts. Default false.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          mixin:: {\n          },\n        },\n        // PersistentVolumeList is a list of PersistentVolume items.\n        persistentVolumeList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of persistent volumes. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of persistent volumes. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.persistentVolume,\n          mixin:: {\n          },\n        },\n        // PersistentVolumeSpec is the specification of a persistent volume.\n        persistentVolumeSpec:: {\n          new():: {},\n          // AccessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes\n          withAccessModes(accessModes):: self + if std.type(accessModes) == \"array\" then {accessModes: accessModes} else {accessModes: [accessModes]},\n          // AccessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes\n          withAccessModesMixin(accessModes):: self + if std.type(accessModes) == \"array\" then {accessModes+: accessModes} else {accessModes+: [accessModes]},\n          // A description of the persistent volume's resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity\n          withCapacity(capacity):: self + {capacity: capacity},\n          // A description of the persistent volume's resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity\n          withCapacityMixin(capacity):: self + {capacity+: capacity},\n          // A list of mount options, e.g. [\"ro\", \"soft\"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options\n          withMountOptions(mountOptions):: self + if std.type(mountOptions) == \"array\" then {mountOptions: mountOptions} else {mountOptions: [mountOptions]},\n          // A list of mount options, e.g. [\"ro\", \"soft\"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options\n          withMountOptionsMixin(mountOptions):: self + if std.type(mountOptions) == \"array\" then {mountOptions+: mountOptions} else {mountOptions+: [mountOptions]},\n          // What happens to a persistent volume when released from its claim. Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming\n          withPersistentVolumeReclaimPolicy(persistentVolumeReclaimPolicy):: self + {persistentVolumeReclaimPolicy: persistentVolumeReclaimPolicy},\n          // Name of StorageClass to which this persistent volume belongs. Empty value means that this volume does not belong to any StorageClass.\n          withStorageClassName(storageClassName):: self + {storageClassName: storageClassName},\n          // volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. Value of Filesystem is implied when not included in spec. This is an alpha feature and may change in the future.\n          withVolumeMode(volumeMode):: self + {volumeMode: volumeMode},\n          mixin:: {\n            // AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n            awsElasticBlockStore:: {\n              local __awsElasticBlockStoreMixin(awsElasticBlockStore) = {awsElasticBlockStore+: awsElasticBlockStore},\n              mixinInstance(awsElasticBlockStore):: __awsElasticBlockStoreMixin(awsElasticBlockStore),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withFsType(fsType):: self + __awsElasticBlockStoreMixin({fsType: fsType}),\n              // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty).\n              withPartition(partition):: self + __awsElasticBlockStoreMixin({partition: partition}),\n              // Specify \"true\" to force and set the ReadOnly property in VolumeMounts to \"true\". If omitted, the default is \"false\". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withReadOnly(readOnly):: self + __awsElasticBlockStoreMixin({readOnly: readOnly}),\n              // Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withVolumeId(volumeId):: self + __awsElasticBlockStoreMixin({volumeID: volumeId}),\n            },\n            awsElasticBlockStoreType:: hidden.core.v1.awsElasticBlockStoreVolumeSource,\n            // AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.\n            azureDisk:: {\n              local __azureDiskMixin(azureDisk) = {azureDisk+: azureDisk},\n              mixinInstance(azureDisk):: __azureDiskMixin(azureDisk),\n              // Host Caching mode: None, Read Only, Read Write.\n              withCachingMode(cachingMode):: self + __azureDiskMixin({cachingMode: cachingMode}),\n              // The Name of the data disk in the blob storage\n              withDiskName(diskName):: self + __azureDiskMixin({diskName: diskName}),\n              // The URI the data disk in the blob storage\n              withDiskUri(diskUri):: self + __azureDiskMixin({diskURI: diskUri}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __azureDiskMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __azureDiskMixin({readOnly: readOnly}),\n            },\n            azureDiskType:: hidden.core.v1.azureDiskVolumeSource,\n            // AzureFile represents an Azure File Service mount on the host and bind mount to the pod.\n            azureFile:: {\n              local __azureFileMixin(azureFile) = {azureFile+: azureFile},\n              mixinInstance(azureFile):: __azureFileMixin(azureFile),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __azureFileMixin({readOnly: readOnly}),\n              // the name of secret that contains Azure Storage Account Name and Key\n              withSecretName(secretName):: self + __azureFileMixin({secretName: secretName}),\n              // the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod\n              withSecretNamespace(secretNamespace):: self + __azureFileMixin({secretNamespace: secretNamespace}),\n              // Share Name\n              withShareName(shareName):: self + __azureFileMixin({shareName: shareName}),\n            },\n            azureFileType:: hidden.core.v1.azureFilePersistentVolumeSource,\n            // CephFS represents a Ceph FS mount on the host that shares a pod's lifetime\n            cephfs:: {\n              local __cephfsMixin(cephfs) = {cephfs+: cephfs},\n              mixinInstance(cephfs):: __cephfsMixin(cephfs),\n              // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withMonitors(monitors):: self + if std.type(monitors) == \"array\" then __cephfsMixin({monitors: monitors}) else __cephfsMixin({monitors: [monitors]}),\n              // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then __cephfsMixin({monitors+: monitors}) else __cephfsMixin({monitors+: [monitors]}),\n              // Optional: Used as the mounted root, rather than the full Ceph tree, default is /\n              withPath(path):: self + __cephfsMixin({path: path}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withReadOnly(readOnly):: self + __cephfsMixin({readOnly: readOnly}),\n              // Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withSecretFile(secretFile):: self + __cephfsMixin({secretFile: secretFile}),\n              // Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __cephfsMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withUser(user):: self + __cephfsMixin({user: user}),\n            },\n            cephfsType:: hidden.core.v1.cephFsPersistentVolumeSource,\n            // Cinder represents a cinder volume attached and mounted on kubelets host machine More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n            cinder:: {\n              local __cinderMixin(cinder) = {cinder+: cinder},\n              mixinInstance(cinder):: __cinderMixin(cinder),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withFsType(fsType):: self + __cinderMixin({fsType: fsType}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withReadOnly(readOnly):: self + __cinderMixin({readOnly: readOnly}),\n              // volume id used to identify the volume in cinder More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withVolumeId(volumeId):: self + __cinderMixin({volumeID: volumeId}),\n            },\n            cinderType:: hidden.core.v1.cinderVolumeSource,\n            // ClaimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. Expected to be non-nil when bound. claim.VolumeName is the authoritative bind between PV and PVC. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding\n            claimRef:: {\n              local __claimRefMixin(claimRef) = {claimRef+: claimRef},\n              mixinInstance(claimRef):: __claimRefMixin(claimRef),\n              // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n              withFieldPath(fieldPath):: self + __claimRefMixin({fieldPath: fieldPath}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __claimRefMixin({name: name}),\n              // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n              withNamespace(namespace):: self + __claimRefMixin({namespace: namespace}),\n              // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n              withResourceVersion(resourceVersion):: self + __claimRefMixin({resourceVersion: resourceVersion}),\n              // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n              withUid(uid):: self + __claimRefMixin({uid: uid}),\n            },\n            claimRefType:: hidden.core.v1.objectReference,\n            // CSI represents storage that handled by an external CSI driver (Beta feature).\n            csi:: {\n              local __csiMixin(csi) = {csi+: csi},\n              mixinInstance(csi):: __csiMixin(csi),\n              // ControllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n              controllerPublishSecretRef:: {\n                local __controllerPublishSecretRefMixin(controllerPublishSecretRef) = __csiMixin({controllerPublishSecretRef+: controllerPublishSecretRef}),\n                mixinInstance(controllerPublishSecretRef):: __controllerPublishSecretRefMixin(controllerPublishSecretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __controllerPublishSecretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __controllerPublishSecretRefMixin({namespace: namespace}),\n              },\n              controllerPublishSecretRefType:: hidden.core.v1.secretReference,\n              // Driver is the name of the driver to use for this volume. Required.\n              withDriver(driver):: self + __csiMixin({driver: driver}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __csiMixin({fsType: fsType}),\n              // NodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n              nodePublishSecretRef:: {\n                local __nodePublishSecretRefMixin(nodePublishSecretRef) = __csiMixin({nodePublishSecretRef+: nodePublishSecretRef}),\n                mixinInstance(nodePublishSecretRef):: __nodePublishSecretRefMixin(nodePublishSecretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __nodePublishSecretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __nodePublishSecretRefMixin({namespace: namespace}),\n              },\n              nodePublishSecretRefType:: hidden.core.v1.secretReference,\n              // NodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.\n              nodeStageSecretRef:: {\n                local __nodeStageSecretRefMixin(nodeStageSecretRef) = __csiMixin({nodeStageSecretRef+: nodeStageSecretRef}),\n                mixinInstance(nodeStageSecretRef):: __nodeStageSecretRefMixin(nodeStageSecretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __nodeStageSecretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __nodeStageSecretRefMixin({namespace: namespace}),\n              },\n              nodeStageSecretRefType:: hidden.core.v1.secretReference,\n              // Optional: The value to pass to ControllerPublishVolumeRequest. Defaults to false (read/write).\n              withReadOnly(readOnly):: self + __csiMixin({readOnly: readOnly}),\n              // Attributes of the volume to publish.\n              withVolumeAttributes(volumeAttributes):: self + __csiMixin({volumeAttributes: volumeAttributes}),\n              // Attributes of the volume to publish.\n              withVolumeAttributesMixin(volumeAttributes):: self + __csiMixin({volumeAttributes+: volumeAttributes}),\n              // VolumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. Required.\n              withVolumeHandle(volumeHandle):: self + __csiMixin({volumeHandle: volumeHandle}),\n            },\n            csiType:: hidden.core.v1.csiPersistentVolumeSource,\n            // FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.\n            fc:: {\n              local __fcMixin(fc) = {fc+: fc},\n              mixinInstance(fc):: __fcMixin(fc),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __fcMixin({fsType: fsType}),\n              // Optional: FC target lun number\n              withLun(lun):: self + __fcMixin({lun: lun}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __fcMixin({readOnly: readOnly}),\n              // Optional: FC target worldwide names (WWNs)\n              withTargetWwns(targetWwns):: self + if std.type(targetWwns) == \"array\" then __fcMixin({targetWWNs: targetWwns}) else __fcMixin({targetWWNs: [targetWwns]}),\n              // Optional: FC target worldwide names (WWNs)\n              withTargetWwnsMixin(targetWwns):: self + if std.type(targetWwns) == \"array\" then __fcMixin({targetWWNs+: targetWwns}) else __fcMixin({targetWWNs+: [targetWwns]}),\n              // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n              withWwids(wwids):: self + if std.type(wwids) == \"array\" then __fcMixin({wwids: wwids}) else __fcMixin({wwids: [wwids]}),\n              // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n              withWwidsMixin(wwids):: self + if std.type(wwids) == \"array\" then __fcMixin({wwids+: wwids}) else __fcMixin({wwids+: [wwids]}),\n            },\n            fcType:: hidden.core.v1.fcVolumeSource,\n            // FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.\n            flexVolume:: {\n              local __flexVolumeMixin(flexVolume) = {flexVolume+: flexVolume},\n              mixinInstance(flexVolume):: __flexVolumeMixin(flexVolume),\n              // Driver is the name of the driver to use for this volume.\n              withDriver(driver):: self + __flexVolumeMixin({driver: driver}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". The default filesystem depends on FlexVolume script.\n              withFsType(fsType):: self + __flexVolumeMixin({fsType: fsType}),\n              // Optional: Extra command options if any.\n              withOptions(options):: self + __flexVolumeMixin({options: options}),\n              // Optional: Extra command options if any.\n              withOptionsMixin(options):: self + __flexVolumeMixin({options+: options}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __flexVolumeMixin({readOnly: readOnly}),\n              // Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __flexVolumeMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n            },\n            flexVolumeType:: hidden.core.v1.flexPersistentVolumeSource,\n            // Flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage. This depends on the Flocker control service being running\n            flocker:: {\n              local __flockerMixin(flocker) = {flocker+: flocker},\n              mixinInstance(flocker):: __flockerMixin(flocker),\n              // Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated\n              withDatasetName(datasetName):: self + __flockerMixin({datasetName: datasetName}),\n              // UUID of the dataset. This is unique identifier of a Flocker dataset\n              withDatasetUuid(datasetUuid):: self + __flockerMixin({datasetUUID: datasetUuid}),\n            },\n            flockerType:: hidden.core.v1.flockerVolumeSource,\n            // GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n            gcePersistentDisk:: {\n              local __gcePersistentDiskMixin(gcePersistentDisk) = {gcePersistentDisk+: gcePersistentDisk},\n              mixinInstance(gcePersistentDisk):: __gcePersistentDiskMixin(gcePersistentDisk),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withFsType(fsType):: self + __gcePersistentDiskMixin({fsType: fsType}),\n              // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withPartition(partition):: self + __gcePersistentDiskMixin({partition: partition}),\n              // Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withPdName(pdName):: self + __gcePersistentDiskMixin({pdName: pdName}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withReadOnly(readOnly):: self + __gcePersistentDiskMixin({readOnly: readOnly}),\n            },\n            gcePersistentDiskType:: hidden.core.v1.gcePersistentDiskVolumeSource,\n            // Glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod. Provisioned by an admin. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md\n            glusterfs:: {\n              local __glusterfsMixin(glusterfs) = {glusterfs+: glusterfs},\n              mixinInstance(glusterfs):: __glusterfsMixin(glusterfs),\n              // EndpointsName is the endpoint name that details Glusterfs topology. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withEndpoints(endpoints):: self + __glusterfsMixin({endpoints: endpoints}),\n              // Path is the Glusterfs volume path. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withPath(path):: self + __glusterfsMixin({path: path}),\n              // ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withReadOnly(readOnly):: self + __glusterfsMixin({readOnly: readOnly}),\n            },\n            glusterfsType:: hidden.core.v1.glusterfsVolumeSource,\n            // HostPath represents a directory on the host. Provisioned by a developer or tester. This is useful for single-node development and testing only! On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n            hostPath:: {\n              local __hostPathMixin(hostPath) = {hostPath+: hostPath},\n              mixinInstance(hostPath):: __hostPathMixin(hostPath),\n              // Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n              withPath(path):: self + __hostPathMixin({path: path}),\n              // Type for HostPath Volume Defaults to \"\" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n              withType(type):: self + __hostPathMixin({type: type}),\n            },\n            hostPathType:: hidden.core.v1.hostPathVolumeSource,\n            // ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. Provisioned by an admin.\n            iscsi:: {\n              local __iscsiMixin(iscsi) = {iscsi+: iscsi},\n              mixinInstance(iscsi):: __iscsiMixin(iscsi),\n              // whether support iSCSI Discovery CHAP authentication\n              withChapAuthDiscovery(chapAuthDiscovery):: self + __iscsiMixin({chapAuthDiscovery: chapAuthDiscovery}),\n              // whether support iSCSI Session CHAP authentication\n              withChapAuthSession(chapAuthSession):: self + __iscsiMixin({chapAuthSession: chapAuthSession}),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi\n              withFsType(fsType):: self + __iscsiMixin({fsType: fsType}),\n              // Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.\n              withInitiatorName(initiatorName):: self + __iscsiMixin({initiatorName: initiatorName}),\n              // Target iSCSI Qualified Name.\n              withIqn(iqn):: self + __iscsiMixin({iqn: iqn}),\n              // iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).\n              withIscsiInterface(iscsiInterface):: self + __iscsiMixin({iscsiInterface: iscsiInterface}),\n              // iSCSI Target Lun number.\n              withLun(lun):: self + __iscsiMixin({lun: lun}),\n              // iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withPortals(portals):: self + if std.type(portals) == \"array\" then __iscsiMixin({portals: portals}) else __iscsiMixin({portals: [portals]}),\n              // iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withPortalsMixin(portals):: self + if std.type(portals) == \"array\" then __iscsiMixin({portals+: portals}) else __iscsiMixin({portals+: [portals]}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.\n              withReadOnly(readOnly):: self + __iscsiMixin({readOnly: readOnly}),\n              // CHAP Secret for iSCSI target and initiator authentication\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __iscsiMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withTargetPortal(targetPortal):: self + __iscsiMixin({targetPortal: targetPortal}),\n            },\n            iscsiType:: hidden.core.v1.iscsiPersistentVolumeSource,\n            // Local represents directly-attached storage with node affinity\n            localStorage:: {\n              local __localStorageMixin(localStorage) = {localStorage+: localStorage},\n              mixinInstance(localStorage):: __localStorageMixin(localStorage),\n              // The full path to the volume on the node For alpha, this path must be a directory Once block as a source is supported, then this path can point to a block device\n              withPath(path):: self + __localStorageMixin({path: path}),\n            },\n            localType:: hidden.core.v1.localVolumeSource,\n            // NFS represents an NFS mount on the host. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n            nfs:: {\n              local __nfsMixin(nfs) = {nfs+: nfs},\n              mixinInstance(nfs):: __nfsMixin(nfs),\n              // Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withPath(path):: self + __nfsMixin({path: path}),\n              // ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withReadOnly(readOnly):: self + __nfsMixin({readOnly: readOnly}),\n              // Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withServer(server):: self + __nfsMixin({server: server}),\n            },\n            nfsType:: hidden.core.v1.nfsVolumeSource,\n            // NodeAffinity defines constraints that limit what nodes this volume can be accessed from. This field influences the scheduling of pods that use this volume.\n            nodeAffinity:: {\n              local __nodeAffinityMixin(nodeAffinity) = {nodeAffinity+: nodeAffinity},\n              mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n              // Required specifies hard node constraints that must be met.\n              required:: {\n                local __requiredMixin(required) = __nodeAffinityMixin({required+: required}),\n                mixinInstance(required):: __requiredMixin(required),\n                // Required. A list of node selector terms. The terms are ORed.\n                withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                // Required. A list of node selector terms. The terms are ORed.\n                withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n              },\n              requiredType:: hidden.core.v1.nodeSelector,\n            },\n            nodeAffinityType:: hidden.core.v1.volumeNodeAffinity,\n            // PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine\n            photonPersistentDisk:: {\n              local __photonPersistentDiskMixin(photonPersistentDisk) = {photonPersistentDisk+: photonPersistentDisk},\n              mixinInstance(photonPersistentDisk):: __photonPersistentDiskMixin(photonPersistentDisk),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __photonPersistentDiskMixin({fsType: fsType}),\n              // ID that identifies Photon Controller persistent disk\n              withPdId(pdId):: self + __photonPersistentDiskMixin({pdID: pdId}),\n            },\n            photonPersistentDiskType:: hidden.core.v1.photonPersistentDiskVolumeSource,\n            // PortworxVolume represents a portworx volume attached and mounted on kubelets host machine\n            portworxVolume:: {\n              local __portworxVolumeMixin(portworxVolume) = {portworxVolume+: portworxVolume},\n              mixinInstance(portworxVolume):: __portworxVolumeMixin(portworxVolume),\n              // FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __portworxVolumeMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __portworxVolumeMixin({readOnly: readOnly}),\n              // VolumeID uniquely identifies a Portworx volume\n              withVolumeId(volumeId):: self + __portworxVolumeMixin({volumeID: volumeId}),\n            },\n            portworxVolumeType:: hidden.core.v1.portworxVolumeSource,\n            // Quobyte represents a Quobyte mount on the host that shares a pod's lifetime\n            quobyte:: {\n              local __quobyteMixin(quobyte) = {quobyte+: quobyte},\n              mixinInstance(quobyte):: __quobyteMixin(quobyte),\n              // Group to map volume access to Default is no group\n              withGroup(group):: self + __quobyteMixin({group: group}),\n              // ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.\n              withReadOnly(readOnly):: self + __quobyteMixin({readOnly: readOnly}),\n              // Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes\n              withRegistry(registry):: self + __quobyteMixin({registry: registry}),\n              // User to map volume access to Defaults to serivceaccount user\n              withUser(user):: self + __quobyteMixin({user: user}),\n              // Volume is a string that references an already created Quobyte volume by name.\n              withVolume(volume):: self + __quobyteMixin({volume: volume}),\n            },\n            quobyteType:: hidden.core.v1.quobyteVolumeSource,\n            // RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md\n            rbd:: {\n              local __rbdMixin(rbd) = {rbd+: rbd},\n              mixinInstance(rbd):: __rbdMixin(rbd),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd\n              withFsType(fsType):: self + __rbdMixin({fsType: fsType}),\n              // The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withImage(image):: self + __rbdMixin({image: image}),\n              // Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withKeyring(keyring):: self + __rbdMixin({keyring: keyring}),\n              // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withMonitors(monitors):: self + if std.type(monitors) == \"array\" then __rbdMixin({monitors: monitors}) else __rbdMixin({monitors: [monitors]}),\n              // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then __rbdMixin({monitors+: monitors}) else __rbdMixin({monitors+: [monitors]}),\n              // The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withPool(pool):: self + __rbdMixin({pool: pool}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withReadOnly(readOnly):: self + __rbdMixin({readOnly: readOnly}),\n              // SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __rbdMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withUser(user):: self + __rbdMixin({user: user}),\n            },\n            rbdType:: hidden.core.v1.rbdPersistentVolumeSource,\n            // ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.\n            scaleIo:: {\n              local __scaleIoMixin(scaleIo) = {scaleIo+: scaleIo},\n              mixinInstance(scaleIo):: __scaleIoMixin(scaleIo),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __scaleIoMixin({fsType: fsType}),\n              // The host address of the ScaleIO API Gateway.\n              withGateway(gateway):: self + __scaleIoMixin({gateway: gateway}),\n              // The name of the ScaleIO Protection Domain for the configured storage.\n              withProtectionDomain(protectionDomain):: self + __scaleIoMixin({protectionDomain: protectionDomain}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __scaleIoMixin({readOnly: readOnly}),\n              // SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __scaleIoMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name is unique within a namespace to reference a secret resource.\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace defines the space within which the secret name must be unique.\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              },\n              secretRefType:: hidden.core.v1.secretReference,\n              // Flag to enable/disable SSL communication with Gateway, default false\n              withSslEnabled(sslEnabled):: self + __scaleIoMixin({sslEnabled: sslEnabled}),\n              // Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.\n              withStorageMode(storageMode):: self + __scaleIoMixin({storageMode: storageMode}),\n              // The ScaleIO Storage Pool associated with the protection domain.\n              withStoragePool(storagePool):: self + __scaleIoMixin({storagePool: storagePool}),\n              // The name of the storage system as configured in ScaleIO.\n              withSystem(system):: self + __scaleIoMixin({system: system}),\n              // The name of a volume already created in the ScaleIO system that is associated with this volume source.\n              withVolumeName(volumeName):: self + __scaleIoMixin({volumeName: volumeName}),\n            },\n            scaleIOType:: hidden.core.v1.scaleIoPersistentVolumeSource,\n            // StorageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://releases.k8s.io/HEAD/examples/volumes/storageos/README.md\n            storageos:: {\n              local __storageosMixin(storageos) = {storageos+: storageos},\n              mixinInstance(storageos):: __storageosMixin(storageos),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __storageosMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __storageosMixin({readOnly: readOnly}),\n              // SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __storageosMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n                withFieldPath(fieldPath):: self + __secretRefMixin({fieldPath: fieldPath}),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n                // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n                withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n                // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n                withResourceVersion(resourceVersion):: self + __secretRefMixin({resourceVersion: resourceVersion}),\n                // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n                withUid(uid):: self + __secretRefMixin({uid: uid}),\n              },\n              secretRefType:: hidden.core.v1.objectReference,\n              // VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.\n              withVolumeName(volumeName):: self + __storageosMixin({volumeName: volumeName}),\n              // VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to \"default\" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.\n              withVolumeNamespace(volumeNamespace):: self + __storageosMixin({volumeNamespace: volumeNamespace}),\n            },\n            storageosType:: hidden.core.v1.storageOsPersistentVolumeSource,\n            // VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine\n            vsphereVolume:: {\n              local __vsphereVolumeMixin(vsphereVolume) = {vsphereVolume+: vsphereVolume},\n              mixinInstance(vsphereVolume):: __vsphereVolumeMixin(vsphereVolume),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __vsphereVolumeMixin({fsType: fsType}),\n              // Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.\n              withStoragePolicyId(storagePolicyId):: self + __vsphereVolumeMixin({storagePolicyID: storagePolicyId}),\n              // Storage Policy Based Management (SPBM) profile name.\n              withStoragePolicyName(storagePolicyName):: self + __vsphereVolumeMixin({storagePolicyName: storagePolicyName}),\n              // Path that identifies vSphere volume vmdk\n              withVolumePath(volumePath):: self + __vsphereVolumeMixin({volumePath: volumePath}),\n            },\n            vsphereVolumeType:: hidden.core.v1.vsphereVirtualDiskVolumeSource,\n          },\n        },\n        // PersistentVolumeStatus is the current status of a persistent volume.\n        persistentVolumeStatus:: {\n          new():: {},\n          // A human-readable message indicating details about why the volume is in this state.\n          withMessage(message):: self + {message: message},\n          // Phase indicates if a volume is available, bound to a claim, or released by a claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#phase\n          withPhase(phase):: self + {phase: phase},\n          // Reason is a brief CamelCase string that describes any failure and is meant for machine parsing and tidy display in the CLI.\n          withReason(reason):: self + {reason: reason},\n          mixin:: {\n          },\n        },\n        // Represents a Photon Controller persistent disk resource.\n        photonPersistentDiskVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // ID that identifies Photon Controller persistent disk\n          withPdId(pdId):: self + {pdID: pdId},\n          mixin:: {\n          },\n        },\n        // Pod affinity is a group of inter pod affinity scheduling rules.\n        podAffinity:: {\n          new():: {},\n          // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n          withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then {preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution} else {preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]},\n          // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n          withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then {preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution} else {preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]},\n          preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n          // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n          withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then {requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution} else {requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]},\n          // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n          withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then {requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution} else {requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]},\n          requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n          mixin:: {\n          },\n        },\n        // Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running\n        podAffinityTerm:: {\n          new():: {},\n          // namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means \"this pod's namespace\"\n          withNamespaces(namespaces):: self + if std.type(namespaces) == \"array\" then {namespaces: namespaces} else {namespaces: [namespaces]},\n          // namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means \"this pod's namespace\"\n          withNamespacesMixin(namespaces):: self + if std.type(namespaces) == \"array\" then {namespaces+: namespaces} else {namespaces+: [namespaces]},\n          // This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.\n          withTopologyKey(topologyKey):: self + {topologyKey: topologyKey},\n          mixin:: {\n            // A label query over a set of resources, in this case pods.\n            labelSelector:: {\n              local __labelSelectorMixin(labelSelector) = {labelSelector+: labelSelector},\n              mixinInstance(labelSelector):: __labelSelectorMixin(labelSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __labelSelectorMixin({matchExpressions: matchExpressions}) else __labelSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __labelSelectorMixin({matchExpressions+: matchExpressions}) else __labelSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __labelSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __labelSelectorMixin({matchLabels+: matchLabels}),\n            },\n            labelSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // Pod anti affinity is a group of inter pod anti affinity scheduling rules.\n        podAntiAffinity:: {\n          new():: {},\n          // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n          withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then {preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution} else {preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]},\n          // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n          withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then {preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution} else {preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]},\n          preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n          // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n          withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then {requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution} else {requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]},\n          // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n          withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then {requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution} else {requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]},\n          requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n          mixin:: {\n          },\n        },\n        // PodCondition contains details for the current condition of this pod.\n        podCondition:: {\n          new():: {},\n          // Last time we probed the condition.\n          withLastProbeTime(lastProbeTime):: self + {lastProbeTime: lastProbeTime},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // Human-readable message indicating details about last transition.\n          withMessage(message):: self + {message: message},\n          // Unique, one-word, CamelCase reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status is the status of the condition. Can be True, False, Unknown. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions\n          withStatus(status):: self + {status: status},\n          // Type is the type of the condition. Currently only Ready. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // PodDNSConfig defines the DNS parameters of a pod in addition to those generated from DNSPolicy.\n        podDnsConfig:: {\n          new():: {},\n          // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n          withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then {nameservers: nameservers} else {nameservers: [nameservers]},\n          // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n          withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then {nameservers+: nameservers} else {nameservers+: [nameservers]},\n          // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n          withOptions(options):: self + if std.type(options) == \"array\" then {options: options} else {options: [options]},\n          // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n          withOptionsMixin(options):: self + if std.type(options) == \"array\" then {options+: options} else {options+: [options]},\n          optionsType:: hidden.core.v1.podDnsConfigOption,\n          // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n          withSearches(searches):: self + if std.type(searches) == \"array\" then {searches: searches} else {searches: [searches]},\n          // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n          withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then {searches+: searches} else {searches+: [searches]},\n          mixin:: {\n          },\n        },\n        // PodDNSConfigOption defines DNS resolver options of a pod.\n        podDnsConfigOption:: {\n          new():: {},\n          // Required.\n          withName(name):: self + {name: name},\n          withValue(value):: self + {value: value},\n          mixin:: {\n          },\n        },\n        // PodList is a list of Pods.\n        podList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of pods. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of pods. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.pod,\n          mixin:: {\n          },\n        },\n        // PodSecurityContext holds pod-level security attributes and common container settings. Some fields are also present in container.securityContext.  Field values of container.securityContext take precedence over field values of PodSecurityContext.\n        podSecurityContext:: {\n          new():: {},\n          // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n          //\n          // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n          //\n          // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n          withFsGroup(fsGroup):: self + {fsGroup: fsGroup},\n          // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n          withRunAsGroup(runAsGroup):: self + {runAsGroup: runAsGroup},\n          // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n          withRunAsNonRoot(runAsNonRoot):: self + {runAsNonRoot: runAsNonRoot},\n          // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n          withRunAsUser(runAsUser):: self + {runAsUser: runAsUser},\n          // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n          withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then {supplementalGroups: supplementalGroups} else {supplementalGroups: [supplementalGroups]},\n          // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n          withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then {supplementalGroups+: supplementalGroups} else {supplementalGroups+: [supplementalGroups]},\n          mixin:: {\n            // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n            seLinuxOptions:: {\n              local __seLinuxOptionsMixin(seLinuxOptions) = {seLinuxOptions+: seLinuxOptions},\n              mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n              // Level is SELinux level label that applies to the container.\n              withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n              // Role is a SELinux role label that applies to the container.\n              withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n              // Type is a SELinux type label that applies to the container.\n              withType(type):: self + __seLinuxOptionsMixin({type: type}),\n              // User is a SELinux user label that applies to the container.\n              withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n            },\n            seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n          },\n        },\n        // PodSpec is a description of a pod.\n        podSpec:: {\n          new():: {},\n          // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n          withActiveDeadlineSeconds(activeDeadlineSeconds):: self + {activeDeadlineSeconds: activeDeadlineSeconds},\n          // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n          withAutomountServiceAccountToken(automountServiceAccountToken):: self + {automountServiceAccountToken: automountServiceAccountToken},\n          // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n          withContainers(containers):: self + if std.type(containers) == \"array\" then {containers: containers} else {containers: [containers]},\n          // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n          withContainersMixin(containers):: self + if std.type(containers) == \"array\" then {containers+: containers} else {containers+: [containers]},\n          containersType:: hidden.core.v1.container,\n          // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n          withDnsPolicy(dnsPolicy):: self + {dnsPolicy: dnsPolicy},\n          // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n          withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then {hostAliases: hostAliases} else {hostAliases: [hostAliases]},\n          // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n          withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then {hostAliases+: hostAliases} else {hostAliases+: [hostAliases]},\n          hostAliasesType:: hidden.core.v1.hostAlias,\n          // Use the host's ipc namespace. Optional: Default to false.\n          withHostIpc(hostIpc):: self + {hostIPC: hostIpc},\n          // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n          withHostNetwork(hostNetwork):: self + {hostNetwork: hostNetwork},\n          // Use the host's pid namespace. Optional: Default to false.\n          withHostPid(hostPid):: self + {hostPID: hostPid},\n          // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n          withHostname(hostname):: self + {hostname: hostname},\n          // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n          withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then {imagePullSecrets: imagePullSecrets} else {imagePullSecrets: [imagePullSecrets]},\n          // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n          withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then {imagePullSecrets+: imagePullSecrets} else {imagePullSecrets+: [imagePullSecrets]},\n          imagePullSecretsType:: hidden.core.v1.localObjectReference,\n          // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n          withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then {initContainers: initContainers} else {initContainers: [initContainers]},\n          // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n          withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then {initContainers+: initContainers} else {initContainers+: [initContainers]},\n          initContainersType:: hidden.core.v1.container,\n          // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n          withNodeName(nodeName):: self + {nodeName: nodeName},\n          // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n          withNodeSelector(nodeSelector):: self + {nodeSelector: nodeSelector},\n          // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n          withNodeSelectorMixin(nodeSelector):: self + {nodeSelector+: nodeSelector},\n          // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n          withPriority(priority):: self + {priority: priority},\n          // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n          withPriorityClassName(priorityClassName):: self + {priorityClassName: priorityClassName},\n          // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n          withRestartPolicy(restartPolicy):: self + {restartPolicy: restartPolicy},\n          // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n          withSchedulerName(schedulerName):: self + {schedulerName: schedulerName},\n          // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n          withServiceAccount(serviceAccount):: self + {serviceAccount: serviceAccount},\n          // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n          withServiceAccountName(serviceAccountName):: self + {serviceAccountName: serviceAccountName},\n          // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n          withShareProcessNamespace(shareProcessNamespace):: self + {shareProcessNamespace: shareProcessNamespace},\n          // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n          withSubdomain(subdomain):: self + {subdomain: subdomain},\n          // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n          withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + {terminationGracePeriodSeconds: terminationGracePeriodSeconds},\n          // If specified, the pod's tolerations.\n          withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then {tolerations: tolerations} else {tolerations: [tolerations]},\n          // If specified, the pod's tolerations.\n          withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then {tolerations+: tolerations} else {tolerations+: [tolerations]},\n          tolerationsType:: hidden.core.v1.toleration,\n          // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n          withVolumes(volumes):: self + if std.type(volumes) == \"array\" then {volumes: volumes} else {volumes: [volumes]},\n          // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n          withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then {volumes+: volumes} else {volumes+: [volumes]},\n          volumesType:: hidden.core.v1.volume,\n          mixin:: {\n            // If specified, the pod's scheduling constraints\n            affinity:: {\n              local __affinityMixin(affinity) = {affinity+: affinity},\n              mixinInstance(affinity):: __affinityMixin(affinity),\n              // Describes node affinity scheduling rules for the pod.\n              nodeAffinity:: {\n                local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                requiredDuringSchedulingIgnoredDuringExecution:: {\n                  local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                  mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                  // Required. A list of node selector terms. The terms are ORed.\n                  withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                  // Required. A list of node selector terms. The terms are ORed.\n                  withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                  nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                },\n                requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n              },\n              nodeAffinityType:: hidden.core.v1.nodeAffinity,\n              // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n              podAffinity:: {\n                local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n              },\n              podAffinityType:: hidden.core.v1.podAffinity,\n              // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n              podAntiAffinity:: {\n                local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n              },\n              podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n            },\n            affinityType:: hidden.core.v1.affinity,\n            // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n            dnsConfig:: {\n              local __dnsConfigMixin(dnsConfig) = {dnsConfig+: dnsConfig},\n              mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n              // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n              withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n              // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n              withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n              // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n              withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n              // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n              withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n              optionsType:: hidden.core.v1.podDnsConfigOption,\n              // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n              withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n              // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n              withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n            },\n            dnsConfigType:: hidden.core.v1.podDnsConfig,\n            // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n            securityContext:: {\n              local __securityContextMixin(securityContext) = {securityContext+: securityContext},\n              mixinInstance(securityContext):: __securityContextMixin(securityContext),\n              // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n              //\n              // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n              //\n              // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n              withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n              // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n              withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n              // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n              withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n              // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n              withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n              // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n              // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n              withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n              // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n              withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n            },\n            securityContextType:: hidden.core.v1.podSecurityContext,\n          },\n        },\n        // PodStatus represents information about the status of a pod. Status may trail the actual state of a system.\n        podStatus:: {\n          new():: {},\n          // Current service state of pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Current service state of pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.core.v1.podCondition,\n          // The list has one entry per container in the manifest. Each entry is currently the output of `docker inspect`. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status\n          withContainerStatuses(containerStatuses):: self + if std.type(containerStatuses) == \"array\" then {containerStatuses: containerStatuses} else {containerStatuses: [containerStatuses]},\n          // The list has one entry per container in the manifest. Each entry is currently the output of `docker inspect`. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status\n          withContainerStatusesMixin(containerStatuses):: self + if std.type(containerStatuses) == \"array\" then {containerStatuses+: containerStatuses} else {containerStatuses+: [containerStatuses]},\n          containerStatusesType:: hidden.core.v1.containerStatus,\n          // IP address of the host to which the pod is assigned. Empty if not yet scheduled.\n          withHostIp(hostIp):: self + {hostIP: hostIp},\n          // The list has one entry per init container in the manifest. The most recent successful init container will have ready = true, the most recently started container will have startTime set. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status\n          withInitContainerStatuses(initContainerStatuses):: self + if std.type(initContainerStatuses) == \"array\" then {initContainerStatuses: initContainerStatuses} else {initContainerStatuses: [initContainerStatuses]},\n          // The list has one entry per init container in the manifest. The most recent successful init container will have ready = true, the most recently started container will have startTime set. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status\n          withInitContainerStatusesMixin(initContainerStatuses):: self + if std.type(initContainerStatuses) == \"array\" then {initContainerStatuses+: initContainerStatuses} else {initContainerStatuses+: [initContainerStatuses]},\n          initContainerStatusesType:: hidden.core.v1.containerStatus,\n          // A human readable message indicating details about why the pod is in this condition.\n          withMessage(message):: self + {message: message},\n          // nominatedNodeName is set only when this pod preempts other pods on the node, but it cannot be scheduled right away as preemption victims receive their graceful termination periods. This field does not guarantee that the pod will be scheduled on this node. Scheduler may decide to place the pod elsewhere if other nodes become available sooner. Scheduler may also decide to give the resources on this node to a higher priority pod that is created after preemption. As a result, this field may be different than PodSpec.nodeName when the pod is scheduled.\n          withNominatedNodeName(nominatedNodeName):: self + {nominatedNodeName: nominatedNodeName},\n          // Current condition of the pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-phase\n          withPhase(phase):: self + {phase: phase},\n          // IP address allocated to the pod. Routable at least within the cluster. Empty if not yet allocated.\n          withPodIp(podIp):: self + {podIP: podIp},\n          // The Quality of Service (QOS) classification assigned to the pod based on resource requirements See PodQOSClass type for available QOS classes More info: https://git.k8s.io/community/contributors/design-proposals/node/resource-qos.md\n          withQosClass(qosClass):: self + {qosClass: qosClass},\n          // A brief CamelCase message indicating details about why the pod is in this state. e.g. 'Evicted'\n          withReason(reason):: self + {reason: reason},\n          // RFC 3339 date and time at which the object was acknowledged by the Kubelet. This is before the Kubelet pulled the container image(s) for the pod.\n          withStartTime(startTime):: self + {startTime: startTime},\n          mixin:: {\n          },\n        },\n        // PodTemplateList is a list of PodTemplates.\n        podTemplateList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of pod templates\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of pod templates\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.podTemplate,\n          mixin:: {\n          },\n        },\n        // PodTemplateSpec describes the data a pod should have when created from a template\n        podTemplateSpec:: {\n          new():: {},\n          mixin:: {\n            // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n            metadata:: {\n              local __metadataMixin(metadata) = {metadata+: metadata},\n              mixinInstance(metadata):: __metadataMixin(metadata),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n              // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n              withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n              // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n              withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n              // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n              withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n              // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n              //\n              // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n              //\n              // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n              withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n              // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n              //\n              // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n              initializers:: {\n                local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                mixinInstance(initializers):: __initializersMixin(initializers),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                pendingType:: hidden.meta.v1.initializer,\n              },\n              initializersType:: hidden.meta.v1.initializers,\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabels(labels):: self + __metadataMixin({labels: labels}),\n              // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n              withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n              // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n              withName(name):: self + __metadataMixin({name: name}),\n              // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n              //\n              // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n              withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n              // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n              withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n              ownerReferencesType:: hidden.meta.v1.ownerReference,\n            },\n            metadataType:: hidden.meta.v1.objectMeta,\n            // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n            spec:: {\n              local __specMixin(spec) = {spec+: spec},\n              mixinInstance(spec):: __specMixin(spec),\n              // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n              withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n              // If specified, the pod's scheduling constraints\n              affinity:: {\n                local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                mixinInstance(affinity):: __affinityMixin(affinity),\n                // Describes node affinity scheduling rules for the pod.\n                nodeAffinity:: {\n                  local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                  mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                  // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                  requiredDuringSchedulingIgnoredDuringExecution:: {\n                    local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                    mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                    // Required. A list of node selector terms. The terms are ORed.\n                    withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                    // Required. A list of node selector terms. The terms are ORed.\n                    withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                    nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                  },\n                  requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                },\n                nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                podAffinity:: {\n                  local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                  mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                  // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                },\n                podAffinityType:: hidden.core.v1.podAffinity,\n                // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                podAntiAffinity:: {\n                  local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                  mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                  withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                  preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                  // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                  withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                  requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                },\n                podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n              },\n              affinityType:: hidden.core.v1.affinity,\n              // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n              withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n              // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n              withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n              // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n              withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n              containersType:: hidden.core.v1.container,\n              // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n              dnsConfig:: {\n                local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                optionsType:: hidden.core.v1.podDnsConfigOption,\n                // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n              },\n              dnsConfigType:: hidden.core.v1.podDnsConfig,\n              // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n              withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n              // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n              withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n              // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n              withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n              hostAliasesType:: hidden.core.v1.hostAlias,\n              // Use the host's ipc namespace. Optional: Default to false.\n              withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n              // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n              withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n              // Use the host's pid namespace. Optional: Default to false.\n              withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n              // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n              withHostname(hostname):: self + __specMixin({hostname: hostname}),\n              // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n              withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n              // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n              withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n              imagePullSecretsType:: hidden.core.v1.localObjectReference,\n              // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n              withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n              // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n              withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n              initContainersType:: hidden.core.v1.container,\n              // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n              withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n              // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n              withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n              // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n              withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n              // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n              withPriority(priority):: self + __specMixin({priority: priority}),\n              // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n              withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n              // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n              withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n              // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n              withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n              // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n              securityContext:: {\n                local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                //\n                // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                //\n                // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                seLinuxOptions:: {\n                  local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                  mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                  // Level is SELinux level label that applies to the container.\n                  withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                  // Role is a SELinux role label that applies to the container.\n                  withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                  // Type is a SELinux type label that applies to the container.\n                  withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                  // User is a SELinux user label that applies to the container.\n                  withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                },\n                seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n              },\n              securityContextType:: hidden.core.v1.podSecurityContext,\n              // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n              withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n              // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n              withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n              // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n              withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n              // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n              withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n              // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n              withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n              // If specified, the pod's tolerations.\n              withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n              // If specified, the pod's tolerations.\n              withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n              tolerationsType:: hidden.core.v1.toleration,\n              // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n              withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n              // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n              withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n              volumesType:: hidden.core.v1.volume,\n            },\n            specType:: hidden.core.v1.podSpec,\n          },\n        },\n        // PortworxVolumeSource represents a Portworx volume resource.\n        portworxVolumeSource:: {\n          new():: {},\n          // FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // VolumeID uniquely identifies a Portworx volume\n          withVolumeId(volumeId):: self + {volumeID: volumeId},\n          mixin:: {\n          },\n        },\n        // An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).\n        preferredSchedulingTerm:: {\n          new():: {},\n          // Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.\n          withWeight(weight):: self + {weight: weight},\n          mixin:: {\n            // A node selector term, associated with the corresponding weight.\n            preference:: {\n              local __preferenceMixin(preference) = {preference+: preference},\n              mixinInstance(preference):: __preferenceMixin(preference),\n              // Required. A list of node selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __preferenceMixin({matchExpressions: matchExpressions}) else __preferenceMixin({matchExpressions: [matchExpressions]}),\n              // Required. A list of node selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __preferenceMixin({matchExpressions+: matchExpressions}) else __preferenceMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.core.v1.nodeSelectorRequirement,\n            },\n            preferenceType:: hidden.core.v1.nodeSelectorTerm,\n          },\n        },\n        // Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.\n        probe:: {\n          new():: {},\n          // Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.\n          withFailureThreshold(failureThreshold):: self + {failureThreshold: failureThreshold},\n          // Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n          withInitialDelaySeconds(initialDelaySeconds):: self + {initialDelaySeconds: initialDelaySeconds},\n          // How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.\n          withPeriodSeconds(periodSeconds):: self + {periodSeconds: periodSeconds},\n          // Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness. Minimum value is 1.\n          withSuccessThreshold(successThreshold):: self + {successThreshold: successThreshold},\n          // Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes\n          withTimeoutSeconds(timeoutSeconds):: self + {timeoutSeconds: timeoutSeconds},\n          mixin:: {\n            // One and only one of the following should be specified. Exec specifies the action to take.\n            exec:: {\n              local __execMixin(exec) = {exec+: exec},\n              mixinInstance(exec):: __execMixin(exec),\n              // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n              withCommand(command):: self + if std.type(command) == \"array\" then __execMixin({command: command}) else __execMixin({command: [command]}),\n              // Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.\n              withCommandMixin(command):: self + if std.type(command) == \"array\" then __execMixin({command+: command}) else __execMixin({command+: [command]}),\n            },\n            execType:: hidden.core.v1.execAction,\n            // HTTPGet specifies the http request to perform.\n            httpGet:: {\n              local __httpGetMixin(httpGet) = {httpGet+: httpGet},\n              mixinInstance(httpGet):: __httpGetMixin(httpGet),\n              // Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.\n              withHost(host):: self + __httpGetMixin({host: host}),\n              // Custom headers to set in the request. HTTP allows repeated headers.\n              withHttpHeaders(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders: httpHeaders}) else __httpGetMixin({httpHeaders: [httpHeaders]}),\n              // Custom headers to set in the request. HTTP allows repeated headers.\n              withHttpHeadersMixin(httpHeaders):: self + if std.type(httpHeaders) == \"array\" then __httpGetMixin({httpHeaders+: httpHeaders}) else __httpGetMixin({httpHeaders+: [httpHeaders]}),\n              httpHeadersType:: hidden.core.v1.httpHeader,\n              // Path to access on the HTTP server.\n              withPath(path):: self + __httpGetMixin({path: path}),\n              // Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n              withPort(port):: self + __httpGetMixin({port: port}),\n              // Scheme to use for connecting to the host. Defaults to HTTP.\n              withScheme(scheme):: self + __httpGetMixin({scheme: scheme}),\n            },\n            httpGetType:: hidden.core.v1.httpGetAction,\n            // TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported\n            tcpSocket:: {\n              local __tcpSocketMixin(tcpSocket) = {tcpSocket+: tcpSocket},\n              mixinInstance(tcpSocket):: __tcpSocketMixin(tcpSocket),\n              // Optional: Host name to connect to, defaults to the pod IP.\n              withHost(host):: self + __tcpSocketMixin({host: host}),\n              // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n              withPort(port):: self + __tcpSocketMixin({port: port}),\n            },\n            tcpSocketType:: hidden.core.v1.tcpSocketAction,\n          },\n        },\n        // Represents a projected volume source\n        projectedVolumeSource:: {\n          new():: {},\n          // Mode bits to use on created files by default. Must be a value between 0 and 0777. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n          withDefaultMode(defaultMode):: self + {defaultMode: defaultMode},\n          // list of volume projections\n          withSources(sources):: self + if std.type(sources) == \"array\" then {sources: sources} else {sources: [sources]},\n          // list of volume projections\n          withSourcesMixin(sources):: self + if std.type(sources) == \"array\" then {sources+: sources} else {sources+: [sources]},\n          sourcesType:: hidden.core.v1.volumeProjection,\n          mixin:: {\n          },\n        },\n        // Represents a Quobyte mount that lasts the lifetime of a pod. Quobyte volumes do not support ownership management or SELinux relabeling.\n        quobyteVolumeSource:: {\n          new():: {},\n          // Group to map volume access to Default is no group\n          withGroup(group):: self + {group: group},\n          // ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes\n          withRegistry(registry):: self + {registry: registry},\n          // User to map volume access to Defaults to serivceaccount user\n          withUser(user):: self + {user: user},\n          // Volume is a string that references an already created Quobyte volume by name.\n          withVolume(volume):: self + {volume: volume},\n          mixin:: {\n          },\n        },\n        // Represents a Rados Block Device mount that lasts the lifetime of a pod. RBD volumes support ownership management and SELinux relabeling.\n        rbdPersistentVolumeSource:: {\n          new():: {},\n          // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd\n          withFsType(fsType):: self + {fsType: fsType},\n          // The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withImage(image):: self + {image: image},\n          // Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withKeyring(keyring):: self + {keyring: keyring},\n          // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withMonitors(monitors):: self + if std.type(monitors) == \"array\" then {monitors: monitors} else {monitors: [monitors]},\n          // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then {monitors+: monitors} else {monitors+: [monitors]},\n          // The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withPool(pool):: self + {pool: pool},\n          // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withUser(user):: self + {user: user},\n          mixin:: {\n            // SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n            },\n            secretRefType:: hidden.core.v1.secretReference,\n          },\n        },\n        // Represents a Rados Block Device mount that lasts the lifetime of a pod. RBD volumes support ownership management and SELinux relabeling.\n        rbdVolumeSource:: {\n          new():: {},\n          // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd\n          withFsType(fsType):: self + {fsType: fsType},\n          // The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withImage(image):: self + {image: image},\n          // Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withKeyring(keyring):: self + {keyring: keyring},\n          // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withMonitors(monitors):: self + if std.type(monitors) == \"array\" then {monitors: monitors} else {monitors: [monitors]},\n          // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then {monitors+: monitors} else {monitors+: [monitors]},\n          // The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withPool(pool):: self + {pool: pool},\n          // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n          withUser(user):: self + {user: user},\n          mixin:: {\n            // SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n            },\n            secretRefType:: hidden.core.v1.localObjectReference,\n          },\n        },\n        // ReplicationControllerCondition describes the state of a replication controller at a certain point.\n        replicationControllerCondition:: {\n          new():: {},\n          // The last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of replication controller condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // ReplicationControllerList is a collection of replication controllers.\n        replicationControllerList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of replication controllers. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of replication controllers. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.replicationController,\n          mixin:: {\n          },\n        },\n        // ReplicationControllerSpec is the specification of a replication controller.\n        replicationControllerSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          // Selector is a label query over pods that should match the Replicas count. If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n          withSelector(selector):: self + {selector: selector},\n          // Selector is a label query over pods that should match the Replicas count. If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n          withSelectorMixin(selector):: self + {selector+: selector},\n          mixin:: {\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. This takes precedence over a TemplateRef. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // ReplicationControllerStatus represents the current status of a replication controller.\n        replicationControllerStatus:: {\n          new():: {},\n          // The number of available replicas (ready for at least minReadySeconds) for this replication controller.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Represents the latest available observations of a replication controller's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a replication controller's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.core.v1.replicationControllerCondition,\n          // The number of pods that have labels matching the labels of the pod template of the replication controller.\n          withFullyLabeledReplicas(fullyLabeledReplicas):: self + {fullyLabeledReplicas: fullyLabeledReplicas},\n          // ObservedGeneration reflects the generation of the most recently observed replication controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The number of ready replicas for this replication controller.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // ResourceFieldSelector represents container resources (cpu, memory) and their output format\n        resourceFieldSelector:: {\n          new():: {},\n          // Container name: required for volumes, optional for env vars\n          withContainerName(containerName):: self + {containerName: containerName},\n          // Required: resource to select\n          withResource(resource):: self + {resource: resource},\n          mixin:: {\n            // Specifies the output format of the exposed resources, defaults to \"1\"\n            divisor:: {\n              local __divisorMixin(divisor) = {divisor+: divisor},\n              mixinInstance(divisor):: __divisorMixin(divisor),\n            },\n            divisorType:: hidden.core.resource.quantity,\n          },\n        },\n        // ResourceQuotaList is a list of ResourceQuota items.\n        resourceQuotaList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is a list of ResourceQuota objects. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ResourceQuota objects. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.resourceQuota,\n          mixin:: {\n          },\n        },\n        // ResourceQuotaSpec defines the desired hard limits to enforce for Quota.\n        resourceQuotaSpec:: {\n          new():: {},\n          // Hard is the set of desired hard limits for each named resource. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n          withHard(hard):: self + {hard: hard},\n          // Hard is the set of desired hard limits for each named resource. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n          withHardMixin(hard):: self + {hard+: hard},\n          // A collection of filters that must match each object tracked by a quota. If not specified, the quota matches all objects.\n          withScopes(scopes):: self + if std.type(scopes) == \"array\" then {scopes: scopes} else {scopes: [scopes]},\n          // A collection of filters that must match each object tracked by a quota. If not specified, the quota matches all objects.\n          withScopesMixin(scopes):: self + if std.type(scopes) == \"array\" then {scopes+: scopes} else {scopes+: [scopes]},\n          mixin:: {\n          },\n        },\n        // ResourceQuotaStatus defines the enforced hard limits and observed use.\n        resourceQuotaStatus:: {\n          new():: {},\n          // Hard is the set of enforced hard limits for each named resource. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n          withHard(hard):: self + {hard: hard},\n          // Hard is the set of enforced hard limits for each named resource. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/\n          withHardMixin(hard):: self + {hard+: hard},\n          // Used is the current observed total usage of the resource in the namespace.\n          withUsed(used):: self + {used: used},\n          // Used is the current observed total usage of the resource in the namespace.\n          withUsedMixin(used):: self + {used+: used},\n          mixin:: {\n          },\n        },\n        // ResourceRequirements describes the compute resource requirements.\n        resourceRequirements:: {\n          new():: {},\n          // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n          withLimits(limits):: self + {limits: limits},\n          // Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n          withLimitsMixin(limits):: self + {limits+: limits},\n          // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n          withRequests(requests):: self + {requests: requests},\n          // Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/\n          withRequestsMixin(requests):: self + {requests+: requests},\n          mixin:: {\n          },\n        },\n        // ScaleIOPersistentVolumeSource represents a persistent ScaleIO volume\n        scaleIoPersistentVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // The host address of the ScaleIO API Gateway.\n          withGateway(gateway):: self + {gateway: gateway},\n          // The name of the ScaleIO Protection Domain for the configured storage.\n          withProtectionDomain(protectionDomain):: self + {protectionDomain: protectionDomain},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Flag to enable/disable SSL communication with Gateway, default false\n          withSslEnabled(sslEnabled):: self + {sslEnabled: sslEnabled},\n          // Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.\n          withStorageMode(storageMode):: self + {storageMode: storageMode},\n          // The ScaleIO Storage Pool associated with the protection domain.\n          withStoragePool(storagePool):: self + {storagePool: storagePool},\n          // The name of the storage system as configured in ScaleIO.\n          withSystem(system):: self + {system: system},\n          // The name of a volume already created in the ScaleIO system that is associated with this volume source.\n          withVolumeName(volumeName):: self + {volumeName: volumeName},\n          mixin:: {\n            // SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name is unique within a namespace to reference a secret resource.\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Namespace defines the space within which the secret name must be unique.\n              withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n            },\n            secretRefType:: hidden.core.v1.secretReference,\n          },\n        },\n        // ScaleIOVolumeSource represents a persistent ScaleIO volume\n        scaleIoVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // The host address of the ScaleIO API Gateway.\n          withGateway(gateway):: self + {gateway: gateway},\n          // The name of the ScaleIO Protection Domain for the configured storage.\n          withProtectionDomain(protectionDomain):: self + {protectionDomain: protectionDomain},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Flag to enable/disable SSL communication with Gateway, default false\n          withSslEnabled(sslEnabled):: self + {sslEnabled: sslEnabled},\n          // Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.\n          withStorageMode(storageMode):: self + {storageMode: storageMode},\n          // The ScaleIO Storage Pool associated with the protection domain.\n          withStoragePool(storagePool):: self + {storagePool: storagePool},\n          // The name of the storage system as configured in ScaleIO.\n          withSystem(system):: self + {system: system},\n          // The name of a volume already created in the ScaleIO system that is associated with this volume source.\n          withVolumeName(volumeName):: self + {volumeName: volumeName},\n          mixin:: {\n            // SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n            },\n            secretRefType:: hidden.core.v1.localObjectReference,\n          },\n        },\n        // SELinuxOptions are the labels to be applied to the container\n        seLinuxOptions:: {\n          new():: {},\n          // Level is SELinux level label that applies to the container.\n          withLevel(level):: self + {level: level},\n          // Role is a SELinux role label that applies to the container.\n          withRole(role):: self + {role: role},\n          // Type is a SELinux type label that applies to the container.\n          withType(type):: self + {type: type},\n          // User is a SELinux user label that applies to the container.\n          withUser(user):: self + {user: user},\n          mixin:: {\n          },\n        },\n        // SecretEnvSource selects a Secret to populate the environment variables with.\n        //\n        // The contents of the target Secret's Data field will represent the key-value pairs as environment variables.\n        secretEnvSource:: {\n          new():: {},\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the Secret must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // SecretKeySelector selects a key of a Secret.\n        secretKeySelector:: {\n          new():: {},\n          // The key of the secret to select from.  Must be a valid secret key.\n          withKey(key):: self + {key: key},\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the Secret or it's key must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // SecretList is a list of Secret.\n        secretList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is a list of secret objects. More info: https://kubernetes.io/docs/concepts/configuration/secret\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of secret objects. More info: https://kubernetes.io/docs/concepts/configuration/secret\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.secret,\n          mixin:: {\n          },\n        },\n        // Adapts a secret into a projected volume.\n        //\n        // The contents of the target Secret's Data field will be presented in a projected volume as files using the keys in the Data field as the file names. Note that this is identical to a secret volume source without the default mode.\n        secretProjection:: {\n          new():: {},\n          // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.keyToPath,\n          // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          // Specify whether the Secret or its key must be defined\n          withOptional(optional):: self + {optional: optional},\n          mixin:: {\n          },\n        },\n        // SecretReference represents a Secret Reference. It has enough information to retrieve secret in any namespace\n        secretReference:: {\n          new():: {},\n          // Name is unique within a namespace to reference a secret resource.\n          withName(name):: self + {name: name},\n          // Namespace defines the space within which the secret name must be unique.\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n        // Adapts a Secret into a volume.\n        //\n        // The contents of the target Secret's Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.\n        secretVolumeSource:: {\n          new():: {},\n          // Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n          withDefaultMode(defaultMode):: self + {defaultMode: defaultMode},\n          // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.keyToPath,\n          // Specify whether the Secret or it's keys must be defined\n          withOptional(optional):: self + {optional: optional},\n          // Name of the secret in the pod's namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret\n          withSecretName(secretName):: self + {secretName: secretName},\n          mixin:: {\n          },\n        },\n        // SecurityContext holds security configuration that will be applied to a container. Some fields are present in both SecurityContext and PodSecurityContext.  When both are set, the values in SecurityContext take precedence.\n        securityContext:: {\n          new():: {},\n          // AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN\n          withAllowPrivilegeEscalation(allowPrivilegeEscalation):: self + {allowPrivilegeEscalation: allowPrivilegeEscalation},\n          // Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false.\n          withPrivileged(privileged):: self + {privileged: privileged},\n          // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n          withRunAsGroup(runAsGroup):: self + {runAsGroup: runAsGroup},\n          // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n          withRunAsNonRoot(runAsNonRoot):: self + {runAsNonRoot: runAsNonRoot},\n          // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n          withRunAsUser(runAsUser):: self + {runAsUser: runAsUser},\n          mixin:: {\n            // The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime.\n            capabilities:: {\n              local __capabilitiesMixin(capabilities) = {capabilities+: capabilities},\n              mixinInstance(capabilities):: __capabilitiesMixin(capabilities),\n              // Added capabilities\n              withAdd(add):: self + if std.type(add) == \"array\" then __capabilitiesMixin({add: add}) else __capabilitiesMixin({add: [add]}),\n              // Added capabilities\n              withAddMixin(add):: self + if std.type(add) == \"array\" then __capabilitiesMixin({add+: add}) else __capabilitiesMixin({add+: [add]}),\n              // Removed capabilities\n              withDrop(drop):: self + if std.type(drop) == \"array\" then __capabilitiesMixin({drop: drop}) else __capabilitiesMixin({drop: [drop]}),\n              // Removed capabilities\n              withDropMixin(drop):: self + if std.type(drop) == \"array\" then __capabilitiesMixin({drop+: drop}) else __capabilitiesMixin({drop+: [drop]}),\n            },\n            capabilitiesType:: hidden.core.v1.capabilities,\n            // The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n            seLinuxOptions:: {\n              local __seLinuxOptionsMixin(seLinuxOptions) = {seLinuxOptions+: seLinuxOptions},\n              mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n              // Level is SELinux level label that applies to the container.\n              withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n              // Role is a SELinux role label that applies to the container.\n              withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n              // Type is a SELinux type label that applies to the container.\n              withType(type):: self + __seLinuxOptionsMixin({type: type}),\n              // User is a SELinux user label that applies to the container.\n              withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n            },\n            seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n          },\n        },\n        // ServiceAccountList is a list of ServiceAccount objects\n        serviceAccountList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of ServiceAccounts. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of ServiceAccounts. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.serviceAccount,\n          mixin:: {\n          },\n        },\n        // ServiceList holds a list of services.\n        serviceList:: {\n          new(items=\"\"):: self.withItems(items),\n          // List of services\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of services\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.core.v1.service,\n          mixin:: {\n          },\n        },\n        // ServicePort contains information on service's port.\n        servicePort:: {\n          new(port=\"\", targetPort=\"\"):: self.withPort(port).withTargetPort(targetPort),\n          newNamed(name=\"\", port=\"\", targetPort=\"\"):: self.withPort(port).withTargetPort(targetPort) + self.mixin.metadata.withName(name),\n          // The name of this port within the service. This must be a DNS_LABEL. All ports within a ServiceSpec must have unique names. This maps to the 'Name' field in EndpointPort objects. Optional if only one ServicePort is defined on this service.\n          withName(name):: self + {name: name},\n          // The port on each node on which this service is exposed when type=NodePort or LoadBalancer. Usually assigned by the system. If specified, it will be allocated to the service if unused or else creation of the service will fail. Default is to auto-allocate a port if the ServiceType of this Service requires one. More info: https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport\n          withNodePort(nodePort):: self + {nodePort: nodePort},\n          // The port that will be exposed by this service.\n          withPort(port):: self + {port: port},\n          // The IP protocol for this port. Supports \"TCP\" and \"UDP\". Default is TCP.\n          withProtocol(protocol):: self + {protocol: protocol},\n          // Number or name of the port to access on the pods targeted by the service. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. If this is a string, it will be looked up as a named port in the target Pod's container ports. If this is not specified, the value of the 'port' field is used (an identity map). This field is ignored for services with clusterIP=None, and should be omitted or set equal to the 'port' field. More info: https://kubernetes.io/docs/concepts/services-networking/service/#defining-a-service\n          withTargetPort(targetPort):: self + {targetPort: targetPort},\n          mixin:: {\n          },\n        },\n        // ServiceSpec describes the attributes that a user creates on a service.\n        serviceSpec:: {\n          new():: {},\n          // clusterIP is the IP address of the service and is usually assigned randomly by the master. If an address is specified manually and is not in use by others, it will be allocated to the service; otherwise, creation of the service will fail. This field can not be changed through updates. Valid values are \"None\", empty string (\"\"), or a valid IP address. \"None\" can be specified for headless services when proxying is not required. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n          withClusterIp(clusterIp):: self + {clusterIP: clusterIp},\n          // externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.  These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.\n          withExternalIps(externalIps):: self + if std.type(externalIps) == \"array\" then {externalIPs: externalIps} else {externalIPs: [externalIps]},\n          // externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.  These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.\n          withExternalIpsMixin(externalIps):: self + if std.type(externalIps) == \"array\" then {externalIPs+: externalIps} else {externalIPs+: [externalIps]},\n          // externalName is the external reference that kubedns or equivalent will return as a CNAME record for this service. No proxying will be involved. Must be a valid RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires Type to be ExternalName.\n          withExternalName(externalName):: self + {externalName: externalName},\n          // externalTrafficPolicy denotes if this Service desires to route external traffic to node-local or cluster-wide endpoints. \"Local\" preserves the client source IP and avoids a second hop for LoadBalancer and Nodeport type services, but risks potentially imbalanced traffic spreading. \"Cluster\" obscures the client source IP and may cause a second hop to another node, but should have good overall load-spreading.\n          withExternalTrafficPolicy(externalTrafficPolicy):: self + {externalTrafficPolicy: externalTrafficPolicy},\n          // healthCheckNodePort specifies the healthcheck nodePort for the service. If not specified, HealthCheckNodePort is created by the service api backend with the allocated nodePort. Will use user-specified nodePort value if specified by the client. Only effects when Type is set to LoadBalancer and ExternalTrafficPolicy is set to Local.\n          withHealthCheckNodePort(healthCheckNodePort):: self + {healthCheckNodePort: healthCheckNodePort},\n          // Only applies to Service Type: LoadBalancer LoadBalancer will get created with the IP specified in this field. This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature.\n          withLoadBalancerIp(loadBalancerIp):: self + {loadBalancerIP: loadBalancerIp},\n          // If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature.\" More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/\n          withLoadBalancerSourceRanges(loadBalancerSourceRanges):: self + if std.type(loadBalancerSourceRanges) == \"array\" then {loadBalancerSourceRanges: loadBalancerSourceRanges} else {loadBalancerSourceRanges: [loadBalancerSourceRanges]},\n          // If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature.\" More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/\n          withLoadBalancerSourceRangesMixin(loadBalancerSourceRanges):: self + if std.type(loadBalancerSourceRanges) == \"array\" then {loadBalancerSourceRanges+: loadBalancerSourceRanges} else {loadBalancerSourceRanges+: [loadBalancerSourceRanges]},\n          // The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.core.v1.servicePort,\n          // publishNotReadyAddresses, when set to true, indicates that DNS implementations must publish the notReadyAddresses of subsets for the Endpoints associated with the Service. The default value is false. The primary use case for setting this field is to use a StatefulSet's Headless Service to propagate SRV records for its Pods without respect to their readiness for purpose of peer discovery. This field will replace the service.alpha.kubernetes.io/tolerate-unready-endpoints when that annotation is deprecated and all clients have been converted to use this field.\n          withPublishNotReadyAddresses(publishNotReadyAddresses):: self + {publishNotReadyAddresses: publishNotReadyAddresses},\n          // Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/\n          withSelector(selector):: self + {selector: selector},\n          // Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/\n          withSelectorMixin(selector):: self + {selector+: selector},\n          // Supports \"ClientIP\" and \"None\". Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies\n          withSessionAffinity(sessionAffinity):: self + {sessionAffinity: sessionAffinity},\n          // type determines how the Service is exposed. Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. \"ExternalName\" maps to the specified externalName. \"ClusterIP\" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object. If clusterIP is \"None\", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a stable IP. \"NodePort\" builds on ClusterIP and allocates a port on every node which routes to the clusterIP. \"LoadBalancer\" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the clusterIP. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services---service-types\n          withType(type):: self + {type: type},\n          mixin:: {\n            // sessionAffinityConfig contains the configurations of session affinity.\n            sessionAffinityConfig:: {\n              local __sessionAffinityConfigMixin(sessionAffinityConfig) = {sessionAffinityConfig+: sessionAffinityConfig},\n              mixinInstance(sessionAffinityConfig):: __sessionAffinityConfigMixin(sessionAffinityConfig),\n              // clientIP contains the configurations of Client IP based session affinity.\n              clientIp:: {\n                local __clientIpMixin(clientIp) = __sessionAffinityConfigMixin({clientIp+: clientIp}),\n                mixinInstance(clientIp):: __clientIpMixin(clientIp),\n                // timeoutSeconds specifies the seconds of ClientIP type session sticky time. The value must be >0 && <=86400(for 1 day) if ServiceAffinity == \"ClientIP\". Default value is 10800(for 3 hours).\n                withTimeoutSeconds(timeoutSeconds):: self + __clientIpMixin({timeoutSeconds: timeoutSeconds}),\n              },\n              clientIPType:: hidden.core.v1.clientIpConfig,\n            },\n            sessionAffinityConfigType:: hidden.core.v1.sessionAffinityConfig,\n          },\n        },\n        // ServiceStatus represents the current status of a service.\n        serviceStatus:: {\n          new():: {},\n          mixin:: {\n            // LoadBalancer contains the current status of the load-balancer, if one is present.\n            loadBalancer:: {\n              local __loadBalancerMixin(loadBalancer) = {loadBalancer+: loadBalancer},\n              mixinInstance(loadBalancer):: __loadBalancerMixin(loadBalancer),\n              // Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points.\n              withIngress(ingress):: self + if std.type(ingress) == \"array\" then __loadBalancerMixin({ingress: ingress}) else __loadBalancerMixin({ingress: [ingress]}),\n              // Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points.\n              withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then __loadBalancerMixin({ingress+: ingress}) else __loadBalancerMixin({ingress+: [ingress]}),\n              ingressType:: hidden.core.v1.loadBalancerIngress,\n            },\n            loadBalancerType:: hidden.core.v1.loadBalancerStatus,\n          },\n        },\n        // SessionAffinityConfig represents the configurations of session affinity.\n        sessionAffinityConfig:: {\n          new():: {},\n          mixin:: {\n            // clientIP contains the configurations of Client IP based session affinity.\n            clientIp:: {\n              local __clientIpMixin(clientIp) = {clientIp+: clientIp},\n              mixinInstance(clientIp):: __clientIpMixin(clientIp),\n              // timeoutSeconds specifies the seconds of ClientIP type session sticky time. The value must be >0 && <=86400(for 1 day) if ServiceAffinity == \"ClientIP\". Default value is 10800(for 3 hours).\n              withTimeoutSeconds(timeoutSeconds):: self + __clientIpMixin({timeoutSeconds: timeoutSeconds}),\n            },\n            clientIPType:: hidden.core.v1.clientIpConfig,\n          },\n        },\n        // Represents a StorageOS persistent volume resource.\n        storageOsPersistentVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.\n          withVolumeName(volumeName):: self + {volumeName: volumeName},\n          // VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to \"default\" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.\n          withVolumeNamespace(volumeNamespace):: self + {volumeNamespace: volumeNamespace},\n          mixin:: {\n            // SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: \"spec.containers{name}\" (where \"name\" refers to the name of the container that triggered the event) or if no container name is specified \"spec.containers[2]\" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.\n              withFieldPath(fieldPath):: self + __secretRefMixin({fieldPath: fieldPath}),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n              // Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/\n              withNamespace(namespace):: self + __secretRefMixin({namespace: namespace}),\n              // Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#concurrency-control-and-consistency\n              withResourceVersion(resourceVersion):: self + __secretRefMixin({resourceVersion: resourceVersion}),\n              // UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids\n              withUid(uid):: self + __secretRefMixin({uid: uid}),\n            },\n            secretRefType:: hidden.core.v1.objectReference,\n          },\n        },\n        // Represents a StorageOS persistent volume resource.\n        storageOsVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.\n          withVolumeName(volumeName):: self + {volumeName: volumeName},\n          // VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to \"default\" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.\n          withVolumeNamespace(volumeNamespace):: self + {volumeNamespace: volumeNamespace},\n          mixin:: {\n            // SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.\n            secretRef:: {\n              local __secretRefMixin(secretRef) = {secretRef+: secretRef},\n              mixinInstance(secretRef):: __secretRefMixin(secretRef),\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretRefMixin({name: name}),\n            },\n            secretRefType:: hidden.core.v1.localObjectReference,\n          },\n        },\n        // The node this Taint is attached to has the \"effect\" on any pod that does not tolerate the Taint.\n        taint:: {\n          new():: {},\n          // Required. The effect of the taint on pods that do not tolerate the taint. Valid effects are NoSchedule, PreferNoSchedule and NoExecute.\n          withEffect(effect):: self + {effect: effect},\n          // Required. The taint key to be applied to a node.\n          withKey(key):: self + {key: key},\n          // TimeAdded represents the time at which the taint was added. It is only written for NoExecute taints.\n          withTimeAdded(timeAdded):: self + {timeAdded: timeAdded},\n          // Required. The taint value corresponding to the taint key.\n          withValue(value):: self + {value: value},\n          mixin:: {\n          },\n        },\n        // TCPSocketAction describes an action based on opening a socket\n        tcpSocketAction:: {\n          new():: {},\n          // Optional: Host name to connect to, defaults to the pod IP.\n          withHost(host):: self + {host: host},\n          // Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.\n          withPort(port):: self + {port: port},\n          mixin:: {\n          },\n        },\n        // The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.\n        toleration:: {\n          new():: {},\n          // Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.\n          withEffect(effect):: self + {effect: effect},\n          // Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.\n          withKey(key):: self + {key: key},\n          // Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.\n          withOperator(operator):: self + {operator: operator},\n          // TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.\n          withTolerationSeconds(tolerationSeconds):: self + {tolerationSeconds: tolerationSeconds},\n          // Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.\n          withValue(value):: self + {value: value},\n          mixin:: {\n          },\n        },\n        // Volume represents a named volume in a pod that may be accessed by any container in the pod.\n        volume:: {\n          fromConfigMap(name=\"\", configMapName=\"\", configMapItems=\"\"):: self.withName(name) + self.mixin.configMap.withItems(configMapItems).withName(configMapName),\n          fromEmptyDir(name=\"\", emptyDir={}):: self.withName(name),\n          fromPersistentVolumeClaim(name=\"\", emptyDir=\"\"):: self.withName(name) + self.mixin.persistentVolumeClaim.withClaimName(emptyDir),\n          fromHostPath(name=\"\", hostPath=\"\"):: self.withName(name) + self.mixin.hostPath.withPath(hostPath),\n          fromSecret(name=\"\", secretName=\"\"):: self.withName(name) + self.mixin.secret.withSecretName(secretName),\n          // Volume's name. Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n          withName(name):: self + {name: name},\n          mixin:: {\n            // AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n            awsElasticBlockStore:: {\n              local __awsElasticBlockStoreMixin(awsElasticBlockStore) = {awsElasticBlockStore+: awsElasticBlockStore},\n              mixinInstance(awsElasticBlockStore):: __awsElasticBlockStoreMixin(awsElasticBlockStore),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withFsType(fsType):: self + __awsElasticBlockStoreMixin({fsType: fsType}),\n              // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty).\n              withPartition(partition):: self + __awsElasticBlockStoreMixin({partition: partition}),\n              // Specify \"true\" to force and set the ReadOnly property in VolumeMounts to \"true\". If omitted, the default is \"false\". More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withReadOnly(readOnly):: self + __awsElasticBlockStoreMixin({readOnly: readOnly}),\n              // Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n              withVolumeId(volumeId):: self + __awsElasticBlockStoreMixin({volumeID: volumeId}),\n            },\n            awsElasticBlockStoreType:: hidden.core.v1.awsElasticBlockStoreVolumeSource,\n            // AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.\n            azureDisk:: {\n              local __azureDiskMixin(azureDisk) = {azureDisk+: azureDisk},\n              mixinInstance(azureDisk):: __azureDiskMixin(azureDisk),\n              // Host Caching mode: None, Read Only, Read Write.\n              withCachingMode(cachingMode):: self + __azureDiskMixin({cachingMode: cachingMode}),\n              // The Name of the data disk in the blob storage\n              withDiskName(diskName):: self + __azureDiskMixin({diskName: diskName}),\n              // The URI the data disk in the blob storage\n              withDiskUri(diskUri):: self + __azureDiskMixin({diskURI: diskUri}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __azureDiskMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __azureDiskMixin({readOnly: readOnly}),\n            },\n            azureDiskType:: hidden.core.v1.azureDiskVolumeSource,\n            // AzureFile represents an Azure File Service mount on the host and bind mount to the pod.\n            azureFile:: {\n              local __azureFileMixin(azureFile) = {azureFile+: azureFile},\n              mixinInstance(azureFile):: __azureFileMixin(azureFile),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __azureFileMixin({readOnly: readOnly}),\n              // the name of secret that contains Azure Storage Account Name and Key\n              withSecretName(secretName):: self + __azureFileMixin({secretName: secretName}),\n              // Share Name\n              withShareName(shareName):: self + __azureFileMixin({shareName: shareName}),\n            },\n            azureFileType:: hidden.core.v1.azureFileVolumeSource,\n            // CephFS represents a Ceph FS mount on the host that shares a pod's lifetime\n            cephfs:: {\n              local __cephfsMixin(cephfs) = {cephfs+: cephfs},\n              mixinInstance(cephfs):: __cephfsMixin(cephfs),\n              // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withMonitors(monitors):: self + if std.type(monitors) == \"array\" then __cephfsMixin({monitors: monitors}) else __cephfsMixin({monitors: [monitors]}),\n              // Required: Monitors is a collection of Ceph monitors More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then __cephfsMixin({monitors+: monitors}) else __cephfsMixin({monitors+: [monitors]}),\n              // Optional: Used as the mounted root, rather than the full Ceph tree, default is /\n              withPath(path):: self + __cephfsMixin({path: path}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withReadOnly(readOnly):: self + __cephfsMixin({readOnly: readOnly}),\n              // Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withSecretFile(secretFile):: self + __cephfsMixin({secretFile: secretFile}),\n              // Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __cephfsMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n              },\n              secretRefType:: hidden.core.v1.localObjectReference,\n              // Optional: User is the rados user name, default is admin More info: https://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it\n              withUser(user):: self + __cephfsMixin({user: user}),\n            },\n            cephfsType:: hidden.core.v1.cephFsVolumeSource,\n            // Cinder represents a cinder volume attached and mounted on kubelets host machine More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n            cinder:: {\n              local __cinderMixin(cinder) = {cinder+: cinder},\n              mixinInstance(cinder):: __cinderMixin(cinder),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withFsType(fsType):: self + __cinderMixin({fsType: fsType}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withReadOnly(readOnly):: self + __cinderMixin({readOnly: readOnly}),\n              // volume id used to identify the volume in cinder More info: https://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md\n              withVolumeId(volumeId):: self + __cinderMixin({volumeID: volumeId}),\n            },\n            cinderType:: hidden.core.v1.cinderVolumeSource,\n            // ConfigMap represents a configMap that should populate this volume\n            configMap:: {\n              local __configMapMixin(configMap) = {configMap+: configMap},\n              mixinInstance(configMap):: __configMapMixin(configMap),\n              // Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n              withDefaultMode(defaultMode):: self + __configMapMixin({defaultMode: defaultMode}),\n              // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItems(items):: self + if std.type(items) == \"array\" then __configMapMixin({items: items}) else __configMapMixin({items: [items]}),\n              // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItemsMixin(items):: self + if std.type(items) == \"array\" then __configMapMixin({items+: items}) else __configMapMixin({items+: [items]}),\n              itemsType:: hidden.core.v1.keyToPath,\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __configMapMixin({name: name}),\n              // Specify whether the ConfigMap or it's keys must be defined\n              withOptional(optional):: self + __configMapMixin({optional: optional}),\n            },\n            configMapType:: hidden.core.v1.configMapVolumeSource,\n            // DownwardAPI represents downward API about the pod that should populate this volume\n            downwardApi:: {\n              local __downwardApiMixin(downwardApi) = {downwardApi+: downwardApi},\n              mixinInstance(downwardApi):: __downwardApiMixin(downwardApi),\n              // Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n              withDefaultMode(defaultMode):: self + __downwardApiMixin({defaultMode: defaultMode}),\n              // Items is a list of downward API volume file\n              withItems(items):: self + if std.type(items) == \"array\" then __downwardApiMixin({items: items}) else __downwardApiMixin({items: [items]}),\n              // Items is a list of downward API volume file\n              withItemsMixin(items):: self + if std.type(items) == \"array\" then __downwardApiMixin({items+: items}) else __downwardApiMixin({items+: [items]}),\n              itemsType:: hidden.core.v1.downwardApiVolumeFile,\n            },\n            downwardAPIType:: hidden.core.v1.downwardApiVolumeSource,\n            // EmptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir\n            emptyDir:: {\n              local __emptyDirMixin(emptyDir) = {emptyDir+: emptyDir},\n              mixinInstance(emptyDir):: __emptyDirMixin(emptyDir),\n              // What type of storage medium should back this directory. The default is \"\" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir\n              withMedium(medium):: self + __emptyDirMixin({medium: medium}),\n              // Total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir\n              sizeLimit:: {\n                local __sizeLimitMixin(sizeLimit) = __emptyDirMixin({sizeLimit+: sizeLimit}),\n                mixinInstance(sizeLimit):: __sizeLimitMixin(sizeLimit),\n              },\n              sizeLimitType:: hidden.core.resource.quantity,\n            },\n            emptyDirType:: hidden.core.v1.emptyDirVolumeSource,\n            // FC represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.\n            fc:: {\n              local __fcMixin(fc) = {fc+: fc},\n              mixinInstance(fc):: __fcMixin(fc),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __fcMixin({fsType: fsType}),\n              // Optional: FC target lun number\n              withLun(lun):: self + __fcMixin({lun: lun}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __fcMixin({readOnly: readOnly}),\n              // Optional: FC target worldwide names (WWNs)\n              withTargetWwns(targetWwns):: self + if std.type(targetWwns) == \"array\" then __fcMixin({targetWWNs: targetWwns}) else __fcMixin({targetWWNs: [targetWwns]}),\n              // Optional: FC target worldwide names (WWNs)\n              withTargetWwnsMixin(targetWwns):: self + if std.type(targetWwns) == \"array\" then __fcMixin({targetWWNs+: targetWwns}) else __fcMixin({targetWWNs+: [targetWwns]}),\n              // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n              withWwids(wwids):: self + if std.type(wwids) == \"array\" then __fcMixin({wwids: wwids}) else __fcMixin({wwids: [wwids]}),\n              // Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n              withWwidsMixin(wwids):: self + if std.type(wwids) == \"array\" then __fcMixin({wwids+: wwids}) else __fcMixin({wwids+: [wwids]}),\n            },\n            fcType:: hidden.core.v1.fcVolumeSource,\n            // FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.\n            flexVolume:: {\n              local __flexVolumeMixin(flexVolume) = {flexVolume+: flexVolume},\n              mixinInstance(flexVolume):: __flexVolumeMixin(flexVolume),\n              // Driver is the name of the driver to use for this volume.\n              withDriver(driver):: self + __flexVolumeMixin({driver: driver}),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". The default filesystem depends on FlexVolume script.\n              withFsType(fsType):: self + __flexVolumeMixin({fsType: fsType}),\n              // Optional: Extra command options if any.\n              withOptions(options):: self + __flexVolumeMixin({options: options}),\n              // Optional: Extra command options if any.\n              withOptionsMixin(options):: self + __flexVolumeMixin({options+: options}),\n              // Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __flexVolumeMixin({readOnly: readOnly}),\n              // Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __flexVolumeMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n              },\n              secretRefType:: hidden.core.v1.localObjectReference,\n            },\n            flexVolumeType:: hidden.core.v1.flexVolumeSource,\n            // Flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running\n            flocker:: {\n              local __flockerMixin(flocker) = {flocker+: flocker},\n              mixinInstance(flocker):: __flockerMixin(flocker),\n              // Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated\n              withDatasetName(datasetName):: self + __flockerMixin({datasetName: datasetName}),\n              // UUID of the dataset. This is unique identifier of a Flocker dataset\n              withDatasetUuid(datasetUuid):: self + __flockerMixin({datasetUUID: datasetUuid}),\n            },\n            flockerType:: hidden.core.v1.flockerVolumeSource,\n            // GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n            gcePersistentDisk:: {\n              local __gcePersistentDiskMixin(gcePersistentDisk) = {gcePersistentDisk+: gcePersistentDisk},\n              mixinInstance(gcePersistentDisk):: __gcePersistentDiskMixin(gcePersistentDisk),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withFsType(fsType):: self + __gcePersistentDiskMixin({fsType: fsType}),\n              // The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as \"1\". Similarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withPartition(partition):: self + __gcePersistentDiskMixin({partition: partition}),\n              // Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withPdName(pdName):: self + __gcePersistentDiskMixin({pdName: pdName}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n              withReadOnly(readOnly):: self + __gcePersistentDiskMixin({readOnly: readOnly}),\n            },\n            gcePersistentDiskType:: hidden.core.v1.gcePersistentDiskVolumeSource,\n            // GitRepo represents a git repository at a particular revision.\n            gitRepo:: {\n              local __gitRepoMixin(gitRepo) = {gitRepo+: gitRepo},\n              mixinInstance(gitRepo):: __gitRepoMixin(gitRepo),\n              // Target directory name. Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.\n              withDirectory(directory):: self + __gitRepoMixin({directory: directory}),\n              // Repository URL\n              withRepository(repository):: self + __gitRepoMixin({repository: repository}),\n              // Commit hash for the specified revision.\n              withRevision(revision):: self + __gitRepoMixin({revision: revision}),\n            },\n            gitRepoType:: hidden.core.v1.gitRepoVolumeSource,\n            // Glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md\n            glusterfs:: {\n              local __glusterfsMixin(glusterfs) = {glusterfs+: glusterfs},\n              mixinInstance(glusterfs):: __glusterfsMixin(glusterfs),\n              // EndpointsName is the endpoint name that details Glusterfs topology. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withEndpoints(endpoints):: self + __glusterfsMixin({endpoints: endpoints}),\n              // Path is the Glusterfs volume path. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withPath(path):: self + __glusterfsMixin({path: path}),\n              // ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod\n              withReadOnly(readOnly):: self + __glusterfsMixin({readOnly: readOnly}),\n            },\n            glusterfsType:: hidden.core.v1.glusterfsVolumeSource,\n            // HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n            hostPath:: {\n              local __hostPathMixin(hostPath) = {hostPath+: hostPath},\n              mixinInstance(hostPath):: __hostPathMixin(hostPath),\n              // Path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n              withPath(path):: self + __hostPathMixin({path: path}),\n              // Type for HostPath Volume Defaults to \"\" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n              withType(type):: self + __hostPathMixin({type: type}),\n            },\n            hostPathType:: hidden.core.v1.hostPathVolumeSource,\n            // ISCSI represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://releases.k8s.io/HEAD/examples/volumes/iscsi/README.md\n            iscsi:: {\n              local __iscsiMixin(iscsi) = {iscsi+: iscsi},\n              mixinInstance(iscsi):: __iscsiMixin(iscsi),\n              // whether support iSCSI Discovery CHAP authentication\n              withChapAuthDiscovery(chapAuthDiscovery):: self + __iscsiMixin({chapAuthDiscovery: chapAuthDiscovery}),\n              // whether support iSCSI Session CHAP authentication\n              withChapAuthSession(chapAuthSession):: self + __iscsiMixin({chapAuthSession: chapAuthSession}),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi\n              withFsType(fsType):: self + __iscsiMixin({fsType: fsType}),\n              // Custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.\n              withInitiatorName(initiatorName):: self + __iscsiMixin({initiatorName: initiatorName}),\n              // Target iSCSI Qualified Name.\n              withIqn(iqn):: self + __iscsiMixin({iqn: iqn}),\n              // iSCSI Interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).\n              withIscsiInterface(iscsiInterface):: self + __iscsiMixin({iscsiInterface: iscsiInterface}),\n              // iSCSI Target Lun number.\n              withLun(lun):: self + __iscsiMixin({lun: lun}),\n              // iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withPortals(portals):: self + if std.type(portals) == \"array\" then __iscsiMixin({portals: portals}) else __iscsiMixin({portals: [portals]}),\n              // iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withPortalsMixin(portals):: self + if std.type(portals) == \"array\" then __iscsiMixin({portals+: portals}) else __iscsiMixin({portals+: [portals]}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.\n              withReadOnly(readOnly):: self + __iscsiMixin({readOnly: readOnly}),\n              // CHAP Secret for iSCSI target and initiator authentication\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __iscsiMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n              },\n              secretRefType:: hidden.core.v1.localObjectReference,\n              // iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).\n              withTargetPortal(targetPortal):: self + __iscsiMixin({targetPortal: targetPortal}),\n            },\n            iscsiType:: hidden.core.v1.iscsiVolumeSource,\n            // NFS represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n            nfs:: {\n              local __nfsMixin(nfs) = {nfs+: nfs},\n              mixinInstance(nfs):: __nfsMixin(nfs),\n              // Path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withPath(path):: self + __nfsMixin({path: path}),\n              // ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withReadOnly(readOnly):: self + __nfsMixin({readOnly: readOnly}),\n              // Server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n              withServer(server):: self + __nfsMixin({server: server}),\n            },\n            nfsType:: hidden.core.v1.nfsVolumeSource,\n            // PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims\n            persistentVolumeClaim:: {\n              local __persistentVolumeClaimMixin(persistentVolumeClaim) = {persistentVolumeClaim+: persistentVolumeClaim},\n              mixinInstance(persistentVolumeClaim):: __persistentVolumeClaimMixin(persistentVolumeClaim),\n              // ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims\n              withClaimName(claimName):: self + __persistentVolumeClaimMixin({claimName: claimName}),\n              // Will force the ReadOnly setting in VolumeMounts. Default false.\n              withReadOnly(readOnly):: self + __persistentVolumeClaimMixin({readOnly: readOnly}),\n            },\n            persistentVolumeClaimType:: hidden.core.v1.persistentVolumeClaimVolumeSource,\n            // PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine\n            photonPersistentDisk:: {\n              local __photonPersistentDiskMixin(photonPersistentDisk) = {photonPersistentDisk+: photonPersistentDisk},\n              mixinInstance(photonPersistentDisk):: __photonPersistentDiskMixin(photonPersistentDisk),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __photonPersistentDiskMixin({fsType: fsType}),\n              // ID that identifies Photon Controller persistent disk\n              withPdId(pdId):: self + __photonPersistentDiskMixin({pdID: pdId}),\n            },\n            photonPersistentDiskType:: hidden.core.v1.photonPersistentDiskVolumeSource,\n            // PortworxVolume represents a portworx volume attached and mounted on kubelets host machine\n            portworxVolume:: {\n              local __portworxVolumeMixin(portworxVolume) = {portworxVolume+: portworxVolume},\n              mixinInstance(portworxVolume):: __portworxVolumeMixin(portworxVolume),\n              // FSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __portworxVolumeMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __portworxVolumeMixin({readOnly: readOnly}),\n              // VolumeID uniquely identifies a Portworx volume\n              withVolumeId(volumeId):: self + __portworxVolumeMixin({volumeID: volumeId}),\n            },\n            portworxVolumeType:: hidden.core.v1.portworxVolumeSource,\n            // Items for all in one resources secrets, configmaps, and downward API\n            projected:: {\n              local __projectedMixin(projected) = {projected+: projected},\n              mixinInstance(projected):: __projectedMixin(projected),\n              // Mode bits to use on created files by default. Must be a value between 0 and 0777. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n              withDefaultMode(defaultMode):: self + __projectedMixin({defaultMode: defaultMode}),\n              // list of volume projections\n              withSources(sources):: self + if std.type(sources) == \"array\" then __projectedMixin({sources: sources}) else __projectedMixin({sources: [sources]}),\n              // list of volume projections\n              withSourcesMixin(sources):: self + if std.type(sources) == \"array\" then __projectedMixin({sources+: sources}) else __projectedMixin({sources+: [sources]}),\n              sourcesType:: hidden.core.v1.volumeProjection,\n            },\n            projectedType:: hidden.core.v1.projectedVolumeSource,\n            // Quobyte represents a Quobyte mount on the host that shares a pod's lifetime\n            quobyte:: {\n              local __quobyteMixin(quobyte) = {quobyte+: quobyte},\n              mixinInstance(quobyte):: __quobyteMixin(quobyte),\n              // Group to map volume access to Default is no group\n              withGroup(group):: self + __quobyteMixin({group: group}),\n              // ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.\n              withReadOnly(readOnly):: self + __quobyteMixin({readOnly: readOnly}),\n              // Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes\n              withRegistry(registry):: self + __quobyteMixin({registry: registry}),\n              // User to map volume access to Defaults to serivceaccount user\n              withUser(user):: self + __quobyteMixin({user: user}),\n              // Volume is a string that references an already created Quobyte volume by name.\n              withVolume(volume):: self + __quobyteMixin({volume: volume}),\n            },\n            quobyteType:: hidden.core.v1.quobyteVolumeSource,\n            // RBD represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md\n            rbd:: {\n              local __rbdMixin(rbd) = {rbd+: rbd},\n              mixinInstance(rbd):: __rbdMixin(rbd),\n              // Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd\n              withFsType(fsType):: self + __rbdMixin({fsType: fsType}),\n              // The rados image name. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withImage(image):: self + __rbdMixin({image: image}),\n              // Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withKeyring(keyring):: self + __rbdMixin({keyring: keyring}),\n              // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withMonitors(monitors):: self + if std.type(monitors) == \"array\" then __rbdMixin({monitors: monitors}) else __rbdMixin({monitors: [monitors]}),\n              // A collection of Ceph monitors. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withMonitorsMixin(monitors):: self + if std.type(monitors) == \"array\" then __rbdMixin({monitors+: monitors}) else __rbdMixin({monitors+: [monitors]}),\n              // The rados pool name. Default is rbd. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withPool(pool):: self + __rbdMixin({pool: pool}),\n              // ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withReadOnly(readOnly):: self + __rbdMixin({readOnly: readOnly}),\n              // SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __rbdMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n              },\n              secretRefType:: hidden.core.v1.localObjectReference,\n              // The rados user name. Default is admin. More info: https://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it\n              withUser(user):: self + __rbdMixin({user: user}),\n            },\n            rbdType:: hidden.core.v1.rbdVolumeSource,\n            // ScaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.\n            scaleIo:: {\n              local __scaleIoMixin(scaleIo) = {scaleIo+: scaleIo},\n              mixinInstance(scaleIo):: __scaleIoMixin(scaleIo),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __scaleIoMixin({fsType: fsType}),\n              // The host address of the ScaleIO API Gateway.\n              withGateway(gateway):: self + __scaleIoMixin({gateway: gateway}),\n              // The name of the ScaleIO Protection Domain for the configured storage.\n              withProtectionDomain(protectionDomain):: self + __scaleIoMixin({protectionDomain: protectionDomain}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __scaleIoMixin({readOnly: readOnly}),\n              // SecretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __scaleIoMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n              },\n              secretRefType:: hidden.core.v1.localObjectReference,\n              // Flag to enable/disable SSL communication with Gateway, default false\n              withSslEnabled(sslEnabled):: self + __scaleIoMixin({sslEnabled: sslEnabled}),\n              // Indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.\n              withStorageMode(storageMode):: self + __scaleIoMixin({storageMode: storageMode}),\n              // The ScaleIO Storage Pool associated with the protection domain.\n              withStoragePool(storagePool):: self + __scaleIoMixin({storagePool: storagePool}),\n              // The name of the storage system as configured in ScaleIO.\n              withSystem(system):: self + __scaleIoMixin({system: system}),\n              // The name of a volume already created in the ScaleIO system that is associated with this volume source.\n              withVolumeName(volumeName):: self + __scaleIoMixin({volumeName: volumeName}),\n            },\n            scaleIOType:: hidden.core.v1.scaleIoVolumeSource,\n            // Secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret\n            secret:: {\n              local __secretMixin(secret) = {secret+: secret},\n              mixinInstance(secret):: __secretMixin(secret),\n              // Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.\n              withDefaultMode(defaultMode):: self + __secretMixin({defaultMode: defaultMode}),\n              // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItems(items):: self + if std.type(items) == \"array\" then __secretMixin({items: items}) else __secretMixin({items: [items]}),\n              // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItemsMixin(items):: self + if std.type(items) == \"array\" then __secretMixin({items+: items}) else __secretMixin({items+: [items]}),\n              itemsType:: hidden.core.v1.keyToPath,\n              // Specify whether the Secret or it's keys must be defined\n              withOptional(optional):: self + __secretMixin({optional: optional}),\n              // Name of the secret in the pod's namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret\n              withSecretName(secretName):: self + __secretMixin({secretName: secretName}),\n            },\n            secretType:: hidden.core.v1.secretVolumeSource,\n            // StorageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.\n            storageos:: {\n              local __storageosMixin(storageos) = {storageos+: storageos},\n              mixinInstance(storageos):: __storageosMixin(storageos),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __storageosMixin({fsType: fsType}),\n              // Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.\n              withReadOnly(readOnly):: self + __storageosMixin({readOnly: readOnly}),\n              // SecretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.\n              secretRef:: {\n                local __secretRefMixin(secretRef) = __storageosMixin({secretRef+: secretRef}),\n                mixinInstance(secretRef):: __secretRefMixin(secretRef),\n                // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n                withName(name):: self + __secretRefMixin({name: name}),\n              },\n              secretRefType:: hidden.core.v1.localObjectReference,\n              // VolumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.\n              withVolumeName(volumeName):: self + __storageosMixin({volumeName: volumeName}),\n              // VolumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to \"default\" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.\n              withVolumeNamespace(volumeNamespace):: self + __storageosMixin({volumeNamespace: volumeNamespace}),\n            },\n            storageosType:: hidden.core.v1.storageOsVolumeSource,\n            // VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine\n            vsphereVolume:: {\n              local __vsphereVolumeMixin(vsphereVolume) = {vsphereVolume+: vsphereVolume},\n              mixinInstance(vsphereVolume):: __vsphereVolumeMixin(vsphereVolume),\n              // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n              withFsType(fsType):: self + __vsphereVolumeMixin({fsType: fsType}),\n              // Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.\n              withStoragePolicyId(storagePolicyId):: self + __vsphereVolumeMixin({storagePolicyID: storagePolicyId}),\n              // Storage Policy Based Management (SPBM) profile name.\n              withStoragePolicyName(storagePolicyName):: self + __vsphereVolumeMixin({storagePolicyName: storagePolicyName}),\n              // Path that identifies vSphere volume vmdk\n              withVolumePath(volumePath):: self + __vsphereVolumeMixin({volumePath: volumePath}),\n            },\n            vsphereVolumeType:: hidden.core.v1.vsphereVirtualDiskVolumeSource,\n          },\n        },\n        // volumeDevice describes a mapping of a raw block device within a container.\n        volumeDevice:: {\n          new():: {},\n          // devicePath is the path inside of the container that the device will be mapped to.\n          withDevicePath(devicePath):: self + {devicePath: devicePath},\n          // name must match the name of a persistentVolumeClaim in the pod\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // VolumeMount describes a mounting of a Volume within a container.\n        volumeMount:: {\n          new(name=\"\", mountPath=\"\", readOnly=false):: self.withMountPath(mountPath).withName(name).withReadOnly(readOnly),\n          // Path within the container at which the volume should be mounted.  Must not contain ':'.\n          withMountPath(mountPath):: self + {mountPath: mountPath},\n          // mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationHostToContainer is used. This field is beta in 1.10.\n          withMountPropagation(mountPropagation):: self + {mountPropagation: mountPropagation},\n          // This must match the Name of a Volume.\n          withName(name):: self + {name: name},\n          // Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.\n          withReadOnly(readOnly):: self + {readOnly: readOnly},\n          // Path within the volume from which the container's volume should be mounted. Defaults to \"\" (volume's root).\n          withSubPath(subPath):: self + {subPath: subPath},\n          mixin:: {\n          },\n        },\n        // VolumeNodeAffinity defines constraints that limit what nodes this volume can be accessed from.\n        volumeNodeAffinity:: {\n          new():: {},\n          mixin:: {\n            // Required specifies hard node constraints that must be met.\n            required:: {\n              local __requiredMixin(required) = {required+: required},\n              mixinInstance(required):: __requiredMixin(required),\n              // Required. A list of node selector terms. The terms are ORed.\n              withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n              // Required. A list of node selector terms. The terms are ORed.\n              withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n              nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n            },\n            requiredType:: hidden.core.v1.nodeSelector,\n          },\n        },\n        // Projection that may be projected along with other supported volume types\n        volumeProjection:: {\n          new():: {},\n          mixin:: {\n            // information about the configMap data to project\n            configMap:: {\n              local __configMapMixin(configMap) = {configMap+: configMap},\n              mixinInstance(configMap):: __configMapMixin(configMap),\n              // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItems(items):: self + if std.type(items) == \"array\" then __configMapMixin({items: items}) else __configMapMixin({items: [items]}),\n              // If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItemsMixin(items):: self + if std.type(items) == \"array\" then __configMapMixin({items+: items}) else __configMapMixin({items+: [items]}),\n              itemsType:: hidden.core.v1.keyToPath,\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __configMapMixin({name: name}),\n              // Specify whether the ConfigMap or it's keys must be defined\n              withOptional(optional):: self + __configMapMixin({optional: optional}),\n            },\n            configMapType:: hidden.core.v1.configMapProjection,\n            // information about the downwardAPI data to project\n            downwardApi:: {\n              local __downwardApiMixin(downwardApi) = {downwardApi+: downwardApi},\n              mixinInstance(downwardApi):: __downwardApiMixin(downwardApi),\n              // Items is a list of DownwardAPIVolume file\n              withItems(items):: self + if std.type(items) == \"array\" then __downwardApiMixin({items: items}) else __downwardApiMixin({items: [items]}),\n              // Items is a list of DownwardAPIVolume file\n              withItemsMixin(items):: self + if std.type(items) == \"array\" then __downwardApiMixin({items+: items}) else __downwardApiMixin({items+: [items]}),\n              itemsType:: hidden.core.v1.downwardApiVolumeFile,\n            },\n            downwardAPIType:: hidden.core.v1.downwardApiProjection,\n            // information about the secret data to project\n            secret:: {\n              local __secretMixin(secret) = {secret+: secret},\n              mixinInstance(secret):: __secretMixin(secret),\n              // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItems(items):: self + if std.type(items) == \"array\" then __secretMixin({items: items}) else __secretMixin({items: [items]}),\n              // If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.\n              withItemsMixin(items):: self + if std.type(items) == \"array\" then __secretMixin({items+: items}) else __secretMixin({items+: [items]}),\n              itemsType:: hidden.core.v1.keyToPath,\n              // Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n              withName(name):: self + __secretMixin({name: name}),\n              // Specify whether the Secret or its key must be defined\n              withOptional(optional):: self + __secretMixin({optional: optional}),\n            },\n            secretType:: hidden.core.v1.secretProjection,\n          },\n        },\n        // Represents a vSphere volume resource.\n        vsphereVirtualDiskVolumeSource:: {\n          new():: {},\n          // Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n          withFsType(fsType):: self + {fsType: fsType},\n          // Storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.\n          withStoragePolicyId(storagePolicyId):: self + {storagePolicyID: storagePolicyId},\n          // Storage Policy Based Management (SPBM) profile name.\n          withStoragePolicyName(storagePolicyName):: self + {storagePolicyName: storagePolicyName},\n          // Path that identifies vSphere volume vmdk\n          withVolumePath(volumePath):: self + {volumePath: volumePath},\n          mixin:: {\n          },\n        },\n        // The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)\n        weightedPodAffinityTerm:: {\n          new():: {},\n          // weight associated with matching the corresponding podAffinityTerm, in the range 1-100.\n          withWeight(weight):: self + {weight: weight},\n          mixin:: {\n            // Required. A pod affinity term, associated with the corresponding weight.\n            podAffinityTerm:: {\n              local __podAffinityTermMixin(podAffinityTerm) = {podAffinityTerm+: podAffinityTerm},\n              mixinInstance(podAffinityTerm):: __podAffinityTermMixin(podAffinityTerm),\n              // A label query over a set of resources, in this case pods.\n              labelSelector:: {\n                local __labelSelectorMixin(labelSelector) = __podAffinityTermMixin({labelSelector+: labelSelector}),\n                mixinInstance(labelSelector):: __labelSelectorMixin(labelSelector),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __labelSelectorMixin({matchExpressions: matchExpressions}) else __labelSelectorMixin({matchExpressions: [matchExpressions]}),\n                // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n                withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __labelSelectorMixin({matchExpressions+: matchExpressions}) else __labelSelectorMixin({matchExpressions+: [matchExpressions]}),\n                matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabels(matchLabels):: self + __labelSelectorMixin({matchLabels: matchLabels}),\n                // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n                withMatchLabelsMixin(matchLabels):: self + __labelSelectorMixin({matchLabels+: matchLabels}),\n              },\n              labelSelectorType:: hidden.meta.v1.labelSelector,\n              // namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means \"this pod's namespace\"\n              withNamespaces(namespaces):: self + if std.type(namespaces) == \"array\" then __podAffinityTermMixin({namespaces: namespaces}) else __podAffinityTermMixin({namespaces: [namespaces]}),\n              // namespaces specifies which namespaces the labelSelector applies to (matches against); null or empty list means \"this pod's namespace\"\n              withNamespacesMixin(namespaces):: self + if std.type(namespaces) == \"array\" then __podAffinityTermMixin({namespaces+: namespaces}) else __podAffinityTermMixin({namespaces+: [namespaces]}),\n              // This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.\n              withTopologyKey(topologyKey):: self + __podAffinityTermMixin({topologyKey: topologyKey}),\n            },\n            podAffinityTermType:: hidden.core.v1.podAffinityTerm,\n          },\n        },\n      },\n    },\n    events:: {\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"events/v1beta1\"},\n        // EventList is a list of Event objects.\n        eventList:: {\n          new():: {},\n          // Items is a list of schema objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of schema objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.events.v1beta1.event,\n          mixin:: {\n          },\n        },\n        // EventSeries contain information on series of events, i.e. thing that was/is happening continuously for some time.\n        eventSeries:: {\n          new():: {},\n          // Number of occurrences in this series up to the last heartbeat time\n          withCount(count):: self + {count: count},\n          // Time when last Event from the series was seen before last heartbeat.\n          withLastObservedTime(lastObservedTime):: self + {lastObservedTime: lastObservedTime},\n          // Information whether this series is ongoing or finished.\n          withState(state):: self + {state: state},\n          mixin:: {\n          },\n        },\n      },\n    },\n    extensions:: {\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"extensions/v1beta1\"},\n        // AllowedFlexVolume represents a single Flexvolume that is allowed to be used.\n        allowedFlexVolume:: {\n          new():: {},\n          // Driver is the name of the Flexvolume driver.\n          withDriver(driver):: self + {driver: driver},\n          mixin:: {\n          },\n        },\n        // defines the host volume conditions that will be enabled by a policy for pods to use. It requires the path prefix to be defined.\n        allowedHostPath:: {\n          new():: {},\n          // is the path prefix that the host volume must match. It does not support `*`. Trailing slashes are trimmed when validating the path prefix with a host path.\n          //\n          // Examples: `/foo` would allow `/foo`, `/foo/` and `/foo/bar` `/foo` would not allow `/food` or `/etc/foo`\n          withPathPrefix(pathPrefix):: self + {pathPrefix: pathPrefix},\n          mixin:: {\n          },\n        },\n        // DaemonSetCondition describes the state of a DaemonSet at a certain point.\n        daemonSetCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of DaemonSet condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DaemonSetList is a collection of daemon sets.\n        daemonSetList:: {\n          new():: {},\n          // A list of daemon sets.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // A list of daemon sets.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.extensions.v1beta1.daemonSet,\n          mixin:: {\n          },\n        },\n        // DaemonSetSpec is the specification of a daemon set.\n        daemonSetSpec:: {\n          new():: {},\n          // The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready).\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // The number of old history to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          // DEPRECATED. A sequence number representing a specific generation of the template. Populated by the system. It can be set only during the creation.\n          withTemplateGeneration(templateGeneration):: self + {templateGeneration: templateGeneration},\n          mixin:: {\n            // A label query over pods that are managed by the daemon set. Must match in order to be controlled. If empty, defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // An object that describes the pod that will be created. The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n            // An update strategy to replace existing DaemonSet pods with new pods.\n            updateStrategy:: {\n              local __updateStrategyMixin(updateStrategy) = {updateStrategy+: updateStrategy},\n              mixinInstance(updateStrategy):: __updateStrategyMixin(updateStrategy),\n              // Rolling update config params. Present only if type = \"RollingUpdate\".\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __updateStrategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.extensions.v1beta1.rollingUpdateDaemonSet,\n              // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is OnDelete.\n              withType(type):: self + __updateStrategyMixin({type: type}),\n            },\n            updateStrategyType:: hidden.extensions.v1beta1.daemonSetUpdateStrategy,\n          },\n        },\n        // DaemonSetStatus represents the current status of a daemon set.\n        daemonSetStatus:: {\n          new():: {},\n          // Count of hash collisions for the DaemonSet. The DaemonSet controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ControllerRevision.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a DaemonSet's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a DaemonSet's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.extensions.v1beta1.daemonSetCondition,\n          // The number of nodes that are running at least 1 daemon pod and are supposed to run the daemon pod. More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withCurrentNumberScheduled(currentNumberScheduled):: self + {currentNumberScheduled: currentNumberScheduled},\n          // The total number of nodes that should be running the daemon pod (including nodes correctly running the daemon pod). More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withDesiredNumberScheduled(desiredNumberScheduled):: self + {desiredNumberScheduled: desiredNumberScheduled},\n          // The number of nodes that should be running the daemon pod and have one or more of the daemon pod running and available (ready for at least spec.minReadySeconds)\n          withNumberAvailable(numberAvailable):: self + {numberAvailable: numberAvailable},\n          // The number of nodes that are running the daemon pod, but are not supposed to run the daemon pod. More info: https://kubernetes.io/docs/concepts/workloads/controllers/daemonset/\n          withNumberMisscheduled(numberMisscheduled):: self + {numberMisscheduled: numberMisscheduled},\n          // The number of nodes that should be running the daemon pod and have one or more of the daemon pod running and ready.\n          withNumberReady(numberReady):: self + {numberReady: numberReady},\n          // The number of nodes that should be running the daemon pod and have none of the daemon pod running and available (ready for at least spec.minReadySeconds)\n          withNumberUnavailable(numberUnavailable):: self + {numberUnavailable: numberUnavailable},\n          // The most recent generation observed by the daemon set controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The total number of nodes that are running updated daemon pod\n          withUpdatedNumberScheduled(updatedNumberScheduled):: self + {updatedNumberScheduled: updatedNumberScheduled},\n          mixin:: {\n          },\n        },\n        daemonSetUpdateStrategy:: {\n          new():: {},\n          // Type of daemon set update. Can be \"RollingUpdate\" or \"OnDelete\". Default is OnDelete.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if type = \"RollingUpdate\".\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.extensions.v1beta1.rollingUpdateDaemonSet,\n          },\n        },\n        // DeploymentCondition describes the state of a deployment at a certain point.\n        deploymentCondition:: {\n          new():: {},\n          // Last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // The last time this condition was updated.\n          withLastUpdateTime(lastUpdateTime):: self + {lastUpdateTime: lastUpdateTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of deployment condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // DeploymentList is a list of Deployments.\n        deploymentList:: {\n          new(items=\"\"):: self.withItems(items),\n          // Items is the list of Deployments.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of Deployments.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.extensions.v1beta1.deployment,\n          mixin:: {\n          },\n        },\n        // DeploymentSpec is the specification of the desired behavior of the Deployment.\n        deploymentSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Indicates that the deployment is paused and will not be processed by the deployment controller.\n          withPaused(paused):: self + {paused: paused},\n          // The maximum time in seconds for a deployment to make progress before it is considered to be failed. The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. This is not set by default.\n          withProgressDeadlineSeconds(progressDeadlineSeconds):: self + {progressDeadlineSeconds: progressDeadlineSeconds},\n          // Number of desired pods. This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // The number of old ReplicaSets to retain to allow rollback. This is a pointer to distinguish between explicit zero and not specified.\n          withRevisionHistoryLimit(revisionHistoryLimit):: self + {revisionHistoryLimit: revisionHistoryLimit},\n          mixin:: {\n            // DEPRECATED. The config this deployment is rolling back to. Will be cleared after rollback is done.\n            rollbackTo:: {\n              local __rollbackToMixin(rollbackTo) = {rollbackTo+: rollbackTo},\n              mixinInstance(rollbackTo):: __rollbackToMixin(rollbackTo),\n              // The revision to rollback to. If set to 0, rollback to the last revision.\n              withRevision(revision):: self + __rollbackToMixin({revision: revision}),\n            },\n            rollbackToType:: hidden.extensions.v1beta1.rollbackConfig,\n            // Label selector for pods. Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // The deployment strategy to use to replace existing pods with new ones.\n            strategy:: {\n              local __strategyMixin(strategy) = {strategy+: strategy},\n              mixinInstance(strategy):: __strategyMixin(strategy),\n              // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n              rollingUpdate:: {\n                local __rollingUpdateMixin(rollingUpdate) = __strategyMixin({rollingUpdate+: rollingUpdate}),\n                mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n                // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. By default, a value of 1 is used. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n                withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n                // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. By default, a fixed value of 1 is used. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n                withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n              },\n              rollingUpdateType:: hidden.extensions.v1beta1.rollingUpdateDeployment,\n              // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n              withType(type):: self + __strategyMixin({type: type}),\n            },\n            strategyType:: hidden.extensions.v1beta1.deploymentStrategy,\n            // Template describes the pods that will be created.\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // DeploymentStatus is the most recently observed status of the Deployment.\n        deploymentStatus:: {\n          new():: {},\n          // Total number of available pods (ready for at least minReadySeconds) targeted by this deployment.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Count of hash collisions for the Deployment. The Deployment controller uses this field as a collision avoidance mechanism when it needs to create the name for the newest ReplicaSet.\n          withCollisionCount(collisionCount):: self + {collisionCount: collisionCount},\n          // Represents the latest available observations of a deployment's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a deployment's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.extensions.v1beta1.deploymentCondition,\n          // The generation observed by the deployment controller.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // Total number of ready pods targeted by this deployment.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Total number of non-terminated pods targeted by this deployment (their labels match the selector).\n          withReplicas(replicas):: self + {replicas: replicas},\n          // Total number of unavailable pods targeted by this deployment. This is the total number of pods that are still required for the deployment to have 100% available capacity. They may either be pods that are running but not yet available or pods that still have not been created.\n          withUnavailableReplicas(unavailableReplicas):: self + {unavailableReplicas: unavailableReplicas},\n          // Total number of non-terminated pods targeted by this deployment that have the desired template spec.\n          withUpdatedReplicas(updatedReplicas):: self + {updatedReplicas: updatedReplicas},\n          mixin:: {\n          },\n        },\n        // DeploymentStrategy describes how to replace existing pods with new ones.\n        deploymentStrategy:: {\n          new():: {},\n          // Type of deployment. Can be \"Recreate\" or \"RollingUpdate\". Default is RollingUpdate.\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Rolling update config params. Present only if DeploymentStrategyType = RollingUpdate.\n            rollingUpdate:: {\n              local __rollingUpdateMixin(rollingUpdate) = {rollingUpdate+: rollingUpdate},\n              mixinInstance(rollingUpdate):: __rollingUpdateMixin(rollingUpdate),\n              // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. By default, a value of 1 is used. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n              withMaxSurge(maxSurge):: self + __rollingUpdateMixin({maxSurge: maxSurge}),\n              // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. By default, a fixed value of 1 is used. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n              withMaxUnavailable(maxUnavailable):: self + __rollingUpdateMixin({maxUnavailable: maxUnavailable}),\n            },\n            rollingUpdateType:: hidden.extensions.v1beta1.rollingUpdateDeployment,\n          },\n        },\n        // FSGroupStrategyOptions defines the strategy type and options used to create the strategy.\n        fsGroupStrategyOptions:: {\n          new():: {},\n          // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n          withRanges(ranges):: self + if std.type(ranges) == \"array\" then {ranges: ranges} else {ranges: [ranges]},\n          // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n          withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then {ranges+: ranges} else {ranges+: [ranges]},\n          rangesType:: hidden.extensions.v1beta1.idRange,\n          // Rule is the strategy that will dictate what FSGroup is used in the SecurityContext.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n          },\n        },\n        // Host Port Range defines a range of host ports that will be enabled by a policy for pods to use.  It requires both the start and end to be defined.\n        hostPortRange:: {\n          new():: {},\n          // max is the end of the range, inclusive.\n          withMax(max):: self + {max: max},\n          // min is the start of the range, inclusive.\n          withMin(min):: self + {min: min},\n          mixin:: {\n          },\n        },\n        // HTTPIngressPath associates a path regex with a backend. Incoming urls matching the path are forwarded to the backend.\n        httpIngressPath:: {\n          new():: {},\n          // Path is an extended POSIX regex as defined by IEEE Std 1003.1, (i.e this follows the egrep/unix syntax, not the perl syntax) matched against the path of an incoming request. Currently it can contain characters disallowed from the conventional \"path\" part of a URL as defined by RFC 3986. Paths must begin with a '/'. If unspecified, the path defaults to a catch all sending traffic to the backend.\n          withPath(path):: self + {path: path},\n          mixin:: {\n            // Backend defines the referenced service endpoint to which the traffic will be forwarded to.\n            backend:: {\n              local __backendMixin(backend) = {backend+: backend},\n              mixinInstance(backend):: __backendMixin(backend),\n              // Specifies the name of the referenced service.\n              withServiceName(serviceName):: self + __backendMixin({serviceName: serviceName}),\n              // Specifies the port of the referenced service.\n              withServicePort(servicePort):: self + __backendMixin({servicePort: servicePort}),\n            },\n            backendType:: hidden.extensions.v1beta1.ingressBackend,\n          },\n        },\n        // HTTPIngressRuleValue is a list of http selectors pointing to backends. In the example: http://<host>/<path>?<searchpart> -> backend where where parts of the url correspond to RFC 3986, this resource will be used to match against everything after the last '/' and before the first '?' or '#'.\n        httpIngressRuleValue:: {\n          new():: {},\n          // A collection of paths that map requests to backends.\n          withPaths(paths):: self + if std.type(paths) == \"array\" then {paths: paths} else {paths: [paths]},\n          // A collection of paths that map requests to backends.\n          withPathsMixin(paths):: self + if std.type(paths) == \"array\" then {paths+: paths} else {paths+: [paths]},\n          pathsType:: hidden.extensions.v1beta1.httpIngressPath,\n          mixin:: {\n          },\n        },\n        // ID Range provides a min/max of an allowed range of IDs.\n        idRange:: {\n          new():: {},\n          // Max is the end of the range, inclusive.\n          withMax(max):: self + {max: max},\n          // Min is the start of the range, inclusive.\n          withMin(min):: self + {min: min},\n          mixin:: {\n          },\n        },\n        // IngressBackend describes all endpoints for a given service and port.\n        ingressBackend:: {\n          new():: {},\n          // Specifies the name of the referenced service.\n          withServiceName(serviceName):: self + {serviceName: serviceName},\n          // Specifies the port of the referenced service.\n          withServicePort(servicePort):: self + {servicePort: servicePort},\n          mixin:: {\n          },\n        },\n        // IngressList is a collection of Ingress.\n        ingressList:: {\n          new():: {},\n          // Items is the list of Ingress.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of Ingress.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.extensions.v1beta1.ingress,\n          mixin:: {\n          },\n        },\n        // IngressRule represents the rules mapping the paths under a specified host to the related backend services. Incoming requests are first evaluated for a host match, then routed to the backend associated with the matching IngressRuleValue.\n        ingressRule:: {\n          new():: {},\n          // Host is the fully qualified domain name of a network host, as defined by RFC 3986. Note the following deviations from the \"host\" part of the URI as defined in the RFC: 1. IPs are not allowed. Currently an IngressRuleValue can only apply to the\n          // IP in the Spec of the parent Ingress.\n          // 2. The `:` delimiter is not respected because ports are not allowed.\n          // Currently the port of an Ingress is implicitly :80 for http and\n          // :443 for https.\n          // Both these may change in the future. Incoming requests are matched against the host before the IngressRuleValue. If the host is unspecified, the Ingress routes all traffic based on the specified IngressRuleValue.\n          withHost(host):: self + {host: host},\n          mixin:: {\n            http:: {\n              local __httpMixin(http) = {http+: http},\n              mixinInstance(http):: __httpMixin(http),\n              // A collection of paths that map requests to backends.\n              withPaths(paths):: self + if std.type(paths) == \"array\" then __httpMixin({paths: paths}) else __httpMixin({paths: [paths]}),\n              // A collection of paths that map requests to backends.\n              withPathsMixin(paths):: self + if std.type(paths) == \"array\" then __httpMixin({paths+: paths}) else __httpMixin({paths+: [paths]}),\n              pathsType:: hidden.extensions.v1beta1.httpIngressPath,\n            },\n            httpType:: hidden.extensions.v1beta1.httpIngressRuleValue,\n          },\n        },\n        // IngressSpec describes the Ingress the user wishes to exist.\n        ingressSpec:: {\n          new():: {},\n          // A list of host rules used to configure the Ingress. If unspecified, or no rule matches, all traffic is sent to the default backend.\n          withRules(rules):: self + if std.type(rules) == \"array\" then {rules: rules} else {rules: [rules]},\n          // A list of host rules used to configure the Ingress. If unspecified, or no rule matches, all traffic is sent to the default backend.\n          withRulesMixin(rules):: self + if std.type(rules) == \"array\" then {rules+: rules} else {rules+: [rules]},\n          rulesType:: hidden.extensions.v1beta1.ingressRule,\n          // TLS configuration. Currently the Ingress only supports a single TLS port, 443. If multiple members of this list specify different hosts, they will be multiplexed on the same port according to the hostname specified through the SNI TLS extension, if the ingress controller fulfilling the ingress supports SNI.\n          withTls(tls):: self + if std.type(tls) == \"array\" then {tls: tls} else {tls: [tls]},\n          // TLS configuration. Currently the Ingress only supports a single TLS port, 443. If multiple members of this list specify different hosts, they will be multiplexed on the same port according to the hostname specified through the SNI TLS extension, if the ingress controller fulfilling the ingress supports SNI.\n          withTlsMixin(tls):: self + if std.type(tls) == \"array\" then {tls+: tls} else {tls+: [tls]},\n          tlsType:: hidden.extensions.v1beta1.ingressTls,\n          mixin:: {\n            // A default backend capable of servicing requests that don't match any rule. At least one of 'backend' or 'rules' must be specified. This field is optional to allow the loadbalancer controller or defaulting logic to specify a global default.\n            backend:: {\n              local __backendMixin(backend) = {backend+: backend},\n              mixinInstance(backend):: __backendMixin(backend),\n              // Specifies the name of the referenced service.\n              withServiceName(serviceName):: self + __backendMixin({serviceName: serviceName}),\n              // Specifies the port of the referenced service.\n              withServicePort(servicePort):: self + __backendMixin({servicePort: servicePort}),\n            },\n            backendType:: hidden.extensions.v1beta1.ingressBackend,\n          },\n        },\n        // IngressStatus describe the current state of the Ingress.\n        ingressStatus:: {\n          new():: {},\n          mixin:: {\n            // LoadBalancer contains the current status of the load-balancer.\n            loadBalancer:: {\n              local __loadBalancerMixin(loadBalancer) = {loadBalancer+: loadBalancer},\n              mixinInstance(loadBalancer):: __loadBalancerMixin(loadBalancer),\n              // Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points.\n              withIngress(ingress):: self + if std.type(ingress) == \"array\" then __loadBalancerMixin({ingress: ingress}) else __loadBalancerMixin({ingress: [ingress]}),\n              // Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points.\n              withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then __loadBalancerMixin({ingress+: ingress}) else __loadBalancerMixin({ingress+: [ingress]}),\n              ingressType:: hidden.core.v1.loadBalancerIngress,\n            },\n            loadBalancerType:: hidden.core.v1.loadBalancerStatus,\n          },\n        },\n        // IngressTLS describes the transport layer security associated with an Ingress.\n        ingressTls:: {\n          new():: {},\n          // Hosts are a list of hosts included in the TLS certificate. The values in this list must match the name/s used in the tlsSecret. Defaults to the wildcard host setting for the loadbalancer controller fulfilling this Ingress, if left unspecified.\n          withHosts(hosts):: self + if std.type(hosts) == \"array\" then {hosts: hosts} else {hosts: [hosts]},\n          // Hosts are a list of hosts included in the TLS certificate. The values in this list must match the name/s used in the tlsSecret. Defaults to the wildcard host setting for the loadbalancer controller fulfilling this Ingress, if left unspecified.\n          withHostsMixin(hosts):: self + if std.type(hosts) == \"array\" then {hosts+: hosts} else {hosts+: [hosts]},\n          // SecretName is the name of the secret used to terminate SSL traffic on 443. Field is left optional to allow SSL routing based on SNI hostname alone. If the SNI host in a listener conflicts with the \"Host\" header field used by an IngressRule, the SNI host is used for termination and value of the Host header is used for routing.\n          withSecretName(secretName):: self + {secretName: secretName},\n          mixin:: {\n          },\n        },\n        // DEPRECATED 1.9 - This group version of IPBlock is deprecated by networking/v1/IPBlock. IPBlock describes a particular CIDR (Ex. \"192.168.1.1/24\") that is allowed to the pods matched by a NetworkPolicySpec's podSelector. The except entry describes CIDRs that should not be included within this rule.\n        ipBlock:: {\n          new():: {},\n          // CIDR is a string representing the IP Block Valid examples are \"192.168.1.1/24\"\n          withCidr(cidr):: self + {cidr: cidr},\n          // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n          withExcept(except):: self + if std.type(except) == \"array\" then {except: except} else {except: [except]},\n          // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n          withExceptMixin(except):: self + if std.type(except) == \"array\" then {except+: except} else {except+: [except]},\n          mixin:: {\n          },\n        },\n        // DEPRECATED 1.9 - This group version of NetworkPolicyEgressRule is deprecated by networking/v1/NetworkPolicyEgressRule. NetworkPolicyEgressRule describes a particular set of traffic that is allowed out of pods matched by a NetworkPolicySpec's podSelector. The traffic must match both ports and to. This type is beta-level in 1.8\n        networkPolicyEgressRule:: {\n          new():: {},\n          // List of destination ports for outgoing traffic. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // List of destination ports for outgoing traffic. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.extensions.v1beta1.networkPolicyPort,\n          // List of destinations for outgoing traffic of pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all destinations (traffic not restricted by destination). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the to list.\n          withTo(to):: self + if std.type(to) == \"array\" then {to: to} else {to: [to]},\n          // List of destinations for outgoing traffic of pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all destinations (traffic not restricted by destination). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the to list.\n          withToMixin(to):: self + if std.type(to) == \"array\" then {to+: to} else {to+: [to]},\n          toType:: hidden.extensions.v1beta1.networkPolicyPeer,\n          mixin:: {\n          },\n        },\n        // DEPRECATED 1.9 - This group version of NetworkPolicyIngressRule is deprecated by networking/v1/NetworkPolicyIngressRule. This NetworkPolicyIngressRule matches traffic if and only if the traffic matches both ports AND from.\n        networkPolicyIngressRule:: {\n          new():: {},\n          // List of sources which should be able to access the pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all sources (traffic not restricted by source). If this field is present and contains at least on item, this rule allows traffic only if the traffic matches at least one item in the from list.\n          withFrom(from):: self + if std.type(from) == \"array\" then {from: from} else {from: [from]},\n          // List of sources which should be able to access the pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all sources (traffic not restricted by source). If this field is present and contains at least on item, this rule allows traffic only if the traffic matches at least one item in the from list.\n          withFromMixin(from):: self + if std.type(from) == \"array\" then {from+: from} else {from+: [from]},\n          fromType:: hidden.extensions.v1beta1.networkPolicyPeer,\n          // List of ports which should be made accessible on the pods selected for this rule. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // List of ports which should be made accessible on the pods selected for this rule. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.extensions.v1beta1.networkPolicyPort,\n          mixin:: {\n          },\n        },\n        // DEPRECATED 1.9 - This group version of NetworkPolicyList is deprecated by networking/v1/NetworkPolicyList. Network Policy List is a list of NetworkPolicy objects.\n        networkPolicyList:: {\n          new():: {},\n          // Items is a list of schema objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of schema objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.extensions.v1beta1.networkPolicy,\n          mixin:: {\n          },\n        },\n        // DEPRECATED 1.9 - This group version of NetworkPolicyPeer is deprecated by networking/v1/NetworkPolicyPeer.\n        networkPolicyPeer:: {\n          new():: {},\n          mixin:: {\n            // IPBlock defines policy on a particular IPBlock\n            ipBlock:: {\n              local __ipBlockMixin(ipBlock) = {ipBlock+: ipBlock},\n              mixinInstance(ipBlock):: __ipBlockMixin(ipBlock),\n              // CIDR is a string representing the IP Block Valid examples are \"192.168.1.1/24\"\n              withCidr(cidr):: self + __ipBlockMixin({cidr: cidr}),\n              // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n              withExcept(except):: self + if std.type(except) == \"array\" then __ipBlockMixin({except: except}) else __ipBlockMixin({except: [except]}),\n              // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n              withExceptMixin(except):: self + if std.type(except) == \"array\" then __ipBlockMixin({except+: except}) else __ipBlockMixin({except+: [except]}),\n            },\n            ipBlockType:: hidden.extensions.v1beta1.ipBlock,\n            // Selects Namespaces using cluster scoped-labels.  This matches all pods in all namespaces selected by this label selector. This field follows standard label selector semantics. If present but empty, this selector selects all namespaces.\n            namespaceSelector:: {\n              local __namespaceSelectorMixin(namespaceSelector) = {namespaceSelector+: namespaceSelector},\n              mixinInstance(namespaceSelector):: __namespaceSelectorMixin(namespaceSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __namespaceSelectorMixin({matchExpressions: matchExpressions}) else __namespaceSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __namespaceSelectorMixin({matchExpressions+: matchExpressions}) else __namespaceSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __namespaceSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __namespaceSelectorMixin({matchLabels+: matchLabels}),\n            },\n            namespaceSelectorType:: hidden.meta.v1.labelSelector,\n            // This is a label selector which selects Pods in this namespace. This field follows standard label selector semantics. If present but empty, this selector selects all pods in this namespace.\n            podSelector:: {\n              local __podSelectorMixin(podSelector) = {podSelector+: podSelector},\n              mixinInstance(podSelector):: __podSelectorMixin(podSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions: matchExpressions}) else __podSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions+: matchExpressions}) else __podSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __podSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __podSelectorMixin({matchLabels+: matchLabels}),\n            },\n            podSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // DEPRECATED 1.9 - This group version of NetworkPolicyPort is deprecated by networking/v1/NetworkPolicyPort.\n        networkPolicyPort:: {\n          new():: {},\n          // If specified, the port on the given protocol.  This can either be a numerical or named port on a pod.  If this field is not provided, this matches all port names and numbers. If present, only traffic on the specified protocol AND port will be matched.\n          withPort(port):: self + {port: port},\n          // Optional.  The protocol (TCP or UDP) which traffic must match. If not specified, this field defaults to TCP.\n          withProtocol(protocol):: self + {protocol: protocol},\n          mixin:: {\n          },\n        },\n        // DEPRECATED 1.9 - This group version of NetworkPolicySpec is deprecated by networking/v1/NetworkPolicySpec.\n        networkPolicySpec:: {\n          new():: {},\n          // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n          withEgress(egress):: self + if std.type(egress) == \"array\" then {egress: egress} else {egress: [egress]},\n          // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n          withEgressMixin(egress):: self + if std.type(egress) == \"array\" then {egress+: egress} else {egress+: [egress]},\n          egressType:: hidden.extensions.v1beta1.networkPolicyEgressRule,\n          // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default).\n          withIngress(ingress):: self + if std.type(ingress) == \"array\" then {ingress: ingress} else {ingress: [ingress]},\n          // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default).\n          withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then {ingress+: ingress} else {ingress+: [ingress]},\n          ingressType:: hidden.extensions.v1beta1.networkPolicyIngressRule,\n          // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n          withPolicyTypes(policyTypes):: self + if std.type(policyTypes) == \"array\" then {policyTypes: policyTypes} else {policyTypes: [policyTypes]},\n          // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n          withPolicyTypesMixin(policyTypes):: self + if std.type(policyTypes) == \"array\" then {policyTypes+: policyTypes} else {policyTypes+: [policyTypes]},\n          mixin:: {\n            // Selects the pods to which this NetworkPolicy object applies.  The array of ingress rules is applied to any pods selected by this field. Multiple network policies can select the same set of pods.  In this case, the ingress rules for each are combined additively. This field is NOT optional and follows standard label selector semantics. An empty podSelector matches all pods in this namespace.\n            podSelector:: {\n              local __podSelectorMixin(podSelector) = {podSelector+: podSelector},\n              mixinInstance(podSelector):: __podSelectorMixin(podSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions: matchExpressions}) else __podSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions+: matchExpressions}) else __podSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __podSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __podSelectorMixin({matchLabels+: matchLabels}),\n            },\n            podSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // Pod Security Policy List is a list of PodSecurityPolicy objects.\n        podSecurityPolicyList:: {\n          new():: {},\n          // Items is a list of schema objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of schema objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.extensions.v1beta1.podSecurityPolicy,\n          mixin:: {\n          },\n        },\n        // Pod Security Policy Spec defines the policy enforced.\n        podSecurityPolicySpec:: {\n          new():: {},\n          // AllowPrivilegeEscalation determines if a pod can request to allow privilege escalation. If unspecified, defaults to true.\n          withAllowPrivilegeEscalation(allowPrivilegeEscalation):: self + {allowPrivilegeEscalation: allowPrivilegeEscalation},\n          // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n          withAllowedCapabilities(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then {allowedCapabilities: allowedCapabilities} else {allowedCapabilities: [allowedCapabilities]},\n          // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n          withAllowedCapabilitiesMixin(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then {allowedCapabilities+: allowedCapabilities} else {allowedCapabilities+: [allowedCapabilities]},\n          // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n          withAllowedFlexVolumes(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then {allowedFlexVolumes: allowedFlexVolumes} else {allowedFlexVolumes: [allowedFlexVolumes]},\n          // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n          withAllowedFlexVolumesMixin(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then {allowedFlexVolumes+: allowedFlexVolumes} else {allowedFlexVolumes+: [allowedFlexVolumes]},\n          allowedFlexVolumesType:: hidden.extensions.v1beta1.allowedFlexVolume,\n          // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n          withAllowedHostPaths(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then {allowedHostPaths: allowedHostPaths} else {allowedHostPaths: [allowedHostPaths]},\n          // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n          withAllowedHostPathsMixin(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then {allowedHostPaths+: allowedHostPaths} else {allowedHostPaths+: [allowedHostPaths]},\n          allowedHostPathsType:: hidden.extensions.v1beta1.allowedHostPath,\n          // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n          withDefaultAddCapabilities(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then {defaultAddCapabilities: defaultAddCapabilities} else {defaultAddCapabilities: [defaultAddCapabilities]},\n          // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n          withDefaultAddCapabilitiesMixin(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then {defaultAddCapabilities+: defaultAddCapabilities} else {defaultAddCapabilities+: [defaultAddCapabilities]},\n          // DefaultAllowPrivilegeEscalation controls the default setting for whether a process can gain more privileges than its parent process.\n          withDefaultAllowPrivilegeEscalation(defaultAllowPrivilegeEscalation):: self + {defaultAllowPrivilegeEscalation: defaultAllowPrivilegeEscalation},\n          // hostIPC determines if the policy allows the use of HostIPC in the pod spec.\n          withHostIpc(hostIpc):: self + {hostIPC: hostIpc},\n          // hostNetwork determines if the policy allows the use of HostNetwork in the pod spec.\n          withHostNetwork(hostNetwork):: self + {hostNetwork: hostNetwork},\n          // hostPID determines if the policy allows the use of HostPID in the pod spec.\n          withHostPid(hostPid):: self + {hostPID: hostPid},\n          // hostPorts determines which host port ranges are allowed to be exposed.\n          withHostPorts(hostPorts):: self + if std.type(hostPorts) == \"array\" then {hostPorts: hostPorts} else {hostPorts: [hostPorts]},\n          // hostPorts determines which host port ranges are allowed to be exposed.\n          withHostPortsMixin(hostPorts):: self + if std.type(hostPorts) == \"array\" then {hostPorts+: hostPorts} else {hostPorts+: [hostPorts]},\n          hostPortsType:: hidden.extensions.v1beta1.hostPortRange,\n          // privileged determines if a pod can request to be run as privileged.\n          withPrivileged(privileged):: self + {privileged: privileged},\n          // ReadOnlyRootFilesystem when set to true will force containers to run with a read only root file system.  If the container specifically requests to run with a non-read only root file system the PSP should deny the pod. If set to false the container may run with a read only root file system if it wishes but it will not be forced to.\n          withReadOnlyRootFilesystem(readOnlyRootFilesystem):: self + {readOnlyRootFilesystem: readOnlyRootFilesystem},\n          // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n          withRequiredDropCapabilities(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then {requiredDropCapabilities: requiredDropCapabilities} else {requiredDropCapabilities: [requiredDropCapabilities]},\n          // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n          withRequiredDropCapabilitiesMixin(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then {requiredDropCapabilities+: requiredDropCapabilities} else {requiredDropCapabilities+: [requiredDropCapabilities]},\n          // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n          withVolumes(volumes):: self + if std.type(volumes) == \"array\" then {volumes: volumes} else {volumes: [volumes]},\n          // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n          withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then {volumes+: volumes} else {volumes+: [volumes]},\n          mixin:: {\n            // FSGroup is the strategy that will dictate what fs group is used by the SecurityContext.\n            fsGroup:: {\n              local __fsGroupMixin(fsGroup) = {fsGroup+: fsGroup},\n              mixinInstance(fsGroup):: __fsGroupMixin(fsGroup),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges: ranges}) else __fsGroupMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges+: ranges}) else __fsGroupMixin({ranges+: [ranges]}),\n              rangesType:: hidden.extensions.v1beta1.idRange,\n              // Rule is the strategy that will dictate what FSGroup is used in the SecurityContext.\n              withRule(rule):: self + __fsGroupMixin({rule: rule}),\n            },\n            fsGroupType:: hidden.extensions.v1beta1.fsGroupStrategyOptions,\n            // runAsUser is the strategy that will dictate the allowable RunAsUser values that may be set.\n            runAsUser:: {\n              local __runAsUserMixin(runAsUser) = {runAsUser+: runAsUser},\n              mixinInstance(runAsUser):: __runAsUserMixin(runAsUser),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges: ranges}) else __runAsUserMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges+: ranges}) else __runAsUserMixin({ranges+: [ranges]}),\n              rangesType:: hidden.extensions.v1beta1.idRange,\n              // Rule is the strategy that will dictate the allowable RunAsUser values that may be set.\n              withRule(rule):: self + __runAsUserMixin({rule: rule}),\n            },\n            runAsUserType:: hidden.extensions.v1beta1.runAsUserStrategyOptions,\n            // seLinux is the strategy that will dictate the allowable labels that may be set.\n            seLinux:: {\n              local __seLinuxMixin(seLinux) = {seLinux+: seLinux},\n              mixinInstance(seLinux):: __seLinuxMixin(seLinux),\n              // type is the strategy that will dictate the allowable labels that may be set.\n              withRule(rule):: self + __seLinuxMixin({rule: rule}),\n              // seLinuxOptions required to run as; required for MustRunAs More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __seLinuxMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n            },\n            seLinuxType:: hidden.extensions.v1beta1.seLinuxStrategyOptions,\n            // SupplementalGroups is the strategy that will dictate what supplemental groups are used by the SecurityContext.\n            supplementalGroups:: {\n              local __supplementalGroupsMixin(supplementalGroups) = {supplementalGroups+: supplementalGroups},\n              mixinInstance(supplementalGroups):: __supplementalGroupsMixin(supplementalGroups),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges: ranges}) else __supplementalGroupsMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges+: ranges}) else __supplementalGroupsMixin({ranges+: [ranges]}),\n              rangesType:: hidden.extensions.v1beta1.idRange,\n              // Rule is the strategy that will dictate what supplemental groups is used in the SecurityContext.\n              withRule(rule):: self + __supplementalGroupsMixin({rule: rule}),\n            },\n            supplementalGroupsType:: hidden.extensions.v1beta1.supplementalGroupsStrategyOptions,\n          },\n        },\n        // ReplicaSetCondition describes the state of a replica set at a certain point.\n        replicaSetCondition:: {\n          new():: {},\n          // The last time the condition transitioned from one status to another.\n          withLastTransitionTime(lastTransitionTime):: self + {lastTransitionTime: lastTransitionTime},\n          // A human readable message indicating details about the transition.\n          withMessage(message):: self + {message: message},\n          // The reason for the condition's last transition.\n          withReason(reason):: self + {reason: reason},\n          // Status of the condition, one of True, False, Unknown.\n          withStatus(status):: self + {status: status},\n          // Type of replica set condition.\n          withType(type):: self + {type: type},\n          mixin:: {\n          },\n        },\n        // ReplicaSetList is a collection of ReplicaSets.\n        replicaSetList:: {\n          new():: {},\n          // List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.extensions.v1beta1.replicaSet,\n          mixin:: {\n          },\n        },\n        // ReplicaSetSpec is the specification of a ReplicaSet.\n        replicaSetSpec:: {\n          new():: {},\n          // Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. Defaults to 0 (pod will be considered available as soon as it is ready)\n          withMinReadySeconds(minReadySeconds):: self + {minReadySeconds: minReadySeconds},\n          // Replicas is the number of desired replicas. This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n            // Selector is a label query over pods that should match the replica count. If the selector is empty, it is defaulted to the labels present on the pod template. Label keys and values that must match in order to be controlled by this replica set. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n            // Template is the object that describes the pod that will be created if insufficient replicas are detected. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template\n            template:: {\n              local __templateMixin(template) = {template+: template},\n              mixinInstance(template):: __templateMixin(template),\n              // Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#metadata\n              metadata:: {\n                local __metadataMixin(metadata) = __templateMixin({metadata+: metadata}),\n                mixinInstance(metadata):: __metadataMixin(metadata),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotations(annotations):: self + __metadataMixin({annotations: annotations}),\n                // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n                withAnnotationsMixin(annotations):: self + __metadataMixin({annotations+: annotations}),\n                // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n                withClusterName(clusterName):: self + __metadataMixin({clusterName: clusterName}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers: finalizers}) else __metadataMixin({finalizers: [finalizers]}),\n                // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n                withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then __metadataMixin({finalizers+: finalizers}) else __metadataMixin({finalizers+: [finalizers]}),\n                // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n                //\n                // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n                //\n                // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n                withGenerateName(generateName):: self + __metadataMixin({generateName: generateName}),\n                // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n                //\n                // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n                initializers:: {\n                  local __initializersMixin(initializers) = __metadataMixin({initializers+: initializers}),\n                  mixinInstance(initializers):: __initializersMixin(initializers),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n                  // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n                  withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n                  pendingType:: hidden.meta.v1.initializer,\n                },\n                initializersType:: hidden.meta.v1.initializers,\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabels(labels):: self + __metadataMixin({labels: labels}),\n                // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n                withLabelsMixin(labels):: self + __metadataMixin({labels+: labels}),\n                // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n                withName(name):: self + __metadataMixin({name: name}),\n                // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n                //\n                // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n                withNamespace(namespace):: self + __metadataMixin({namespace: namespace}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences: ownerReferences}) else __metadataMixin({ownerReferences: [ownerReferences]}),\n                // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n                withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then __metadataMixin({ownerReferences+: ownerReferences}) else __metadataMixin({ownerReferences+: [ownerReferences]}),\n                ownerReferencesType:: hidden.meta.v1.ownerReference,\n              },\n              metadataType:: hidden.meta.v1.objectMeta,\n              // Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#spec-and-status\n              spec:: {\n                local __specMixin(spec) = __templateMixin({spec+: spec}),\n                mixinInstance(spec):: __specMixin(spec),\n                // Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.\n                withActiveDeadlineSeconds(activeDeadlineSeconds):: self + __specMixin({activeDeadlineSeconds: activeDeadlineSeconds}),\n                // If specified, the pod's scheduling constraints\n                affinity:: {\n                  local __affinityMixin(affinity) = __specMixin({affinity+: affinity}),\n                  mixinInstance(affinity):: __affinityMixin(affinity),\n                  // Describes node affinity scheduling rules for the pod.\n                  nodeAffinity:: {\n                    local __nodeAffinityMixin(nodeAffinity) = __affinityMixin({nodeAffinity+: nodeAffinity}),\n                    mixinInstance(nodeAffinity):: __nodeAffinityMixin(nodeAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __nodeAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.preferredSchedulingTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.\n                    requiredDuringSchedulingIgnoredDuringExecution:: {\n                      local __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution) = __nodeAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}),\n                      mixinInstance(requiredDuringSchedulingIgnoredDuringExecution):: __requiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTerms(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms: [nodeSelectorTerms]}),\n                      // Required. A list of node selector terms. The terms are ORed.\n                      withNodeSelectorTermsMixin(nodeSelectorTerms):: self + if std.type(nodeSelectorTerms) == \"array\" then __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: nodeSelectorTerms}) else __requiredDuringSchedulingIgnoredDuringExecutionMixin({nodeSelectorTerms+: [nodeSelectorTerms]}),\n                      nodeSelectorTermsType:: hidden.core.v1.nodeSelectorTerm,\n                    },\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.nodeSelector,\n                  },\n                  nodeAffinityType:: hidden.core.v1.nodeAffinity,\n                  // Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).\n                  podAffinity:: {\n                    local __podAffinityMixin(podAffinity) = __affinityMixin({podAffinity+: podAffinity}),\n                    mixinInstance(podAffinity):: __podAffinityMixin(podAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAffinityType:: hidden.core.v1.podAffinity,\n                  // Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).\n                  podAntiAffinity:: {\n                    local __podAntiAffinityMixin(podAntiAffinity) = __affinityMixin({podAntiAffinity+: podAntiAffinity}),\n                    mixinInstance(podAntiAffinity):: __podAntiAffinityMixin(podAntiAffinity),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecution(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    // The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.\n                    withPreferredDuringSchedulingIgnoredDuringExecutionMixin(preferredDuringSchedulingIgnoredDuringExecution):: self + if std.type(preferredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: preferredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({preferredDuringSchedulingIgnoredDuringExecution+: [preferredDuringSchedulingIgnoredDuringExecution]}),\n                    preferredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.weightedPodAffinityTerm,\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecution(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    // If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.\n                    withRequiredDuringSchedulingIgnoredDuringExecutionMixin(requiredDuringSchedulingIgnoredDuringExecution):: self + if std.type(requiredDuringSchedulingIgnoredDuringExecution) == \"array\" then __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: requiredDuringSchedulingIgnoredDuringExecution}) else __podAntiAffinityMixin({requiredDuringSchedulingIgnoredDuringExecution+: [requiredDuringSchedulingIgnoredDuringExecution]}),\n                    requiredDuringSchedulingIgnoredDuringExecutionType:: hidden.core.v1.podAffinityTerm,\n                  },\n                  podAntiAffinityType:: hidden.core.v1.podAntiAffinity,\n                },\n                affinityType:: hidden.core.v1.affinity,\n                // AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n                withAutomountServiceAccountToken(automountServiceAccountToken):: self + __specMixin({automountServiceAccountToken: automountServiceAccountToken}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainers(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers: containers}) else __specMixin({containers: [containers]}),\n                // List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.\n                withContainersMixin(containers):: self + if std.type(containers) == \"array\" then __specMixin({containers+: containers}) else __specMixin({containers+: [containers]}),\n                containersType:: hidden.core.v1.container,\n                // Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.\n                dnsConfig:: {\n                  local __dnsConfigMixin(dnsConfig) = __specMixin({dnsConfig+: dnsConfig}),\n                  mixinInstance(dnsConfig):: __dnsConfigMixin(dnsConfig),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameservers(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers: nameservers}) else __dnsConfigMixin({nameservers: [nameservers]}),\n                  // A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.\n                  withNameserversMixin(nameservers):: self + if std.type(nameservers) == \"array\" then __dnsConfigMixin({nameservers+: nameservers}) else __dnsConfigMixin({nameservers+: [nameservers]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptions(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options: options}) else __dnsConfigMixin({options: [options]}),\n                  // A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.\n                  withOptionsMixin(options):: self + if std.type(options) == \"array\" then __dnsConfigMixin({options+: options}) else __dnsConfigMixin({options+: [options]}),\n                  optionsType:: hidden.core.v1.podDnsConfigOption,\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearches(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches: searches}) else __dnsConfigMixin({searches: [searches]}),\n                  // A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.\n                  withSearchesMixin(searches):: self + if std.type(searches) == \"array\" then __dnsConfigMixin({searches+: searches}) else __dnsConfigMixin({searches+: [searches]}),\n                },\n                dnsConfigType:: hidden.core.v1.podDnsConfig,\n                // Set DNS policy for the pod. Defaults to \"ClusterFirst\". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.\n                withDnsPolicy(dnsPolicy):: self + __specMixin({dnsPolicy: dnsPolicy}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliases(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases: hostAliases}) else __specMixin({hostAliases: [hostAliases]}),\n                // HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.\n                withHostAliasesMixin(hostAliases):: self + if std.type(hostAliases) == \"array\" then __specMixin({hostAliases+: hostAliases}) else __specMixin({hostAliases+: [hostAliases]}),\n                hostAliasesType:: hidden.core.v1.hostAlias,\n                // Use the host's ipc namespace. Optional: Default to false.\n                withHostIpc(hostIpc):: self + __specMixin({hostIPC: hostIpc}),\n                // Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.\n                withHostNetwork(hostNetwork):: self + __specMixin({hostNetwork: hostNetwork}),\n                // Use the host's pid namespace. Optional: Default to false.\n                withHostPid(hostPid):: self + __specMixin({hostPID: hostPid}),\n                // Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.\n                withHostname(hostname):: self + __specMixin({hostname: hostname}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecrets(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets: imagePullSecrets}) else __specMixin({imagePullSecrets: [imagePullSecrets]}),\n                // ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n                withImagePullSecretsMixin(imagePullSecrets):: self + if std.type(imagePullSecrets) == \"array\" then __specMixin({imagePullSecrets+: imagePullSecrets}) else __specMixin({imagePullSecrets+: [imagePullSecrets]}),\n                imagePullSecretsType:: hidden.core.v1.localObjectReference,\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainers(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers: initContainers}) else __specMixin({initContainers: [initContainers]}),\n                // List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, or Liveness probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n                withInitContainersMixin(initContainers):: self + if std.type(initContainers) == \"array\" then __specMixin({initContainers+: initContainers}) else __specMixin({initContainers+: [initContainers]}),\n                initContainersType:: hidden.core.v1.container,\n                // NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.\n                withNodeName(nodeName):: self + __specMixin({nodeName: nodeName}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelector(nodeSelector):: self + __specMixin({nodeSelector: nodeSelector}),\n                // NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n                withNodeSelectorMixin(nodeSelector):: self + __specMixin({nodeSelector+: nodeSelector}),\n                // The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.\n                withPriority(priority):: self + __specMixin({priority: priority}),\n                // If specified, indicates the pod's priority. \"system-node-critical\" and \"system-cluster-critical\" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.\n                withPriorityClassName(priorityClassName):: self + __specMixin({priorityClassName: priorityClassName}),\n                // Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n                withRestartPolicy(restartPolicy):: self + __specMixin({restartPolicy: restartPolicy}),\n                // If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.\n                withSchedulerName(schedulerName):: self + __specMixin({schedulerName: schedulerName}),\n                // SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.\n                securityContext:: {\n                  local __securityContextMixin(securityContext) = __specMixin({securityContext+: securityContext}),\n                  mixinInstance(securityContext):: __securityContextMixin(securityContext),\n                  // A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n                  //\n                  // 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----\n                  //\n                  // If unset, the Kubelet will not modify the ownership and permissions of any volume.\n                  withFsGroup(fsGroup):: self + __securityContextMixin({fsGroup: fsGroup}),\n                  // The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsGroup(runAsGroup):: self + __securityContextMixin({runAsGroup: runAsGroup}),\n                  // Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.\n                  withRunAsNonRoot(runAsNonRoot):: self + __securityContextMixin({runAsNonRoot: runAsNonRoot}),\n                  // The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  withRunAsUser(runAsUser):: self + __securityContextMixin({runAsUser: runAsUser}),\n                  // The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container.\n                  seLinuxOptions:: {\n                    local __seLinuxOptionsMixin(seLinuxOptions) = __securityContextMixin({seLinuxOptions+: seLinuxOptions}),\n                    mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                    // Level is SELinux level label that applies to the container.\n                    withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                    // Role is a SELinux role label that applies to the container.\n                    withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                    // Type is a SELinux type label that applies to the container.\n                    withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                    // User is a SELinux user label that applies to the container.\n                    withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n                  },\n                  seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroups(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups: supplementalGroups}) else __securityContextMixin({supplementalGroups: [supplementalGroups]}),\n                  // A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container.\n                  withSupplementalGroupsMixin(supplementalGroups):: self + if std.type(supplementalGroups) == \"array\" then __securityContextMixin({supplementalGroups+: supplementalGroups}) else __securityContextMixin({supplementalGroups+: [supplementalGroups]}),\n                },\n                securityContextType:: hidden.core.v1.podSecurityContext,\n                // DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.\n                withServiceAccount(serviceAccount):: self + __specMixin({serviceAccount: serviceAccount}),\n                // ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n                withServiceAccountName(serviceAccountName):: self + __specMixin({serviceAccountName: serviceAccountName}),\n                // Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false. This field is alpha-level and is honored only by servers that enable the PodShareProcessNamespace feature.\n                withShareProcessNamespace(shareProcessNamespace):: self + __specMixin({shareProcessNamespace: shareProcessNamespace}),\n                // If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\". If not specified, the pod will not have a domainname at all.\n                withSubdomain(subdomain):: self + __specMixin({subdomain: subdomain}),\n                // Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.\n                withTerminationGracePeriodSeconds(terminationGracePeriodSeconds):: self + __specMixin({terminationGracePeriodSeconds: terminationGracePeriodSeconds}),\n                // If specified, the pod's tolerations.\n                withTolerations(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations: tolerations}) else __specMixin({tolerations: [tolerations]}),\n                // If specified, the pod's tolerations.\n                withTolerationsMixin(tolerations):: self + if std.type(tolerations) == \"array\" then __specMixin({tolerations+: tolerations}) else __specMixin({tolerations+: [tolerations]}),\n                tolerationsType:: hidden.core.v1.toleration,\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumes(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes: volumes}) else __specMixin({volumes: [volumes]}),\n                // List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes\n                withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then __specMixin({volumes+: volumes}) else __specMixin({volumes+: [volumes]}),\n                volumesType:: hidden.core.v1.volume,\n              },\n              specType:: hidden.core.v1.podSpec,\n            },\n            templateType:: hidden.core.v1.podTemplateSpec,\n          },\n        },\n        // ReplicaSetStatus represents the current status of a ReplicaSet.\n        replicaSetStatus:: {\n          new():: {},\n          // The number of available replicas (ready for at least minReadySeconds) for this replica set.\n          withAvailableReplicas(availableReplicas):: self + {availableReplicas: availableReplicas},\n          // Represents the latest available observations of a replica set's current state.\n          withConditions(conditions):: self + if std.type(conditions) == \"array\" then {conditions: conditions} else {conditions: [conditions]},\n          // Represents the latest available observations of a replica set's current state.\n          withConditionsMixin(conditions):: self + if std.type(conditions) == \"array\" then {conditions+: conditions} else {conditions+: [conditions]},\n          conditionsType:: hidden.extensions.v1beta1.replicaSetCondition,\n          // The number of pods that have labels matching the labels of the pod template of the replicaset.\n          withFullyLabeledReplicas(fullyLabeledReplicas):: self + {fullyLabeledReplicas: fullyLabeledReplicas},\n          // ObservedGeneration reflects the generation of the most recently observed ReplicaSet.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          // The number of ready replicas for this replica set.\n          withReadyReplicas(readyReplicas):: self + {readyReplicas: readyReplicas},\n          // Replicas is the most recently oberved number of replicas. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // DEPRECATED.\n        rollbackConfig:: {\n          new():: {},\n          // The revision to rollback to. If set to 0, rollback to the last revision.\n          withRevision(revision):: self + {revision: revision},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of daemon set rolling update.\n        rollingUpdateDaemonSet:: {\n          new():: {},\n          // The maximum number of DaemonSet pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0. Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // Spec to control the desired behavior of rolling update.\n        rollingUpdateDeployment:: {\n          new():: {},\n          // The maximum number of pods that can be scheduled above the desired number of pods. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. By default, a value of 1 is used. Example: when this is set to 30%, the new RC can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new RC can be scaled up further, ensuring that total number of pods running at any time during the update is atmost 130% of desired pods.\n          withMaxSurge(maxSurge):: self + {maxSurge: maxSurge},\n          // The maximum number of pods that can be unavailable during the update. Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. By default, a fixed value of 1 is used. Example: when this is set to 30%, the old RC can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old RC can be scaled down further, followed by scaling up the new RC, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          mixin:: {\n          },\n        },\n        // Run A sUser Strategy Options defines the strategy type and any options used to create the strategy.\n        runAsUserStrategyOptions:: {\n          new():: {},\n          // Ranges are the allowed ranges of uids that may be used.\n          withRanges(ranges):: self + if std.type(ranges) == \"array\" then {ranges: ranges} else {ranges: [ranges]},\n          // Ranges are the allowed ranges of uids that may be used.\n          withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then {ranges+: ranges} else {ranges+: [ranges]},\n          rangesType:: hidden.extensions.v1beta1.idRange,\n          // Rule is the strategy that will dictate the allowable RunAsUser values that may be set.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n          },\n        },\n        // describes the attributes of a scale subresource\n        scaleSpec:: {\n          new():: {},\n          // desired number of instances for the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          mixin:: {\n          },\n        },\n        // represents the current status of a scale subresource.\n        scaleStatus:: {\n          new():: {},\n          // actual number of observed instances of the scaled object.\n          withReplicas(replicas):: self + {replicas: replicas},\n          // label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelector(selector):: self + {selector: selector},\n          // label query over pods that should match the replicas count. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors\n          withSelectorMixin(selector):: self + {selector+: selector},\n          // label selector for pods that should match the replicas count. This is a serializated version of both map-based and more expressive set-based selectors. This is done to avoid introspection in the clients. The string will be in the same format as the query-param syntax. If the target type only supports map-based selectors, both this field and map-based selector field are populated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors\n          withTargetSelector(targetSelector):: self + {targetSelector: targetSelector},\n          mixin:: {\n          },\n        },\n        // SELinux  Strategy Options defines the strategy type and any options used to create the strategy.\n        seLinuxStrategyOptions:: {\n          new():: {},\n          // type is the strategy that will dictate the allowable labels that may be set.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n            // seLinuxOptions required to run as; required for MustRunAs More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n            seLinuxOptions:: {\n              local __seLinuxOptionsMixin(seLinuxOptions) = {seLinuxOptions+: seLinuxOptions},\n              mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n              // Level is SELinux level label that applies to the container.\n              withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n              // Role is a SELinux role label that applies to the container.\n              withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n              // Type is a SELinux type label that applies to the container.\n              withType(type):: self + __seLinuxOptionsMixin({type: type}),\n              // User is a SELinux user label that applies to the container.\n              withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n            },\n            seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n          },\n        },\n        // SupplementalGroupsStrategyOptions defines the strategy type and options used to create the strategy.\n        supplementalGroupsStrategyOptions:: {\n          new():: {},\n          // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n          withRanges(ranges):: self + if std.type(ranges) == \"array\" then {ranges: ranges} else {ranges: [ranges]},\n          // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n          withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then {ranges+: ranges} else {ranges+: [ranges]},\n          rangesType:: hidden.extensions.v1beta1.idRange,\n          // Rule is the strategy that will dictate what supplemental groups is used in the SecurityContext.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n          },\n        },\n      },\n    },\n    meta:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"meta/v1\"},\n        // APIGroup contains the name, the supported versions, and the preferred version of a group.\n        apiGroup:: {\n          new():: {},\n          // name is the name of the group.\n          withName(name):: self + {name: name},\n          // a map of client CIDR to server address that is serving this group. This is to help clients reach servers in the most network-efficient way possible. Clients can use the appropriate server address as per the CIDR that they match. In case of multiple matches, clients should use the longest matching CIDR. The server returns only those CIDRs that it thinks that the client can match. For example: the master will return an internal IP CIDR only, if the client reaches the server using an internal IP. Server looks at X-Forwarded-For header or X-Real-Ip header or request.RemoteAddr (in that order) to get the client IP.\n          withServerAddressByClientCidrs(serverAddressByClientCidrs):: self + if std.type(serverAddressByClientCidrs) == \"array\" then {serverAddressByClientCIDRs: serverAddressByClientCidrs} else {serverAddressByClientCIDRs: [serverAddressByClientCidrs]},\n          // a map of client CIDR to server address that is serving this group. This is to help clients reach servers in the most network-efficient way possible. Clients can use the appropriate server address as per the CIDR that they match. In case of multiple matches, clients should use the longest matching CIDR. The server returns only those CIDRs that it thinks that the client can match. For example: the master will return an internal IP CIDR only, if the client reaches the server using an internal IP. Server looks at X-Forwarded-For header or X-Real-Ip header or request.RemoteAddr (in that order) to get the client IP.\n          withServerAddressByClientCidrsMixin(serverAddressByClientCidrs):: self + if std.type(serverAddressByClientCidrs) == \"array\" then {serverAddressByClientCIDRs+: serverAddressByClientCidrs} else {serverAddressByClientCIDRs+: [serverAddressByClientCidrs]},\n          serverAddressByClientCIDRsType:: hidden.meta.v1.serverAddressByClientCidr,\n          // versions are the versions supported in this group.\n          withVersions(versions):: self + if std.type(versions) == \"array\" then {versions: versions} else {versions: [versions]},\n          // versions are the versions supported in this group.\n          withVersionsMixin(versions):: self + if std.type(versions) == \"array\" then {versions+: versions} else {versions+: [versions]},\n          versionsType:: hidden.meta.v1.groupVersionForDiscovery,\n          mixin:: {\n            // preferredVersion is the version preferred by the API server, which probably is the storage version.\n            preferredVersion:: {\n              local __preferredVersionMixin(preferredVersion) = {preferredVersion+: preferredVersion},\n              mixinInstance(preferredVersion):: __preferredVersionMixin(preferredVersion),\n              // groupVersion specifies the API group and version in the form \"group/version\"\n              withGroupVersion(groupVersion):: self + __preferredVersionMixin({groupVersion: groupVersion}),\n              // version specifies the version in the form of \"version\". This is to save the clients the trouble of splitting the GroupVersion.\n              withVersion(version):: self + __preferredVersionMixin({version: version}),\n            },\n            preferredVersionType:: hidden.meta.v1.groupVersionForDiscovery,\n          },\n        },\n        // APIGroupList is a list of APIGroup, to allow clients to discover the API at /apis.\n        apiGroupList:: {\n          new():: {},\n          // groups is a list of APIGroup.\n          withGroups(groups):: self + if std.type(groups) == \"array\" then {groups: groups} else {groups: [groups]},\n          // groups is a list of APIGroup.\n          withGroupsMixin(groups):: self + if std.type(groups) == \"array\" then {groups+: groups} else {groups+: [groups]},\n          groupsType:: hidden.meta.v1.apiGroup,\n          mixin:: {\n          },\n        },\n        // APIResource specifies the name of a resource and whether it is namespaced.\n        apiResource:: {\n          new():: {},\n          // categories is a list of the grouped resources this resource belongs to (e.g. 'all')\n          withCategories(categories):: self + if std.type(categories) == \"array\" then {categories: categories} else {categories: [categories]},\n          // categories is a list of the grouped resources this resource belongs to (e.g. 'all')\n          withCategoriesMixin(categories):: self + if std.type(categories) == \"array\" then {categories+: categories} else {categories+: [categories]},\n          // group is the preferred group of the resource.  Empty implies the group of the containing resource list. For subresources, this may have a different value, for example: Scale\".\n          withGroup(group):: self + {group: group},\n          // kind is the kind for the resource (e.g. 'Foo' is the kind for a resource 'foo')\n          withKind(kind):: self + {kind: kind},\n          // name is the plural name of the resource.\n          withName(name):: self + {name: name},\n          // namespaced indicates if a resource is namespaced or not.\n          withNamespaced(namespaced):: self + {namespaced: namespaced},\n          // shortNames is a list of suggested short names of the resource.\n          withShortNames(shortNames):: self + if std.type(shortNames) == \"array\" then {shortNames: shortNames} else {shortNames: [shortNames]},\n          // shortNames is a list of suggested short names of the resource.\n          withShortNamesMixin(shortNames):: self + if std.type(shortNames) == \"array\" then {shortNames+: shortNames} else {shortNames+: [shortNames]},\n          // singularName is the singular name of the resource.  This allows clients to handle plural and singular opaquely. The singularName is more correct for reporting status on a single item and both singular and plural are allowed from the kubectl CLI interface.\n          withSingularName(singularName):: self + {singularName: singularName},\n          // verbs is a list of supported kube verbs (this includes get, list, watch, create, update, patch, delete, deletecollection, and proxy)\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // verbs is a list of supported kube verbs (this includes get, list, watch, create, update, patch, delete, deletecollection, and proxy)\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          // version is the preferred version of the resource.  Empty implies the version of the containing resource list For subresources, this may have a different value, for example: v1 (while inside a v1beta1 version of the core resource's group)\".\n          withVersion(version):: self + {version: version},\n          mixin:: {\n          },\n        },\n        // APIResourceList is a list of APIResource, it is used to expose the name of the resources supported in a specific group and version, and if the resource is namespaced.\n        apiResourceList:: {\n          new():: {},\n          // groupVersion is the group and version this APIResourceList is for.\n          withGroupVersion(groupVersion):: self + {groupVersion: groupVersion},\n          // resources contains the name of the resources and if they are namespaced.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // resources contains the name of the resources and if they are namespaced.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          resourcesType:: hidden.meta.v1.apiResource,\n          mixin:: {\n          },\n        },\n        // APIVersions lists the versions that are available, to allow clients to discover the API at /api, which is the root path of the legacy v1 API.\n        apiVersions:: {\n          new():: {},\n          // a map of client CIDR to server address that is serving this group. This is to help clients reach servers in the most network-efficient way possible. Clients can use the appropriate server address as per the CIDR that they match. In case of multiple matches, clients should use the longest matching CIDR. The server returns only those CIDRs that it thinks that the client can match. For example: the master will return an internal IP CIDR only, if the client reaches the server using an internal IP. Server looks at X-Forwarded-For header or X-Real-Ip header or request.RemoteAddr (in that order) to get the client IP.\n          withServerAddressByClientCidrs(serverAddressByClientCidrs):: self + if std.type(serverAddressByClientCidrs) == \"array\" then {serverAddressByClientCIDRs: serverAddressByClientCidrs} else {serverAddressByClientCIDRs: [serverAddressByClientCidrs]},\n          // a map of client CIDR to server address that is serving this group. This is to help clients reach servers in the most network-efficient way possible. Clients can use the appropriate server address as per the CIDR that they match. In case of multiple matches, clients should use the longest matching CIDR. The server returns only those CIDRs that it thinks that the client can match. For example: the master will return an internal IP CIDR only, if the client reaches the server using an internal IP. Server looks at X-Forwarded-For header or X-Real-Ip header or request.RemoteAddr (in that order) to get the client IP.\n          withServerAddressByClientCidrsMixin(serverAddressByClientCidrs):: self + if std.type(serverAddressByClientCidrs) == \"array\" then {serverAddressByClientCIDRs+: serverAddressByClientCidrs} else {serverAddressByClientCIDRs+: [serverAddressByClientCidrs]},\n          serverAddressByClientCIDRsType:: hidden.meta.v1.serverAddressByClientCidr,\n          // versions are the api versions that are available.\n          withVersions(versions):: self + if std.type(versions) == \"array\" then {versions: versions} else {versions: [versions]},\n          // versions are the api versions that are available.\n          withVersionsMixin(versions):: self + if std.type(versions) == \"array\" then {versions+: versions} else {versions+: [versions]},\n          mixin:: {\n          },\n        },\n        // DeleteOptions may be provided when deleting an API object.\n        deleteOptions:: {\n          new():: {},\n          // The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.\n          withGracePeriodSeconds(gracePeriodSeconds):: self + {gracePeriodSeconds: gracePeriodSeconds},\n          // Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the \"orphan\" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both.\n          withOrphanDependents(orphanDependents):: self + {orphanDependents: orphanDependents},\n          // Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: 'Orphan' - orphan the dependents; 'Background' - allow the garbage collector to delete the dependents in the background; 'Foreground' - a cascading policy that deletes all dependents in the foreground.\n          withPropagationPolicy(propagationPolicy):: self + {propagationPolicy: propagationPolicy},\n          mixin:: {\n            // Must be fulfilled before a deletion is carried out. If not possible, a 409 Conflict status will be returned.\n            preconditions:: {\n              local __preconditionsMixin(preconditions) = {preconditions+: preconditions},\n              mixinInstance(preconditions):: __preconditionsMixin(preconditions),\n              // Specifies the target UID.\n              withUid(uid):: self + __preconditionsMixin({uid: uid}),\n            },\n            preconditionsType:: hidden.meta.v1.preconditions,\n          },\n        },\n        // GroupVersion contains the \"group/version\" and \"version\" string of a version. It is made a struct to keep extensibility.\n        groupVersionForDiscovery:: {\n          new():: {},\n          // groupVersion specifies the API group and version in the form \"group/version\"\n          withGroupVersion(groupVersion):: self + {groupVersion: groupVersion},\n          // version specifies the version in the form of \"version\". This is to save the clients the trouble of splitting the GroupVersion.\n          withVersion(version):: self + {version: version},\n          mixin:: {\n          },\n        },\n        // Initializer is information about an initializer that has not yet completed.\n        initializer:: {\n          new():: {},\n          // name of the process that is responsible for initializing this object.\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // Initializers tracks the progress of initialization.\n        initializers:: {\n          new():: {},\n          // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n          withPending(pending):: self + if std.type(pending) == \"array\" then {pending: pending} else {pending: [pending]},\n          // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n          withPendingMixin(pending):: self + if std.type(pending) == \"array\" then {pending+: pending} else {pending+: [pending]},\n          pendingType:: hidden.meta.v1.initializer,\n          mixin:: {\n          },\n        },\n        // A label selector is a label query over a set of resources. The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.\n        labelSelector:: {\n          new():: {},\n          // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n          withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then {matchExpressions: matchExpressions} else {matchExpressions: [matchExpressions]},\n          // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n          withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then {matchExpressions+: matchExpressions} else {matchExpressions+: [matchExpressions]},\n          matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n          // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n          withMatchLabels(matchLabels):: self + {matchLabels: matchLabels},\n          // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n          withMatchLabelsMixin(matchLabels):: self + {matchLabels+: matchLabels},\n          mixin:: {\n          },\n        },\n        // A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.\n        labelSelectorRequirement:: {\n          new():: {},\n          // key is the label key that the selector applies to.\n          withKey(key):: self + {key: key},\n          // operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.\n          withOperator(operator):: self + {operator: operator},\n          // values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.\n          withValues(values):: self + if std.type(values) == \"array\" then {values: values} else {values: [values]},\n          // values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.\n          withValuesMixin(values):: self + if std.type(values) == \"array\" then {values+: values} else {values+: [values]},\n          mixin:: {\n          },\n        },\n        // ListMeta describes metadata that synthetic resources must have, including lists and various status objects. A resource may have only one of {ObjectMeta, ListMeta}.\n        listMeta:: {\n          new():: {},\n          // continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response.\n          withContinue(continue):: self + {continue: continue},\n          mixin:: {\n          },\n        },\n        microTime:: {\n          new():: {},\n          mixin:: {\n          },\n        },\n        // ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.\n        objectMeta:: {\n          new():: {},\n          // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n          withAnnotations(annotations):: self + {annotations: annotations},\n          // Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations\n          withAnnotationsMixin(annotations):: self + {annotations+: annotations},\n          // The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request.\n          withClusterName(clusterName):: self + {clusterName: clusterName},\n          // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n          withFinalizers(finalizers):: self + if std.type(finalizers) == \"array\" then {finalizers: finalizers} else {finalizers: [finalizers]},\n          // Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.\n          withFinalizersMixin(finalizers):: self + if std.type(finalizers) == \"array\" then {finalizers+: finalizers} else {finalizers+: [finalizers]},\n          // GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n          //\n          // If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).\n          //\n          // Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#idempotency\n          withGenerateName(generateName):: self + {generateName: generateName},\n          // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n          withLabels(labels):: self + {labels: labels},\n          // Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels\n          withLabelsMixin(labels):: self + {labels+: labels},\n          // Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n          withName(name):: self + {name: name},\n          // Namespace defines the space within each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n          //\n          // Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces\n          withNamespace(namespace):: self + {namespace: namespace},\n          // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n          withOwnerReferences(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then {ownerReferences: ownerReferences} else {ownerReferences: [ownerReferences]},\n          // List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.\n          withOwnerReferencesMixin(ownerReferences):: self + if std.type(ownerReferences) == \"array\" then {ownerReferences+: ownerReferences} else {ownerReferences+: [ownerReferences]},\n          ownerReferencesType:: hidden.meta.v1.ownerReference,\n          mixin:: {\n            // An initializer is a controller which enforces some system invariant at object creation time. This field is a list of initializers that have not yet acted on this object. If nil or empty, this object has been completely initialized. Otherwise, the object is considered uninitialized and is hidden (in list/watch and get calls) from clients that haven't explicitly asked to observe uninitialized objects.\n            //\n            // When an object is created, the system will populate this list with the current set of initializers. Only privileged users may set or modify this list. Once it is empty, it may not be modified further by any user.\n            initializers:: {\n              local __initializersMixin(initializers) = {initializers+: initializers},\n              mixinInstance(initializers):: __initializersMixin(initializers),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPending(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending: pending}) else __initializersMixin({pending: [pending]}),\n              // Pending is a list of initializers that must execute in order before this object is visible. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.\n              withPendingMixin(pending):: self + if std.type(pending) == \"array\" then __initializersMixin({pending+: pending}) else __initializersMixin({pending+: [pending]}),\n              pendingType:: hidden.meta.v1.initializer,\n            },\n            initializersType:: hidden.meta.v1.initializers,\n          },\n        },\n        // OwnerReference contains enough information to let you identify an owning object. Currently, an owning object must be in the same namespace, so there is no namespace field.\n        ownerReference:: {\n          new():: {},\n          // API version of the referent.\n          withApiVersion(apiVersion):: self + {apiVersion: apiVersion},\n          // If true, AND if the owner has the \"foregroundDeletion\" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs \"delete\" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.\n          withBlockOwnerDeletion(blockOwnerDeletion):: self + {blockOwnerDeletion: blockOwnerDeletion},\n          // If true, this reference points to the managing controller.\n          withController(controller):: self + {controller: controller},\n          // Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/api-conventions.md#types-kinds\n          withKind(kind):: self + {kind: kind},\n          // Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names\n          withName(name):: self + {name: name},\n          // UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids\n          withUid(uid):: self + {uid: uid},\n          mixin:: {\n          },\n        },\n        // Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.\n        preconditions:: {\n          new():: {},\n          // Specifies the target UID.\n          withUid(uid):: self + {uid: uid},\n          mixin:: {\n          },\n        },\n        // ServerAddressByClientCIDR helps the client to determine the server address that they should use, depending on the clientCIDR that they match.\n        serverAddressByClientCidr:: {\n          new():: {},\n          // The CIDR with which clients can match their IP to figure out the server address that they should use.\n          withClientCidr(clientCidr):: self + {clientCIDR: clientCidr},\n          // Address of this server, suitable for a client that matches the above CIDR. This can be a hostname, hostname:port, IP or IP:port.\n          withServerAddress(serverAddress):: self + {serverAddress: serverAddress},\n          mixin:: {\n          },\n        },\n        // Status is a return value for calls that don't return other objects.\n        status:: {\n          new():: {},\n          // Suggested HTTP return code for this status, 0 if not set.\n          withCode(code):: self + {code: code},\n          // A human-readable description of the status of this operation.\n          withMessage(message):: self + {message: message},\n          // A machine-readable description of why this operation is in the \"Failure\" status. If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.\n          withReason(reason):: self + {reason: reason},\n          mixin:: {\n            // Extended data associated with the reason.  Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.\n            details:: {\n              local __detailsMixin(details) = {details+: details},\n              mixinInstance(details):: __detailsMixin(details),\n              // The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.\n              withCauses(causes):: self + if std.type(causes) == \"array\" then __detailsMixin({causes: causes}) else __detailsMixin({causes: [causes]}),\n              // The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.\n              withCausesMixin(causes):: self + if std.type(causes) == \"array\" then __detailsMixin({causes+: causes}) else __detailsMixin({causes+: [causes]}),\n              causesType:: hidden.meta.v1.statusCause,\n              // The group attribute of the resource associated with the status StatusReason.\n              withGroup(group):: self + __detailsMixin({group: group}),\n              // The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).\n              withName(name):: self + __detailsMixin({name: name}),\n              // If specified, the time in seconds before the operation should be retried. Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.\n              withRetryAfterSeconds(retryAfterSeconds):: self + __detailsMixin({retryAfterSeconds: retryAfterSeconds}),\n              // UID of the resource. (when there is a single resource which can be described). More info: http://kubernetes.io/docs/user-guide/identifiers#uids\n              withUid(uid):: self + __detailsMixin({uid: uid}),\n            },\n            detailsType:: hidden.meta.v1.statusDetails,\n          },\n        },\n        // StatusCause provides more information about an api.Status failure, including cases when multiple errors are encountered.\n        statusCause:: {\n          new():: {},\n          // The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.\n          //\n          // Examples:\n          // \"name\" - the field \"name\" on the current resource\n          // \"items[0].name\" - the field \"name\" on the first array entry in \"items\"\n          withField(field):: self + {field: field},\n          // A human-readable description of the cause of the error.  This field may be presented as-is to a reader.\n          withMessage(message):: self + {message: message},\n          // A machine-readable description of the cause of the error. If this value is empty there is no information available.\n          withReason(reason):: self + {reason: reason},\n          mixin:: {\n          },\n        },\n        // StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response. The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.\n        statusDetails:: {\n          new():: {},\n          // The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.\n          withCauses(causes):: self + if std.type(causes) == \"array\" then {causes: causes} else {causes: [causes]},\n          // The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.\n          withCausesMixin(causes):: self + if std.type(causes) == \"array\" then {causes+: causes} else {causes+: [causes]},\n          causesType:: hidden.meta.v1.statusCause,\n          // The group attribute of the resource associated with the status StatusReason.\n          withGroup(group):: self + {group: group},\n          // The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).\n          withName(name):: self + {name: name},\n          // If specified, the time in seconds before the operation should be retried. Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.\n          withRetryAfterSeconds(retryAfterSeconds):: self + {retryAfterSeconds: retryAfterSeconds},\n          // UID of the resource. (when there is a single resource which can be described). More info: http://kubernetes.io/docs/user-guide/identifiers#uids\n          withUid(uid):: self + {uid: uid},\n          mixin:: {\n          },\n        },\n        time:: {\n          new():: {},\n          mixin:: {\n          },\n        },\n        // Event represents a single event to a watched resource.\n        watchEvent:: {\n          new():: {},\n          withType(type):: self + {type: type},\n          mixin:: {\n            // Object is:\n            // * If Type is Added or Modified: the new state of the object.\n            // * If Type is Deleted: the state of the object immediately before deletion.\n            // * If Type is Error: *Status is recommended; other types may make sense\n            // depending on context.\n            object:: {\n              local __objectMixin(object) = {object+: object},\n              mixinInstance(object):: __objectMixin(object),\n              // Raw is the underlying serialization of this object.\n              withRaw(raw):: self + __objectMixin({Raw: raw}),\n            },\n          },\n        },\n      },\n    },\n    networking:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"networking/v1\"},\n        // IPBlock describes a particular CIDR (Ex. \"192.168.1.1/24\") that is allowed to the pods matched by a NetworkPolicySpec's podSelector. The except entry describes CIDRs that should not be included within this rule.\n        ipBlock:: {\n          new():: {},\n          // CIDR is a string representing the IP Block Valid examples are \"192.168.1.1/24\"\n          withCidr(cidr):: self + {cidr: cidr},\n          // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n          withExcept(except):: self + if std.type(except) == \"array\" then {except: except} else {except: [except]},\n          // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n          withExceptMixin(except):: self + if std.type(except) == \"array\" then {except+: except} else {except+: [except]},\n          mixin:: {\n          },\n        },\n        // NetworkPolicyEgressRule describes a particular set of traffic that is allowed out of pods matched by a NetworkPolicySpec's podSelector. The traffic must match both ports and to. This type is beta-level in 1.8\n        networkPolicyEgressRule:: {\n          new():: {},\n          // List of destination ports for outgoing traffic. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // List of destination ports for outgoing traffic. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.networking.v1.networkPolicyPort,\n          // List of destinations for outgoing traffic of pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all destinations (traffic not restricted by destination). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the to list.\n          withTo(to):: self + if std.type(to) == \"array\" then {to: to} else {to: [to]},\n          // List of destinations for outgoing traffic of pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all destinations (traffic not restricted by destination). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the to list.\n          withToMixin(to):: self + if std.type(to) == \"array\" then {to+: to} else {to+: [to]},\n          toType:: hidden.networking.v1.networkPolicyPeer,\n          mixin:: {\n          },\n        },\n        // NetworkPolicyIngressRule describes a particular set of traffic that is allowed to the pods matched by a NetworkPolicySpec's podSelector. The traffic must match both ports and from.\n        networkPolicyIngressRule:: {\n          new():: {},\n          // List of sources which should be able to access the pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all sources (traffic not restricted by source). If this field is present and contains at least on item, this rule allows traffic only if the traffic matches at least one item in the from list.\n          withFrom(from):: self + if std.type(from) == \"array\" then {from: from} else {from: [from]},\n          // List of sources which should be able to access the pods selected for this rule. Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all sources (traffic not restricted by source). If this field is present and contains at least on item, this rule allows traffic only if the traffic matches at least one item in the from list.\n          withFromMixin(from):: self + if std.type(from) == \"array\" then {from+: from} else {from+: [from]},\n          fromType:: hidden.networking.v1.networkPolicyPeer,\n          // List of ports which should be made accessible on the pods selected for this rule. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPorts(ports):: self + if std.type(ports) == \"array\" then {ports: ports} else {ports: [ports]},\n          // List of ports which should be made accessible on the pods selected for this rule. Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.\n          withPortsMixin(ports):: self + if std.type(ports) == \"array\" then {ports+: ports} else {ports+: [ports]},\n          portsType:: hidden.networking.v1.networkPolicyPort,\n          mixin:: {\n          },\n        },\n        // NetworkPolicyList is a list of NetworkPolicy objects.\n        networkPolicyList:: {\n          new():: {},\n          // Items is a list of schema objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of schema objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.networking.v1.networkPolicy,\n          mixin:: {\n          },\n        },\n        // NetworkPolicyPeer describes a peer to allow traffic from. Exactly one of its fields must be specified.\n        networkPolicyPeer:: {\n          new():: {},\n          mixin:: {\n            // IPBlock defines policy on a particular IPBlock\n            ipBlock:: {\n              local __ipBlockMixin(ipBlock) = {ipBlock+: ipBlock},\n              mixinInstance(ipBlock):: __ipBlockMixin(ipBlock),\n              // CIDR is a string representing the IP Block Valid examples are \"192.168.1.1/24\"\n              withCidr(cidr):: self + __ipBlockMixin({cidr: cidr}),\n              // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n              withExcept(except):: self + if std.type(except) == \"array\" then __ipBlockMixin({except: except}) else __ipBlockMixin({except: [except]}),\n              // Except is a slice of CIDRs that should not be included within an IP Block Valid examples are \"192.168.1.1/24\" Except values will be rejected if they are outside the CIDR range\n              withExceptMixin(except):: self + if std.type(except) == \"array\" then __ipBlockMixin({except+: except}) else __ipBlockMixin({except+: [except]}),\n            },\n            ipBlockType:: hidden.networking.v1.ipBlock,\n            // Selects Namespaces using cluster scoped-labels. This matches all pods in all namespaces selected by this label selector. This field follows standard label selector semantics. If present but empty, this selector selects all namespaces.\n            namespaceSelector:: {\n              local __namespaceSelectorMixin(namespaceSelector) = {namespaceSelector+: namespaceSelector},\n              mixinInstance(namespaceSelector):: __namespaceSelectorMixin(namespaceSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __namespaceSelectorMixin({matchExpressions: matchExpressions}) else __namespaceSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __namespaceSelectorMixin({matchExpressions+: matchExpressions}) else __namespaceSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __namespaceSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __namespaceSelectorMixin({matchLabels+: matchLabels}),\n            },\n            namespaceSelectorType:: hidden.meta.v1.labelSelector,\n            // This is a label selector which selects Pods in this namespace. This field follows standard label selector semantics. If present but empty, this selector selects all pods in this namespace.\n            podSelector:: {\n              local __podSelectorMixin(podSelector) = {podSelector+: podSelector},\n              mixinInstance(podSelector):: __podSelectorMixin(podSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions: matchExpressions}) else __podSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions+: matchExpressions}) else __podSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __podSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __podSelectorMixin({matchLabels+: matchLabels}),\n            },\n            podSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // NetworkPolicyPort describes a port to allow traffic on\n        networkPolicyPort:: {\n          new():: {},\n          // The port on the given protocol. This can either be a numerical or named port on a pod. If this field is not provided, this matches all port names and numbers.\n          withPort(port):: self + {port: port},\n          // The protocol (TCP or UDP) which traffic must match. If not specified, this field defaults to TCP.\n          withProtocol(protocol):: self + {protocol: protocol},\n          mixin:: {\n          },\n        },\n        // NetworkPolicySpec provides the specification of a NetworkPolicy\n        networkPolicySpec:: {\n          new():: {},\n          // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n          withEgress(egress):: self + if std.type(egress) == \"array\" then {egress: egress} else {egress: [egress]},\n          // List of egress rules to be applied to the selected pods. Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8\n          withEgressMixin(egress):: self + if std.type(egress) == \"array\" then {egress+: egress} else {egress+: [egress]},\n          egressType:: hidden.networking.v1.networkPolicyEgressRule,\n          // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default)\n          withIngress(ingress):: self + if std.type(ingress) == \"array\" then {ingress: ingress} else {ingress: [ingress]},\n          // List of ingress rules to be applied to the selected pods. Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default)\n          withIngressMixin(ingress):: self + if std.type(ingress) == \"array\" then {ingress+: ingress} else {ingress+: [ingress]},\n          ingressType:: hidden.networking.v1.networkPolicyIngressRule,\n          // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n          withPolicyTypes(policyTypes):: self + if std.type(policyTypes) == \"array\" then {policyTypes: policyTypes} else {policyTypes: [policyTypes]},\n          // List of rule types that the NetworkPolicy relates to. Valid options are Ingress, Egress, or Ingress,Egress. If this field is not specified, it will default based on the existence of Ingress or Egress rules; policies that contain an Egress section are assumed to affect Egress, and all policies (whether or not they contain an Ingress section) are assumed to affect Ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ \"Egress\" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include \"Egress\" (since such a policy would not include an Egress section and would otherwise default to just [ \"Ingress\" ]). This field is beta-level in 1.8\n          withPolicyTypesMixin(policyTypes):: self + if std.type(policyTypes) == \"array\" then {policyTypes+: policyTypes} else {policyTypes+: [policyTypes]},\n          mixin:: {\n            // Selects the pods to which this NetworkPolicy object applies. The array of ingress rules is applied to any pods selected by this field. Multiple network policies can select the same set of pods. In this case, the ingress rules for each are combined additively. This field is NOT optional and follows standard label selector semantics. An empty podSelector matches all pods in this namespace.\n            podSelector:: {\n              local __podSelectorMixin(podSelector) = {podSelector+: podSelector},\n              mixinInstance(podSelector):: __podSelectorMixin(podSelector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions: matchExpressions}) else __podSelectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __podSelectorMixin({matchExpressions+: matchExpressions}) else __podSelectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __podSelectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __podSelectorMixin({matchLabels+: matchLabels}),\n            },\n            podSelectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n      },\n    },\n    policy:: {\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"policy/v1beta1\"},\n        // AllowedFlexVolume represents a single Flexvolume that is allowed to be used.\n        allowedFlexVolume:: {\n          new():: {},\n          // Driver is the name of the Flexvolume driver.\n          withDriver(driver):: self + {driver: driver},\n          mixin:: {\n          },\n        },\n        // defines the host volume conditions that will be enabled by a policy for pods to use. It requires the path prefix to be defined.\n        allowedHostPath:: {\n          new():: {},\n          // is the path prefix that the host volume must match. It does not support `*`. Trailing slashes are trimmed when validating the path prefix with a host path.\n          //\n          // Examples: `/foo` would allow `/foo`, `/foo/` and `/foo/bar` `/foo` would not allow `/food` or `/etc/foo`\n          withPathPrefix(pathPrefix):: self + {pathPrefix: pathPrefix},\n          mixin:: {\n          },\n        },\n        // FSGroupStrategyOptions defines the strategy type and options used to create the strategy.\n        fsGroupStrategyOptions:: {\n          new():: {},\n          // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n          withRanges(ranges):: self + if std.type(ranges) == \"array\" then {ranges: ranges} else {ranges: [ranges]},\n          // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n          withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then {ranges+: ranges} else {ranges+: [ranges]},\n          rangesType:: hidden.policy.v1beta1.idRange,\n          // Rule is the strategy that will dictate what FSGroup is used in the SecurityContext.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n          },\n        },\n        // Host Port Range defines a range of host ports that will be enabled by a policy for pods to use.  It requires both the start and end to be defined.\n        hostPortRange:: {\n          new():: {},\n          // max is the end of the range, inclusive.\n          withMax(max):: self + {max: max},\n          // min is the start of the range, inclusive.\n          withMin(min):: self + {min: min},\n          mixin:: {\n          },\n        },\n        // ID Range provides a min/max of an allowed range of IDs.\n        idRange:: {\n          new():: {},\n          // Max is the end of the range, inclusive.\n          withMax(max):: self + {max: max},\n          // Min is the start of the range, inclusive.\n          withMin(min):: self + {min: min},\n          mixin:: {\n          },\n        },\n        // PodDisruptionBudgetList is a collection of PodDisruptionBudgets.\n        podDisruptionBudgetList:: {\n          new():: {},\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.policy.v1beta1.podDisruptionBudget,\n          mixin:: {\n          },\n        },\n        // PodDisruptionBudgetSpec is a description of a PodDisruptionBudget.\n        podDisruptionBudgetSpec:: {\n          new():: {},\n          // An eviction is allowed if at most \"maxUnavailable\" pods selected by \"selector\" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with \"minAvailable\".\n          withMaxUnavailable(maxUnavailable):: self + {maxUnavailable: maxUnavailable},\n          // An eviction is allowed if at least \"minAvailable\" pods selected by \"selector\" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying \"100%\".\n          withMinAvailable(minAvailable):: self + {minAvailable: minAvailable},\n          mixin:: {\n            // Label query over pods whose evictions are managed by the disruption budget.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n        // PodDisruptionBudgetStatus represents information about the status of a PodDisruptionBudget. Status may trail the actual state of a system.\n        podDisruptionBudgetStatus:: {\n          new():: {},\n          // current number of healthy pods\n          withCurrentHealthy(currentHealthy):: self + {currentHealthy: currentHealthy},\n          // minimum desired number of healthy pods\n          withDesiredHealthy(desiredHealthy):: self + {desiredHealthy: desiredHealthy},\n          // DisruptedPods contains information about pods whose eviction was processed by the API server eviction subresource handler but has not yet been observed by the PodDisruptionBudget controller. A pod will be in this map from the time when the API server processed the eviction request to the time when the pod is seen by PDB controller as having been marked for deletion (or after a timeout). The key in the map is the name of the pod and the value is the time when the API server processed the eviction request. If the deletion didn't occur and a pod is still there it will be removed from the list automatically by PodDisruptionBudget controller after some time. If everything goes smooth this map should be empty for the most of the time. Large number of entries in the map may indicate problems with pod deletions.\n          withDisruptedPods(disruptedPods):: self + {disruptedPods: disruptedPods},\n          // DisruptedPods contains information about pods whose eviction was processed by the API server eviction subresource handler but has not yet been observed by the PodDisruptionBudget controller. A pod will be in this map from the time when the API server processed the eviction request to the time when the pod is seen by PDB controller as having been marked for deletion (or after a timeout). The key in the map is the name of the pod and the value is the time when the API server processed the eviction request. If the deletion didn't occur and a pod is still there it will be removed from the list automatically by PodDisruptionBudget controller after some time. If everything goes smooth this map should be empty for the most of the time. Large number of entries in the map may indicate problems with pod deletions.\n          withDisruptedPodsMixin(disruptedPods):: self + {disruptedPods+: disruptedPods},\n          // Number of pod disruptions that are currently allowed.\n          withDisruptionsAllowed(disruptionsAllowed):: self + {disruptionsAllowed: disruptionsAllowed},\n          // total number of pods counted by this disruption budget\n          withExpectedPods(expectedPods):: self + {expectedPods: expectedPods},\n          // Most recent generation observed when updating this PDB status. PodDisruptionsAllowed and other status informatio is valid only if observedGeneration equals to PDB's object generation.\n          withObservedGeneration(observedGeneration):: self + {observedGeneration: observedGeneration},\n          mixin:: {\n          },\n        },\n        // Pod Security Policy List is a list of PodSecurityPolicy objects.\n        podSecurityPolicyList:: {\n          new():: {},\n          // Items is a list of schema objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of schema objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.policy.v1beta1.podSecurityPolicy,\n          mixin:: {\n          },\n        },\n        // Pod Security Policy Spec defines the policy enforced.\n        podSecurityPolicySpec:: {\n          new():: {},\n          // AllowPrivilegeEscalation determines if a pod can request to allow privilege escalation. If unspecified, defaults to true.\n          withAllowPrivilegeEscalation(allowPrivilegeEscalation):: self + {allowPrivilegeEscalation: allowPrivilegeEscalation},\n          // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n          withAllowedCapabilities(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then {allowedCapabilities: allowedCapabilities} else {allowedCapabilities: [allowedCapabilities]},\n          // AllowedCapabilities is a list of capabilities that can be requested to add to the container. Capabilities in this field may be added at the pod author's discretion. You must not list a capability in both AllowedCapabilities and RequiredDropCapabilities.\n          withAllowedCapabilitiesMixin(allowedCapabilities):: self + if std.type(allowedCapabilities) == \"array\" then {allowedCapabilities+: allowedCapabilities} else {allowedCapabilities+: [allowedCapabilities]},\n          // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n          withAllowedFlexVolumes(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then {allowedFlexVolumes: allowedFlexVolumes} else {allowedFlexVolumes: [allowedFlexVolumes]},\n          // AllowedFlexVolumes is a whitelist of allowed Flexvolumes.  Empty or nil indicates that all Flexvolumes may be used.  This parameter is effective only when the usage of the Flexvolumes is allowed in the \"Volumes\" field.\n          withAllowedFlexVolumesMixin(allowedFlexVolumes):: self + if std.type(allowedFlexVolumes) == \"array\" then {allowedFlexVolumes+: allowedFlexVolumes} else {allowedFlexVolumes+: [allowedFlexVolumes]},\n          allowedFlexVolumesType:: hidden.policy.v1beta1.allowedFlexVolume,\n          // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n          withAllowedHostPaths(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then {allowedHostPaths: allowedHostPaths} else {allowedHostPaths: [allowedHostPaths]},\n          // is a white list of allowed host paths. Empty indicates that all host paths may be used.\n          withAllowedHostPathsMixin(allowedHostPaths):: self + if std.type(allowedHostPaths) == \"array\" then {allowedHostPaths+: allowedHostPaths} else {allowedHostPaths+: [allowedHostPaths]},\n          allowedHostPathsType:: hidden.policy.v1beta1.allowedHostPath,\n          // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n          withDefaultAddCapabilities(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then {defaultAddCapabilities: defaultAddCapabilities} else {defaultAddCapabilities: [defaultAddCapabilities]},\n          // DefaultAddCapabilities is the default set of capabilities that will be added to the container unless the pod spec specifically drops the capability.  You may not list a capability in both DefaultAddCapabilities and RequiredDropCapabilities. Capabilities added here are implicitly allowed, and need not be included in the AllowedCapabilities list.\n          withDefaultAddCapabilitiesMixin(defaultAddCapabilities):: self + if std.type(defaultAddCapabilities) == \"array\" then {defaultAddCapabilities+: defaultAddCapabilities} else {defaultAddCapabilities+: [defaultAddCapabilities]},\n          // DefaultAllowPrivilegeEscalation controls the default setting for whether a process can gain more privileges than its parent process.\n          withDefaultAllowPrivilegeEscalation(defaultAllowPrivilegeEscalation):: self + {defaultAllowPrivilegeEscalation: defaultAllowPrivilegeEscalation},\n          // hostIPC determines if the policy allows the use of HostIPC in the pod spec.\n          withHostIpc(hostIpc):: self + {hostIPC: hostIpc},\n          // hostNetwork determines if the policy allows the use of HostNetwork in the pod spec.\n          withHostNetwork(hostNetwork):: self + {hostNetwork: hostNetwork},\n          // hostPID determines if the policy allows the use of HostPID in the pod spec.\n          withHostPid(hostPid):: self + {hostPID: hostPid},\n          // hostPorts determines which host port ranges are allowed to be exposed.\n          withHostPorts(hostPorts):: self + if std.type(hostPorts) == \"array\" then {hostPorts: hostPorts} else {hostPorts: [hostPorts]},\n          // hostPorts determines which host port ranges are allowed to be exposed.\n          withHostPortsMixin(hostPorts):: self + if std.type(hostPorts) == \"array\" then {hostPorts+: hostPorts} else {hostPorts+: [hostPorts]},\n          hostPortsType:: hidden.policy.v1beta1.hostPortRange,\n          // privileged determines if a pod can request to be run as privileged.\n          withPrivileged(privileged):: self + {privileged: privileged},\n          // ReadOnlyRootFilesystem when set to true will force containers to run with a read only root file system.  If the container specifically requests to run with a non-read only root file system the PSP should deny the pod. If set to false the container may run with a read only root file system if it wishes but it will not be forced to.\n          withReadOnlyRootFilesystem(readOnlyRootFilesystem):: self + {readOnlyRootFilesystem: readOnlyRootFilesystem},\n          // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n          withRequiredDropCapabilities(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then {requiredDropCapabilities: requiredDropCapabilities} else {requiredDropCapabilities: [requiredDropCapabilities]},\n          // RequiredDropCapabilities are the capabilities that will be dropped from the container.  These are required to be dropped and cannot be added.\n          withRequiredDropCapabilitiesMixin(requiredDropCapabilities):: self + if std.type(requiredDropCapabilities) == \"array\" then {requiredDropCapabilities+: requiredDropCapabilities} else {requiredDropCapabilities+: [requiredDropCapabilities]},\n          // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n          withVolumes(volumes):: self + if std.type(volumes) == \"array\" then {volumes: volumes} else {volumes: [volumes]},\n          // volumes is a white list of allowed volume plugins.  Empty indicates that all plugins may be used.\n          withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then {volumes+: volumes} else {volumes+: [volumes]},\n          mixin:: {\n            // FSGroup is the strategy that will dictate what fs group is used by the SecurityContext.\n            fsGroup:: {\n              local __fsGroupMixin(fsGroup) = {fsGroup+: fsGroup},\n              mixinInstance(fsGroup):: __fsGroupMixin(fsGroup),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges: ranges}) else __fsGroupMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of fs groups.  If you would like to force a single fs group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __fsGroupMixin({ranges+: ranges}) else __fsGroupMixin({ranges+: [ranges]}),\n              rangesType:: hidden.policy.v1beta1.idRange,\n              // Rule is the strategy that will dictate what FSGroup is used in the SecurityContext.\n              withRule(rule):: self + __fsGroupMixin({rule: rule}),\n            },\n            fsGroupType:: hidden.policy.v1beta1.fsGroupStrategyOptions,\n            // runAsUser is the strategy that will dictate the allowable RunAsUser values that may be set.\n            runAsUser:: {\n              local __runAsUserMixin(runAsUser) = {runAsUser+: runAsUser},\n              mixinInstance(runAsUser):: __runAsUserMixin(runAsUser),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges: ranges}) else __runAsUserMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of uids that may be used.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __runAsUserMixin({ranges+: ranges}) else __runAsUserMixin({ranges+: [ranges]}),\n              rangesType:: hidden.policy.v1beta1.idRange,\n              // Rule is the strategy that will dictate the allowable RunAsUser values that may be set.\n              withRule(rule):: self + __runAsUserMixin({rule: rule}),\n            },\n            runAsUserType:: hidden.policy.v1beta1.runAsUserStrategyOptions,\n            // seLinux is the strategy that will dictate the allowable labels that may be set.\n            seLinux:: {\n              local __seLinuxMixin(seLinux) = {seLinux+: seLinux},\n              mixinInstance(seLinux):: __seLinuxMixin(seLinux),\n              // type is the strategy that will dictate the allowable labels that may be set.\n              withRule(rule):: self + __seLinuxMixin({rule: rule}),\n              // seLinuxOptions required to run as; required for MustRunAs More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n              seLinuxOptions:: {\n                local __seLinuxOptionsMixin(seLinuxOptions) = __seLinuxMixin({seLinuxOptions+: seLinuxOptions}),\n                mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n                // Level is SELinux level label that applies to the container.\n                withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n                // Role is a SELinux role label that applies to the container.\n                withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n                // Type is a SELinux type label that applies to the container.\n                withType(type):: self + __seLinuxOptionsMixin({type: type}),\n                // User is a SELinux user label that applies to the container.\n                withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n              },\n              seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n            },\n            seLinuxType:: hidden.policy.v1beta1.seLinuxStrategyOptions,\n            // SupplementalGroups is the strategy that will dictate what supplemental groups are used by the SecurityContext.\n            supplementalGroups:: {\n              local __supplementalGroupsMixin(supplementalGroups) = {supplementalGroups+: supplementalGroups},\n              mixinInstance(supplementalGroups):: __supplementalGroupsMixin(supplementalGroups),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRanges(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges: ranges}) else __supplementalGroupsMixin({ranges: [ranges]}),\n              // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n              withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then __supplementalGroupsMixin({ranges+: ranges}) else __supplementalGroupsMixin({ranges+: [ranges]}),\n              rangesType:: hidden.policy.v1beta1.idRange,\n              // Rule is the strategy that will dictate what supplemental groups is used in the SecurityContext.\n              withRule(rule):: self + __supplementalGroupsMixin({rule: rule}),\n            },\n            supplementalGroupsType:: hidden.policy.v1beta1.supplementalGroupsStrategyOptions,\n          },\n        },\n        // Run A sUser Strategy Options defines the strategy type and any options used to create the strategy.\n        runAsUserStrategyOptions:: {\n          new():: {},\n          // Ranges are the allowed ranges of uids that may be used.\n          withRanges(ranges):: self + if std.type(ranges) == \"array\" then {ranges: ranges} else {ranges: [ranges]},\n          // Ranges are the allowed ranges of uids that may be used.\n          withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then {ranges+: ranges} else {ranges+: [ranges]},\n          rangesType:: hidden.policy.v1beta1.idRange,\n          // Rule is the strategy that will dictate the allowable RunAsUser values that may be set.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n          },\n        },\n        // SELinux  Strategy Options defines the strategy type and any options used to create the strategy.\n        seLinuxStrategyOptions:: {\n          new():: {},\n          // type is the strategy that will dictate the allowable labels that may be set.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n            // seLinuxOptions required to run as; required for MustRunAs More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/\n            seLinuxOptions:: {\n              local __seLinuxOptionsMixin(seLinuxOptions) = {seLinuxOptions+: seLinuxOptions},\n              mixinInstance(seLinuxOptions):: __seLinuxOptionsMixin(seLinuxOptions),\n              // Level is SELinux level label that applies to the container.\n              withLevel(level):: self + __seLinuxOptionsMixin({level: level}),\n              // Role is a SELinux role label that applies to the container.\n              withRole(role):: self + __seLinuxOptionsMixin({role: role}),\n              // Type is a SELinux type label that applies to the container.\n              withType(type):: self + __seLinuxOptionsMixin({type: type}),\n              // User is a SELinux user label that applies to the container.\n              withUser(user):: self + __seLinuxOptionsMixin({user: user}),\n            },\n            seLinuxOptionsType:: hidden.core.v1.seLinuxOptions,\n          },\n        },\n        // SupplementalGroupsStrategyOptions defines the strategy type and options used to create the strategy.\n        supplementalGroupsStrategyOptions:: {\n          new():: {},\n          // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n          withRanges(ranges):: self + if std.type(ranges) == \"array\" then {ranges: ranges} else {ranges: [ranges]},\n          // Ranges are the allowed ranges of supplemental groups.  If you would like to force a single supplemental group then supply a single range with the same start and end.\n          withRangesMixin(ranges):: self + if std.type(ranges) == \"array\" then {ranges+: ranges} else {ranges+: [ranges]},\n          rangesType:: hidden.policy.v1beta1.idRange,\n          // Rule is the strategy that will dictate what supplemental groups is used in the SecurityContext.\n          withRule(rule):: self + {rule: rule},\n          mixin:: {\n          },\n        },\n      },\n    },\n    rbac:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"rbac/v1\"},\n        // AggregationRule describes how to locate ClusterRoles to aggregate into the ClusterRole\n        aggregationRule:: {\n          new():: {},\n          // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n          withClusterRoleSelectors(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then {clusterRoleSelectors: clusterRoleSelectors} else {clusterRoleSelectors: [clusterRoleSelectors]},\n          // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n          withClusterRoleSelectorsMixin(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then {clusterRoleSelectors+: clusterRoleSelectors} else {clusterRoleSelectors+: [clusterRoleSelectors]},\n          clusterRoleSelectorsType:: hidden.meta.v1.labelSelector,\n          mixin:: {\n          },\n        },\n        // ClusterRoleBindingList is a collection of ClusterRoleBindings\n        clusterRoleBindingList:: {\n          new():: {},\n          // Items is a list of ClusterRoleBindings\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ClusterRoleBindings\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1.clusterRoleBinding,\n          mixin:: {\n          },\n        },\n        // ClusterRoleList is a collection of ClusterRoles\n        clusterRoleList:: {\n          new():: {},\n          // Items is a list of ClusterRoles\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ClusterRoles\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1.clusterRole,\n          mixin:: {\n          },\n        },\n        // PolicyRule holds information that describes a policy rule, but does not contain information about who the rule applies to or which namespace the rule applies to.\n        policyRule:: {\n          new():: {},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as \"pods\" or \"secrets\") or non-resource URL paths (such as \"/api\"),  but not both.\n          withNonResourceUrls(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs: nonResourceUrls} else {nonResourceURLs: [nonResourceUrls]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as \"pods\" or \"secrets\") or non-resource URL paths (such as \"/api\"),  but not both.\n          withNonResourceUrlsMixin(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs+: nonResourceUrls} else {nonResourceURLs+: [nonResourceUrls]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.\n          withResourceNames(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames: resourceNames} else {resourceNames: [resourceNames]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.\n          withResourceNamesMixin(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames+: resourceNames} else {resourceNames+: [resourceNames]},\n          // Resources is a list of resources this rule applies to.  ResourceAll represents all resources.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.  ResourceAll represents all resources.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          // Verbs is a list of Verbs that apply to ALL the ResourceKinds and AttributeRestrictions contained in this rule.  VerbAll represents all kinds.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verbs is a list of Verbs that apply to ALL the ResourceKinds and AttributeRestrictions contained in this rule.  VerbAll represents all kinds.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // RoleBindingList is a collection of RoleBindings\n        roleBindingList:: {\n          new():: {},\n          // Items is a list of RoleBindings\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of RoleBindings\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1.roleBinding,\n          mixin:: {\n          },\n        },\n        // RoleList is a collection of Roles\n        roleList:: {\n          new():: {},\n          // Items is a list of Roles\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of Roles\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1.role,\n          mixin:: {\n          },\n        },\n        // RoleRef contains information that points to the role being used\n        roleRef:: {\n          new():: {},\n          // APIGroup is the group for the resource being referenced\n          withApiGroup(apiGroup):: self + {apiGroup: apiGroup},\n          // Kind is the type of resource being referenced\n          withKind(kind):: self + {kind: kind},\n          // Name is the name of resource being referenced\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // Subject contains a reference to the object or user identities a role binding applies to.  This can either hold a direct API object reference, or a value for non-objects such as user and group names.\n        subject:: {\n          new():: {},\n          // APIGroup holds the API group of the referenced subject. Defaults to \"\" for ServiceAccount subjects. Defaults to \"rbac.authorization.k8s.io\" for User and Group subjects.\n          withApiGroup(apiGroup):: self + {apiGroup: apiGroup},\n          // Kind of object being referenced. Values defined by this API group are \"User\", \"Group\", and \"ServiceAccount\". If the Authorizer does not recognized the kind value, the Authorizer should report an error.\n          withKind(kind):: self + {kind: kind},\n          // Name of the object being referenced.\n          withName(name):: self + {name: name},\n          // Namespace of the referenced object.  If the object kind is non-namespace, such as \"User\" or \"Group\", and this value is not empty the Authorizer should report an error.\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n      },\n      v1alpha1:: {\n        local apiVersion = {apiVersion: \"rbac/v1alpha1\"},\n        // AggregationRule describes how to locate ClusterRoles to aggregate into the ClusterRole\n        aggregationRule:: {\n          new():: {},\n          // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n          withClusterRoleSelectors(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then {clusterRoleSelectors: clusterRoleSelectors} else {clusterRoleSelectors: [clusterRoleSelectors]},\n          // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n          withClusterRoleSelectorsMixin(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then {clusterRoleSelectors+: clusterRoleSelectors} else {clusterRoleSelectors+: [clusterRoleSelectors]},\n          clusterRoleSelectorsType:: hidden.meta.v1.labelSelector,\n          mixin:: {\n          },\n        },\n        // ClusterRoleBindingList is a collection of ClusterRoleBindings\n        clusterRoleBindingList:: {\n          new():: {},\n          // Items is a list of ClusterRoleBindings\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ClusterRoleBindings\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1alpha1.clusterRoleBinding,\n          mixin:: {\n          },\n        },\n        // ClusterRoleList is a collection of ClusterRoles\n        clusterRoleList:: {\n          new():: {},\n          // Items is a list of ClusterRoles\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ClusterRoles\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1alpha1.clusterRole,\n          mixin:: {\n          },\n        },\n        // PolicyRule holds information that describes a policy rule, but does not contain information about who the rule applies to or which namespace the rule applies to.\n        policyRule:: {\n          new():: {},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path This name is intentionally different than the internal type so that the DefaultConvert works nicely and because the ordering may be different. Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as \"pods\" or \"secrets\") or non-resource URL paths (such as \"/api\"),  but not both.\n          withNonResourceUrls(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs: nonResourceUrls} else {nonResourceURLs: [nonResourceUrls]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path This name is intentionally different than the internal type so that the DefaultConvert works nicely and because the ordering may be different. Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as \"pods\" or \"secrets\") or non-resource URL paths (such as \"/api\"),  but not both.\n          withNonResourceUrlsMixin(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs+: nonResourceUrls} else {nonResourceURLs+: [nonResourceUrls]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.\n          withResourceNames(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames: resourceNames} else {resourceNames: [resourceNames]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.\n          withResourceNamesMixin(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames+: resourceNames} else {resourceNames+: [resourceNames]},\n          // Resources is a list of resources this rule applies to.  ResourceAll represents all resources.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.  ResourceAll represents all resources.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          // Verbs is a list of Verbs that apply to ALL the ResourceKinds and AttributeRestrictions contained in this rule.  VerbAll represents all kinds.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verbs is a list of Verbs that apply to ALL the ResourceKinds and AttributeRestrictions contained in this rule.  VerbAll represents all kinds.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // RoleBindingList is a collection of RoleBindings\n        roleBindingList:: {\n          new():: {},\n          // Items is a list of RoleBindings\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of RoleBindings\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1alpha1.roleBinding,\n          mixin:: {\n          },\n        },\n        // RoleList is a collection of Roles\n        roleList:: {\n          new():: {},\n          // Items is a list of Roles\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of Roles\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1alpha1.role,\n          mixin:: {\n          },\n        },\n        // RoleRef contains information that points to the role being used\n        roleRef:: {\n          new():: {},\n          // APIGroup is the group for the resource being referenced\n          withApiGroup(apiGroup):: self + {apiGroup: apiGroup},\n          // Kind is the type of resource being referenced\n          withKind(kind):: self + {kind: kind},\n          // Name is the name of resource being referenced\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // Subject contains a reference to the object or user identities a role binding applies to.  This can either hold a direct API object reference, or a value for non-objects such as user and group names.\n        subject:: {\n          new():: {},\n          // Kind of object being referenced. Values defined by this API group are \"User\", \"Group\", and \"ServiceAccount\". If the Authorizer does not recognized the kind value, the Authorizer should report an error.\n          withKind(kind):: self + {kind: kind},\n          // Name of the object being referenced.\n          withName(name):: self + {name: name},\n          // Namespace of the referenced object.  If the object kind is non-namespace, such as \"User\" or \"Group\", and this value is not empty the Authorizer should report an error.\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"rbac/v1beta1\"},\n        // AggregationRule describes how to locate ClusterRoles to aggregate into the ClusterRole\n        aggregationRule:: {\n          new():: {},\n          // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n          withClusterRoleSelectors(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then {clusterRoleSelectors: clusterRoleSelectors} else {clusterRoleSelectors: [clusterRoleSelectors]},\n          // ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. If any of the selectors match, then the ClusterRole's permissions will be added\n          withClusterRoleSelectorsMixin(clusterRoleSelectors):: self + if std.type(clusterRoleSelectors) == \"array\" then {clusterRoleSelectors+: clusterRoleSelectors} else {clusterRoleSelectors+: [clusterRoleSelectors]},\n          clusterRoleSelectorsType:: hidden.meta.v1.labelSelector,\n          mixin:: {\n          },\n        },\n        // ClusterRoleBindingList is a collection of ClusterRoleBindings\n        clusterRoleBindingList:: {\n          new():: {},\n          // Items is a list of ClusterRoleBindings\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ClusterRoleBindings\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1beta1.clusterRoleBinding,\n          mixin:: {\n          },\n        },\n        // ClusterRoleList is a collection of ClusterRoles\n        clusterRoleList:: {\n          new():: {},\n          // Items is a list of ClusterRoles\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of ClusterRoles\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1beta1.clusterRole,\n          mixin:: {\n          },\n        },\n        // PolicyRule holds information that describes a policy rule, but does not contain information about who the rule applies to or which namespace the rule applies to.\n        policyRule:: {\n          new():: {},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.\n          withApiGroups(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups: apiGroups} else {apiGroups: [apiGroups]},\n          // APIGroups is the name of the APIGroup that contains the resources.  If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed.\n          withApiGroupsMixin(apiGroups):: self + if std.type(apiGroups) == \"array\" then {apiGroups+: apiGroups} else {apiGroups+: [apiGroups]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as \"pods\" or \"secrets\") or non-resource URL paths (such as \"/api\"),  but not both.\n          withNonResourceUrls(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs: nonResourceUrls} else {nonResourceURLs: [nonResourceUrls]},\n          // NonResourceURLs is a set of partial urls that a user should have access to.  *s are allowed, but only as the full, final step in the path Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as \"pods\" or \"secrets\") or non-resource URL paths (such as \"/api\"),  but not both.\n          withNonResourceUrlsMixin(nonResourceUrls):: self + if std.type(nonResourceUrls) == \"array\" then {nonResourceURLs+: nonResourceUrls} else {nonResourceURLs+: [nonResourceUrls]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.\n          withResourceNames(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames: resourceNames} else {resourceNames: [resourceNames]},\n          // ResourceNames is an optional white list of names that the rule applies to.  An empty set means that everything is allowed.\n          withResourceNamesMixin(resourceNames):: self + if std.type(resourceNames) == \"array\" then {resourceNames+: resourceNames} else {resourceNames+: [resourceNames]},\n          // Resources is a list of resources this rule applies to.  '*' represents all resources in the specified apiGroups. '*/foo' represents the subresource 'foo' for all resources in the specified apiGroups.\n          withResources(resources):: self + if std.type(resources) == \"array\" then {resources: resources} else {resources: [resources]},\n          // Resources is a list of resources this rule applies to.  '*' represents all resources in the specified apiGroups. '*/foo' represents the subresource 'foo' for all resources in the specified apiGroups.\n          withResourcesMixin(resources):: self + if std.type(resources) == \"array\" then {resources+: resources} else {resources+: [resources]},\n          // Verbs is a list of Verbs that apply to ALL the ResourceKinds and AttributeRestrictions contained in this rule.  VerbAll represents all kinds.\n          withVerbs(verbs):: self + if std.type(verbs) == \"array\" then {verbs: verbs} else {verbs: [verbs]},\n          // Verbs is a list of Verbs that apply to ALL the ResourceKinds and AttributeRestrictions contained in this rule.  VerbAll represents all kinds.\n          withVerbsMixin(verbs):: self + if std.type(verbs) == \"array\" then {verbs+: verbs} else {verbs+: [verbs]},\n          mixin:: {\n          },\n        },\n        // RoleBindingList is a collection of RoleBindings\n        roleBindingList:: {\n          new():: {},\n          // Items is a list of RoleBindings\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of RoleBindings\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1beta1.roleBinding,\n          mixin:: {\n          },\n        },\n        // RoleList is a collection of Roles\n        roleList:: {\n          new():: {},\n          // Items is a list of Roles\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of Roles\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.rbac.v1beta1.role,\n          mixin:: {\n          },\n        },\n        // RoleRef contains information that points to the role being used\n        roleRef:: {\n          new():: {},\n          // APIGroup is the group for the resource being referenced\n          withApiGroup(apiGroup):: self + {apiGroup: apiGroup},\n          // Kind is the type of resource being referenced\n          withKind(kind):: self + {kind: kind},\n          // Name is the name of resource being referenced\n          withName(name):: self + {name: name},\n          mixin:: {\n          },\n        },\n        // Subject contains a reference to the object or user identities a role binding applies to.  This can either hold a direct API object reference, or a value for non-objects such as user and group names.\n        subject:: {\n          new():: {},\n          // APIGroup holds the API group of the referenced subject. Defaults to \"\" for ServiceAccount subjects. Defaults to \"rbac.authorization.k8s.io\" for User and Group subjects.\n          withApiGroup(apiGroup):: self + {apiGroup: apiGroup},\n          // Kind of object being referenced. Values defined by this API group are \"User\", \"Group\", and \"ServiceAccount\". If the Authorizer does not recognized the kind value, the Authorizer should report an error.\n          withKind(kind):: self + {kind: kind},\n          // Name of the object being referenced.\n          withName(name):: self + {name: name},\n          // Namespace of the referenced object.  If the object kind is non-namespace, such as \"User\" or \"Group\", and this value is not empty the Authorizer should report an error.\n          withNamespace(namespace):: self + {namespace: namespace},\n          mixin:: {\n          },\n        },\n      },\n    },\n    scheduling:: {\n      v1alpha1:: {\n        local apiVersion = {apiVersion: \"scheduling/v1alpha1\"},\n        // PriorityClassList is a collection of priority classes.\n        priorityClassList:: {\n          new():: {},\n          // items is the list of PriorityClasses\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // items is the list of PriorityClasses\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.scheduling.v1alpha1.priorityClass,\n          mixin:: {\n          },\n        },\n      },\n    },\n    settings:: {\n      v1alpha1:: {\n        local apiVersion = {apiVersion: \"settings/v1alpha1\"},\n        // PodPresetList is a list of PodPreset objects.\n        podPresetList:: {\n          new():: {},\n          // Items is a list of schema objects.\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is a list of schema objects.\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.settings.v1alpha1.podPreset,\n          mixin:: {\n          },\n        },\n        // PodPresetSpec is a description of a pod preset.\n        podPresetSpec:: {\n          new():: {},\n          // Env defines the collection of EnvVar to inject into containers.\n          withEnv(env):: self + if std.type(env) == \"array\" then {env: env} else {env: [env]},\n          // Env defines the collection of EnvVar to inject into containers.\n          withEnvMixin(env):: self + if std.type(env) == \"array\" then {env+: env} else {env+: [env]},\n          envType:: hidden.core.v1.envVar,\n          // EnvFrom defines the collection of EnvFromSource to inject into containers.\n          withEnvFrom(envFrom):: self + if std.type(envFrom) == \"array\" then {envFrom: envFrom} else {envFrom: [envFrom]},\n          // EnvFrom defines the collection of EnvFromSource to inject into containers.\n          withEnvFromMixin(envFrom):: self + if std.type(envFrom) == \"array\" then {envFrom+: envFrom} else {envFrom+: [envFrom]},\n          envFromType:: hidden.core.v1.envFromSource,\n          // VolumeMounts defines the collection of VolumeMount to inject into containers.\n          withVolumeMounts(volumeMounts):: self + if std.type(volumeMounts) == \"array\" then {volumeMounts: volumeMounts} else {volumeMounts: [volumeMounts]},\n          // VolumeMounts defines the collection of VolumeMount to inject into containers.\n          withVolumeMountsMixin(volumeMounts):: self + if std.type(volumeMounts) == \"array\" then {volumeMounts+: volumeMounts} else {volumeMounts+: [volumeMounts]},\n          volumeMountsType:: hidden.core.v1.volumeMount,\n          // Volumes defines the collection of Volume to inject into the pod.\n          withVolumes(volumes):: self + if std.type(volumes) == \"array\" then {volumes: volumes} else {volumes: [volumes]},\n          // Volumes defines the collection of Volume to inject into the pod.\n          withVolumesMixin(volumes):: self + if std.type(volumes) == \"array\" then {volumes+: volumes} else {volumes+: [volumes]},\n          volumesType:: hidden.core.v1.volume,\n          mixin:: {\n            // Selector is a label query over a set of resources, in this case pods. Required.\n            selector:: {\n              local __selectorMixin(selector) = {selector+: selector},\n              mixinInstance(selector):: __selectorMixin(selector),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressions(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions: matchExpressions}) else __selectorMixin({matchExpressions: [matchExpressions]}),\n              // matchExpressions is a list of label selector requirements. The requirements are ANDed.\n              withMatchExpressionsMixin(matchExpressions):: self + if std.type(matchExpressions) == \"array\" then __selectorMixin({matchExpressions+: matchExpressions}) else __selectorMixin({matchExpressions+: [matchExpressions]}),\n              matchExpressionsType:: hidden.meta.v1.labelSelectorRequirement,\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabels(matchLabels):: self + __selectorMixin({matchLabels: matchLabels}),\n              // matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n              withMatchLabelsMixin(matchLabels):: self + __selectorMixin({matchLabels+: matchLabels}),\n            },\n            selectorType:: hidden.meta.v1.labelSelector,\n          },\n        },\n      },\n    },\n    storage:: {\n      v1:: {\n        local apiVersion = {apiVersion: \"storage/v1\"},\n        // StorageClassList is a collection of storage classes.\n        storageClassList:: {\n          new():: {},\n          // Items is the list of StorageClasses\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of StorageClasses\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.storage.v1.storageClass,\n          mixin:: {\n          },\n        },\n      },\n      v1alpha1:: {\n        local apiVersion = {apiVersion: \"storage/v1alpha1\"},\n        // VolumeAttachmentList is a collection of VolumeAttachment objects.\n        volumeAttachmentList:: {\n          new():: {},\n          // Items is the list of VolumeAttachments\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of VolumeAttachments\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.storage.v1alpha1.volumeAttachment,\n          mixin:: {\n          },\n        },\n        // VolumeAttachmentSource represents a volume that should be attached. Right now only PersistenVolumes can be attached via external attacher, in future we may allow also inline volumes in pods. Exactly one member can be set.\n        volumeAttachmentSource:: {\n          new():: {},\n          // Name of the persistent volume to attach.\n          withPersistentVolumeName(persistentVolumeName):: self + {persistentVolumeName: persistentVolumeName},\n          mixin:: {\n          },\n        },\n        // VolumeAttachmentSpec is the specification of a VolumeAttachment request.\n        volumeAttachmentSpec:: {\n          new():: {},\n          // Attacher indicates the name of the volume driver that MUST handle this request. This is the name returned by GetPluginName().\n          withAttacher(attacher):: self + {attacher: attacher},\n          // The node that the volume should be attached to.\n          withNodeName(nodeName):: self + {nodeName: nodeName},\n          mixin:: {\n            // Source represents the volume that should be attached.\n            source:: {\n              local __sourceMixin(source) = {source+: source},\n              mixinInstance(source):: __sourceMixin(source),\n              // Name of the persistent volume to attach.\n              withPersistentVolumeName(persistentVolumeName):: self + __sourceMixin({persistentVolumeName: persistentVolumeName}),\n            },\n            sourceType:: hidden.storage.v1alpha1.volumeAttachmentSource,\n          },\n        },\n        // VolumeAttachmentStatus is the status of a VolumeAttachment request.\n        volumeAttachmentStatus:: {\n          new():: {},\n          // Indicates the volume is successfully attached. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n          withAttached(attached):: self + {attached: attached},\n          // Upon successful attach, this field is populated with any information returned by the attach operation that must be passed into subsequent WaitForAttach or Mount calls. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n          withAttachmentMetadata(attachmentMetadata):: self + {attachmentMetadata: attachmentMetadata},\n          // Upon successful attach, this field is populated with any information returned by the attach operation that must be passed into subsequent WaitForAttach or Mount calls. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n          withAttachmentMetadataMixin(attachmentMetadata):: self + {attachmentMetadata+: attachmentMetadata},\n          mixin:: {\n            // The last error encountered during attach operation, if any. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n            attachError:: {\n              local __attachErrorMixin(attachError) = {attachError+: attachError},\n              mixinInstance(attachError):: __attachErrorMixin(attachError),\n              // String detailing the error encountered during Attach or Detach operation. This string maybe logged, so it should not contain sensitive information.\n              withMessage(message):: self + __attachErrorMixin({message: message}),\n              // Time the error was encountered.\n              withTime(time):: self + __attachErrorMixin({time: time}),\n            },\n            attachErrorType:: hidden.storage.v1alpha1.volumeError,\n            // The last error encountered during detach operation, if any. This field must only be set by the entity completing the detach operation, i.e. the external-attacher.\n            detachError:: {\n              local __detachErrorMixin(detachError) = {detachError+: detachError},\n              mixinInstance(detachError):: __detachErrorMixin(detachError),\n              // String detailing the error encountered during Attach or Detach operation. This string maybe logged, so it should not contain sensitive information.\n              withMessage(message):: self + __detachErrorMixin({message: message}),\n              // Time the error was encountered.\n              withTime(time):: self + __detachErrorMixin({time: time}),\n            },\n            detachErrorType:: hidden.storage.v1alpha1.volumeError,\n          },\n        },\n        // VolumeError captures an error encountered during a volume operation.\n        volumeError:: {\n          new():: {},\n          // String detailing the error encountered during Attach or Detach operation. This string maybe logged, so it should not contain sensitive information.\n          withMessage(message):: self + {message: message},\n          // Time the error was encountered.\n          withTime(time):: self + {time: time},\n          mixin:: {\n          },\n        },\n      },\n      v1beta1:: {\n        local apiVersion = {apiVersion: \"storage/v1beta1\"},\n        // StorageClassList is a collection of storage classes.\n        storageClassList:: {\n          new():: {},\n          // Items is the list of StorageClasses\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of StorageClasses\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.storage.v1beta1.storageClass,\n          mixin:: {\n          },\n        },\n        // VolumeAttachmentList is a collection of VolumeAttachment objects.\n        volumeAttachmentList:: {\n          new():: {},\n          // Items is the list of VolumeAttachments\n          withItems(items):: self + if std.type(items) == \"array\" then {items: items} else {items: [items]},\n          // Items is the list of VolumeAttachments\n          withItemsMixin(items):: self + if std.type(items) == \"array\" then {items+: items} else {items+: [items]},\n          itemsType:: hidden.storage.v1beta1.volumeAttachment,\n          mixin:: {\n          },\n        },\n        // VolumeAttachmentSource represents a volume that should be attached. Right now only PersistenVolumes can be attached via external attacher, in future we may allow also inline volumes in pods. Exactly one member can be set.\n        volumeAttachmentSource:: {\n          new():: {},\n          // Name of the persistent volume to attach.\n          withPersistentVolumeName(persistentVolumeName):: self + {persistentVolumeName: persistentVolumeName},\n          mixin:: {\n          },\n        },\n        // VolumeAttachmentSpec is the specification of a VolumeAttachment request.\n        volumeAttachmentSpec:: {\n          new():: {},\n          // Attacher indicates the name of the volume driver that MUST handle this request. This is the name returned by GetPluginName().\n          withAttacher(attacher):: self + {attacher: attacher},\n          // The node that the volume should be attached to.\n          withNodeName(nodeName):: self + {nodeName: nodeName},\n          mixin:: {\n            // Source represents the volume that should be attached.\n            source:: {\n              local __sourceMixin(source) = {source+: source},\n              mixinInstance(source):: __sourceMixin(source),\n              // Name of the persistent volume to attach.\n              withPersistentVolumeName(persistentVolumeName):: self + __sourceMixin({persistentVolumeName: persistentVolumeName}),\n            },\n            sourceType:: hidden.storage.v1beta1.volumeAttachmentSource,\n          },\n        },\n        // VolumeAttachmentStatus is the status of a VolumeAttachment request.\n        volumeAttachmentStatus:: {\n          new():: {},\n          // Indicates the volume is successfully attached. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n          withAttached(attached):: self + {attached: attached},\n          // Upon successful attach, this field is populated with any information returned by the attach operation that must be passed into subsequent WaitForAttach or Mount calls. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n          withAttachmentMetadata(attachmentMetadata):: self + {attachmentMetadata: attachmentMetadata},\n          // Upon successful attach, this field is populated with any information returned by the attach operation that must be passed into subsequent WaitForAttach or Mount calls. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n          withAttachmentMetadataMixin(attachmentMetadata):: self + {attachmentMetadata+: attachmentMetadata},\n          mixin:: {\n            // The last error encountered during attach operation, if any. This field must only be set by the entity completing the attach operation, i.e. the external-attacher.\n            attachError:: {\n              local __attachErrorMixin(attachError) = {attachError+: attachError},\n              mixinInstance(attachError):: __attachErrorMixin(attachError),\n              // String detailing the error encountered during Attach or Detach operation. This string maybe logged, so it should not contain sensitive information.\n              withMessage(message):: self + __attachErrorMixin({message: message}),\n              // Time the error was encountered.\n              withTime(time):: self + __attachErrorMixin({time: time}),\n            },\n            attachErrorType:: hidden.storage.v1beta1.volumeError,\n            // The last error encountered during detach operation, if any. This field must only be set by the entity completing the detach operation, i.e. the external-attacher.\n            detachError:: {\n              local __detachErrorMixin(detachError) = {detachError+: detachError},\n              mixinInstance(detachError):: __detachErrorMixin(detachError),\n              // String detailing the error encountered during Attach or Detach operation. This string maybe logged, so it should not contain sensitive information.\n              withMessage(message):: self + __detachErrorMixin({message: message}),\n              // Time the error was encountered.\n              withTime(time):: self + __detachErrorMixin({time: time}),\n            },\n            detachErrorType:: hidden.storage.v1beta1.volumeError,\n          },\n        },\n        // VolumeError captures an error encountered during a volume operation.\n        volumeError:: {\n          new():: {},\n          // String detailing the error encountered during Attach or Detach operation. This string maybe logged, so it should not contain sensitive information.\n          withMessage(message):: self + {message: message},\n          // Time the error was encountered.\n          withTime(time):: self + {time: time},\n          mixin:: {\n          },\n        },\n      },\n    },\n  },\n}"),
	}

	// define dirs
	dir1 := &embedded.EmbeddedDir{
		Filename:   "",
		DirModTime: time.Unix(1523279712, 0),
		ChildFiles: []*embedded.EmbeddedFile{
			file2, // "k.libsonnet"
			file3, // "k8s.libsonnet"

		},
	}

	// link ChildDirs
	dir1.ChildDirs = []*embedded.EmbeddedDir{}

	// register embeddedBox
	embedded.RegisterEmbeddedBox(`assets`, &embedded.EmbeddedBox{
		Name: `assets`,
		Time: time.Unix(1523279712, 0),
		Dirs: map[string]*embedded.EmbeddedDir{
			"": dir1,
		},
		Files: map[string]*embedded.EmbeddedFile{
			"k.libsonnet":   file2,
			"k8s.libsonnet": file3,
		},
	})
}
